searchData={"items":[{"type":"task","title":"mix local.phx","doc":"Updates the Phoenix project generator locally.\n\n    $ mix local.phx\n\nAccepts the same command line options as `archive.install hex phx_new`.","ref":"Mix.Tasks.Local.Phx.html"},{"type":"task","title":"mix phx","doc":"Prints Phoenix tasks and their information.\n\n    $ mix phx\n\nTo print the Phoenix version, pass `-v` or `--version`, for example:\n\n    $ mix phx --version","ref":"Mix.Tasks.Phx.html"},{"type":"task","title":"mix phx.digest","doc":"Digests and compresses static files.\n\n    $ mix phx.digest\n    $ mix phx.digest priv/static -o /www/public\n\nThe first argument is the path where the static files are located. The\n`-o` option indicates the path that will be used to save the digested and\ncompressed files.\n\nIf no path is given, it will use `priv/static` as the input and output path.\n\nThe output folder will contain:\n\n  * the original file\n  * the file compressed with gzip\n  * a file containing the original file name and its digest\n  * a compressed file containing the file name and its digest\n  * a cache manifest file\n\nExample of generated files:\n\n  * app.js\n  * app.js.gz\n  * app-eb0a5b9302e8d32828d8a73f137cc8f0.js\n  * app-eb0a5b9302e8d32828d8a73f137cc8f0.js.gz\n  * cache_manifest.json\n\nYou can use `mix phx.digest.clean` to prune stale versions of the assets.\nIf you want to remove all produced files, run `mix phx.digest.clean --all`.","ref":"Mix.Tasks.Phx.Digest.html"},{"type":"task","title":"vsn - mix phx.digest","doc":"It is possible to digest the stylesheet asset references without the query\nstring \"?vsn=d\" with the option `--no-vsn`.","ref":"Mix.Tasks.Phx.Digest.html#module-vsn"},{"type":"task","title":"mix phx.digest.clean","doc":"Removes old versions of compiled assets.\n\nBy default, it will keep the latest version and\n2 previous versions as well as any digest created\nin the last hour.\n\n    $ mix phx.digest.clean\n    $ mix phx.digest.clean -o /www/public\n    $ mix phx.digest.clean --age 600 --keep 3\n    $ mix phx.digest.clean --all","ref":"Mix.Tasks.Phx.Digest.Clean.html"},{"type":"task","title":"Options - mix phx.digest.clean","doc":"* `-o, --output` - indicates the path to your compiled\n    assets directory. Defaults to `priv/static`\n\n  * `--age` - specifies a maximum age (in seconds) for assets.\n    Files older than age that are not in the last `--keep` versions\n    will be removed. Defaults to 3600 (1 hour)\n\n  * `--keep` - specifies how many previous versions of assets to keep.\n    Defaults to 2 previous versions\n\n  * `--all` - specifies that all compiled assets (including the manifest)\n    will be removed. Note this overrides the age and keep switches.","ref":"Mix.Tasks.Phx.Digest.Clean.html#module-options"},{"type":"task","title":"mix phx.gen","doc":"Lists all available Phoenix generators.","ref":"Mix.Tasks.Phx.Gen.html"},{"type":"task","title":"CRUD related generators - mix phx.gen","doc":"The table below shows a summary of the contents created by the CRUD generators:\n\n| Task | Schema | Migration | Context | Controller | View | LiveView |\n|:------------------ |:-:|:-:|:-:|:-:|:-:|:-:|\n| `phx.gen.embedded` | x |   |   |   |   |   |\n| `phx.gen.schema`   | x | x |   |   |   |   |\n| `phx.gen.context`  | x | x | x |   |   |   |\n| `phx.gen.live`     | x | x | x |   |   | x |\n| `phx.gen.json`     | x | x | x | x | x |   |\n| `phx.gen.html`     | x | x | x | x | x |   |","ref":"Mix.Tasks.Phx.Gen.html#module-crud-related-generators"},{"type":"function","title":"Mix.Tasks.Phx.Gen.run/1","doc":"","ref":"Mix.Tasks.Phx.Gen.html#run/1"},{"type":"task","title":"mix phx.gen.auth","doc":"Generates authentication logic and related views for a resource.\n\n    $ mix phx.gen.auth Accounts User users\n\nThe first argument is the context module followed by the schema module\nand its plural name (used as the schema table name).\n\nAdditional information and security considerations are detailed in the\n[`mix phx.gen.auth` guide](mix_phx_gen_auth.html).","ref":"Mix.Tasks.Phx.Gen.Auth.html"},{"type":"task","title":"LiveView vs conventional Controllers & Views - mix phx.gen.auth","doc":"Authentication views can either be generated to use LiveView by passing\nthe `--live` option, or they can use conventional Phoenix\nControllers & Views by passing `--no-live`.\n\nIf neither of these options are provided, a prompt will be displayed.\n\nUsing the `--live` option is advised if you plan on using LiveView\nelsewhere in your application. The user experience when navigating between\nLiveViews can be tightly controlled, allowing you to let your users navigate\nto authentication views without necessarily triggering a new HTTP request\neach time (which would result in a full page load).","ref":"Mix.Tasks.Phx.Gen.Auth.html#module-liveview-vs-conventional-controllers-views"},{"type":"task","title":"Password hashing - mix phx.gen.auth","doc":"The password hashing mechanism defaults to `bcrypt` for\nUnix systems and `pbkdf2` for Windows systems. Both\nsystems use the [Comeonin interface](https://hexdocs.pm/comeonin/).\n\nThe password hashing mechanism can be overridden with the\n`--hashing-lib` option. The following values are supported:\n\n  * `bcrypt` - [bcrypt_elixir](https://hex.pm/packages/bcrypt_elixir)\n  * `pbkdf2` - [pbkdf2_elixir](https://hex.pm/packages/pbkdf2_elixir)\n  * `argon2` - [argon2_elixir](https://hex.pm/packages/argon2_elixir)\n\nWe recommend developers to consider using `argon2`, which\nis the most robust of all 3. The downside is that `argon2`\nis quite CPU and memory intensive, and you will need more\npowerful instances to run your applications on.\n\nFor more information about choosing these libraries, see the\n[Comeonin project](https://github.com/riverrun/comeonin).","ref":"Mix.Tasks.Phx.Gen.Auth.html#module-password-hashing"},{"type":"task","title":"Web namespace - mix phx.gen.auth","doc":"By default, the controllers and HTML view will be namespaced by the schema name.\nYou can customize the web module namespace by passing the `--web` flag with a\nmodule name, for example:\n\n    $ mix phx.gen.auth Accounts User users --web Warehouse\n\nWhich would generate the controllers, views, templates and associated tests nested in the `MyAppWeb.Warehouse` namespace:\n\n  * `lib/my_app_web/controllers/warehouse/user_auth.ex`\n  * `lib/my_app_web/controllers/warehouse/user_confirmation_controller.ex`\n  * `lib/my_app_web/controllers/warehouse/user_confirmation_html.ex`\n  * `lib/my_app_web/controllers/warehouse/user_confirmation_html/new.html.heex`\n  * `test/my_app_web/controllers/warehouse/user_auth_test.exs`\n  * `test/my_app_web/controllers/warehouse/user_confirmation_controller_test.exs`\n  * and so on...","ref":"Mix.Tasks.Phx.Gen.Auth.html#module-web-namespace"},{"type":"task","title":"Multiple invocations - mix phx.gen.auth","doc":"You can invoke this generator multiple times. This is typically useful\nif you have distinct resources that go through distinct authentication\nworkflows:\n\n    $ mix phx.gen.auth Store User users\n    $ mix phx.gen.auth Backoffice Admin admins","ref":"Mix.Tasks.Phx.Gen.Auth.html#module-multiple-invocations"},{"type":"task","title":"Binary ids - mix phx.gen.auth","doc":"The `--binary-id` option causes the generated migration to use\n`binary_id` for its primary key and foreign keys.","ref":"Mix.Tasks.Phx.Gen.Auth.html#module-binary-ids"},{"type":"task","title":"Default options - mix phx.gen.auth","doc":"This generator uses default options provided in the `:generators`\nconfiguration of your application. These are the defaults:\n\n    config :your_app, :generators,\n      binary_id: false,\n      sample_binary_id: \"11111111-1111-1111-1111-111111111111\"\n\nYou can override those options per invocation by providing corresponding\nswitches, e.g. `--no-binary-id` to use normal ids despite the default\nconfiguration.","ref":"Mix.Tasks.Phx.Gen.Auth.html#module-default-options"},{"type":"task","title":"Custom table names - mix phx.gen.auth","doc":"By default, the table name for the migration and schema will be\nthe plural name provided for the resource. To customize this value,\na `--table` option may be provided. For example:\n\n    $ mix phx.gen.auth Accounts User users --table accounts_users\n\nThis will cause the generated tables to be named `\"accounts_users\"` and `\"accounts_users_tokens\"`.","ref":"Mix.Tasks.Phx.Gen.Auth.html#module-custom-table-names"},{"type":"task","title":"mix phx.gen.cert","doc":"Generates a self-signed certificate for HTTPS testing.\n\n    $ mix phx.gen.cert\n    $ mix phx.gen.cert my-app my-app.local my-app.internal.example.com\n\nCreates a private key and a self-signed certificate in PEM format. These\nfiles can be referenced in the `certfile` and `keyfile` parameters of an\nHTTPS Endpoint.\n\nWARNING: only use the generated certificate for testing in a closed network\nenvironment, such as running a development server on `localhost`.\nFor production, staging, or testing servers on the public internet, obtain a\nproper certificate, for example from [Let's Encrypt](https://letsencrypt.org).\n\nNOTE: when using Google Chrome, open chrome://flags/#allow-insecure-localhost\nto enable the use of self-signed certificates on `localhost`.","ref":"Mix.Tasks.Phx.Gen.Cert.html"},{"type":"task","title":"Arguments - mix phx.gen.cert","doc":"The list of hostnames, if none are specified, defaults to:\n\n  * localhost\n\nOther (optional) arguments:\n\n  * `--output` (`-o`): the path and base filename for the certificate and\n    key (default: priv/cert/selfsigned)\n  * `--name` (`-n`): the Common Name value in certificate's subject\n    (default: \"Self-signed test certificate\")\n\nRequires OTP 21.3 or later.","ref":"Mix.Tasks.Phx.Gen.Cert.html#module-arguments"},{"type":"task","title":"mix phx.gen.channel","doc":"Generates a Phoenix channel.\n\n    $ mix phx.gen.channel Room\n\nAccepts the module name for the channel\n\nThe generated files will contain:\n\nFor a regular application:\n\n  * a channel in `lib/my_app_web/channels`\n  * a channel test in `test/my_app_web/channels`\n\nFor an umbrella application:\n\n  * a channel in `apps/my_app_web/lib/app_name_web/channels`\n  * a channel test in `apps/my_app_web/test/my_app_web/channels`","ref":"Mix.Tasks.Phx.Gen.Channel.html"},{"type":"task","title":"mix phx.gen.context","doc":"Generates a context with functions around an Ecto schema.\n\n    $ mix phx.gen.context Accounts User users name:string age:integer\n\nThe first argument is the context module followed by the schema module\nand its plural name (used as the schema table name).\n\nThe context is an Elixir module that serves as an API boundary for\nthe given resource. A context often holds many related resources.\nTherefore, if the context already exists, it will be augmented with\nfunctions for the given resource.\n\n> Note: A resource may also be split\n> over distinct contexts (such as Accounts.User and Payments.User).\n\nThe schema is responsible for mapping the database fields into an\nElixir struct.\n\nOverall, this generator will add the following files to `lib/your_app`:\n\n  * a context module in `accounts.ex`, serving as the API boundary\n  * a schema in `accounts/user.ex`, with a `users` table\n\nA migration file for the repository and test files for the context\nwill also be generated.","ref":"Mix.Tasks.Phx.Gen.Context.html"},{"type":"task","title":"Generating without a schema - mix phx.gen.context","doc":"In some cases, you may wish to bootstrap the context module and\ntests, but leave internal implementation of the context and schema\nto yourself. Use the `--no-schema` flags to accomplish this.","ref":"Mix.Tasks.Phx.Gen.Context.html#module-generating-without-a-schema"},{"type":"task","title":"table - mix phx.gen.context","doc":"By default, the table name for the migration and schema will be\nthe plural name provided for the resource. To customize this value,\na `--table` option may be provided. For example:\n\n    $ mix phx.gen.context Accounts User users --table cms_users","ref":"Mix.Tasks.Phx.Gen.Context.html#module-table"},{"type":"task","title":"binary_id - mix phx.gen.context","doc":"Generated migration can use `binary_id` for schema's primary key\nand its references with option `--binary-id`.","ref":"Mix.Tasks.Phx.Gen.Context.html#module-binary_id"},{"type":"task","title":"Default options - mix phx.gen.context","doc":"This generator uses default options provided in the `:generators`\nconfiguration of your application. These are the defaults:\n\n    config :your_app, :generators,\n      migration: true,\n      binary_id: false,\n      timestamp_type: :naive_datetime,\n      sample_binary_id: \"11111111-1111-1111-1111-111111111111\"\n\nYou can override those options per invocation by providing corresponding\nswitches, e.g. `--no-binary-id` to use normal ids despite the default\nconfiguration or `--migration` to force generation of the migration.\n\nRead the documentation for `phx.gen.schema` for more information on\nattributes.","ref":"Mix.Tasks.Phx.Gen.Context.html#module-default-options"},{"type":"task","title":"Skipping prompts - mix phx.gen.context","doc":"This generator will prompt you if there is an existing context with the same\nname, in order to provide more instructions on how to correctly use phoenix contexts.\nYou can skip this prompt and automatically merge the new schema access functions and tests into the\nexisting context using `--merge-with-existing-context`. To prevent changes to\nthe existing context and exit the generator, use `--no-merge-with-existing-context`.","ref":"Mix.Tasks.Phx.Gen.Context.html#module-skipping-prompts"},{"type":"task","title":"mix phx.gen.embedded","doc":"Generates an embedded Ecto schema for casting/validating data outside the DB.\n\n    mix phx.gen.embedded Blog.Post title:string views:integer\n\nThe first argument is the schema module followed by the schema attributes.\n\nThe generated schema above will contain:\n\n  * an embedded schema file in `lib/my_app/blog/post.ex`","ref":"Mix.Tasks.Phx.Gen.Embedded.html"},{"type":"task","title":"Attributes - mix phx.gen.embedded","doc":"The resource fields are given using `name:type` syntax\nwhere type are the types supported by Ecto. Omitting\nthe type makes it default to `:string`:\n\n    mix phx.gen.embedded Blog.Post title views:integer\n\nThe following types are supported:\n\n  * `:integer`\n  * `:float`\n  * `:decimal`\n  * `:boolean`\n  * `:map`\n  * `:string`\n  * `:array`\n  * `:references`\n  * `:text`\n  * `:date`\n  * `:time`\n  * `:time_usec`\n  * `:naive_datetime`\n  * `:naive_datetime_usec`\n  * `:utc_datetime`\n  * `:utc_datetime_usec`\n  * `:uuid`\n  * `:binary`\n  * `:enum`\n\n  * `:datetime` - An alias for `:naive_datetime`","ref":"Mix.Tasks.Phx.Gen.Embedded.html#module-attributes"},{"type":"task","title":"mix phx.gen.html","doc":"Generates controller with view, templates, schema and context for an HTML resource.\n\n    mix phx.gen.html Accounts User users name:string age:integer\n\nThe first argument, `Accounts`, is the resource's context.\nA context is an Elixir module that serves as an API boundary for closely related resources.\n\nThe second argument, `User`, is the resource's schema.\nA schema is an Elixir module responsible for mapping database fields into an Elixir struct.\nThe `User` schema above specifies two fields with their respective colon-delimited data types:\n`name:string` and `age:integer`. See `mix phx.gen.schema` for more information on attributes.\n\n> Note: A resource may also be split\n> over distinct contexts (such as `Accounts.User` and `Payments.User`).\n\nThis generator adds the following files to `lib/`:\n\n  * a controller in `lib/my_app_web/controllers/user_controller.ex`\n  * default CRUD HTML templates in `lib/my_app_web/controllers/user_html`\n  * an HTML view collocated with the controller in `lib/my_app_web/controllers/user_html.ex`\n  * a schema in `lib/my_app/accounts/user.ex`, with an `users` table\n  * a context module in `lib/my_app/accounts.ex` for the accounts API\n\nAdditionally, this generator creates the following files:\n\n  * a migration for the schema in `priv/repo/migrations`\n  * a controller test module in `test/my_app/controllers/user_controller_test.exs`\n  * a context test module in `test/my_app/accounts_test.exs`\n  * a context test helper module in `test/support/fixtures/accounts_fixtures.ex`\n\nIf the context already exists, this generator injects functions for the given resource into\nthe context, context test, and context test helper modules.","ref":"Mix.Tasks.Phx.Gen.Html.html"},{"type":"task","title":"Umbrella app configuration - mix phx.gen.html","doc":"By default, Phoenix injects both web and domain specific functionality into the same\napplication. When using umbrella applications, those concerns are typically broken\ninto two separate apps, your context application - let's call it `my_app` - and its web\nlayer, which Phoenix assumes to be `my_app_web`.\n\nYou can teach Phoenix to use this style via the `:context_app` configuration option\nin your `my_app_umbrella/config/config.exs`:\n\n    config :my_app_web,\n      ecto_repos: [Stuff.Repo],\n      generators: [context_app: :my_app]\n\nAlternatively, the `--context-app` option may be supplied to the generator:\n\n    mix phx.gen.html Sales User users --context-app my_app\n\nIf you delete the `:context_app` configuration option, Phoenix will automatically put generated web files in\n`my_app_umbrella/apps/my_app_web_web`.\n\nIf you change the value of `:context_app` to `:new_value`, `my_app_umbrella/apps/new_value_web`\nmust already exist or you will get the following error:\n\n   ** (Mix) no directory for context_app :new_value found in my_app_web's deps.","ref":"Mix.Tasks.Phx.Gen.Html.html#module-umbrella-app-configuration"},{"type":"task","title":"Web namespace - mix phx.gen.html","doc":"By default, the controller and HTML view will be namespaced by the schema name.\nYou can customize the web module namespace by passing the `--web` flag with a\nmodule name, for example:\n\n    mix phx.gen.html Sales User users --web Sales\n\nWhich would generate a `lib/app_web/controllers/sales/user_controller.ex` and\n`lib/app_web/controllers/sales/user_html.ex`.","ref":"Mix.Tasks.Phx.Gen.Html.html#module-web-namespace"},{"type":"task","title":"Customizing the context, schema, tables and migrations - mix phx.gen.html","doc":"In some cases, you may wish to bootstrap HTML templates, controllers,\nand controller tests, but leave internal implementation of the context\nor schema to yourself. You can use the `--no-context` and `--no-schema`\nflags for file generation control.\n\nYou can also change the table name or configure the migrations to\nuse binary ids for primary keys, see `mix phx.gen.schema` for more\ninformation.","ref":"Mix.Tasks.Phx.Gen.Html.html#module-customizing-the-context-schema-tables-and-migrations"},{"type":"task","title":"mix phx.gen.json","doc":"Generates controller, JSON view, and context for a JSON resource.\n\n    mix phx.gen.json Accounts User users name:string age:integer\n\nThe first argument is the context module followed by the schema module\nand its plural name (used as the schema table name).\n\nThe context is an Elixir module that serves as an API boundary for\nthe given resource. A context often holds many related resources.\nTherefore, if the context already exists, it will be augmented with\nfunctions for the given resource.\n\n> Note: A resource may also be split\n> over distinct contexts (such as `Accounts.User` and `Payments.User`).\n\nThe schema is responsible for mapping the database fields into an\nElixir struct. It is followed by an optional list of attributes,\nwith their respective names and types. See `mix phx.gen.schema`\nfor more information on attributes.\n\nOverall, this generator will add the following files to `lib/`:\n\n  * a context module in `lib/app/accounts.ex` for the accounts API\n  * a schema in `lib/app/accounts/user.ex`, with an `users` table\n  * a controller in `lib/app_web/controllers/user_controller.ex`\n  * a JSON view collocated with the controller in `lib/app_web/controllers/user_json.ex`\n\nA migration file for the repository and test files for the context and\ncontroller features will also be generated.","ref":"Mix.Tasks.Phx.Gen.Json.html"},{"type":"task","title":"API Prefix - mix phx.gen.json","doc":"By default, the prefix \"/api\" will be generated for API route paths.\nThis can be customized via the `:api_prefix` generators configuration:\n\n    config :your_app, :generators,\n      api_prefix: \"/api/v1\"","ref":"Mix.Tasks.Phx.Gen.Json.html#module-api-prefix"},{"type":"task","title":"The context app - mix phx.gen.json","doc":"The location of the web files (controllers, json views, etc) in an\numbrella application will vary based on the `:context_app` config located\nin your applications `:generators` configuration. When set, the Phoenix\ngenerators will generate web files directly in your lib and test folders\nsince the application is assumed to be isolated to web specific functionality.\nIf `:context_app` is not set, the generators will place web related lib\nand test files in a `web/` directory since the application is assumed\nto be handling both web and domain specific functionality.\nExample configuration:\n\n    config :my_app_web, :generators, context_app: :my_app\n\nAlternatively, the `--context-app` option may be supplied to the generator:\n\n    mix phx.gen.json Sales User users --context-app warehouse","ref":"Mix.Tasks.Phx.Gen.Json.html#module-the-context-app"},{"type":"task","title":"Web namespace - mix phx.gen.json","doc":"By default, the controller and json view will be namespaced by the schema name.\nYou can customize the web module namespace by passing the `--web` flag with a\nmodule name, for example:\n\n    mix phx.gen.json Sales User users --web Sales\n\nWhich would generate a `lib/app_web/controllers/sales/user_controller.ex` and\n`lib/app_web/controller/sales/user_json.ex`.","ref":"Mix.Tasks.Phx.Gen.Json.html#module-web-namespace"},{"type":"task","title":"Customizing the context, schema, tables and migrations - mix phx.gen.json","doc":"In some cases, you may wish to bootstrap JSON views, controllers,\nand controller tests, but leave internal implementation of the context\nor schema to yourself. You can use the `--no-context` and `--no-schema`\nflags for file generation control.\n\nYou can also change the table name or configure the migrations to\nuse binary ids for primary keys, see `mix phx.gen.schema` for more\ninformation.","ref":"Mix.Tasks.Phx.Gen.Json.html#module-customizing-the-context-schema-tables-and-migrations"},{"type":"task","title":"mix phx.gen.live","doc":"Generates LiveView, templates, and context for a resource.\n\n    mix phx.gen.live Accounts User users name:string age:integer\n\nThe first argument is the context module.  The context is an Elixir module\nthat serves as an API boundary for the given resource. A context often holds\nmany related resources.  Therefore, if the context already exists, it will be\naugmented with functions for the given resource.\n\nThe second argument is the schema module.  The schema is responsible for\nmapping the database fields into an Elixir struct.\n\nThe remaining arguments are the schema module plural name (used as the schema\ntable name), and an optional list of attributes as their respective names and\ntypes.  See `mix help phx.gen.schema` for more information on attributes.\n\nWhen this command is run for the first time, a `Components` module will be\ncreated if it does not exist, along with the resource level LiveViews and\ncomponents, including `UserLive.Index`, `UserLive.Show`, and\n`UserLive.FormComponent` modules for the new resource.\n\n> Note: A resource may also be split\n> over distinct contexts (such as `Accounts.User` and `Payments.User`).\n\nOverall, this generator will add the following files:\n\n  * a context module in `lib/app/accounts.ex` for the accounts API\n  * a schema in `lib/app/accounts/user.ex`, with a `users` table\n  * a LiveView in `lib/app_web/live/user_live/show.ex`\n  * a LiveView in `lib/app_web/live/user_live/index.ex`\n  * a LiveComponent in `lib/app_web/live/user_live/form_component.ex`\n  * a helpers module in `lib/app_web/live/live_helpers.ex` with a modal\n\nAfter file generation is complete, there will be output regarding required\nupdates to the `lib/app_web/router.ex` file.\n\n    Add the live routes to your browser scope in lib/app_web/router.ex:\n\n      live \"/users\", UserLive.Index, :index\n      live \"/users/new\", UserLive.Index, :new\n      live \"/users/:id/edit\", UserLive.Index, :edit\n\n      live \"/users/:id\", UserLive.Show, :show\n      live \"/users/:id/show/edit\", UserLive.Show, :edit","ref":"Mix.Tasks.Phx.Gen.Live.html"},{"type":"task","title":"The context app - mix phx.gen.live","doc":"A migration file for the repository and test files for the context and\ncontroller features will also be generated.\n\nThe location of the web files (LiveView's, views, templates, etc.) in an\numbrella application will vary based on the `:context_app` config located\nin your applications `:generators` configuration. When set, the Phoenix\ngenerators will generate web files directly in your lib and test folders\nsince the application is assumed to be isolated to web specific functionality.\nIf `:context_app` is not set, the generators will place web related lib\nand test files in a `web/` directory since the application is assumed\nto be handling both web and domain specific functionality.\nExample configuration:\n\n    config :my_app_web, :generators, context_app: :my_app\n\nAlternatively, the `--context-app` option may be supplied to the generator:\n\n    mix phx.gen.live Accounts User users --context-app warehouse","ref":"Mix.Tasks.Phx.Gen.Live.html#module-the-context-app"},{"type":"task","title":"Web namespace - mix phx.gen.live","doc":"By default, the LiveView modules will be namespaced by the web module.\nYou can customize the web module namespace by passing the `--web` flag with a\nmodule name, for example:\n\n    mix phx.gen.live Accounts User users --web Sales\n\nWhich would generate the LiveViews in `lib/app_web/live/sales/user_live/`,\nnamespaced `AppWeb.Sales.UserLive` instead of `AppWeb.UserLive`.","ref":"Mix.Tasks.Phx.Gen.Live.html#module-web-namespace"},{"type":"task","title":"Customizing the context, schema, tables and migrations - mix phx.gen.live","doc":"In some cases, you may wish to bootstrap HTML templates, LiveViews,\nand tests, but leave internal implementation of the context or schema\nto yourself. You can use the `--no-context` and `--no-schema` flags\nfor file generation control.\n\n    mix phx.gen.live Accounts User users --no-context --no-schema\n\nIn the cases above, tests are still generated, but they will all fail.\n\nYou can also change the table name or configure the migrations to\nuse binary ids for primary keys, see `mix help phx.gen.schema` for more\ninformation.","ref":"Mix.Tasks.Phx.Gen.Live.html#module-customizing-the-context-schema-tables-and-migrations"},{"type":"task","title":"mix phx.gen.notifier","doc":"Generates a notifier that delivers emails by default.\n\n    $ mix phx.gen.notifier Accounts User welcome_user reset_password confirmation_instructions\n\nThis task expects a context module name, followed by a\nnotifier name and one or more message names. Messages\nare the functions that will be created prefixed by \"deliver\",\nso the message name should be \"snake_case\" without punctuation.\n\nAdditionally a context app can be specified with the flag\n`--context-app`, which is useful if the notifier is being\ngenerated in a different app under an umbrella.\n\n    $ mix phx.gen.notifier Accounts User welcome_user --context-app marketing\n\nThe app \"marketing\" must exist before the command is executed.","ref":"Mix.Tasks.Phx.Gen.Notifier.html"},{"type":"task","title":"mix phx.gen.presence","doc":"Generates a Presence tracker.\n\n    $ mix phx.gen.presence\n    $ mix phx.gen.presence MyPresence\n\nThe argument, which defaults to `Presence`, defines the module name of the\nPresence tracker.\n\nGenerates a new file, `lib/my_app_web/channels/my_presence.ex`, where\n`my_presence` is the snake-cased version of the provided module name.","ref":"Mix.Tasks.Phx.Gen.Presence.html"},{"type":"task","title":"mix phx.gen.release","doc":"Generates release files and optional Dockerfile for release-based deployments.\n\nThe following release files are created:\n\n  * `lib/app_name/release.ex` - A release module containing tasks for running\n    migrations inside a release\n\n  * `rel/overlays/bin/migrate` - A migrate script for conveniently invoking\n    the release system migrations\n\n  * `rel/overlays/bin/server` - A server script for conveniently invoking\n    the release system with environment variables to start the phoenix web server\n\nNote, the `rel/overlays` directory is copied into the release build by default when\nrunning `mix release`.\n\nTo skip generating the migration-related files, use the `--no-ecto` flag. To\nforce these migration-related files to be generated, the use `--ecto` flag.","ref":"Mix.Tasks.Phx.Gen.Release.html"},{"type":"task","title":"Docker - mix phx.gen.release","doc":"When the `--docker` flag is passed, the following docker files are generated:\n\n  * `Dockerfile` - The Dockerfile for use in any standard docker deployment\n\n  * `.dockerignore` - A docker ignore file with standard elixir defaults\n\nFor extended release configuration, the `mix release.init` task can be used\nin addition to this task. See the `Mix.Release` docs for more details.","ref":"Mix.Tasks.Phx.Gen.Release.html#module-docker"},{"type":"function","title":"Mix.Tasks.Phx.Gen.Release.otp_vsn/0","doc":"","ref":"Mix.Tasks.Phx.Gen.Release.html#otp_vsn/0"},{"type":"task","title":"mix phx.gen.schema","doc":"Generates an Ecto schema and migration.\n\n    $ mix phx.gen.schema Blog.Post blog_posts title:string views:integer\n\nThe first argument is the schema module followed by its plural\nname (used as the table name).\n\nThe generated schema above will contain:\n\n  * a schema file in `lib/my_app/blog/post.ex`, with a `blog_posts` table\n  * a migration file for the repository\n\nThe generated migration can be skipped with `--no-migration`.","ref":"Mix.Tasks.Phx.Gen.Schema.html"},{"type":"task","title":"Contexts - mix phx.gen.schema","doc":"Your schemas can be generated and added to a separate OTP app.\nMake sure your configuration is properly setup or manually\nspecify the context app with the `--context-app` option with\nthe CLI.\n\nVia config:\n\n    config :marketing_web, :generators, context_app: :marketing\n\nVia CLI:\n\n    $ mix phx.gen.schema Blog.Post blog_posts title:string views:integer --context-app marketing","ref":"Mix.Tasks.Phx.Gen.Schema.html#module-contexts"},{"type":"task","title":"Attributes - mix phx.gen.schema","doc":"The resource fields are given using `name:type` syntax\nwhere type are the types supported by Ecto. Omitting\nthe type makes it default to `:string`:\n\n    $ mix phx.gen.schema Blog.Post blog_posts title views:integer\n\nThe following types are supported:\n\n  * `:integer`\n  * `:float`\n  * `:decimal`\n  * `:boolean`\n  * `:map`\n  * `:string`\n  * `:array`\n  * `:references`\n  * `:text`\n  * `:date`\n  * `:time`\n  * `:time_usec`\n  * `:naive_datetime`\n  * `:naive_datetime_usec`\n  * `:utc_datetime`\n  * `:utc_datetime_usec`\n  * `:uuid`\n  * `:binary`\n  * `:enum`\n\n  * `:datetime` - An alias for `:naive_datetime`\n\nThe generator also supports references, which we will properly\nassociate the given column to the primary key column of the\nreferenced table:\n\n    $ mix phx.gen.schema Blog.Post blog_posts title user_id:references:users\n\nThis will result in a migration with an `:integer` column\nof `:user_id` and create an index.\n\nFurthermore an array type can also be given if it is\nsupported by your database, although it requires the\ntype of the underlying array element to be given too:\n\n    $ mix phx.gen.schema Blog.Post blog_posts tags:array:string\n\nUnique columns can be automatically generated by using:\n\n    $ mix phx.gen.schema Blog.Post blog_posts title:unique unique_int:integer:unique\n\nRedact columns can be automatically generated by using:\n\n    $ mix phx.gen.schema Accounts.Superhero superheroes secret_identity:redact password:string:redact\n\nEcto.Enum fields can be generated by using:\n\n    $ mix phx.gen.schema Blog.Post blog_posts title status:enum:unpublished:published:deleted\n\nIf no data type is given, it defaults to a string.","ref":"Mix.Tasks.Phx.Gen.Schema.html#module-attributes"},{"type":"task","title":"table - mix phx.gen.schema","doc":"By default, the table name for the migration and schema will be\nthe plural name provided for the resource. To customize this value,\na `--table` option may be provided. For example:\n\n    $ mix phx.gen.schema Blog.Post posts --table cms_posts","ref":"Mix.Tasks.Phx.Gen.Schema.html#module-table"},{"type":"task","title":"binary_id - mix phx.gen.schema","doc":"Generated migration can use `binary_id` for schema's primary key\nand its references with option `--binary-id`.","ref":"Mix.Tasks.Phx.Gen.Schema.html#module-binary_id"},{"type":"task","title":"repo - mix phx.gen.schema","doc":"Generated migration can use `repo` to set the migration repository\nfolder with option `--repo`:\n\n    $ mix phx.gen.schema Blog.Post posts --repo MyApp.Repo.Auth","ref":"Mix.Tasks.Phx.Gen.Schema.html#module-repo"},{"type":"task","title":"migration_dir - mix phx.gen.schema","doc":"Generated migrations can be added to a specific `--migration-dir` which sets\nthe migration folder path:\n\n    $ mix phx.gen.schema Blog.Post posts --migration-dir /path/to/directory","ref":"Mix.Tasks.Phx.Gen.Schema.html#module-migration_dir"},{"type":"task","title":"prefix - mix phx.gen.schema","doc":"By default migrations and schemas are generated without a prefix.\n\nFor PostgreSQL this sets the \"SCHEMA\" (typically set via `search_path`)\nand for MySQL it sets the database for the generated migration and schema.\nThe prefix can be used to thematically organize your tables on the database level.\n\nA prefix can be specified with the `--prefix` flags. For example:\n\n    $ mix phx.gen.schema Blog.Post posts --prefix blog\n\n> #### Warning {: .warning}\n>\n> The flag does not generate migrations to create the schema / database.\n> This needs to be done manually or in a separate migration.","ref":"Mix.Tasks.Phx.Gen.Schema.html#module-prefix"},{"type":"task","title":"Default options - mix phx.gen.schema","doc":"This generator uses default options provided in the `:generators`\nconfiguration of your application. These are the defaults:\n\n    config :your_app, :generators,\n      migration: true,\n      binary_id: false,\n      timestamp_type: :naive_datetime,\n      sample_binary_id: \"11111111-1111-1111-1111-111111111111\"\n\nYou can override those options per invocation by providing corresponding\nswitches, e.g. `--no-binary-id` to use normal ids despite the default\nconfiguration or `--migration` to force generation of the migration.","ref":"Mix.Tasks.Phx.Gen.Schema.html#module-default-options"},{"type":"task","title":"UTC timestamps - mix phx.gen.schema","doc":"By setting the `:timestamp_type` to `:utc_datetime`, the timestamps\nwill be created using the UTC timezone. This results in a `DateTime` struct\ninstead of a `NaiveDateTime`. This can also be set to `:utc_datetime_usec` for\nmicrosecond precision.","ref":"Mix.Tasks.Phx.Gen.Schema.html#module-utc-timestamps"},{"type":"task","title":"mix phx.gen.secret","doc":"Generates a secret and prints it to the terminal.\n\n    $ mix phx.gen.secret [length]\n\nBy default, mix phx.gen.secret generates a key 64 characters long.\n\nThe minimum value for `length` is 32.","ref":"Mix.Tasks.Phx.Gen.Secret.html"},{"type":"task","title":"mix phx.gen.socket","doc":"Generates a Phoenix socket handler.\n\n    $ mix phx.gen.socket User\n\nAccepts the module name for the socket.\n\nThe generated files will contain:\n\nFor a regular application:\n\n  * a client in `assets/js`\n  * a socket in `lib/my_app_web/channels`\n\nFor an umbrella application:\n\n  * a client in `apps/my_app_web/assets/js`\n  * a socket in `apps/my_app_web/lib/my_app_web/channels`\n\nYou can then generate channels with `mix phx.gen.channel`.","ref":"Mix.Tasks.Phx.Gen.Socket.html"},{"type":"task","title":"mix phx.new","doc":"Creates a new Phoenix project.\n\nIt expects the path of the project as an argument.\n\n    $ mix phx.new PATH [--module MODULE] [--app APP]\n\nA project at the given PATH will be created. The\napplication name and module name will be retrieved\nfrom the path, unless `--module` or `--app` is given.","ref":"Mix.Tasks.Phx.New.html"},{"type":"task","title":"Options - mix phx.new","doc":"* `--umbrella` - generate an umbrella project,\n    with one application for your domain, and\n    a second application for the web interface.\n\n  * `--app` - the name of the OTP application\n\n  * `--module` - the name of the base module in\n    the generated skeleton\n\n  * `--database` - specify the database adapter for Ecto. One of:\n\n      * `postgres` - via https://github.com/elixir-ecto/postgrex\n      * `mysql` - via https://github.com/elixir-ecto/myxql\n      * `mssql` - via https://github.com/livehelpnow/tds\n      * `sqlite3` - via https://github.com/elixir-sqlite/ecto_sqlite3\n\n    Please check the driver docs for more information\n    and requirements. Defaults to \"postgres\".\n\n  * `--adapter` - specify the http adapter. One of:\n      * `cowboy` - via https://github.com/elixir-plug/plug_cowboy\n      * `bandit` - via https://github.com/mtrudel/bandit\n\n    Please check the adapter docs for more information\n    and requirements. Defaults to \"bandit\".\n\n  * `--no-assets` - equivalent to `--no-esbuild` and `--no-tailwind`\n\n  * `--no-dashboard` - do not include Phoenix.LiveDashboard\n\n  * `--no-ecto` - do not generate Ecto files\n\n  * `--no-esbuild` - do not include esbuild dependencies and assets.\n    We do not recommend setting this option, unless for API only\n    applications, as doing so requires you to manually add and\n    track JavaScript dependencies\n\n  * `--no-gettext` - do not generate gettext files\n\n  * `--no-html` - do not generate HTML views\n\n  * `--no-live` - comment out LiveView socket setup in your Endpoint \n    and assets/js/app.js. Automatically disabled if --no-html is given\n\n  * `--no-mailer` - do not generate Swoosh mailer files\n\n  * `--no-tailwind` - do not include tailwind dependencies and assets.\n    The generated markup will still include Tailwind CSS classes, those\n    are left-in as reference for the subsequent styling of your layout\n    and components\n\n  * `--binary-id` - use `binary_id` as primary key type in Ecto schemas\n\n  * `--verbose` - use verbose output\n\n  * `-v`, `--version` - prints the Phoenix installer version\n\nWhen passing the `--no-ecto` flag, Phoenix generators such as\n`phx.gen.html`, `phx.gen.json`, `phx.gen.live`, and `phx.gen.context`\nmay no longer work as expected as they generate context files that rely\non Ecto for the database access. In those cases, you can pass the\n`--no-context` flag to generate most of the HTML and JSON files\nbut skip the context, allowing you to fill in the blanks as desired.\n\nSimilarly, if `--no-html` is given, the files generated by\n`phx.gen.html` will no longer work, as important HTML components\nwill be missing.","ref":"Mix.Tasks.Phx.New.html#module-options"},{"type":"task","title":"Installation - mix phx.new","doc":"`mix phx.new` by default prompts you to fetch and install your\ndependencies. You can enable this behaviour by passing the\n`--install` flag or disable it with the `--no-install` flag.","ref":"Mix.Tasks.Phx.New.html#module-installation"},{"type":"task","title":"Examples - mix phx.new","doc":"$ mix phx.new hello_world\n\nIs equivalent to:\n\n    $ mix phx.new hello_world --module HelloWorld\n\nOr without the HTML and JS bits (useful for APIs):\n\n    $ mix phx.new ~/Workspace/hello_world --no-html --no-assets\n\nAs an umbrella:\n\n    $ mix phx.new hello --umbrella\n\nWould generate the following directory structure and modules:\n\n```text\nhello_umbrella/   Hello.Umbrella\n  apps/\n    hello/        Hello\n    hello_web/    HelloWeb\n```\n\nYou can read more about umbrella projects using the\nofficial [Elixir guide](https://hexdocs.pm/elixir/dependencies-and-umbrella-projects.html#umbrella-projects)","ref":"Mix.Tasks.Phx.New.html#module-examples"},{"type":"task","title":"mix phx.new.ecto","doc":"Creates a new Ecto project within an umbrella project.\n\nThis task is intended to create a bare Ecto project without\nweb integration, which serves as a core application of your\ndomain for web applications and your greater umbrella\nplatform to integrate with.\n\nIt expects the name of the project as an argument.\n\n    $ cd my_umbrella/apps\n    $ mix phx.new.ecto APP [--module MODULE] [--app APP]\n\nA project at the given APP directory will be created. The\napplication name and module name will be retrieved\nfrom the application name, unless `--module` or `--app` is given.","ref":"Mix.Tasks.Phx.New.Ecto.html"},{"type":"task","title":"Options - mix phx.new.ecto","doc":"* `--app` - the name of the OTP application\n\n  * `--module` - the name of the base module in\n    the generated skeleton\n\n  * `--database` - specify the database adapter for Ecto. One of:\n\n      * `postgres` - via https://github.com/elixir-ecto/postgrex\n      * `mysql` - via https://github.com/elixir-ecto/myxql\n      * `mssql` - via https://github.com/livehelpnow/tds\n      * `sqlite3` - via https://github.com/elixir-sqlite/ecto_sqlite3\n\n    Please check the driver docs for more information\n    and requirements. Defaults to \"postgres\".\n\n  * `--binary-id` - use `binary_id` as primary key type\n    in Ecto schemas","ref":"Mix.Tasks.Phx.New.Ecto.html#module-options"},{"type":"task","title":"Examples - mix phx.new.ecto","doc":"$ mix phx.new.ecto hello_ecto\n\nIs equivalent to:\n\n    $ mix phx.new.ecto hello_ecto --module HelloEcto","ref":"Mix.Tasks.Phx.New.Ecto.html#module-examples"},{"type":"task","title":"mix phx.new.web","doc":"Creates a new Phoenix web project within an umbrella project.\n\nIt expects the name of the OTP app as the first argument and\nfor the command to be run inside your umbrella application's\napps directory:\n\n    $ cd my_umbrella/apps\n    $ mix phx.new.web APP [--module MODULE] [--app APP]\n\nThis task is intended to create a bare Phoenix project without\ndatabase integration, which interfaces with your greater\numbrella application(s).","ref":"Mix.Tasks.Phx.New.Web.html"},{"type":"task","title":"Examples - mix phx.new.web","doc":"$ mix phx.new.web hello_web\n\nIs equivalent to:\n\n    $ mix phx.new.web hello_web --module HelloWeb\n\nSupports the same options as the `phx.new` task.\nSee `Mix.Tasks.Phx.New` for details.","ref":"Mix.Tasks.Phx.New.Web.html#module-examples"},{"type":"task","title":"mix phx.routes","doc":"Prints all routes for the default or a given router.\nCan also locate the controller function behind a specified url.\n\n    $ mix phx.routes [ROUTER] [--info URL]\n\nThe default router is inflected from the application\nname unless a configuration named `:namespace`\nis set inside your application configuration. For example,\nthe configuration:\n\n    config :my_app,\n      namespace: My.App\n\nwill exhibit the routes for `My.App.Router` when this\ntask is invoked without arguments.\n\nUmbrella projects do not have a default router and\ntherefore always expect a router to be given. An\nalias can be added to mix.exs to automate this:\n\n    defp aliases do\n      [\n        \"phx.routes\": \"phx.routes MyAppWeb.Router\",\n        # aliases...\n      ]","ref":"Mix.Tasks.Phx.Routes.html"},{"type":"task","title":"Options - mix phx.routes","doc":"* `--info` - locate the controller function definition called by the given url\n  * `--method` - what HTTP method to use with the given url, only works when used with `--info` and defaults to `get`","ref":"Mix.Tasks.Phx.Routes.html#module-options"},{"type":"task","title":"Examples - mix phx.routes","doc":"Print all routes for the default router:\n\n    $ mix phx.routes\n\nPrint all routes for the given router:\n\n    $ mix phx.routes MyApp.AnotherRouter\n\nPrint information about the controller function called by a specified url:\n\n    $ mix phx.routes --info http://0.0.0.0:4000/home\n      Module: RouteInfoTestWeb.PageController\n      Function: :index\n      /home/my_app/controllers/page_controller.ex:4\n\nPrint information about the controller function called by a specified url and HTTP method:\n\n    $ mix phx.routes --info http://0.0.0.0:4000/users --method post\n      Module: RouteInfoTestWeb.UserController\n      Function: :create\n      /home/my_app/controllers/user_controller.ex:24","ref":"Mix.Tasks.Phx.Routes.html#module-examples"},{"type":"function","title":"Mix.Tasks.Phx.Routes.get_url_info/2","doc":"","ref":"Mix.Tasks.Phx.Routes.html#get_url_info/2"},{"type":"task","title":"mix phx.server","doc":"Starts the application by configuring all endpoints servers to run.\n\nNote: to start the endpoint without using this mix task you must set\n`server: true` in your `Phoenix.Endpoint` configuration.","ref":"Mix.Tasks.Phx.Server.html"},{"type":"task","title":"Command line options - mix phx.server","doc":"* `--open` - open browser window for each started endpoint\n\nFurthermore, this task accepts the same command-line options as\n`mix run`.\n\nFor example, to run `phx.server` without recompiling:\n\n    $ mix phx.server --no-compile\n\nThe `--no-halt` flag is automatically added.\n\nNote that the `--no-deps-check` flag cannot be used this way,\nbecause Mix needs to check dependencies to find `phx.server`.\n\nTo run `phx.server` without checking dependencies, you can run:\n\n    $ mix do deps.loadpaths --no-deps-check, phx.server","ref":"Mix.Tasks.Phx.Server.html#module-command-line-options"},{"type":"module","title":"Phoenix","doc":"This is the documentation for the Phoenix project.\n\nTo get started, see our [overview guides](overview.html).","ref":"Phoenix.html"},{"type":"function","title":"Phoenix.json_library/0","doc":"Returns the configured JSON encoding library for Phoenix.\n\nTo customize the JSON library, including the following\nin your `config/config.exs`:\n\n    config :phoenix, :json_library, AlternativeJsonLibrary","ref":"Phoenix.html#json_library/0"},{"type":"function","title":"Phoenix.plug_init_mode/0","doc":"Returns the `:plug_init_mode` that controls when plugs are\ninitialized.\n\nWe recommend to set it to `:runtime` in development for\ncompilation time improvements. It must be `:compile` in\nproduction (the default).\n\nThis option is passed as the `:init_mode` to `Plug.Builder.compile/3`.","ref":"Phoenix.html#plug_init_mode/0"},{"type":"behaviour","title":"Phoenix.Channel","doc":"Defines a Phoenix Channel.\n\nChannels provide a means for bidirectional communication from clients that\nintegrate with the `Phoenix.PubSub` layer for soft-realtime functionality.\n\nFor a conceptual overview, see the [Channels guide](channels.html).","ref":"Phoenix.Channel.html"},{"type":"behaviour","title":"Topics & Callbacks - Phoenix.Channel","doc":"Every time you join a channel, you need to choose which particular topic you\nwant to listen to. The topic is just an identifier, but by convention it is\noften made of two parts: `\"topic:subtopic\"`. Using the `\"topic:subtopic\"`\napproach pairs nicely with the `Phoenix.Socket.channel/3` allowing you to\nmatch on all topics starting with a given prefix by using a splat (the `*`\ncharacter) as the last character in the topic pattern:\n\n    channel \"room:*\", MyAppWeb.RoomChannel\n\nAny topic coming into the router with the `\"room:\"` prefix would dispatch\nto `MyAppWeb.RoomChannel` in the above example. Topics can also be pattern\nmatched in your channels' `join/3` callback to pluck out the scoped pattern:\n\n    # handles the special `\"lobby\"` subtopic\n    def join(\"room:lobby\", _payload, socket) do\n      {:ok, socket}\n    end\n\n    # handles any other subtopic as the room ID, for example `\"room:12\"`, `\"room:34\"`\n    def join(\"room:\" <> room_id, _payload, socket) do\n      {:ok, socket}\n    end","ref":"Phoenix.Channel.html#module-topics-callbacks"},{"type":"behaviour","title":"Authorization - Phoenix.Channel","doc":"Clients must join a channel to send and receive PubSub events on that channel.\nYour channels must implement a `join/3` callback that authorizes the socket\nfor the given topic. For example, you could check if the user is allowed to\njoin that particular room.\n\nTo authorize a socket in `join/3`, return `{:ok, socket}`.\nTo refuse authorization in `join/3`, return `{:error, reply}`.","ref":"Phoenix.Channel.html#module-authorization"},{"type":"behaviour","title":"Incoming Events - Phoenix.Channel","doc":"After a client has successfully joined a channel, incoming events from the\nclient are routed through the channel's `handle_in/3` callbacks. Within these\ncallbacks, you can perform any action. Incoming callbacks must return the\n`socket` to maintain ephemeral state.\n\nTypically you'll either forward a message to all listeners with\n`broadcast!/3` or reply directly to a client event for request/response style\nmessaging.\n\nGeneral message payloads are received as maps:\n\n    def handle_in(\"new_msg\", %{\"uid\" => uid, \"body\" => body}, socket) do\n      ...\n      {:reply, :ok, socket}\n    end\n\nBinary data payloads are passed as a `{:binary, data}` tuple:\n\n    def handle_in(\"file_chunk\", {:binary, chunk}, socket) do\n      ...\n      {:reply, :ok, socket}\n    end","ref":"Phoenix.Channel.html#module-incoming-events"},{"type":"behaviour","title":"Broadcasts - Phoenix.Channel","doc":"Here's an example of receiving an incoming `\"new_msg\"` event from one client,\nand broadcasting the message to all topic subscribers for this socket.\n\n    def handle_in(\"new_msg\", %{\"uid\" => uid, \"body\" => body}, socket) do\n      broadcast!(socket, \"new_msg\", %{uid: uid, body: body})\n      {:noreply, socket}\n    end","ref":"Phoenix.Channel.html#module-broadcasts"},{"type":"behaviour","title":"Replies - Phoenix.Channel","doc":"Replies are useful for acknowledging a client's message or responding with\nthe results of an operation. A reply is sent only to the client connected to\nthe current channel process. Behind the scenes, they include the client\nmessage `ref`, which allows the client to correlate the reply it receives\nwith the message it sent.\n\nFor example, imagine creating a resource and replying with the created record:\n\n    def handle_in(\"create:post\", attrs, socket) do\n      changeset = Post.changeset(%Post{}, attrs)\n\n      if changeset.valid? do\n        post = Repo.insert!(changeset)\n        response = MyAppWeb.PostView.render(\"show.json\", %{post: post})\n        {:reply, {:ok, response}, socket}\n      else\n        response = MyAppWeb.ChangesetView.render(\"errors.json\", %{changeset: changeset})\n        {:reply, {:error, response}, socket}\n      end\n    end\n\nOr you may just want to confirm that the operation succeeded:\n\n    def handle_in(\"create:post\", attrs, socket) do\n      changeset = Post.changeset(%Post{}, attrs)\n\n      if changeset.valid? do\n        Repo.insert!(changeset)\n        {:reply, :ok, socket}\n      else\n        {:reply, :error, socket}\n      end\n    end\n\nBinary data is also supported with replies via a `{:binary, data}` tuple:\n\n    {:reply, {:ok, {:binary, bin}}, socket}\n\nIf you don't want to send a reply to the client, you can return:\n\n    {:noreply, socket}\n\nOne situation when you might do this is if you need to reply later; see\n`reply/2`.","ref":"Phoenix.Channel.html#module-replies"},{"type":"behaviour","title":"Pushes - Phoenix.Channel","doc":"Calling `push/3` allows you to send a message to the client which is not a\nreply to a specific client message. Because it is not a reply, a pushed\nmessage does not contain a client message `ref`; there is no prior client\nmessage to relate it to.\n\nPossible use cases include notifying a client that:\n- You've auto-saved the user's document\n- The user's game is ending soon\n- The IoT device's settings should be updated\n\nFor example, you could `push/3` a message to the client in `handle_info/3`\nafter receiving a `PubSub` message relevant to them.\n\n    alias Phoenix.Socket.Broadcast\n    def handle_info(%Broadcast{topic: _, event: event, payload: payload}, socket) do\n      push(socket, event, payload)\n      {:noreply, socket}\n    end\n\nPush data can be given in the form of a map or a tagged `{:binary, data}`\ntuple:\n\n    # client asks for their current rank. reply contains it, and client\n    # is also pushed a leader board and a badge image\n    def handle_in(\"current_rank\", _, socket) do\n      push(socket, \"leaders\", %{leaders: Game.get_leaders(socket.assigns.game_id)})\n      push(socket, \"badge\", {:binary, File.read!(socket.assigns.badge_path)})\n      {:reply, %{val: Game.get_rank(socket.assigns[:user])}, socket}\n    end\n\nNote that in this example, `push/3` is called from `handle_in/3`; in this way\nyou can essentially reply N times to a single message from the client. See\n`reply/2` for why this may be desirable.","ref":"Phoenix.Channel.html#module-pushes"},{"type":"behaviour","title":"Intercepting Outgoing Events - Phoenix.Channel","doc":"When an event is broadcasted with `broadcast/3`, each channel subscriber can\nchoose to intercept the event and have their `handle_out/3` callback triggered.\nThis allows the event's payload to be customized on a socket by socket basis\nto append extra information, or conditionally filter the message from being\ndelivered. If the event is not intercepted with `Phoenix.Channel.intercept/1`,\nthen the message is pushed directly to the client:\n\n    intercept [\"new_msg\", \"user_joined\"]\n\n    # for every socket subscribing to this topic, append an `is_editable`\n    # value for client metadata.\n    def handle_out(\"new_msg\", msg, socket) do\n      push(socket, \"new_msg\", Map.merge(msg,\n        %{is_editable: User.can_edit_message?(socket.assigns[:user], msg)}\n      ))\n      {:noreply, socket}\n    end\n\n    # do not send broadcasted `\"user_joined\"` events if this socket's user\n    # is ignoring the user who joined.\n    def handle_out(\"user_joined\", msg, socket) do\n      unless User.ignoring?(socket.assigns[:user], msg.user_id) do\n        push(socket, \"user_joined\", msg)\n      end\n      {:noreply, socket}\n    end","ref":"Phoenix.Channel.html#module-intercepting-outgoing-events"},{"type":"behaviour","title":"Broadcasting to an external topic - Phoenix.Channel","doc":"In some cases, you will want to broadcast messages without the context of\na `socket`. This could be for broadcasting from within your channel to an\nexternal topic, or broadcasting from elsewhere in your application like a\ncontroller or another process. Such can be done via your endpoint:\n\n    # within channel\n    def handle_in(\"new_msg\", %{\"uid\" => uid, \"body\" => body}, socket) do\n      ...\n      broadcast_from!(socket, \"new_msg\", %{uid: uid, body: body})\n      MyAppWeb.Endpoint.broadcast_from!(self(), \"room:superadmin\",\n        \"new_msg\", %{uid: uid, body: body})\n      {:noreply, socket}\n    end\n\n    # within controller\n    def create(conn, params) do\n      ...\n      MyAppWeb.Endpoint.broadcast!(\"room:\" <> rid, \"new_msg\", %{uid: uid, body: body})\n      MyAppWeb.Endpoint.broadcast!(\"room:superadmin\", \"new_msg\", %{uid: uid, body: body})\n      redirect(conn, to: \"/\")\n    end","ref":"Phoenix.Channel.html#module-broadcasting-to-an-external-topic"},{"type":"behaviour","title":"Terminate - Phoenix.Channel","doc":"On termination, the channel callback `terminate/2` will be invoked with\nthe error reason and the socket.\n\nIf we are terminating because the client left, the reason will be\n`{:shutdown, :left}`. Similarly, if we are terminating because the\nclient connection was closed, the reason will be `{:shutdown, :closed}`.\n\nIf any of the callbacks return a `:stop` tuple, it will also\ntrigger terminate with the reason given in the tuple.\n\n`terminate/2`, however, won't be invoked in case of errors nor in\ncase of exits. This is the same behaviour as you find in Elixir\nabstractions like `GenServer` and others. Similar to `GenServer`,\nit would also be possible to `:trap_exit` to guarantee that `terminate/2`\nis invoked. This practice is not encouraged though.\n\nGenerally speaking, if you want to clean something up, it is better to\nmonitor your channel process and do the clean up from another process.\nAll channel callbacks, including `join/3`, are called from within the\nchannel process. Therefore, `self()` in any of them returns the PID to\nbe monitored.","ref":"Phoenix.Channel.html#module-terminate"},{"type":"behaviour","title":"Exit reasons when stopping a channel - Phoenix.Channel","doc":"When the channel callbacks return a `:stop` tuple, such as:\n\n    {:stop, :shutdown, socket}\n    {:stop, {:error, :enoent}, socket}\n\nthe second argument is the exit reason, which follows the same behaviour as\nstandard `GenServer` exits.\n\nYou have three options to choose from when shutting down a channel:\n\n  * `:normal` - in such cases, the exit won't be logged and linked processes\n    do not exit\n\n  * `:shutdown` or `{:shutdown, term}` - in such cases, the exit won't be\n    logged and linked processes exit with the same reason unless they're\n    trapping exits\n\n  * any other term - in such cases, the exit will be logged and linked\n    processes exit with the same reason unless they're trapping exits","ref":"Phoenix.Channel.html#module-exit-reasons-when-stopping-a-channel"},{"type":"behaviour","title":"Subscribing to external topics - Phoenix.Channel","doc":"Sometimes you may need to programmatically subscribe a socket to external\ntopics in addition to the internal `socket.topic`. For example,\nimagine you have a bidding system where a remote client dynamically sets\npreferences on products they want to receive bidding notifications on.\nInstead of requiring a unique channel process and topic per\npreference, a more efficient and simple approach would be to subscribe a\nsingle channel to relevant notifications via your endpoint. For example:\n\n    defmodule MyAppWeb.Endpoint.NotificationChannel do\n      use Phoenix.Channel\n\n      def join(\"notification:\" <> user_id, %{\"ids\" => ids}, socket) do\n        topics = for product_id <- ids, do: \"product:#{product_id}\"\n\n        {:ok, socket\n              |> assign(:topics, [])\n              |> put_new_topics(topics)}\n      end\n\n      def handle_in(\"watch\", %{\"product_id\" => id}, socket) do\n        {:reply, :ok, put_new_topics(socket, [\"product:#{id}\"])}\n      end\n\n      def handle_in(\"unwatch\", %{\"product_id\" => id}, socket) do\n        {:reply, :ok, MyAppWeb.Endpoint.unsubscribe(\"product:#{id}\")}\n      end\n\n      defp put_new_topics(socket, topics) do\n        Enum.reduce(topics, socket, fn topic, acc ->\n          topics = acc.assigns.topics\n          if topic in topics do\n            acc\n          else\n            :ok = MyAppWeb.Endpoint.subscribe(topic)\n            assign(acc, :topics, [topic | topics])\n          end\n        end)\n      end\n    end\n\nNote: the caller must be responsible for preventing duplicate subscriptions.\nAfter calling `subscribe/1` from your endpoint, the same flow applies to\nhandling regular Elixir messages within your channel. Most often, you'll\nsimply relay the `%Phoenix.Socket.Broadcast{}` event and payload:\n\n    alias Phoenix.Socket.Broadcast\n    def handle_info(%Broadcast{topic: _, event: event, payload: payload}, socket) do\n      push(socket, event, payload)\n      {:noreply, socket}\n    end","ref":"Phoenix.Channel.html#module-subscribing-to-external-topics"},{"type":"behaviour","title":"Hibernation - Phoenix.Channel","doc":"From Erlang/OTP 20, channels automatically hibernate to save memory\nafter 15_000 milliseconds of inactivity. This can be customized by\npassing the `:hibernate_after` option to `use Phoenix.Channel`:\n\n    use Phoenix.Channel, hibernate_after: 60_000\n\nYou can also set it to `:infinity` to fully disable it.","ref":"Phoenix.Channel.html#module-hibernation"},{"type":"behaviour","title":"Shutdown - Phoenix.Channel","doc":"You can configure the shutdown behavior of each channel used when your\napplication is shutting down by setting the `:shutdown` value on use:\n\n    use Phoenix.Channel, shutdown: 5_000\n\nIt defaults to 5_000. The supported values are described under the\nin the `Supervisor` module docs.","ref":"Phoenix.Channel.html#module-shutdown"},{"type":"behaviour","title":"Logging - Phoenix.Channel","doc":"By default, channel `\"join\"` and `\"handle_in\"` events are logged, using\nthe level `:info` and `:debug`, respectively. You can change the level used\nfor each event, or disable logs, per event type by setting the `:log_join`\nand `:log_handle_in` options when using `Phoenix.Channel`. For example, the\nfollowing configuration logs join events as `:info`, but disables logging for\nincoming events:\n\n    use Phoenix.Channel, log_join: :info, log_handle_in: false\n\nNote that changing an event type's level doesn't affect what is logged,\nunless you set it to `false`, it affects the associated level.","ref":"Phoenix.Channel.html#module-logging"},{"type":"function","title":"Phoenix.Channel.broadcast/3","doc":"Broadcast an event to all subscribers of the socket topic.\n\nThe event's message must be a serializable map or a tagged `{:binary, data}`\ntuple where `data` is binary data.","ref":"Phoenix.Channel.html#broadcast/3"},{"type":"function","title":"Examples - Phoenix.Channel.broadcast/3","doc":"iex> broadcast(socket, \"new_message\", %{id: 1, content: \"hello\"})\n    :ok\n\n    iex> broadcast(socket, \"new_message\", {:binary, \"hello\"})\n    :ok","ref":"Phoenix.Channel.html#broadcast/3-examples"},{"type":"function","title":"Phoenix.Channel.broadcast!/3","doc":"Same as `broadcast/3`, but raises if broadcast fails.","ref":"Phoenix.Channel.html#broadcast!/3"},{"type":"function","title":"Phoenix.Channel.broadcast_from/3","doc":"Broadcast event from pid to all subscribers of the socket topic.\n\nThe channel that owns the socket will not receive the published\nmessage. The event's message must be a serializable map or a tagged\n`{:binary, data}` tuple where `data` is binary data.","ref":"Phoenix.Channel.html#broadcast_from/3"},{"type":"function","title":"Examples - Phoenix.Channel.broadcast_from/3","doc":"iex> broadcast_from(socket, \"new_message\", %{id: 1, content: \"hello\"})\n    :ok\n\n    iex> broadcast_from(socket, \"new_message\", {:binary, \"hello\"})\n    :ok","ref":"Phoenix.Channel.html#broadcast_from/3-examples"},{"type":"function","title":"Phoenix.Channel.broadcast_from!/3","doc":"Same as `broadcast_from/3`, but raises if broadcast fails.","ref":"Phoenix.Channel.html#broadcast_from!/3"},{"type":"callback","title":"Phoenix.Channel.code_change/3","doc":"","ref":"Phoenix.Channel.html#c:code_change/3"},{"type":"callback","title":"Phoenix.Channel.handle_call/3","doc":"Handle regular GenServer call messages.\n\nSee `c:GenServer.handle_call/3`.","ref":"Phoenix.Channel.html#c:handle_call/3"},{"type":"callback","title":"Phoenix.Channel.handle_cast/2","doc":"Handle regular GenServer cast messages.\n\nSee `c:GenServer.handle_cast/2`.","ref":"Phoenix.Channel.html#c:handle_cast/2"},{"type":"callback","title":"Phoenix.Channel.handle_in/3","doc":"Handle incoming `event`s.\n\nPayloads are serialized before sending with the configured serializer.","ref":"Phoenix.Channel.html#c:handle_in/3"},{"type":"callback","title":"Example - Phoenix.Channel.handle_in/3","doc":"def handle_in(\"ping\", payload, socket) do\n      {:reply, {:ok, payload}, socket}\n    end","ref":"Phoenix.Channel.html#c:handle_in/3-example"},{"type":"callback","title":"Phoenix.Channel.handle_info/2","doc":"Handle regular Elixir process messages.\n\nSee `c:GenServer.handle_info/2`.","ref":"Phoenix.Channel.html#c:handle_info/2"},{"type":"callback","title":"Phoenix.Channel.handle_out/3","doc":"Intercepts outgoing `event`s.\n\nSee `intercept/1`.","ref":"Phoenix.Channel.html#c:handle_out/3"},{"type":"macro","title":"Phoenix.Channel.intercept/1","doc":"Defines which Channel events to intercept for `handle_out/3` callbacks.\n\nBy default, broadcasted events are pushed directly to the client, but\nintercepting events gives your channel a chance to customize the event\nfor the client to append extra information or filter the message from being\ndelivered.\n\n*Note*: intercepting events can introduce significantly more overhead if a\nlarge number of subscribers must customize a message since the broadcast will\nbe encoded N times instead of a single shared encoding across all subscribers.","ref":"Phoenix.Channel.html#intercept/1"},{"type":"macro","title":"Examples - Phoenix.Channel.intercept/1","doc":"intercept [\"new_msg\"]\n\n    def handle_out(\"new_msg\", payload, socket) do\n      push(socket, \"new_msg\", Map.merge(payload,\n        is_editable: User.can_edit_message?(socket.assigns[:user], payload)\n      ))\n      {:noreply, socket}\n    end\n\n`handle_out/3` callbacks must return one of:\n\n    {:noreply, Socket.t} |\n    {:noreply, Socket.t, timeout | :hibernate} |\n    {:stop, reason :: term, Socket.t}","ref":"Phoenix.Channel.html#intercept/1-examples"},{"type":"callback","title":"Phoenix.Channel.join/3","doc":"Handle channel joins by `topic`.\n\nTo authorize a socket, return `{:ok, socket}` or `{:ok, reply, socket}`. To\nrefuse authorization, return `{:error, reason}`.\n\nPayloads are serialized before sending with the configured serializer.","ref":"Phoenix.Channel.html#c:join/3"},{"type":"callback","title":"Example - Phoenix.Channel.join/3","doc":"def join(\"room:lobby\", payload, socket) do\n      if authorized?(payload) do\n        {:ok, socket}\n      else\n        {:error, %{reason: \"unauthorized\"}}\n      end\n    end","ref":"Phoenix.Channel.html#c:join/3-example"},{"type":"function","title":"Phoenix.Channel.push/3","doc":"Sends an event directly to the connected client without requiring a prior\nmessage from the client.\n\nThe event's message must be a serializable map or a tagged `{:binary, data}`\ntuple where `data` is binary data.\n\nNote that unlike some in client libraries, this server-side `push/3` does not\nreturn a reference. If you need to get a reply from the client and to\ncorrelate that reply with the message you pushed, you'll need to include a\nunique identifier in the message, track it in the Channel's state, have the\nclient include it in its reply, and examine the ref when the reply comes to\n`handle_in/3`.","ref":"Phoenix.Channel.html#push/3"},{"type":"function","title":"Examples - Phoenix.Channel.push/3","doc":"iex> push(socket, \"new_message\", %{id: 1, content: \"hello\"})\n    :ok\n\n    iex> push(socket, \"new_message\", {:binary, \"hello\"})\n    :ok","ref":"Phoenix.Channel.html#push/3-examples"},{"type":"function","title":"Phoenix.Channel.reply/2","doc":"Replies asynchronously to a socket push.\n\nThe usual way of replying to a client's message is to return a tuple from `handle_in/3`\nlike:\n\n    {:reply, {status, payload}, socket}\n\nBut sometimes you need to reply to a push asynchronously - that is, after\nyour `handle_in/3` callback completes. For example, you might need to perform\nwork in another process and reply when it's finished.\n\nYou can do this by generating a reference to the socket with `socket_ref/1`\nand calling `reply/2` with that ref when you're ready to reply.\n\n*Note*: A `socket_ref` is required so the `socket` itself is not leaked\noutside the channel. The `socket` holds information such as assigns and\ntransport configuration, so it's important to not copy this information\noutside of the channel that owns it.\n\nTechnically, `reply/2` will allow you to reply multiple times to the same\nclient message, and each reply will include the client message `ref`. But the\nclient may expect only one reply; in that case, `push/3` would be preferable\nfor the additional messages.\n\nPayloads are serialized before sending with the configured serializer.","ref":"Phoenix.Channel.html#reply/2"},{"type":"function","title":"Examples - Phoenix.Channel.reply/2","doc":"def handle_in(\"work\", payload, socket) do\n      Worker.perform(payload, socket_ref(socket))\n      {:noreply, socket}\n    end\n\n    def handle_info({:work_complete, result, ref}, socket) do\n      reply(ref, {:ok, result})\n      {:noreply, socket}\n    end","ref":"Phoenix.Channel.html#reply/2-examples"},{"type":"function","title":"Phoenix.Channel.socket_ref/1","doc":"Generates a `socket_ref` for an async reply.\n\nSee `reply/2` for example usage.","ref":"Phoenix.Channel.html#socket_ref/1"},{"type":"callback","title":"Phoenix.Channel.terminate/2","doc":"Invoked when the channel process is about to exit.\n\nSee `c:GenServer.terminate/2`.","ref":"Phoenix.Channel.html#c:terminate/2"},{"type":"type","title":"Phoenix.Channel.payload/0","doc":"","ref":"Phoenix.Channel.html#t:payload/0"},{"type":"type","title":"Phoenix.Channel.reply/0","doc":"","ref":"Phoenix.Channel.html#t:reply/0"},{"type":"type","title":"Phoenix.Channel.socket_ref/0","doc":"","ref":"Phoenix.Channel.html#t:socket_ref/0"},{"type":"module","title":"Phoenix.Controller","doc":"Controllers are used to group common functionality in the same\n(pluggable) module.\n\nFor example, the route:\n\n    get \"/users/:id\", MyAppWeb.UserController, :show\n\nwill invoke the `show/2` action in the `MyAppWeb.UserController`:\n\n    defmodule MyAppWeb.UserController do\n      use MyAppWeb, :controller\n\n      def show(conn, %{\"id\" => id}) do\n        user = Repo.get(User, id)\n        render(conn, :show, user: user)\n      end\n    end\n\nAn action is a regular function that receives the connection\nand the request parameters as arguments. The connection is a\n`Plug.Conn` struct, as specified by the Plug library.\n\nThen we invoke `render/3`, passing the connection, the template\nto render (typically named after the action), and the `user: user`\nas assigns. We will explore all of those concepts next.","ref":"Phoenix.Controller.html"},{"type":"module","title":"Connection - Phoenix.Controller","doc":"A controller by default provides many convenience functions for\nmanipulating the connection, rendering templates, and more.\n\nThose functions are imported from two modules:\n\n  * `Plug.Conn` - a collection of low-level functions to work with\n    the connection\n\n  * `Phoenix.Controller` - functions provided by Phoenix\n    to support rendering, and other Phoenix specific behaviour\n\nIf you want to have functions that manipulate the connection\nwithout fully implementing the controller, you can import both\nmodules directly instead of `use Phoenix.Controller`.","ref":"Phoenix.Controller.html#module-connection"},{"type":"module","title":"Rendering and layouts - Phoenix.Controller","doc":"One of the main features provided by controllers is the ability\nto perform content negotiation and render templates based on\ninformation sent by the client.\n\nThere are two ways to render content in a controller. One option\nis to invoke format-specific functions, such as `html/2` and `json/2`.\n\nHowever, most commonly controllers invoke custom modules called\nviews. Views are modules capable of rendering a custom format.\nThis is done by specifying the option `:formats` when defining\nthe controller:\n\n    use Phoenix.Controller,\n      formats: [:html, :json]\n\n Now, when invoking `render/3`, a controller named `MyAppWeb.UserController`\n will invoke `MyAppWeb.UserHTML` and `MyAppWeb.UserJSON` respectively\n when rendering each format:\n\n    def show(conn, %{\"id\" => id}) do\n      user = Repo.get(User, id)\n      # Will invoke UserHTML.show(%{user: user}) for html requests\n      # Will invoke UserJSON.show(%{user: user}) for json requests\n      render(conn, :show, user: user)\n    end\n\nSome formats are also handy to have layouts, which render content\nshared across all pages. We can also specify layouts on `use`:\n\n    use Phoenix.Controller,\n      formats: [:html, :json],\n      layouts: [html: MyAppWeb.Layouts]\n\nYou can also specify formats and layouts to render by calling\n`put_view/2` and `put_layout/2` directly with a connection.\nThe line above can also be written directly in your actions as:\n\n    conn\n    |> put_view(html: MyAppWeb.UserHTML, json: MyAppWeb.UserJSON)\n    |> put_layout(html: MyAppWeb.Layouts)","ref":"Phoenix.Controller.html#module-rendering-and-layouts"},{"type":"module","title":"Backwards compatibility - Phoenix.Controller","doc":"In previous Phoenix versions, a controller you always render\n`MyApp.UserView`. This behaviour can be explicitly retained by\npassing a suffix to the formats options:\n\n    use Phoenix.Controller,\n      formats: [html: \"View\", json: \"View\"],\n      layouts: [html: MyAppWeb.Layouts]","ref":"Phoenix.Controller.html#module-backwards-compatibility"},{"type":"module","title":"Options - Phoenix.Controller","doc":"When used, the controller supports the following options to customize\ntemplate rendering:\n\n  * `:formats` - the formats this controller will render\n    by default. For example, specifying `formats: [:html, :json]`\n    for a controller named `MyAppWeb.UserController` will\n    invoke `MyAppWeb.UserHTML` and `MyAppWeb.UserJSON` when\n    respectively rendering each format. If `:formats` is not\n    set, the default view is set to `MyAppWeb.UserView`\n\n  * `:layouts` - which layouts to render for each format,\n    for example: `[html: DemoWeb.Layouts]`\n\nDeprecated options:\n\n  * `:namespace` - sets the namespace for the layout. Use\n    `:layouts` instead\n\n  * `:put_default_views` - controls whether the default view\n    and layout should be set or not. Set `formats: []` and\n    `layouts: []` instead","ref":"Phoenix.Controller.html#module-options"},{"type":"module","title":"Plug pipeline - Phoenix.Controller","doc":"As with routers, controllers also have their own plug pipeline.\nHowever, different from routers, controllers have a single pipeline:\n\n    defmodule MyAppWeb.UserController do\n      use MyAppWeb, :controller\n\n      plug :authenticate, usernames: [\"jose\", \"eric\", \"sonny\"]\n\n      def show(conn, params) do\n        # authenticated users only\n      end\n\n      defp authenticate(conn, options) do\n        if get_session(conn, :username) in options[:usernames] do\n          conn\n        else\n          conn |> redirect(to: \"/\") |> halt()\n        end\n      end\n    end\n\nThe `:authenticate` plug will be invoked before the action. If the\nplug calls `Plug.Conn.halt/1` (which is by default imported into\ncontrollers), it will halt the pipeline and won't invoke the action.","ref":"Phoenix.Controller.html#module-plug-pipeline"},{"type":"module","title":"Guards - Phoenix.Controller","doc":"`plug/2` in controllers supports guards, allowing a developer to configure\na plug to only run in some particular action.\n\n    plug :do_something when action in [:show, :edit]\n\nDue to operator precedence in Elixir, if the second argument is a keyword list,\nwe need to wrap the keyword in `[...]` when using `when`:\n\n    plug :authenticate, [usernames: [\"jose\", \"eric\", \"sonny\"]] when action in [:show, :edit]\n    plug :authenticate, [usernames: [\"admin\"]] when not action in [:index]\n\nThe first plug will run only when action is show or edit. The second plug will\nalways run, except for the index action.\n\nThose guards work like regular Elixir guards and the only variables accessible\nin the guard are `conn`, the `action` as an atom and the `controller` as an\nalias.","ref":"Phoenix.Controller.html#module-guards"},{"type":"module","title":"Controllers are plugs - Phoenix.Controller","doc":"Like routers, controllers are plugs, but they are wired to dispatch\nto a particular function which is called an action.\n\nFor example, the route:\n\n    get \"/users/:id\", UserController, :show\n\nwill invoke `UserController` as a plug:\n\n    UserController.call(conn, :show)\n\nwhich will trigger the plug pipeline and which will eventually\ninvoke the inner action plug that dispatches to the `show/2`\nfunction in `UserController`.\n\nAs controllers are plugs, they implement both [`init/1`](`c:Plug.init/1`) and\n[`call/2`](`c:Plug.call/2`), and it also provides a function named `action/2`\nwhich is responsible for dispatching the appropriate action\nafter the plug stack (and is also overridable).","ref":"Phoenix.Controller.html#module-controllers-are-plugs"},{"type":"module","title":"Overriding `action/2` for custom arguments - Phoenix.Controller","doc":"Phoenix injects an `action/2` plug in your controller which calls the\nfunction matched from the router. By default, it passes the conn and params.\nIn some cases, overriding the `action/2` plug in your controller is a\nuseful way to inject arguments into your actions that you would otherwise\nneed to repeatedly fetch off the connection. For example, imagine if you\nstored a `conn.assigns.current_user` in the connection and wanted quick\naccess to the user for every action in your controller:\n\n    def action(conn, _) do\n      args = [conn, conn.params, conn.assigns.current_user]\n      apply(__MODULE__, action_name(conn), args)\n    end\n\n    def index(conn, _params, user) do\n      videos = Repo.all(user_videos(user))\n      # ...\n    end\n\n    def delete(conn, %{\"id\" => id}, user) do\n      video = Repo.get!(user_videos(user), id)\n      # ...\n    end","ref":"Phoenix.Controller.html#module-overriding-action-2-for-custom-arguments"},{"type":"function","title":"Phoenix.Controller.accepts/2","doc":"Performs content negotiation based on the available formats.\n\nIt receives a connection, a list of formats that the server\nis capable of rendering and then proceeds to perform content\nnegotiation based on the request information. If the client\naccepts any of the given formats, the request proceeds.\n\nIf the request contains a \"_format\" parameter, it is\nconsidered to be the format desired by the client. If no\n\"_format\" parameter is available, this function will parse\nthe \"accept\" header and find a matching format accordingly.\n\nThis function is useful when you may want to serve different\ncontent-types (such as JSON and HTML) from the same routes.\nHowever, if you always have distinct routes, you can also\ndisable content negotiation and simply hardcode your format\nof choice in your route pipelines:\n\n    plug :put_format, \"html\"\n\nIt is important to notice that browsers have historically\nsent bad accept headers. For this reason, this function will\ndefault to \"html\" format whenever:\n\n  * the accepted list of arguments contains the \"html\" format\n\n  * the accept header specified more than one media type preceded\n    or followed by the wildcard media type \"`*/*`\"\n\nThis function raises `Phoenix.NotAcceptableError`, which is rendered\nwith status 406, whenever the server cannot serve a response in any\nof the formats expected by the client.","ref":"Phoenix.Controller.html#accepts/2"},{"type":"function","title":"Examples - Phoenix.Controller.accepts/2","doc":"`accepts/2` can be invoked as a function:\n\n    iex> accepts(conn, [\"html\", \"json\"])\n\nor used as a plug:\n\n    plug :accepts, [\"html\", \"json\"]\n    plug :accepts, ~w(html json)","ref":"Phoenix.Controller.html#accepts/2-examples"},{"type":"function","title":"Custom media types - Phoenix.Controller.accepts/2","doc":"It is possible to add custom media types to your Phoenix application.\nThe first step is to teach Plug about those new media types in\nyour `config/config.exs` file:\n\n    config :mime, :types, %{\n      \"application/vnd.api+json\" => [\"json-api\"]\n    }\n\nThe key is the media type, the value is a list of formats the\nmedia type can be identified with. For example, by using\n\"json-api\", you will be able to use templates with extension\n\"index.json-api\" or to force a particular format in a given\nURL by sending \"?_format=json-api\".\n\nAfter this change, you must recompile plug:\n\n    $ mix deps.clean mime --build\n    $ mix deps.get\n\nAnd now you can use it in accepts too:\n\n    plug :accepts, [\"html\", \"json-api\"]","ref":"Phoenix.Controller.html#accepts/2-custom-media-types"},{"type":"macro","title":"Phoenix.Controller.action_fallback/1","doc":"Registers the plug to call as a fallback to the controller action.\n\nA fallback plug is useful to translate common domain data structures\ninto a valid `%Plug.Conn{}` response. If the controller action fails to\nreturn a `%Plug.Conn{}`, the provided plug will be called and receive\nthe controller's `%Plug.Conn{}` as it was before the action was invoked\nalong with the value returned from the controller action.","ref":"Phoenix.Controller.html#action_fallback/1"},{"type":"macro","title":"Examples - Phoenix.Controller.action_fallback/1","doc":"defmodule MyController do\n      use Phoenix.Controller\n\n      action_fallback MyFallbackController\n\n      def show(conn, %{\"id\" => id}, current_user) do\n        with {:ok, post} <- Blog.fetch_post(id),\n             :ok <- Authorizer.authorize(current_user, :view, post) do\n\n          render(conn, \"show.json\", post: post)\n        end\n      end\n    end\n\nIn the above example, `with` is used to match only a successful\npost fetch, followed by valid authorization for the current user.\nIn the event either of those fail to match, `with` will not invoke\nthe render block and instead return the unmatched value. In this case,\nimagine `Blog.fetch_post/2` returned `{:error, :not_found}` or\n`Authorizer.authorize/3` returned `{:error, :unauthorized}`. For cases\nwhere these data structures serve as return values across multiple\nboundaries in our domain, a single fallback module can be used to\ntranslate the value into a valid response. For example, you could\nwrite the following fallback controller to handle the above values:\n\n    defmodule MyFallbackController do\n      use Phoenix.Controller\n\n      def call(conn, {:error, :not_found}) do\n        conn\n        |> put_status(:not_found)\n        |> put_view(MyErrorView)\n        |> render(:\"404\")\n      end\n\n      def call(conn, {:error, :unauthorized}) do\n        conn\n        |> put_status(:forbidden)\n        |> put_view(MyErrorView)\n        |> render(:\"403\")\n      end\n    end","ref":"Phoenix.Controller.html#action_fallback/1-examples"},{"type":"function","title":"Phoenix.Controller.action_name/1","doc":"Returns the action name as an atom, raises if unavailable.","ref":"Phoenix.Controller.html#action_name/1"},{"type":"function","title":"Phoenix.Controller.allow_jsonp/2","doc":"A plug that may convert a JSON response into a JSONP one.\n\nIn case a JSON response is returned, it will be converted\nto a JSONP as long as the callback field is present in\nthe query string. The callback field itself defaults to\n\"callback\", but may be configured with the callback option.\n\nIn case there is no callback or the response is not encoded\nin JSON format, it is a no-op.\n\nOnly alphanumeric characters and underscore are allowed in the\ncallback name. Otherwise an exception is raised.","ref":"Phoenix.Controller.html#allow_jsonp/2"},{"type":"function","title":"Examples - Phoenix.Controller.allow_jsonp/2","doc":"# Will convert JSON to JSONP if callback=someFunction is given\n    plug :allow_jsonp\n\n    # Will convert JSON to JSONP if cb=someFunction is given\n    plug :allow_jsonp, callback: \"cb\"","ref":"Phoenix.Controller.html#allow_jsonp/2-examples"},{"type":"function","title":"Phoenix.Controller.clear_flash/1","doc":"Clears all flash messages.","ref":"Phoenix.Controller.html#clear_flash/1"},{"type":"function","title":"Phoenix.Controller.controller_module/1","doc":"Returns the controller module as an atom, raises if unavailable.","ref":"Phoenix.Controller.html#controller_module/1"},{"type":"function","title":"Phoenix.Controller.current_path/1","doc":"Returns the current request path with its default query parameters:\n\n    iex> current_path(conn)\n    \"/users/123?existing=param\"\n\nSee `current_path/2` to override the default parameters.\n\nThe path is normalized based on the `conn.script_name` and\n`conn.path_info`. For example, \"/foo//bar/\" will become \"/foo/bar\".\nIf you want the original path, use `conn.request_path` instead.","ref":"Phoenix.Controller.html#current_path/1"},{"type":"function","title":"Phoenix.Controller.current_path/2","doc":"Returns the current path with the given query parameters.\n\nYou may also retrieve only the request path by passing an\nempty map of params.","ref":"Phoenix.Controller.html#current_path/2"},{"type":"function","title":"Examples - Phoenix.Controller.current_path/2","doc":"iex> current_path(conn)\n    \"/users/123?existing=param\"\n\n    iex> current_path(conn, %{new: \"param\"})\n    \"/users/123?new=param\"\n\n    iex> current_path(conn, %{filter: %{status: [\"draft\", \"published\"]}})\n    \"/users/123?filter[status][]=draft&filter[status][]=published\"\n\n    iex> current_path(conn, %{})\n    \"/users/123\"\n\nThe path is normalized based on the `conn.script_name` and\n`conn.path_info`. For example, \"/foo//bar/\" will become \"/foo/bar\".\nIf you want the original path, use `conn.request_path` instead.","ref":"Phoenix.Controller.html#current_path/2-examples"},{"type":"function","title":"Phoenix.Controller.current_url/1","doc":"Returns the current request url with its default query parameters:\n\n    iex> current_url(conn)\n    \"https://www.example.com/users/123?existing=param\"\n\nSee `current_url/2` to override the default parameters.","ref":"Phoenix.Controller.html#current_url/1"},{"type":"function","title":"Phoenix.Controller.current_url/2","doc":"Returns the current request URL with query params.\n\nThe path will be retrieved from the currently requested path via\n`current_path/1`. The scheme, host and others will be received from\nthe URL configuration in your Phoenix endpoint. The reason we don't\nuse the host and scheme information in the request is because most\napplications are behind proxies and the host and scheme may not\nactually reflect the host and scheme accessed by the client. If you\nwant to access the url precisely as requested by the client, see\n`Plug.Conn.request_url/1`.","ref":"Phoenix.Controller.html#current_url/2"},{"type":"function","title":"Examples - Phoenix.Controller.current_url/2","doc":"iex> current_url(conn)\n    \"https://www.example.com/users/123?existing=param\"\n\n    iex> current_url(conn, %{new: \"param\"})\n    \"https://www.example.com/users/123?new=param\"\n\n    iex> current_url(conn, %{})\n    \"https://www.example.com/users/123\"","ref":"Phoenix.Controller.html#current_url/2-examples"},{"type":"function","title":"Custom URL Generation - Phoenix.Controller.current_url/2","doc":"In some cases, you'll need to generate a request's URL, but using a\ndifferent scheme, different host, etc. This can be accomplished in\ntwo ways.\n\nIf you want to do so in a case-by-case basis, you can define a custom\nfunction that gets the endpoint URI configuration and changes it accordingly.\nFor example, to get the current URL always in HTTPS format:\n\n    def current_secure_url(conn, params \\\\ %{}) do\n      current_uri = MyAppWeb.Endpoint.struct_url()\n      current_path = Phoenix.Controller.current_path(conn, params)\n      Phoenix.VerifiedRoutes.unverified_url(%URI{current_uri | scheme: \"https\"}, current_path)\n    end\n\nHowever, if you want all generated URLs to always have a certain schema,\nhost, etc, you may use `put_router_url/2`.","ref":"Phoenix.Controller.html#current_url/2-custom-url-generation"},{"type":"function","title":"Phoenix.Controller.delete_csrf_token/0","doc":"Deletes the CSRF token from the process dictionary.\n\n*Note*: The token is deleted only after a response has been sent.","ref":"Phoenix.Controller.html#delete_csrf_token/0"},{"type":"function","title":"Phoenix.Controller.endpoint_module/1","doc":"Returns the endpoint module as an atom, raises if unavailable.","ref":"Phoenix.Controller.html#endpoint_module/1"},{"type":"function","title":"Phoenix.Controller.fetch_flash/2","doc":"Fetches the flash storage.","ref":"Phoenix.Controller.html#fetch_flash/2"},{"type":"function","title":"Phoenix.Controller.get_csrf_token/0","doc":"Gets or generates a CSRF token.\n\nIf a token exists, it is returned, otherwise it is generated and stored\nin the process dictionary.","ref":"Phoenix.Controller.html#get_csrf_token/0"},{"type":"function","title":"Phoenix.Controller.get_flash/1","doc":"Returns a map of previously set flash messages or an empty map.","ref":"Phoenix.Controller.html#get_flash/1"},{"type":"function","title":"Examples - Phoenix.Controller.get_flash/1","doc":"iex> get_flash(conn)\n    %{}\n\n    iex> conn = put_flash(conn, :info, \"Welcome Back!\")\n    iex> get_flash(conn)\n    %{\"info\" => \"Welcome Back!\"}","ref":"Phoenix.Controller.html#get_flash/1-examples"},{"type":"function","title":"Phoenix.Controller.get_flash/2","doc":"Returns a message from flash by `key` (or `nil` if no message is available for `key`).","ref":"Phoenix.Controller.html#get_flash/2"},{"type":"function","title":"Examples - Phoenix.Controller.get_flash/2","doc":"iex> conn = put_flash(conn, :info, \"Welcome Back!\")\n    iex> get_flash(conn, :info)\n    \"Welcome Back!\"","ref":"Phoenix.Controller.html#get_flash/2-examples"},{"type":"function","title":"Phoenix.Controller.get_format/1","doc":"Returns the request format, such as \"json\", \"html\".\n\nThis format is used when rendering a template as an atom.\nFor example, `render(conn, :foo)` will render `\"foo.FORMAT\"`\nwhere the format is the one set here. The default format\nis typically set from the negotiation done in `accepts/2`.","ref":"Phoenix.Controller.html#get_format/1"},{"type":"function","title":"Phoenix.Controller.html/2","doc":"Sends html response.","ref":"Phoenix.Controller.html#html/2"},{"type":"function","title":"Examples - Phoenix.Controller.html/2","doc":"iex> html(conn, \"  ...\")","ref":"Phoenix.Controller.html#html/2-examples"},{"type":"function","title":"Phoenix.Controller.json/2","doc":"Sends JSON response.\n\nIt uses the configured `:json_library` under the `:phoenix`\napplication for `:json` to pick up the encoder module.","ref":"Phoenix.Controller.html#json/2"},{"type":"function","title":"Examples - Phoenix.Controller.json/2","doc":"iex> json(conn, %{id: 123})","ref":"Phoenix.Controller.html#json/2-examples"},{"type":"function","title":"Phoenix.Controller.layout/2","doc":"Retrieves the current layout for the given format.\n\nIf no format is given, takes the current one from the connection.","ref":"Phoenix.Controller.html#layout/2"},{"type":"function","title":"Phoenix.Controller.layout_formats/1","doc":"Retrieves current layout formats.","ref":"Phoenix.Controller.html#layout_formats/1"},{"type":"function","title":"Phoenix.Controller.merge_flash/2","doc":"Merges a map into the flash.\n\nReturns the updated connection.","ref":"Phoenix.Controller.html#merge_flash/2"},{"type":"function","title":"Examples - Phoenix.Controller.merge_flash/2","doc":"iex> conn = merge_flash(conn, info: \"Welcome Back!\")\n    iex> Phoenix.Flash.get(conn.assigns.flash, :info)\n    \"Welcome Back!\"","ref":"Phoenix.Controller.html#merge_flash/2-examples"},{"type":"function","title":"Phoenix.Controller.protect_from_forgery/2","doc":"Enables CSRF protection.\n\nCurrently used as a wrapper function for `Plug.CSRFProtection`\nand mainly serves as a function plug in `YourApp.Router`.\n\nCheck `get_csrf_token/0` and `delete_csrf_token/0` for\nretrieving and deleting CSRF tokens.","ref":"Phoenix.Controller.html#protect_from_forgery/2"},{"type":"function","title":"Phoenix.Controller.put_flash/3","doc":"Persists a value in flash.\n\nReturns the updated connection.","ref":"Phoenix.Controller.html#put_flash/3"},{"type":"function","title":"Examples - Phoenix.Controller.put_flash/3","doc":"iex> conn = put_flash(conn, :info, \"Welcome Back!\")\n    iex> Phoenix.Flash.get(conn.assigns.flash, :info)\n    \"Welcome Back!\"","ref":"Phoenix.Controller.html#put_flash/3-examples"},{"type":"function","title":"Phoenix.Controller.put_format/2","doc":"Puts the format in the connection.\n\nThis format is used when rendering a template as an atom.\nFor example, `render(conn, :foo)` will render `\"foo.FORMAT\"`\nwhere the format is the one set here. The default format\nis typically set from the negotiation done in `accepts/2`.\n\nSee `get_format/1` for retrieval.","ref":"Phoenix.Controller.html#put_format/2"},{"type":"function","title":"Phoenix.Controller.put_layout/2","doc":"Stores the layout for rendering.\n\nThe layout must be given as keyword list where the key is the request\nformat the layout will be applied to (such as `:html`) and the value\nis one of:\n\n  * `{module, layout}` with the `module` the layout is defined and\n    the name of the `layout` as an atom\n\n  * `layout` when the name of the layout. This requires a layout for\n    the given format in the shape of `{module, layout}` to be previously\n    given\n\n  * `false` which disables the layout\n\nIf `false` is given without a format, all layouts are disabled.","ref":"Phoenix.Controller.html#put_layout/2"},{"type":"function","title":"Examples - Phoenix.Controller.put_layout/2","doc":"iex> layout(conn)\n    false\n\n    iex> conn = put_layout(conn, html: {AppView, :application})\n    iex> layout(conn)\n    {AppView, :application}\n\n    iex> conn = put_layout(conn, html: :print)\n    iex> layout(conn)\n    {AppView, :print}\n\nRaises `Plug.Conn.AlreadySentError` if `conn` is already sent.","ref":"Phoenix.Controller.html#put_layout/2-examples"},{"type":"function","title":"Phoenix.Controller.put_layout_formats/2","doc":"Sets which formats have a layout when rendering.","ref":"Phoenix.Controller.html#put_layout_formats/2"},{"type":"function","title":"Examples - Phoenix.Controller.put_layout_formats/2","doc":"iex> layout_formats(conn)\n    [\"html\"]\n\n    iex> put_layout_formats(conn, [\"html\", \"mobile\"])\n    iex> layout_formats(conn)\n    [\"html\", \"mobile\"]\n\nRaises `Plug.Conn.AlreadySentError` if `conn` is already sent.","ref":"Phoenix.Controller.html#put_layout_formats/2-examples"},{"type":"function","title":"Phoenix.Controller.put_new_layout/2","doc":"Stores the layout for rendering if one was not stored yet.\n\nSee `put_layout/2` for more information.\n\nRaises `Plug.Conn.AlreadySentError` if `conn` is already sent.","ref":"Phoenix.Controller.html#put_new_layout/2"},{"type":"function","title":"Phoenix.Controller.put_new_view/2","doc":"Stores the view for rendering if one was not stored yet.\n\nRaises `Plug.Conn.AlreadySentError` if `conn` is already sent.","ref":"Phoenix.Controller.html#put_new_view/2"},{"type":"function","title":"Phoenix.Controller.put_root_layout/2","doc":"Stores the root layout for rendering.\n\nThe layout must be given as keyword list where the key is the request\nformat the layout will be applied to (such as `:html`) and the value\nis one of:\n\n  * `{module, layout}` with the `module` the layout is defined and\n    the name of the `layout` as an atom\n\n  * `layout` when the name of the layout. This requires a layout for\n    the given format in the shape of `{module, layout}` to be previously\n    given\n\n  * `false` which disables the layout","ref":"Phoenix.Controller.html#put_root_layout/2"},{"type":"function","title":"Examples - Phoenix.Controller.put_root_layout/2","doc":"iex> root_layout(conn)\n    false\n\n    iex> conn = put_root_layout(conn, html: {AppView, :root})\n    iex> root_layout(conn)\n    {AppView, :root}\n\n    iex> conn = put_root_layout(conn, html: :bare)\n    iex> root_layout(conn)\n    {AppView, :bare}\n\nRaises `Plug.Conn.AlreadySentError` if `conn` is already sent.","ref":"Phoenix.Controller.html#put_root_layout/2-examples"},{"type":"function","title":"Phoenix.Controller.put_router_url/2","doc":"Puts the url string or `%URI{}` to be used for route generation.\n\nThis function overrides the default URL generation pulled\nfrom the `%Plug.Conn{}`'s endpoint configuration.","ref":"Phoenix.Controller.html#put_router_url/2"},{"type":"function","title":"Examples - Phoenix.Controller.put_router_url/2","doc":"Imagine your application is configured to run on \"example.com\"\nbut after the user signs in, you want all links to use\n\"some_user.example.com\". You can do so by setting the proper\nrouter url configuration:\n\n    def put_router_url_by_user(conn) do\n      put_router_url(conn, get_user_from_conn(conn).account_name <> \".example.com\")\n    end\n\nNow when you call `Routes.some_route_url(conn, ...)`, it will use\nthe router url set above. Keep in mind that, if you want to generate\nroutes to the *current* domain, it is preferred to use\n`Routes.some_route_path` helpers, as those are always relative.","ref":"Phoenix.Controller.html#put_router_url/2-examples"},{"type":"function","title":"Phoenix.Controller.put_secure_browser_headers/2","doc":"Put headers that improve browser security.\n\nIt sets the following headers:\n\n  * `referrer-policy` - only send origin on cross origin requests\n  * `x-frame-options` - set to SAMEORIGIN to avoid clickjacking\n    through iframes unless in the same origin\n  * `x-content-type-options` - set to nosniff. This requires\n    script and style tags to be sent with proper content type\n  * `x-download-options` - set to noopen to instruct the browser\n    not to open a download directly in the browser, to avoid\n    HTML files rendering inline and accessing the security\n    context of the application (like critical domain cookies)\n  * `x-permitted-cross-domain-policies` - set to none to restrict\n    Adobe Flash Player’s access to data\n\nA custom headers map may also be given to be merged with defaults.\nIt is recommended for custom header keys to be in lowercase, to avoid sending\nduplicate keys in a request.\nAdditionally, responses with mixed-case headers served over HTTP/2 are not\nconsidered valid by common clients, resulting in dropped responses.","ref":"Phoenix.Controller.html#put_secure_browser_headers/2"},{"type":"function","title":"Phoenix.Controller.put_static_url/2","doc":"Puts the URL or `%URI{}` to be used for the static url generation.\n\nUsing this function on a `%Plug.Conn{}` struct tells `static_url/2` to use\nthe given information for URL generation instead of the `%Plug.Conn{}`'s\nendpoint configuration (much like `put_router_url/2` but for static URLs).","ref":"Phoenix.Controller.html#put_static_url/2"},{"type":"function","title":"Phoenix.Controller.put_view/2","doc":"Stores the view for rendering.\n\nRaises `Plug.Conn.AlreadySentError` if `conn` is already sent.","ref":"Phoenix.Controller.html#put_view/2"},{"type":"function","title":"Examples - Phoenix.Controller.put_view/2","doc":"# Use single view module\n    iex> put_view(conn, AppView)\n\n    # Use multiple view module for content negotiation\n    iex> put_view(conn, html: AppHTML, json: AppJSON)","ref":"Phoenix.Controller.html#put_view/2-examples"},{"type":"function","title":"Phoenix.Controller.redirect/2","doc":"Sends redirect response to the given url.\n\nFor security, `:to` only accepts paths. Use the `:external`\noption to redirect to any URL.\n\nThe response will be sent with the status code defined within\nthe connection, via `Plug.Conn.put_status/2`. If no status\ncode is set, a 302 response is sent.","ref":"Phoenix.Controller.html#redirect/2"},{"type":"function","title":"Examples - Phoenix.Controller.redirect/2","doc":"iex> redirect(conn, to: \"/login\")\n\n    iex> redirect(conn, external: \"https://elixir-lang.org\")","ref":"Phoenix.Controller.html#redirect/2-examples"},{"type":"function","title":"Phoenix.Controller.render/2","doc":"Render the given template or the default template\nspecified by the current action with the given assigns.\n\nSee `render/3` for more information.","ref":"Phoenix.Controller.html#render/2"},{"type":"function","title":"Phoenix.Controller.render/3","doc":"Renders the given `template` and `assigns` based on the `conn` information.\n\nOnce the template is rendered, the template format is set as the response\ncontent type (for example, an HTML template will set \"text/html\" as response\ncontent type) and the data is sent to the client with default status of 200.","ref":"Phoenix.Controller.html#render/3"},{"type":"function","title":"Arguments - Phoenix.Controller.render/3","doc":"* `conn` - the `Plug.Conn` struct\n\n  * `template` - which may be an atom or a string. If an atom, like `:index`,\n    it will render a template with the same format as the one returned by\n    `get_format/1`. For example, for an HTML request, it will render\n    the \"index.html\" template. If the template is a string, it must contain\n    the extension too, like \"index.json\"\n\n  * `assigns` - a dictionary with the assigns to be used in the view. Those\n    assigns are merged and have higher precedence than the connection assigns\n    (`conn.assigns`)","ref":"Phoenix.Controller.html#render/3-arguments"},{"type":"function","title":"Examples - Phoenix.Controller.render/3","doc":"defmodule MyAppWeb.UserController do\n      use Phoenix.Controller\n\n      def show(conn, _params) do\n        render(conn, \"show.html\", message: \"Hello\")\n      end\n    end\n\nThe example above renders a template \"show.html\" from the `MyAppWeb.UserView`\nand sets the response content type to \"text/html\".\n\nIn many cases, you may want the template format to be set dynamically based\non the request. To do so, you can pass the template name as an atom (without\nthe extension):\n\n    def show(conn, _params) do\n      render(conn, :show, message: \"Hello\")\n    end\n\nIn order for the example above to work, we need to do content negotiation with\nthe accepts plug before rendering. You can do so by adding the following to your\npipeline (in the router):\n\n    plug :accepts, [\"html\"]","ref":"Phoenix.Controller.html#render/3-examples"},{"type":"function","title":"Views - Phoenix.Controller.render/3","doc":"By default, Controllers render templates in a view with a similar name to the\ncontroller. For example, `MyAppWeb.UserController` will render templates inside\nthe `MyAppWeb.UserView`. This information can be changed any time by using the\n`put_view/2` function:\n\n    def show(conn, _params) do\n      conn\n      |> put_view(MyAppWeb.SpecialView)\n      |> render(:show, message: \"Hello\")\n    end\n\n`put_view/2` can also be used as a plug:\n\n    defmodule MyAppWeb.UserController do\n      use Phoenix.Controller\n\n      plug :put_view, html: MyAppWeb.SpecialView\n\n      def show(conn, _params) do\n        render(conn, :show, message: \"Hello\")\n      end\n    end","ref":"Phoenix.Controller.html#render/3-views"},{"type":"function","title":"Layouts - Phoenix.Controller.render/3","doc":"Templates are often rendered inside layouts. By default, Phoenix\nwill render layouts for html requests. For example:\n\n    defmodule MyAppWeb.UserController do\n      use Phoenix.Controller\n\n      def show(conn, _params) do\n        render(conn, \"show.html\", message: \"Hello\")\n      end\n    end\n\nwill render the  \"show.html\" template inside an \"app.html\"\ntemplate specified in `MyAppWeb.LayoutView`. `put_layout/2` can be used\nto change the layout, similar to how `put_view/2` can be used to change\nthe view.","ref":"Phoenix.Controller.html#render/3-layouts"},{"type":"function","title":"Phoenix.Controller.root_layout/2","doc":"Retrieves the current root layout for the given format.\n\nIf no format is given, takes the current one from the connection.","ref":"Phoenix.Controller.html#root_layout/2"},{"type":"function","title":"Phoenix.Controller.router_module/1","doc":"Returns the router module as an atom, raises if unavailable.","ref":"Phoenix.Controller.html#router_module/1"},{"type":"function","title":"Phoenix.Controller.scrub_params/2","doc":"Scrubs the parameters from the request.\n\nThis process is two-fold:\n\n  * Checks to see if the `required_key` is present\n  * Changes empty parameters of `required_key` (recursively) to nils\n\nThis function is useful for removing empty strings sent\nvia HTML forms. If you are providing an API, there\nis likely no need to invoke `scrub_params/2`.\n\nIf the `required_key` is not present, it will\nraise `Phoenix.MissingParamError`.","ref":"Phoenix.Controller.html#scrub_params/2"},{"type":"function","title":"Examples - Phoenix.Controller.scrub_params/2","doc":"iex> scrub_params(conn, \"user\")","ref":"Phoenix.Controller.html#scrub_params/2-examples"},{"type":"function","title":"Phoenix.Controller.send_download/3","doc":"Sends the given file or binary as a download.\n\nThe second argument must be `{:binary, contents}`, where\n`contents` will be sent as download, or`{:file, path}`,\nwhere `path` is the filesystem location of the file to\nbe sent. Be careful to not interpolate the path from\nexternal parameters, as it could allow traversal of the\nfilesystem.\n\nThe download is achieved by setting \"content-disposition\"\nto attachment. The \"content-type\" will also be set based\non the extension of the given filename but can be customized\nvia the `:content_type` and `:charset` options.","ref":"Phoenix.Controller.html#send_download/3"},{"type":"function","title":"Options - Phoenix.Controller.send_download/3","doc":"* `:filename` - the filename to be presented to the user\n    as download\n  * `:content_type` - the content type of the file or binary\n    sent as download. It is automatically inferred from the\n    filename extension\n  * `:disposition` - specifies disposition type\n    (`:attachment` or `:inline`). If `:attachment` was used,\n    user will be prompted to save the file. If `:inline` was used,\n    the browser will attempt to open the file.\n    Defaults to `:attachment`.\n  * `:charset` - the charset of the file, such as \"utf-8\".\n    Defaults to none\n  * `:offset` - the bytes to offset when reading. Defaults to `0`\n  * `:length` - the total bytes to read. Defaults to `:all`\n  * `:encode` - encodes the filename using `URI.encode/2`.\n    Defaults to `true`. When `false`, disables encoding. If you\n    disable encoding, you need to guarantee there are no special\n    characters in the filename, such as quotes, newlines, etc.\n    Otherwise you can expose your application to security attacks","ref":"Phoenix.Controller.html#send_download/3-options"},{"type":"function","title":"Examples - Phoenix.Controller.send_download/3","doc":"To send a file that is stored inside your application priv\ndirectory:\n\n    path = Application.app_dir(:my_app, \"priv/prospectus.pdf\")\n    send_download(conn, {:file, path})\n\nWhen using `{:file, path}`, the filename is inferred from the\ngiven path but may also be set explicitly.\n\nTo allow the user to download contents that are in memory as\na binary or string:\n\n    send_download(conn, {:binary, \"world\"}, filename: \"hello.txt\")\n\nSee `Plug.Conn.send_file/3` and `Plug.Conn.send_resp/3` if you\nwould like to access the low-level functions used to send files\nand responses via Plug.","ref":"Phoenix.Controller.html#send_download/3-examples"},{"type":"function","title":"Phoenix.Controller.status_message_from_template/1","doc":"Generates a status message from the template name.","ref":"Phoenix.Controller.html#status_message_from_template/1"},{"type":"function","title":"Examples - Phoenix.Controller.status_message_from_template/1","doc":"iex> status_message_from_template(\"404.html\")\n    \"Not Found\"\n    iex> status_message_from_template(\"whatever.html\")\n    \"Internal Server Error\"","ref":"Phoenix.Controller.html#status_message_from_template/1-examples"},{"type":"function","title":"Phoenix.Controller.text/2","doc":"Sends text response.","ref":"Phoenix.Controller.html#text/2"},{"type":"function","title":"Examples - Phoenix.Controller.text/2","doc":"iex> text(conn, \"hello\")\n\n    iex> text(conn, :implements_to_string)","ref":"Phoenix.Controller.html#text/2-examples"},{"type":"function","title":"Phoenix.Controller.view_module/2","doc":"Retrieves the current view for the given format.\n\nIf no format is given, takes the current one from the connection.","ref":"Phoenix.Controller.html#view_module/2"},{"type":"function","title":"Phoenix.Controller.view_template/1","doc":"Returns the template name rendered in the view as a string\n(or nil if no template was rendered).","ref":"Phoenix.Controller.html#view_template/1"},{"type":"type","title":"Phoenix.Controller.layout/0","doc":"","ref":"Phoenix.Controller.html#t:layout/0"},{"type":"type","title":"Phoenix.Controller.view/0","doc":"","ref":"Phoenix.Controller.html#t:view/0"},{"type":"behaviour","title":"Phoenix.Endpoint","doc":"Defines a Phoenix endpoint.\n\nThe endpoint is the boundary where all requests to your\nweb application start. It is also the interface your\napplication provides to the underlying web servers.\n\nOverall, an endpoint has three responsibilities:\n\n  * to provide a wrapper for starting and stopping the\n    endpoint as part of a supervision tree\n\n  * to define an initial plug pipeline for requests\n    to pass through\n\n  * to host web specific configuration for your\n    application","ref":"Phoenix.Endpoint.html"},{"type":"behaviour","title":"Endpoints - Phoenix.Endpoint","doc":"An endpoint is simply a module defined with the help\nof `Phoenix.Endpoint`. If you have used the `mix phx.new`\ngenerator, an endpoint was automatically generated as\npart of your application:\n\n    defmodule YourAppWeb.Endpoint do\n      use Phoenix.Endpoint, otp_app: :your_app\n\n      # plug ...\n      # plug ...\n\n      plug YourApp.Router\n    end\n\nEndpoints must be explicitly started as part of your application\nsupervision tree. Endpoints are added by default\nto the supervision tree in generated applications. Endpoints can be\nadded to the supervision tree as follows:\n\n    children = [\n      YourAppWeb.Endpoint\n    ]","ref":"Phoenix.Endpoint.html#module-endpoints"},{"type":"behaviour","title":"Endpoint configuration - Phoenix.Endpoint","doc":"All endpoints are configured in your application environment.\nFor example:\n\n    config :your_app, YourAppWeb.Endpoint,\n      secret_key_base: \"kjoy3o1zeidquwy1398juxzldjlksahdk3\"\n\nEndpoint configuration is split into two categories. Compile-time\nconfiguration means the configuration is read during compilation\nand changing it at runtime has no effect. The compile-time\nconfiguration is mostly related to error handling.\n\nRuntime configuration, instead, is accessed during or\nafter your application is started and can be read through the\n`c:config/2` function:\n\n    YourAppWeb.Endpoint.config(:port)\n    YourAppWeb.Endpoint.config(:some_config, :default_value)","ref":"Phoenix.Endpoint.html#module-endpoint-configuration"},{"type":"behaviour","title":"Compile-time configuration - Phoenix.Endpoint","doc":"Compile-time configuration may be set on `config/dev.exs`, `config/prod.exs`\nand so on, but has no effect on `config/runtime.exs`:\n\n  * `:code_reloader` - when `true`, enables code reloading functionality.\n    For the list of code reloader configuration options see\n    `Phoenix.CodeReloader.reload/1`. Keep in mind code reloading is\n    based on the file-system, therefore it is not possible to run two\n    instances of the same app at the same time with code reloading in\n    development, as they will race each other and only one will effectively\n    recompile the files. In such cases, tweak your config files so code\n    reloading is enabled in only one of the apps or set the MIX_BUILD\n    environment variable to give them distinct build directories\n\n  * `:debug_errors` - when `true`, uses `Plug.Debugger` functionality for\n    debugging failures in the application. Recommended to be set to `true`\n    only in development as it allows listing of the application source\n    code during debugging. Defaults to `false`\n\n  * `:force_ssl` - ensures no data is ever sent via HTTP, always redirecting\n    to HTTPS. It expects a list of options which are forwarded to `Plug.SSL`.\n    By default it sets the \"strict-transport-security\" header in HTTPS requests,\n    forcing browsers to always use HTTPS. If an unsafe request (HTTP) is sent,\n    it redirects to the HTTPS version using the `:host` specified in the `:url`\n    configuration. To dynamically redirect to the `host` of the current request,\n    set `:host` in the `:force_ssl` configuration to `nil`","ref":"Phoenix.Endpoint.html#module-compile-time-configuration"},{"type":"behaviour","title":"Runtime configuration - Phoenix.Endpoint","doc":"The configuration below may be set on `config/dev.exs`, `config/prod.exs`\nand so on, as well as on `config/runtime.exs`. Typically, if you need to\nconfigure them with system environment variables, you set them in\n`config/runtime.exs`. These options may also be set when starting the\nendpoint in your supervision tree, such as `{MyApp.Endpoint, options}`.\n\n  * `:adapter` - which webserver adapter to use for serving web requests.\n    See the \"Adapter configuration\" section below\n\n  * `:cache_static_manifest` - a path to a json manifest file that contains\n    static files and their digested version. This is typically set to\n    \"priv/static/cache_manifest.json\" which is the file automatically generated\n    by `mix phx.digest`. It can be either: a string containing a file system path\n    or a tuple containing the application name and the path within that application.\n\n  * `:cache_static_manifest_latest` - a map of the static files pointing to their\n    digest version. This is automatically loaded from `cache_static_manifest` on\n    boot. However, if you have your own static handling mechanism, you may want to\n    set this value explicitly. This is used by projects such as `LiveView` to\n    detect if the client is running on the latest version of all assets.\n\n  * `:cache_manifest_skip_vsn` - when true, skips the appended query string\n    \"?vsn=d\" when generating paths to static assets. This query string is used\n    by `Plug.Static` to set long expiry dates, therefore, you should set this\n    option to true only if you are not using `Plug.Static` to serve assets,\n    for example, if you are using a CDN. If you are setting this option, you\n    should also consider passing `--no-vsn` to `mix phx.digest`. Defaults to\n    `false`.\n\n  * `:check_origin` - configure the default `:check_origin` setting for\n    transports. See `socket/3` for options. Defaults to `true`.\n\n  * `:secret_key_base` - a secret key used as a base to generate secrets\n    for encrypting and signing data. For example, cookies and tokens\n    are signed by default, but they may also be encrypted if desired.\n    Defaults to `nil` as it must be set per application\n\n  * `:server` - when `true`, starts the web server when the endpoint\n    supervision tree starts. Defaults to `false`. The `mix phx.server`\n    task automatically sets this to `true`\n\n  * `:url` - configuration for generating URLs throughout the app.\n    Accepts the `:host`, `:scheme`, `:path` and `:port` options. All\n    keys except `:path` can be changed at runtime. Defaults to:\n\n        [host: \"localhost\", path: \"/\"]\n\n    The `:port` option requires either an integer or string. The `:host`\n    option requires a string.\n\n    The `:scheme` option accepts `\"http\"` and `\"https\"` values. Default value\n    is inferred from top level `:http` or `:https` option. It is useful\n    when hosting Phoenix behind a load balancer or reverse proxy and\n    terminating SSL there.\n\n    The `:path` option can be used to override root path. Useful when hosting\n    Phoenix behind a reverse proxy with URL rewrite rules\n\n  * `:static_url` - configuration for generating URLs for static files.\n    It will fallback to `url` if no option is provided. Accepts the same\n    options as `url`\n\n  * `:watchers` - a set of watchers to run alongside your server. It\n    expects a list of tuples containing the executable and its arguments.\n    Watchers are guaranteed to run in the application directory, but only\n    when the server is enabled (unless `:force_watchers` configuration is\n    set to `true`). For example, the watcher below will run the \"watch\" mode\n    of the webpack build tool when the server starts. You can configure it\n    to whatever build tool or command you want:\n\n        [\n          node: [\n            \"node_modules/webpack/bin/webpack.js\",\n            \"--mode\",\n            \"development\",\n            \"--watch\",\n            \"--watch-options-stdin\"\n          ]\n        ]\n\n    The `:cd` and `:env` options can be given at the end of the list to customize\n    the watcher:\n\n        [node: [..., cd: \"assets\", env: [{\"TAILWIND_MODE\", \"watch\"}]]]\n\n    A watcher can also be a module-function-args tuple that will be invoked accordingly:\n\n        [another: {Mod, :fun, [arg1, arg2]}]\n\n  * `:force_watchers` - when `true`, forces your watchers to start\n    even when the `:server` option is set to `false`.\n\n  * `:live_reload` - configuration for the live reload option.\n    Configuration requires a `:patterns` option which should be a list of\n    file patterns to watch. When these files change, it will trigger a reload.\n\n        live_reload: [\n          url: \"ws://localhost:4000\",\n          patterns: [\n            ~r\"priv/static/(?!uploads/).*(js|css|png|jpeg|jpg|gif|svg)$\",\n            ~r\"lib/app_web/(live|views)/.*(ex)$\",\n            ~r\"lib/app_web/templates/.*(eex)$\"\n          ]\n        ]\n\n  * `:pubsub_server` - the name of the pubsub server to use in channels\n    and via the Endpoint broadcast functions. The PubSub server is typically\n    started in your supervision tree.\n\n  * `:render_errors` - responsible for rendering templates whenever there\n    is a failure in the application. For example, if the application crashes\n    with a 500 error during a HTML request, `render(\"500.html\", assigns)`\n    will be called in the view given to `:render_errors`.\n    A `:formats` list can be provided to specify a module per format to handle\n    error rendering. Example:\n\n        [formats: [html: MyApp.ErrorHTML], layout: false, log: :debug]\n\n  * `:log_access_url` - log the access url once the server boots\n\nNote that you can also store your own configurations in the Phoenix.Endpoint.\nFor example, [Phoenix LiveView](https://hexdocs.pm/phoenix_live_view) expects\nits own configuration under the `:live_view` key. In such cases, you should\nconsult the documentation of the respective projects.","ref":"Phoenix.Endpoint.html#module-runtime-configuration"},{"type":"behaviour","title":"Adapter configuration - Phoenix.Endpoint","doc":"Phoenix allows you to choose which webserver adapter to use. Newly generated\napplications created via the `phx.new` Mix task use the\n[`Bandit`](https://github.com/mtrudel/bandit) webserver via the\n`Bandit.PhoenixAdapter` adapter. If not otherwise specified via the `adapter`\noption Phoenix will fall back to the `Phoenix.Endpoint.Cowboy2Adapter` for\nbackwards compatibility with applications generated prior to Phoenix 1.7.8.\n\nBoth adapters can be configured in a similar manner using the following two\ntop-level options:\n\n  * `:http` - the configuration for the HTTP server. It accepts all options\n    as defined by either [`Bandit`](https://hexdocs.pm/bandit/Bandit.html#t:options/0)\n    or [`Plug.Cowboy`](https://hexdocs.pm/plug_cowboy/) depending on your\n    choice of adapter. Defaults to `false`\n\n  * `:https` - the configuration for the HTTPS server. It accepts all options\n    as defined by either [`Bandit`](https://hexdocs.pm/bandit/Bandit.html#t:options/0)\n    or [`Plug.Cowboy`](https://hexdocs.pm/plug_cowboy/) depending on your\n    choice of adapter. Defaults to `false`\n\nIn addition, the connection draining can be configured for the Cowboy webserver via the following\ntop-level option (this is not required for Bandit as it has connection draining built-in):\n\n  * `:drainer` - a drainer process waits for any on-going request to finish\n    during application shutdown. It accepts the `:shutdown` and\n    `:check_interval` options as defined by `Plug.Cowboy.Drainer`.\n    Note the draining does not terminate any existing connection, it simply\n    waits for them to finish. Socket connections run their own drainer\n    before this one is invoked. That's because sockets are stateful and\n    can be gracefully notified, which allows us to stagger them over a\n    longer period of time. See the documentation for `socket/3` for more\n    information","ref":"Phoenix.Endpoint.html#module-adapter-configuration"},{"type":"behaviour","title":"Endpoint API - Phoenix.Endpoint","doc":"In the previous section, we have used the `c:config/2` function that is\nautomatically generated in your endpoint. Here's a list of all the functions\nthat are automatically defined in your endpoint:\n\n  * for handling paths and URLs: `c:struct_url/0`, `c:url/0`, `c:path/1`,\n    `c:static_url/0`,`c:static_path/1`, and `c:static_integrity/1`\n\n  * for gathering runtime information about the address and port the\n    endpoint is running on: `c:server_info/1`\n\n  * for broadcasting to channels: `c:broadcast/3`, `c:broadcast!/3`,\n    `c:broadcast_from/4`, `c:broadcast_from!/4`, `c:local_broadcast/3`,\n    and `c:local_broadcast_from/4`\n\n  * for configuration: `c:start_link/1`, `c:config/2`, and `c:config_change/2`\n\n  * as required by the `Plug` behaviour: `c:Plug.init/1` and `c:Plug.call/2`","ref":"Phoenix.Endpoint.html#module-endpoint-api"},{"type":"callback","title":"Phoenix.Endpoint.broadcast/3","doc":"Broadcasts a `msg` as `event` in the given `topic` to all nodes.","ref":"Phoenix.Endpoint.html#c:broadcast/3"},{"type":"callback","title":"Phoenix.Endpoint.broadcast!/3","doc":"Broadcasts a `msg` as `event` in the given `topic` to all nodes.\n\nRaises in case of failures.","ref":"Phoenix.Endpoint.html#c:broadcast!/3"},{"type":"callback","title":"Phoenix.Endpoint.broadcast_from/4","doc":"Broadcasts a `msg` from the given `from` as `event` in the given `topic` to all nodes.","ref":"Phoenix.Endpoint.html#c:broadcast_from/4"},{"type":"callback","title":"Phoenix.Endpoint.broadcast_from!/4","doc":"Broadcasts a `msg` from the given `from` as `event` in the given `topic` to all nodes.\n\nRaises in case of failures.","ref":"Phoenix.Endpoint.html#c:broadcast_from!/4"},{"type":"callback","title":"Phoenix.Endpoint.config/2","doc":"Access the endpoint configuration given by key.","ref":"Phoenix.Endpoint.html#c:config/2"},{"type":"callback","title":"Phoenix.Endpoint.config_change/2","doc":"Reload the endpoint configuration on application upgrades.","ref":"Phoenix.Endpoint.html#c:config_change/2"},{"type":"callback","title":"Phoenix.Endpoint.host/0","doc":"Returns the host from the :url configuration.","ref":"Phoenix.Endpoint.html#c:host/0"},{"type":"callback","title":"Phoenix.Endpoint.local_broadcast/3","doc":"Broadcasts a `msg` as `event` in the given `topic` within the current node.","ref":"Phoenix.Endpoint.html#c:local_broadcast/3"},{"type":"callback","title":"Phoenix.Endpoint.local_broadcast_from/4","doc":"Broadcasts a `msg` from the given `from` as `event` in the given `topic` within the current node.","ref":"Phoenix.Endpoint.html#c:local_broadcast_from/4"},{"type":"callback","title":"Phoenix.Endpoint.path/1","doc":"Generates the path information when routing to this endpoint.","ref":"Phoenix.Endpoint.html#c:path/1"},{"type":"callback","title":"Phoenix.Endpoint.script_name/0","doc":"Returns the script name from the :url configuration.","ref":"Phoenix.Endpoint.html#c:script_name/0"},{"type":"function","title":"Phoenix.Endpoint.server?/2","doc":"Checks if Endpoint's web server has been configured to start.\n\n  * `otp_app` - The OTP app running the endpoint, for example `:my_app`\n  * `endpoint` - The endpoint module, for example `MyAppWeb.Endpoint`","ref":"Phoenix.Endpoint.html#server?/2"},{"type":"function","title":"Examples - Phoenix.Endpoint.server?/2","doc":"iex> Phoenix.Endpoint.server?(:my_app, MyAppWeb.Endpoint)\n    true","ref":"Phoenix.Endpoint.html#server?/2-examples"},{"type":"callback","title":"Phoenix.Endpoint.server_info/1","doc":"Returns the address and port that the server is running on","ref":"Phoenix.Endpoint.html#c:server_info/1"},{"type":"macro","title":"Phoenix.Endpoint.socket/3","doc":"Defines a websocket/longpoll mount-point for a `socket`.\n\nIt expects a `path`, a `socket` module, and a set of options.\nThe socket module is typically defined with `Phoenix.Socket`.\n\nBoth websocket and longpolling connections are supported out\nof the box.","ref":"Phoenix.Endpoint.html#socket/3"},{"type":"macro","title":"Options - Phoenix.Endpoint.socket/3","doc":"* `:websocket` - controls the websocket configuration.\n    Defaults to `true`. May be false or a keyword list\n    of options. See [\"Common configuration\"](#socket/3-common-configuration)\n    and [\"WebSocket configuration\"](#socket/3-websocket-configuration)\n    for the whole list\n\n  * `:longpoll` - controls the longpoll configuration.\n    Defaults to `false`. May be true or a keyword list\n    of options. See [\"Common configuration\"](#socket/3-common-configuration)\n    and [\"Longpoll configuration\"](#socket/3-longpoll-configuration)\n    for the whole list\n\n  * `:drainer` - a keyword list or a custom MFA function returning a keyword list, for example:\n\n        {MyAppWeb.Socket, :drainer_configuration, []}\n\n    configuring how to drain sockets on application shutdown.\n    The goal is to notify all channels (and\n    LiveViews) clients to reconnect. The supported options are:\n\n    * `:batch_size` - How many clients to notify at once in a given batch.\n      Defaults to 10000.\n    * `:batch_interval` - The amount of time in milliseconds given for a\n      batch to terminate. Defaults to 2000ms.\n    * `:shutdown` - The maximum amount of time in milliseconds allowed\n      to drain all batches. Defaults to 30000ms.\n\n    For example, if you have 150k connections, the default values will\n    split them into 15 batches of 10k connections. Each batch takes\n    2000ms before the next batch starts. In this case, we will do everything\n    right under the maximum shutdown time of 30000ms. Therefore, as\n    you increase the number of connections, remember to adjust the shutdown\n    accordingly. Finally, after the socket drainer runs, the lower level\n    HTTP/HTTPS connection drainer will still run, and apply to all connections.\n    Set it to `false` to disable draining.\n\nYou can also pass the options below on `use Phoenix.Socket`.\nThe values specified here override the value in `use Phoenix.Socket`.","ref":"Phoenix.Endpoint.html#socket/3-options"},{"type":"macro","title":"Examples - Phoenix.Endpoint.socket/3","doc":"socket \"/ws\", MyApp.UserSocket\n\n    socket \"/ws/admin\", MyApp.AdminUserSocket,\n      longpoll: true,\n      websocket: [compress: true]","ref":"Phoenix.Endpoint.html#socket/3-examples"},{"type":"macro","title":"Path params - Phoenix.Endpoint.socket/3","doc":"It is possible to include variables in the path, these will be\navailable in the `params` that are passed to the socket.\n\n    socket \"/ws/:user_id\", MyApp.UserSocket,\n      websocket: [path: \"/project/:project_id\"]","ref":"Phoenix.Endpoint.html#socket/3-path-params"},{"type":"macro","title":"Common configuration - Phoenix.Endpoint.socket/3","doc":"The configuration below can be given to both `:websocket` and\n`:longpoll` keys:\n\n  * `:path` - the path to use for the transport. Will default\n     to the transport name (\"/websocket\" or \"/longpoll\")\n\n  * `:serializer` - a list of serializers for messages. See\n    `Phoenix.Socket` for more information\n\n  * `:transport_log` - if the transport layer itself should log and,\n    if so, the level\n\n  * `:check_origin` - if the transport should check the origin of requests when\n    the `origin` header is present. May be `true`, `false`, a list of hosts that\n    are allowed, or a function provided as MFA tuple. Defaults to `:check_origin`\n    setting at endpoint configuration.\n\n    If `true`, the header is checked against `:host` in `YourAppWeb.Endpoint.config(:url)[:host]`.\n\n    If `false` and you do not validate the session in your socket, your app\n    is vulnerable to Cross-Site WebSocket Hijacking (CSWSH) attacks.\n    Only use in development, when the host is truly unknown or when\n    serving clients that do not send the `origin` header, such as mobile apps.\n\n    You can also specify a list of explicitly allowed origins. Wildcards are\n    supported.\n\n        check_origin: [\n          \"https://example.com\",\n          \"//another.com:888\",\n          \"//*.other.com\"\n        ]\n\n    Or to accept any origin matching the request connection's host, port, and scheme:\n\n        check_origin: :conn\n\n    Or a custom MFA function:\n\n        check_origin: {MyAppWeb.Auth, :my_check_origin?, []}\n\n    The MFA is invoked with the request `%URI{}` as the first argument,\n    followed by arguments in the MFA list, and must return a boolean.\n\n  * `:code_reloader` - enable or disable the code reloader. Defaults to your\n    endpoint configuration\n\n  * `:connect_info` - a list of keys that represent data to be copied from\n    the transport to be made available in the user socket `connect/3` callback.\n    See the \"Connect info\" subsection for valid keys","ref":"Phoenix.Endpoint.html#socket/3-common-configuration"},{"type":"macro","title":"Connect info - Phoenix.Endpoint.socket/3","doc":"The valid keys are:\n\n  * `:peer_data` - the result of `Plug.Conn.get_peer_data/1`\n\n  * `:trace_context_headers` - a list of all trace context headers. Supported\n    headers are defined by the [W3C Trace Context Specification](https://www.w3.org/TR/trace-context-1/).\n    These headers are necessary for libraries such as [OpenTelemetry](https://opentelemetry.io/)\n    to extract trace propagation information to know this request is part of a\n    larger trace in progress.\n\n  * `:x_headers` - all request headers that have an \"x-\" prefix\n\n  * `:uri` - a `%URI{}` with information from the conn\n\n  * `:user_agent` - the value of the \"user-agent\" request header\n\n  * `{:session, session_config}` - the session information from `Plug.Conn`.\n    The `session_config` is typically an exact copy of the arguments given\n    to `Plug.Session`. In order to validate the session, the \"_csrf_token\"\n    must be given as request parameter when connecting the socket with the\n    value of `URI.encode_www_form(Plug.CSRFProtection.get_csrf_token())`.\n    The CSRF token request parameter can be modified via the `:csrf_token_key`\n    option.\n\n    Additionally, `session_config` may be a MFA, such as\n    `{MyAppWeb.Auth, :get_session_config, []}`, to allow loading config in\n    runtime.\n\nArbitrary keywords may also appear following the above valid keys, which\nis useful for passing custom connection information to the socket.\n\nFor example:\n\n```\n  socket \"/socket\", AppWeb.UserSocket,\n      websocket: [\n        connect_info: [:peer_data, :trace_context_headers, :x_headers, :uri, session: [store: :cookie]]\n      ]\n```\n\nWith arbitrary keywords:\n\n```\n  socket \"/socket\", AppWeb.UserSocket,\n      websocket: [\n        connect_info: [:uri, custom_value: \"abcdef\"]\n      ]\n```\n\n> #### Where are my headers? {: .tip}\n>\n> Phoenix only gives you limited access to the connection headers for security\n> reasons. WebSockets are cross-domain, which means that, when a user \"John Doe\"\n> visits a malicious website, the malicious website can open up a WebSocket\n> connection to your application, and the browser will gladly submit John Doe's\n> authentication/cookie information. If you were to accept this information as is,\n> the malicious website would have full control of a WebSocket connection to your\n> application, authenticated on John Doe's behalf.\n>\n> To safe-guard your application, Phoenix limits and validates the connection\n> information your socket can access. This means your application is safe from\n> these attacks, but you can't access cookies and other headers in your socket.\n> You may access the session stored in the connection via the `:connect_info`\n> option, provided you also pass a csrf token when connecting over WebSocket.","ref":"Phoenix.Endpoint.html#socket/3-connect-info"},{"type":"macro","title":"Websocket configuration - Phoenix.Endpoint.socket/3","doc":"The following configuration applies only to `:websocket`.\n\n  * `:timeout` - the timeout for keeping websocket connections\n    open after it last received data, defaults to 60_000ms\n\n  * `:max_frame_size` - the maximum allowed frame size in bytes,\n    defaults to \"infinity\"\n\n  * `:fullsweep_after` - the maximum number of garbage collections\n    before forcing a fullsweep for the socket process. You can set\n    it to `0` to force more frequent cleanups of your websocket\n    transport processes. Setting this option requires Erlang/OTP 24\n\n  * `:compress` - whether to enable per message compression on\n    all data frames, defaults to false\n\n  * `:subprotocols` - a list of supported websocket subprotocols.\n    Used for handshake `Sec-WebSocket-Protocol` response header, defaults to nil.\n\n    For example:\n\n        subprotocols: [\"sip\", \"mqtt\"]\n\n  * `:error_handler` - custom error handler for connection errors.\n    If `c:Phoenix.Socket.connect/3` returns an `{:error, reason}` tuple,\n    the error handler will be called with the error reason. For WebSockets,\n    the error handler must be a MFA tuple that receives a `Plug.Conn`, the\n    error reason, and returns a `Plug.Conn` with a response. For example:\n\n        socket \"/socket\", MySocket,\n            websocket: [\n              error_handler: {MySocket, :handle_error, []}\n            ]\n\n    and a `{:error, :rate_limit}` return may be handled on `MySocket` as:\n\n        def handle_error(conn, :rate_limit), do: Plug.Conn.send_resp(conn, 429, \"Too many requests\")","ref":"Phoenix.Endpoint.html#socket/3-websocket-configuration"},{"type":"macro","title":"Longpoll configuration - Phoenix.Endpoint.socket/3","doc":"The following configuration applies only to `:longpoll`:\n\n  * `:window_ms` - how long the client can wait for new messages\n    in its poll request in milliseconds (ms). Defaults to `10_000`.\n\n  * `:pubsub_timeout_ms` - how long a request can wait for the\n    pubsub layer to respond in milliseconds (ms). Defaults to `2000`.\n\n  * `:crypto` - options for verifying and signing the token, accepted\n    by `Phoenix.Token`. By default tokens are valid for 2 weeks","ref":"Phoenix.Endpoint.html#socket/3-longpoll-configuration"},{"type":"callback","title":"Phoenix.Endpoint.start_link/1","doc":"Starts the endpoint supervision tree.\n\nStarts endpoint's configuration cache and possibly the servers for\nhandling requests.","ref":"Phoenix.Endpoint.html#c:start_link/1"},{"type":"callback","title":"Phoenix.Endpoint.static_integrity/1","doc":"Generates an integrity hash to a static file in `priv/static`.","ref":"Phoenix.Endpoint.html#c:static_integrity/1"},{"type":"callback","title":"Phoenix.Endpoint.static_lookup/1","doc":"Generates a two item tuple containing the `static_path` and `static_integrity`.","ref":"Phoenix.Endpoint.html#c:static_lookup/1"},{"type":"callback","title":"Phoenix.Endpoint.static_path/1","doc":"Generates a route to a static file in `priv/static`.","ref":"Phoenix.Endpoint.html#c:static_path/1"},{"type":"callback","title":"Phoenix.Endpoint.static_url/0","doc":"Generates the static URL without any path information.","ref":"Phoenix.Endpoint.html#c:static_url/0"},{"type":"callback","title":"Phoenix.Endpoint.struct_url/0","doc":"Generates the endpoint base URL, but as a `URI` struct.","ref":"Phoenix.Endpoint.html#c:struct_url/0"},{"type":"callback","title":"Phoenix.Endpoint.subscribe/2","doc":"Subscribes the caller to the given topic.\n\nSee `Phoenix.PubSub.subscribe/3` for options.","ref":"Phoenix.Endpoint.html#c:subscribe/2"},{"type":"callback","title":"Phoenix.Endpoint.unsubscribe/1","doc":"Unsubscribes the caller from the given topic.","ref":"Phoenix.Endpoint.html#c:unsubscribe/1"},{"type":"callback","title":"Phoenix.Endpoint.url/0","doc":"Generates the endpoint base URL without any path information.","ref":"Phoenix.Endpoint.html#c:url/0"},{"type":"type","title":"Phoenix.Endpoint.event/0","doc":"","ref":"Phoenix.Endpoint.html#t:event/0"},{"type":"type","title":"Phoenix.Endpoint.msg/0","doc":"","ref":"Phoenix.Endpoint.html#t:msg/0"},{"type":"type","title":"Phoenix.Endpoint.topic/0","doc":"","ref":"Phoenix.Endpoint.html#t:topic/0"},{"type":"module","title":"Phoenix.Flash","doc":"Provides shared flash access.","ref":"Phoenix.Flash.html"},{"type":"function","title":"Phoenix.Flash.get/2","doc":"Gets the key from the map of flash data.","ref":"Phoenix.Flash.html#get/2"},{"type":"function","title":"Examples - Phoenix.Flash.get/2","doc":"<%= Phoenix.Flash.get(@flash, :info) %> \n     <%= Phoenix.Flash.get(@flash, :error) %>","ref":"Phoenix.Flash.html#get/2-examples"},{"type":"module","title":"Phoenix.Logger","doc":"Instrumenter to handle logging of various instrumentation events.","ref":"Phoenix.Logger.html"},{"type":"module","title":"Instrumentation - Phoenix.Logger","doc":"Phoenix uses the `:telemetry` library for instrumentation. The following events\nare published by Phoenix with the following measurements and metadata:\n\n  * `[:phoenix, :endpoint, :init]` - dispatched by `Phoenix.Endpoint` after your\n    Endpoint supervision tree successfully starts\n    * Measurement: `%{system_time: system_time}`\n    * Metadata: `%{pid: pid(), config: Keyword.t(), module: module(), otp_app: atom()}`\n    * Disable logging: This event is not logged\n\n  * `[:phoenix, :endpoint, :start]` - dispatched by `Plug.Telemetry` in your endpoint,\n    usually after code reloading\n    * Measurement: `%{system_time: system_time}`\n    * Metadata: `%{conn: Plug.Conn.t, options: Keyword.t}`\n    * Options: `%{log: Logger.level | false}`\n    * Disable logging: In your endpoint `plug Plug.Telemetry, ..., log: Logger.level | false`\n    * Configure log level dynamically: `plug Plug.Telemetry, ..., log: {Mod, Fun, Args}`\n\n  * `[:phoenix, :endpoint, :stop]` - dispatched by `Plug.Telemetry` in your\n    endpoint whenever the response is sent\n    * Measurement: `%{duration: native_time}`\n    * Metadata: `%{conn: Plug.Conn.t, options: Keyword.t}`\n    * Options: `%{log: Logger.level | false}`\n    * Disable logging: In your endpoint `plug Plug.Telemetry, ..., log: Logger.level | false`\n    * Configure log level dynamically: `plug Plug.Telemetry, ..., log: {Mod, Fun, Args}`\n\n  * `[:phoenix, :router_dispatch, :start]` - dispatched by `Phoenix.Router`\n    before dispatching to a matched route\n    * Measurement: `%{system_time: System.system_time}`\n    * Metadata: `%{conn: Plug.Conn.t, route: binary, plug: module, plug_opts: term, path_params: map, pipe_through: [atom], log: Logger.level | false}`\n    * Disable logging: Pass `log: false` to the router macro, for example: `get(\"/page\", PageController, :index, log: false)`\n    * Configure log level dynamically: `get(\"/page\", PageController, :index, log: {Mod, Fun, Args})`\n\n  * `[:phoenix, :router_dispatch, :exception]` - dispatched by `Phoenix.Router`\n    after exceptions on dispatching a route\n    * Measurement: `%{duration: native_time}`\n    * Metadata: `%{conn: Plug.Conn.t, kind: :throw | :error | :exit, reason: term(), stacktrace: Exception.stacktrace()}`\n    * Disable logging: This event is not logged\n\n  * `[:phoenix, :router_dispatch, :stop]` - dispatched by `Phoenix.Router`\n    after successfully dispatching a matched route\n    * Measurement: `%{duration: native_time}`\n    * Metadata: `%{conn: Plug.Conn.t, route: binary, plug: module, plug_opts: term, path_params: map, pipe_through: [atom], log: Logger.level | false}`\n    * Disable logging: This event is not logged\n\n  * `[:phoenix, :error_rendered]` - dispatched at the end of an error view being rendered\n    * Measurement: `%{duration: native_time}`\n    * Metadata: `%{conn: Plug.Conn.t, status: Plug.Conn.status, kind: Exception.kind, reason: term, stacktrace: Exception.stacktrace}`\n    * Disable logging: Set `render_errors: [log: false]` on your endpoint configuration\n\n  * `[:phoenix, :socket_connected]` - dispatched by `Phoenix.Socket`, at the end of a socket connection\n    * Measurement: `%{duration: native_time}`\n    * Metadata: `%{endpoint: atom, transport: atom, params: term, connect_info: map, vsn: binary, user_socket: atom, result: :ok | :error, serializer: atom, log: Logger.level | false}`\n    * Disable logging: `use Phoenix.Socket, log: false` or `socket \"/foo\", MySocket, websocket: [log: false]` in your endpoint\n\n  * `[:phoenix, :channel_joined]` - dispatched at the end of a channel join\n    * Measurement: `%{duration: native_time}`\n    * Metadata: `%{result: :ok | :error, params: term, socket: Phoenix.Socket.t}`\n    * Disable logging: This event cannot be disabled\n\n  * `[:phoenix, :channel_handled_in]` - dispatched at the end of a channel handle in\n    * Measurement: `%{duration: native_time}`\n    * Metadata: `%{event: binary, params: term, socket: Phoenix.Socket.t}`\n    * Disable logging: This event cannot be disabled\n\nTo see an example of how Phoenix LiveDashboard uses these events to create\nmetrics, visit  .","ref":"Phoenix.Logger.html#module-instrumentation"},{"type":"module","title":"Parameter filtering - Phoenix.Logger","doc":"When logging parameters, Phoenix can filter out sensitive parameters\nsuch as passwords and tokens. Parameters to be filtered can be\nadded via the `:filter_parameters` option:\n\n    config :phoenix, :filter_parameters, [\"password\", \"secret\"]\n\nWith the configuration above, Phoenix will filter any parameter\nthat contains the terms `password` or `secret`. The match is\ncase sensitive.\n\nPhoenix's default is `[\"password\"]`.\n\nPhoenix can filter all parameters by default and selectively keep\nparameters. This can be configured like so:\n\n    config :phoenix, :filter_parameters, {:keep, [\"id\", \"order\"]}\n\nWith the configuration above, Phoenix will filter all parameters,\nexcept those that match exactly `id` or `order`. If a kept parameter\nmatches, all parameters nested under that one will also be kept.","ref":"Phoenix.Logger.html#module-parameter-filtering"},{"type":"module","title":"Dynamic log level - Phoenix.Logger","doc":"In some cases you may wish to set the log level dynamically\non a per-request basis. To do so, set the `:log` option to\na tuple, `{Mod, Fun, Args}`. The `Plug.Conn.t()` for the\nrequest will be prepended to the provided list of arguments.\n\nWhen invoked, your function must return a\n[`Logger.level()`](`t:Logger.level()/0`) or `false` to\ndisable logging for the request.\n\nFor example, in your Endpoint you might do something like this:\n\n      # lib/my_app_web/endpoint.ex\n      plug Plug.Telemetry,\n        event_prefix: [:phoenix, :endpoint],\n        log: {__MODULE__, :log_level, []}\n\n      # Disables logging for routes like /status/*\n      def log_level(%{path_info: [\"status\" | _]}), do: false\n      def log_level(_), do: :info","ref":"Phoenix.Logger.html#module-dynamic-log-level"},{"type":"module","title":"Disabling - Phoenix.Logger","doc":"When you are using custom logging system it is not always desirable to enable\n`Phoenix.Logger` by default. You can always disable this in general by:\n\n    config :phoenix, :logger, false","ref":"Phoenix.Logger.html#module-disabling"},{"type":"module","title":"Phoenix.Naming","doc":"Conveniences for inflecting and working with names in Phoenix.","ref":"Phoenix.Naming.html"},{"type":"function","title":"Phoenix.Naming.camelize/1","doc":"Converts a string to camel case.\n\nTakes an optional `:lower` flag to return lowerCamelCase.","ref":"Phoenix.Naming.html#camelize/1"},{"type":"function","title":"Examples - Phoenix.Naming.camelize/1","doc":"iex> Phoenix.Naming.camelize(\"my_app\")\n    \"MyApp\"\n\n    iex> Phoenix.Naming.camelize(\"my_app\", :lower)\n    \"myApp\"\n\nIn general, `camelize` can be thought of as the reverse of\n`underscore`, however, in some cases formatting may be lost:\n\n    Phoenix.Naming.underscore \"SAPExample\"  #=> \"sap_example\"\n    Phoenix.Naming.camelize   \"sap_example\" #=> \"SapExample\"","ref":"Phoenix.Naming.html#camelize/1-examples"},{"type":"function","title":"Phoenix.Naming.camelize/2","doc":"","ref":"Phoenix.Naming.html#camelize/2"},{"type":"function","title":"Phoenix.Naming.humanize/1","doc":"Converts an attribute/form field into its humanize version.","ref":"Phoenix.Naming.html#humanize/1"},{"type":"function","title":"Examples - Phoenix.Naming.humanize/1","doc":"iex> Phoenix.Naming.humanize(:username)\n    \"Username\"\n    iex> Phoenix.Naming.humanize(:created_at)\n    \"Created at\"\n    iex> Phoenix.Naming.humanize(\"user_id\")\n    \"User\"","ref":"Phoenix.Naming.html#humanize/1-examples"},{"type":"function","title":"Phoenix.Naming.resource_name/2","doc":"Extracts the resource name from an alias.","ref":"Phoenix.Naming.html#resource_name/2"},{"type":"function","title":"Examples - Phoenix.Naming.resource_name/2","doc":"iex> Phoenix.Naming.resource_name(MyApp.User)\n    \"user\"\n\n    iex> Phoenix.Naming.resource_name(MyApp.UserView, \"View\")\n    \"user\"","ref":"Phoenix.Naming.html#resource_name/2-examples"},{"type":"function","title":"Phoenix.Naming.underscore/1","doc":"Converts a string to underscore case.","ref":"Phoenix.Naming.html#underscore/1"},{"type":"function","title":"Examples - Phoenix.Naming.underscore/1","doc":"iex> Phoenix.Naming.underscore(\"MyApp\")\n    \"my_app\"\n\nIn general, `underscore` can be thought of as the reverse of\n`camelize`, however, in some cases formatting may be lost:\n\n    Phoenix.Naming.underscore \"SAPExample\"  #=> \"sap_example\"\n    Phoenix.Naming.camelize   \"sap_example\" #=> \"SapExample\"","ref":"Phoenix.Naming.html#underscore/1-examples"},{"type":"function","title":"Phoenix.Naming.unsuffix/2","doc":"Removes the given suffix from the name if it exists.","ref":"Phoenix.Naming.html#unsuffix/2"},{"type":"function","title":"Examples - Phoenix.Naming.unsuffix/2","doc":"iex> Phoenix.Naming.unsuffix(\"MyApp.User\", \"View\")\n    \"MyApp.User\"\n\n    iex> Phoenix.Naming.unsuffix(\"MyApp.UserView\", \"View\")\n    \"MyApp.User\"","ref":"Phoenix.Naming.html#unsuffix/2-examples"},{"type":"protocol","title":"Phoenix.Param","doc":"A protocol that converts data structures into URL parameters.\n\nThis protocol is used by URL helpers and other parts of the\nPhoenix stack. For example, when you write:\n\n    user_path(conn, :edit, @user)\n\nPhoenix knows how to extract the `:id` from `@user` thanks\nto this protocol.\n\nBy default, Phoenix implements this protocol for integers, binaries, atoms,\nand structs. For structs, a key `:id` is assumed, but you may provide a\nspecific implementation.\n\nNil values cannot be converted to param.","ref":"Phoenix.Param.html"},{"type":"protocol","title":"Custom parameters - Phoenix.Param","doc":"In order to customize the parameter for any struct,\none can simply implement this protocol.\n\nHowever, for convenience, this protocol can also be\nderivable. For example:\n\n    defmodule User do\n      @derive Phoenix.Param\n      defstruct [:id, :username]\n    end\n\nBy default, the derived implementation will also use\nthe `:id` key. In case the user does not contain an\n`:id` key, the key can be specified with an option:\n\n    defmodule User do\n      @derive {Phoenix.Param, key: :username}\n      defstruct [:username]\n    end\n\nwill automatically use `:username` in URLs.\n\nWhen using Ecto, you must call `@derive` before\nyour `schema` call:\n\n    @derive {Phoenix.Param, key: :username}\n    schema \"users\" do","ref":"Phoenix.Param.html#module-custom-parameters"},{"type":"function","title":"Phoenix.Param.to_param/1","doc":"","ref":"Phoenix.Param.html#to_param/1"},{"type":"type","title":"Phoenix.Param.t/0","doc":"All the types that implement this protocol.","ref":"Phoenix.Param.html#t:t/0"},{"type":"behaviour","title":"Phoenix.Presence","doc":"Provides Presence tracking to processes and channels.\n\nThis behaviour provides presence features such as fetching\npresences for a given topic, as well as handling diffs of\njoin and leave events as they occur in real-time. Using this\nmodule defines a supervisor and a module that implements the\n`Phoenix.Tracker` behaviour that uses `Phoenix.PubSub` to\nbroadcast presence updates.\n\nIn case you want to use only a subset of the functionality\nprovided by `Phoenix.Presence`, such as tracking processes\nbut without broadcasting updates, we recommend that you look\nat the `Phoenix.Tracker` functionality from the `phoenix_pubsub`\nproject.","ref":"Phoenix.Presence.html"},{"type":"behaviour","title":"Example Usage - Phoenix.Presence","doc":"Start by defining a presence module within your application\nwhich uses `Phoenix.Presence` and provide the `:otp_app` which\nholds your configuration, as well as the `:pubsub_server`.\n\n    defmodule MyAppWeb.Presence do\n      use Phoenix.Presence,\n        otp_app: :my_app,\n        pubsub_server: MyApp.PubSub\n    end\n\nThe `:pubsub_server` must point to an existing pubsub server\nrunning in your application, which is included by default as\n`MyApp.PubSub` for new applications.\n\nNext, add the new supervisor to your supervision tree in\n`lib/my_app/application.ex`. It must be after the PubSub child\nand before the endpoint:\n\n    children = [\n      ...\n      {Phoenix.PubSub, name: MyApp.PubSub},\n      MyAppWeb.Presence,\n      MyAppWeb.Endpoint\n    ]\n\nOnce added, presences can be tracked in your channel after joining:\n\n    defmodule MyAppWeb.MyChannel do\n      use MyAppWeb, :channel\n      alias MyAppWeb.Presence\n\n      def join(\"some:topic\", _params, socket) do\n        send(self(), :after_join)\n        {:ok, assign(socket, :user_id, ...)}\n      end\n\n      def handle_info(:after_join, socket) do\n        {:ok, _} = Presence.track(socket, socket.assigns.user_id, %{\n          online_at: inspect(System.system_time(:second))\n        })\n\n        push(socket, \"presence_state\", Presence.list(socket))\n        {:noreply, socket}\n      end\n    end\n\nIn the example above, `Presence.track` is used to register this channel's process as a\npresence for the socket's user ID, with a map of metadata.\nNext, the current presence information for\nthe socket's topic is pushed to the client as a `\"presence_state\"` event.\n\nFinally, a diff of presence join and leave events will be sent to the\nclient as they happen in real-time with the \"presence_diff\" event.\nThe diff structure will be a map of `:joins` and `:leaves` of the form:\n\n    %{\n      joins: %{\"123\" => %{metas: [%{status: \"away\", phx_ref: ...}]}},\n      leaves: %{\"456\" => %{metas: [%{status: \"online\", phx_ref: ...}]}}\n    },\n\nSee `c:list/1` for more information on the presence data structure.","ref":"Phoenix.Presence.html#module-example-usage"},{"type":"behaviour","title":"Fetching Presence Information - Phoenix.Presence","doc":"Presence metadata should be minimized and used to store small,\nephemeral state, such as a user's \"online\" or \"away\" status.\nMore detailed information, such as user details that need to be fetched\nfrom the database, can be achieved by overriding the `c:fetch/2` function.\n\nThe `c:fetch/2` callback is triggered when using `c:list/1` and on\nevery update, and it serves as a mechanism to fetch presence information\na single time, before broadcasting the information to all channel subscribers.\nThis prevents N query problems and gives you a single place to group\nisolated data fetching to extend presence metadata.\n\nThe function must return a map of data matching the outlined Presence\ndata structure, including the `:metas` key, but can extend the map of\ninformation to include any additional information. For example:\n\n    def fetch(_topic, presences) do\n      users = presences |> Map.keys() |> Accounts.get_users_map()\n\n      for {key, %{metas: metas}} <- presences, into: %{} do\n        {key, %{metas: metas, user: users[String.to_integer(key)]}}\n      end\n    end\n\nWhere `Account.get_users_map/1` could be implemented like:\n\n    def get_users_map(ids) do\n      query =\n        from u in User,\n          where: u.id in ^ids,\n          select: {u.id, u}\n\n      query |> Repo.all() |> Enum.into(%{})\n    end\n\nThe `fetch/2` function above fetches all users from the database who\nhave registered presences for the given topic. The presences\ninformation is then extended with a `:user` key of the user's\ninformation, while maintaining the required `:metas` field from the\noriginal presence data.","ref":"Phoenix.Presence.html#module-fetching-presence-information"},{"type":"behaviour","title":"Using Elixir as a Presence Client - Phoenix.Presence","doc":"Presence is great for external clients, such as JavaScript applications, but\nit can also be used from an Elixir client process to keep track of presence\nchanges as they happen on the server. This can be accomplished by implementing\nthe optional [`init/1`](`c:init/1`) and [`handle_metas/4`](`c:handle_metas/4`)\ncallbacks on your presence module. For example, the following callback\nreceives presence metadata changes, and broadcasts to other Elixir processes\nabout users joining and leaving:\n\n    defmodule MyApp.Presence do\n      use Phoenix.Presence,\n        otp_app: :my_app,\n        pubsub_server: MyApp.PubSub\n\n      def init(_opts) do\n        {:ok, %{}} # user-land state\n      end\n\n      def handle_metas(topic, %{joins: joins, leaves: leaves}, presences, state) do\n        # fetch existing presence information for the joined users and broadcast the\n        # event to all subscribers\n        for {user_id, presence} <- joins do\n          user_data = %{user: presence.user, metas: Map.fetch!(presences, user_id)}\n          msg = {MyApp.PresenceClient, {:join, user_data}}\n          Phoenix.PubSub.local_broadcast(MyApp.PubSub, topic, msg)\n        end\n\n        # fetch existing presence information for the left users and broadcast the\n        # event to all subscribers\n        for {user_id, presence} <- leaves do\n          metas =\n            case Map.fetch(presences, user_id) do\n              {:ok, presence_metas} -> presence_metas\n              :error -> []\n            end\n\n          user_data = %{user: presence.user, metas: metas}\n          msg = {MyApp.PresenceClient, {:leave, user_data}}\n          Phoenix.PubSub.local_broadcast(MyApp.PubSub, topic, msg)\n        end\n\n        {:ok, state}\n      end\n    end\n\nThe `handle_metas/4` callback receives the topic, presence diff, current presences\nfor the topic with their metadata, and any user-land state accumulated from init and\nsubsequent `handle_metas/4` calls. In our example implementation, we walk the `:joins` and\n`:leaves` in the diff, and populate a complete presence from our known presence information.\nThen we broadcast to the local node subscribers about user joins and leaves.","ref":"Phoenix.Presence.html#module-using-elixir-as-a-presence-client"},{"type":"behaviour","title":"Testing with Presence - Phoenix.Presence","doc":"Every time the `fetch` callback is invoked, it is done from a separate\nprocess. Given those processes run asynchronously, it is often necessary\nto guarantee they have been shutdown at the end of every test. This can\nbe done by using ExUnit's `on_exit` hook plus `fetchers_pids` function:\n\n    on_exit(fn ->\n      for pid <- MyAppWeb.Presence.fetchers_pids() do\n        ref = Process.monitor(pid)\n        assert_receive {:DOWN, ^ref, _, _, _}, 1000\n      end\n    end)","ref":"Phoenix.Presence.html#module-testing-with-presence"},{"type":"callback","title":"Phoenix.Presence.fetch/2","doc":"Extend presence information with additional data.\n\nWhen `c:list/1` is used to list all presences of the given `topic`, this\ncallback is triggered once to modify the result before it is broadcasted to\nall channel subscribers. This avoids N query problems and provides a single\nplace to extend presence metadata. You must return a map of data matching the\noriginal result, including the `:metas` key, but can extend the map to include\nany additional information.\n\nThe default implementation simply passes `presences` through unchanged.","ref":"Phoenix.Presence.html#c:fetch/2"},{"type":"callback","title":"Example - Phoenix.Presence.fetch/2","doc":"def fetch(_topic, presences) do\n      query =\n        from u in User,\n          where: u.id in ^Map.keys(presences),\n          select: {u.id, u}\n\n      users = query |> Repo.all() |> Enum.into(%{})\n      for {key, %{metas: metas}} <- presences, into: %{} do\n        {key, %{metas: metas, user: users[key]}}\n      end\n    end","ref":"Phoenix.Presence.html#c:fetch/2-example"},{"type":"callback","title":"Phoenix.Presence.get_by_key/2","doc":"Returns the map of presence metadata for a socket/topic-key pair.","ref":"Phoenix.Presence.html#c:get_by_key/2"},{"type":"callback","title":"Examples - Phoenix.Presence.get_by_key/2","doc":"Uses the same data format as each presence in `c:list/1`, but only\nreturns metadata for the presences under a topic and key pair. For example,\na user with key `\"user1\"`, connected to the same chat room `\"room:1\"` from two\ndevices, could return:\n\n    iex> MyPresence.get_by_key(\"room:1\", \"user1\")\n    [%{name: \"User 1\", metas: [%{device: \"Desktop\"}, %{device: \"Mobile\"}]}]\n\nLike `c:list/1`, the presence metadata is passed to the `fetch`\ncallback of your presence module to fetch any additional information.","ref":"Phoenix.Presence.html#c:get_by_key/2-examples"},{"type":"callback","title":"Phoenix.Presence.handle_metas/4","doc":"Receives presence metadata changes.","ref":"Phoenix.Presence.html#c:handle_metas/4"},{"type":"callback","title":"Phoenix.Presence.init/1","doc":"Initializes the presence client state.\n\nInvoked when your presence module starts, allows dynamically\nproviding initial state for handling presence metadata.","ref":"Phoenix.Presence.html#c:init/1"},{"type":"callback","title":"Phoenix.Presence.list/1","doc":"Returns presences for a socket/topic.","ref":"Phoenix.Presence.html#c:list/1"},{"type":"callback","title":"Presence data structure - Phoenix.Presence.list/1","doc":"The presence information is returned as a map with presences grouped\nby key, cast as a string, and accumulated metadata, with the following form:\n\n    %{key => %{metas: [%{phx_ref: ..., ...}, ...]}}\n\nFor example, imagine a user with id `123` online from two\ndifferent devices, as well as a user with id `456` online from\njust one device. The following presence information might be returned:\n\n    %{\"123\" => %{metas: [%{status: \"away\", phx_ref: ...},\n                         %{status: \"online\", phx_ref: ...}]},\n      \"456\" => %{metas: [%{status: \"online\", phx_ref: ...}]}}\n\nThe keys of the map will usually point to a resource ID. The value\nwill contain a map with a `:metas` key containing a list of metadata\nfor each resource. Additionally, every metadata entry will contain a\n`:phx_ref` key which can be used to uniquely identify metadata for a\ngiven key. In the event that the metadata was previously updated,\na `:phx_ref_prev` key will be present containing the previous\n`:phx_ref` value.","ref":"Phoenix.Presence.html#c:list/1-presence-data-structure"},{"type":"callback","title":"Phoenix.Presence.track/3","doc":"Track a channel's process as a presence.\n\nTracked presences are grouped by `key`, cast as a string. For example, to\ngroup each user's channels together, use user IDs as keys. Each presence can\nbe associated with a map of metadata to store small, ephemeral state, such as\na user's online status. To store detailed information, see `c:fetch/2`.","ref":"Phoenix.Presence.html#c:track/3"},{"type":"callback","title":"Example - Phoenix.Presence.track/3","doc":"alias MyApp.Presence\n    def handle_info(:after_join, socket) do\n      {:ok, _} = Presence.track(socket, socket.assigns.user_id, %{\n        online_at: inspect(System.system_time(:second))\n      })\n      {:noreply, socket}\n    end","ref":"Phoenix.Presence.html#c:track/3-example"},{"type":"callback","title":"Phoenix.Presence.track/4","doc":"Track an arbitrary process as a presence.\n\nSame with `track/3`, except track any process by `topic` and `key`.","ref":"Phoenix.Presence.html#c:track/4"},{"type":"callback","title":"Phoenix.Presence.untrack/2","doc":"Stop tracking a channel's process.","ref":"Phoenix.Presence.html#c:untrack/2"},{"type":"callback","title":"Phoenix.Presence.untrack/3","doc":"Stop tracking a process.","ref":"Phoenix.Presence.html#c:untrack/3"},{"type":"callback","title":"Phoenix.Presence.update/3","doc":"Update a channel presence's metadata.\n\nReplace a presence's metadata by passing a new map or a function that takes\nthe current map and returns a new one.","ref":"Phoenix.Presence.html#c:update/3"},{"type":"callback","title":"Phoenix.Presence.update/4","doc":"Update a process presence's metadata.\n\nSame as `update/3`, but with an arbitrary process.","ref":"Phoenix.Presence.html#c:update/4"},{"type":"type","title":"Phoenix.Presence.presence/0","doc":"","ref":"Phoenix.Presence.html#t:presence/0"},{"type":"type","title":"Phoenix.Presence.presences/0","doc":"","ref":"Phoenix.Presence.html#t:presences/0"},{"type":"type","title":"Phoenix.Presence.topic/0","doc":"","ref":"Phoenix.Presence.html#t:topic/0"},{"type":"module","title":"Phoenix.Router","doc":"Defines a Phoenix router.\n\nThe router provides a set of macros for generating routes\nthat dispatch to specific controllers and actions. Those\nmacros are named after HTTP verbs. For example:\n\n    defmodule MyAppWeb.Router do\n      use Phoenix.Router\n\n      get \"/pages/:page\", PageController, :show\n    end\n\nThe `get/3` macro above accepts a request to `/pages/hello` and dispatches\nit to `PageController`'s `show` action with `%{\"page\" => \"hello\"}` in\n`params`.\n\nPhoenix's router is extremely efficient, as it relies on Elixir\npattern matching for matching routes and serving requests.","ref":"Phoenix.Router.html"},{"type":"module","title":"Routing - Phoenix.Router","doc":"`get/3`, `post/3`, `put/3`, and other macros named after HTTP verbs are used\nto create routes.\n\nThe route:\n\n    get \"/pages\", PageController, :index\n\nmatches a `GET` request to `/pages` and dispatches it to the `index` action in\n`PageController`.\n\n    get \"/pages/:page\", PageController, :show\n\nmatches `/pages/hello` and dispatches to the `show` action with\n`%{\"page\" => \"hello\"}` in `params`.\n\n    defmodule PageController do\n      def show(conn, params) do\n        # %{\"page\" => \"hello\"} == params\n      end\n    end\n\nPartial and multiple segments can be matched. For example:\n\n    get \"/api/v:version/pages/:id\", PageController, :show\n\nmatches `/api/v1/pages/2` and puts `%{\"version\" => \"1\", \"id\" => \"2\"}` in\n`params`. Only the trailing part of a segment can be captured.\n\nRoutes are matched from top to bottom. The second route here:\n\n    get \"/pages/:page\", PageController, :show\n    get \"/pages/hello\", PageController, :hello\n\nwill never match `/pages/hello` because `/pages/:page` matches that first.\n\nRoutes can use glob-like patterns to match trailing segments.\n\n    get \"/pages/*page\", PageController, :show\n\nmatches `/pages/hello/world` and puts the globbed segments in `params[\"page\"]`.\n\n    GET /pages/hello/world\n    %{\"page\" => [\"hello\", \"world\"]} = params\n\nGlobs cannot have prefixes nor suffixes, but can be mixed with variables:\n\n    get \"/pages/he:page/*rest\", PageController, :show\n\nmatches\n\n    GET /pages/hello\n    %{\"page\" => \"llo\", \"rest\" => []} = params\n\n    GET /pages/hey/there/world\n    %{\"page\" => \"y\", \"rest\" => [\"there\" \"world\"]} = params\n\n> #### Why the macros? {: .info}\n>\n> Phoenix does its best to keep the usage of macros low. You may have noticed,\n> however, that the `Phoenix.Router` relies heavily on macros. Why is that?\n>\n> We use `get`, `post`, `put`, and `delete` to define your routes. We use macros\n> for two purposes:\n>\n> * They define the routing engine, used on every request, to choose which\n>   controller to dispatch the request to. Thanks to macros, Phoenix compiles\n>   all of your routes to a single case-statement with pattern matching rules,\n>   which is heavily optimized by the Erlang VM\n>\n> * For each route you define, we also define metadata to implement `Phoenix.VerifiedRoutes`.\n>   As we will soon learn, verified routes allows to us to reference any route\n>   as if it is a plain looking string, except it is verified by the compiler\n>   to be valid (making it much harder to ship broken links, forms, mails, etc\n>   to production)\n>\n> In other words, the router relies on macros to build applications that are\n> faster and safer. Also remember that macros in Elixir are compile-time only,\n> which gives plenty of stability after the code is compiled. Phoenix also provides\n> introspection for all defined routes via `mix phx.routes`.","ref":"Phoenix.Router.html#module-routing"},{"type":"module","title":"Generating routes - Phoenix.Router","doc":"For generating routes inside your application,  see the `Phoenix.VerifiedRoutes`\ndocumentation for `~p` based route generation which is the preferred way to\ngenerate route paths and URLs with compile-time verification.\n\nPhoenix also supports generating function helpers, which was the default\nmechanism in Phoenix v1.6 and earlier. We will explore it next.","ref":"Phoenix.Router.html#module-generating-routes"},{"type":"module","title":"Helpers (deprecated) - Phoenix.Router","doc":"Phoenix generates a module `Helpers` inside your router by default, which contains\nnamed helpers to help developers generate and keep their routes up to date.\nHelpers can be disabled by passing `helpers: false` to `use Phoenix.Router`.\n\nHelpers are automatically generated based on the controller name.\nFor example, the route:\n\n    get \"/pages/:page\", PageController, :show\n\nwill generate the following named helper:\n\n    MyAppWeb.Router.Helpers.page_path(conn_or_endpoint, :show, \"hello\")\n    \"/pages/hello\"\n\n    MyAppWeb.Router.Helpers.page_path(conn_or_endpoint, :show, \"hello\", some: \"query\")\n    \"/pages/hello?some=query\"\n\n    MyAppWeb.Router.Helpers.page_url(conn_or_endpoint, :show, \"hello\")\n    \"http://example.com/pages/hello\"\n\n    MyAppWeb.Router.Helpers.page_url(conn_or_endpoint, :show, \"hello\", some: \"query\")\n    \"http://example.com/pages/hello?some=query\"\n\nIf the route contains glob-like patterns, parameters for those have to be given as\nlist:\n\n    MyAppWeb.Router.Helpers.page_path(conn_or_endpoint, :show, [\"hello\", \"world\"])\n    \"/pages/hello/world\"\n\nThe URL generated in the named URL helpers is based on the configuration for\n`:url`, `:http` and `:https`. However, if for some reason you need to manually\ncontrol the URL generation, the url helpers also allow you to pass in a `URI`\nstruct:\n\n    uri = %URI{scheme: \"https\", host: \"other.example.com\"}\n    MyAppWeb.Router.Helpers.page_url(uri, :show, \"hello\")\n    \"https://other.example.com/pages/hello\"\n\nThe named helper can also be customized with the `:as` option. Given\nthe route:\n\n    get \"/pages/:page\", PageController, :show, as: :special_page\n\nthe named helper will be:\n\n    MyAppWeb.Router.Helpers.special_page_path(conn, :show, \"hello\")\n    \"/pages/hello\"","ref":"Phoenix.Router.html#module-helpers-deprecated"},{"type":"module","title":"Scopes and Resources - Phoenix.Router","doc":"It is very common in Phoenix applications to namespace all of your\nroutes under the application scope:\n\n    scope \"/\", MyAppWeb do\n      get \"/pages/:id\", PageController, :show\n    end\n\nThe route above will dispatch to `MyAppWeb.PageController`. This syntax\nis not only convenient for developers, since we don't have to repeat\nthe `MyAppWeb.` prefix on all routes, but it also allows Phoenix to put\nless pressure on the Elixir compiler. If instead we had written:\n\n    get \"/pages/:id\", MyAppWeb.PageController, :show\n\nThe Elixir compiler would infer that the router depends directly on\n`MyAppWeb.PageController`, which is not true. By using scopes, Phoenix\ncan properly hint to the Elixir compiler the controller is not an\nactual dependency of the router. This provides more efficient\ncompilation times.\n\nScopes allow us to scope on any path or even on the helper name:\n\n    scope \"/v1\", MyAppWeb, host: \"api.\" do\n      get \"/pages/:id\", PageController, :show\n    end\n\nFor example, the route above will match on the path `\"/api/v1/pages/1\"`\nand the named route will be `api_v1_page_path`, as expected from the\nvalues given to `scope/2` option.\n\nLike all paths you can define dynamic segments that will be applied as\nparameters in the controller:\n\n    scope \"/api/:version\", MyAppWeb do\n      get \"/pages/:id\", PageController, :show\n    end\n\nFor example, the route above will match on the path `\"/api/v1/pages/1\"`\nand in the controller the `params` argument will have a map with the\nkey `:version` with the value `\"v1\"`.\n\nPhoenix also provides a `resources/4` macro that allows developers\nto generate \"RESTful\" routes to a given resource:\n\n    defmodule MyAppWeb.Router do\n      use Phoenix.Router\n\n      resources \"/pages\", PageController, only: [:show]\n      resources \"/users\", UserController, except: [:delete]\n    end\n\nFinally, Phoenix ships with a `mix phx.routes` task that nicely\nformats all routes in a given router. We can use it to verify all\nroutes included in the router above:\n\n    $ mix phx.routes\n    page_path  GET    /pages/:id       PageController.show/2\n    user_path  GET    /users           UserController.index/2\n    user_path  GET    /users/:id/edit  UserController.edit/2\n    user_path  GET    /users/new       UserController.new/2\n    user_path  GET    /users/:id       UserController.show/2\n    user_path  POST   /users           UserController.create/2\n    user_path  PATCH  /users/:id       UserController.update/2\n               PUT    /users/:id       UserController.update/2\n\nOne can also pass a router explicitly as an argument to the task:\n\n    $ mix phx.routes MyAppWeb.Router\n\nCheck `scope/2` and `resources/4` for more information.","ref":"Phoenix.Router.html#module-scopes-and-resources"},{"type":"module","title":"Pipelines and plugs - Phoenix.Router","doc":"Once a request arrives at the Phoenix router, it performs\na series of transformations through pipelines until the\nrequest is dispatched to a desired route.\n\nSuch transformations are defined via plugs, as defined\nin the [Plug](https://github.com/elixir-lang/plug) specification.\nOnce a pipeline is defined, it can be piped through per scope.\n\nFor example:\n\n    defmodule MyAppWeb.Router do\n      use Phoenix.Router\n\n      pipeline :browser do\n        plug :fetch_session\n        plug :accepts, [\"html\"]\n      end\n\n      scope \"/\" do\n        pipe_through :browser\n\n        # browser related routes and resources\n      end\n    end\n\n`Phoenix.Router` imports functions from both `Plug.Conn` and `Phoenix.Controller`\nto help define plugs. In the example above, `fetch_session/2`\ncomes from `Plug.Conn` while `accepts/2` comes from `Phoenix.Controller`.\n\nNote that router pipelines are only invoked after a route is found.\nNo plug is invoked in case no matches were found.","ref":"Phoenix.Router.html#module-pipelines-and-plugs"},{"type":"module","title":"How to organize my routes? - Phoenix.Router","doc":"In Phoenix, we tend to define several pipelines, that provide specific\nfunctionality. For example, the `pipeline :browser` above includes plugs\nthat are common for all routes that are meant to be accessed by a browser.\nSimilarly, if you are also serving `:api` requests, you would have a separate\n`:api` pipeline that validates information specific to your endpoints.\n\nPerhaps more importantly, it is also very common to define pipelines specific\nto authentication and authorization. For example, you might have a pipeline\nthat requires all users are authenticated. Another pipeline may enforce only\nadmin users can access certain routes. Since routes are matched top to bottom,\nit is recommended to place the authenticated/authorized routes before the\nless restricted routes to ensure they are matched first.\n\nOnce your pipelines are defined, you reuse the pipelines in the desired\nscopes, grouping your routes around their pipelines. For example, imagine\nyou are building a blog. Anyone can read a post, but only authenticated\nusers can create them. Your routes could look like this:\n\n    pipeline :browser do\n      plug :fetch_session\n      plug :accepts, [\"html\"]\n    end\n\n    pipeline :auth do\n      plug :ensure_authenticated\n    end\n\n    scope \"/\" do\n      pipe_through [:browser, :auth]\n\n      get \"/posts/new\", PostController, :new\n      post \"/posts\", PostController, :create\n    end\n\n    scope \"/\" do\n      pipe_through [:browser]\n\n      get \"/posts\", PostController, :index\n      get \"/posts/:id\", PostController, :show\n    end\n\nNote in the above how the routes are split across different scopes.\nWhile the separation can be confusing at first, it has one big upside:\nit is very easy to inspect your routes and see all routes that, for\nexample, require authentication and which ones do not. This helps with\nauditing and making sure your routes have the proper scope.\n\nYou can create as few or as many scopes as you want. Because pipelines\nare reusable across scopes, they help encapsulate common functionality\nand you can compose them as necessary on each scope you define.","ref":"Phoenix.Router.html#module-how-to-organize-my-routes"},{"type":"macro","title":"Phoenix.Router.connect/4","doc":"Generates a route to handle a connect request to the given path.\n\n    connect(\"/events/:id\", EventController, :action)\n\nSee `match/5` for options.","ref":"Phoenix.Router.html#connect/4"},{"type":"macro","title":"Phoenix.Router.delete/4","doc":"Generates a route to handle a delete request to the given path.\n\n    delete(\"/events/:id\", EventController, :action)\n\nSee `match/5` for options.","ref":"Phoenix.Router.html#delete/4"},{"type":"macro","title":"Phoenix.Router.forward/4","doc":"Forwards a request at the given path to a plug.\n\nAll paths that match the forwarded prefix will be sent to\nthe forwarded plug. This is useful for sharing a router between\napplications or even breaking a big router into smaller ones.\nThe router pipelines will be invoked prior to forwarding the\nconnection.\n\nHowever, we don't advise forwarding to another endpoint.\nThe reason is that plugs defined by your app and the forwarded\nendpoint would be invoked twice, which may lead to errors.","ref":"Phoenix.Router.html#forward/4"},{"type":"macro","title":"Examples - Phoenix.Router.forward/4","doc":"scope \"/\", MyApp do\n      pipe_through [:browser, :admin]\n\n      forward \"/admin\", SomeLib.AdminDashboard\n      forward \"/api\", ApiRouter\n    end","ref":"Phoenix.Router.html#forward/4-examples"},{"type":"macro","title":"Phoenix.Router.get/4","doc":"Generates a route to handle a get request to the given path.\n\n    get(\"/events/:id\", EventController, :action)\n\nSee `match/5` for options.","ref":"Phoenix.Router.html#get/4"},{"type":"macro","title":"Phoenix.Router.head/4","doc":"Generates a route to handle a head request to the given path.\n\n    head(\"/events/:id\", EventController, :action)\n\nSee `match/5` for options.","ref":"Phoenix.Router.html#head/4"},{"type":"macro","title":"Phoenix.Router.match/5","doc":"Generates a route match based on an arbitrary HTTP method.\n\nUseful for defining routes not included in the built-in macros.\n\nThe catch-all verb, `:*`, may also be used to match all HTTP methods.","ref":"Phoenix.Router.html#match/5"},{"type":"macro","title":"Options - Phoenix.Router.match/5","doc":"* `:as` - configures the named helper. If `nil`, does not generate\n    a helper. Has no effect when using verified routes exclusively\n  * `:alias` - configure if the scope alias should be applied to the route.\n    Defaults to true, disables scoping if false.\n  * `:log` - the level to log the route dispatching under, may be set to false. Defaults to\n    `:debug`. Route dispatching contains information about how the route is handled (which controller\n    action is called, what parameters are available and which pipelines are used) and is separate from\n    the plug level logging. To alter the plug log level, please see\n    https://hexdocs.pm/phoenix/Phoenix.Logger.html#module-dynamic-log-level.\n  * `:private` - a map of private data to merge into the connection\n    when a route matches\n  * `:assigns` - a map of data to merge into the connection when a route matches\n  * `:metadata` - a map of metadata used by the telemetry events and returned by\n    `route_info/4`\n  * `:warn_on_verify` - the boolean for whether matches to this route trigger\n    an unmatched route warning for `Phoenix.VerifiedRoutes`. It is useful to ignore\n    an otherwise catch-all route definition from being matched when verifying routes.\n    Defaults `false`.","ref":"Phoenix.Router.html#match/5-options"},{"type":"macro","title":"Examples - Phoenix.Router.match/5","doc":"match(:move, \"/events/:id\", EventController, :move)\n\n    match(:*, \"/any\", SomeController, :any)","ref":"Phoenix.Router.html#match/5-examples"},{"type":"macro","title":"Phoenix.Router.options/4","doc":"Generates a route to handle a options request to the given path.\n\n    options(\"/events/:id\", EventController, :action)\n\nSee `match/5` for options.","ref":"Phoenix.Router.html#options/4"},{"type":"macro","title":"Phoenix.Router.patch/4","doc":"Generates a route to handle a patch request to the given path.\n\n    patch(\"/events/:id\", EventController, :action)\n\nSee `match/5` for options.","ref":"Phoenix.Router.html#patch/4"},{"type":"macro","title":"Phoenix.Router.pipe_through/1","doc":"Defines a list of plugs (and pipelines) to send the connection through.\n\nPlugs are specified using the atom name of any imported 2-arity function\nwhich takes a `%Plug.Conn{}` and options and returns a `%Plug.Conn{}`; for\nexample, `:require_authenticated_user`.\n\nPipelines are defined in the router; see `pipeline/2` for more information.\n\n    pipe_through [:my_imported_function, :my_pipeline]","ref":"Phoenix.Router.html#pipe_through/1"},{"type":"macro","title":"Phoenix.Router.pipeline/2","doc":"Defines a plug pipeline.\n\nPipelines are defined at the router root and can be used\nfrom any scope.","ref":"Phoenix.Router.html#pipeline/2"},{"type":"macro","title":"Examples - Phoenix.Router.pipeline/2","doc":"pipeline :api do\n      plug :token_authentication\n      plug :dispatch\n    end\n\nA scope may then use this pipeline as:\n\n    scope \"/\" do\n      pipe_through :api\n    end\n\nEvery time `pipe_through/1` is called, the new pipelines\nare appended to the ones previously given.","ref":"Phoenix.Router.html#pipeline/2-examples"},{"type":"macro","title":"Phoenix.Router.plug/2","doc":"Defines a plug inside a pipeline.\n\nSee `pipeline/2` for more information.","ref":"Phoenix.Router.html#plug/2"},{"type":"macro","title":"Phoenix.Router.post/4","doc":"Generates a route to handle a post request to the given path.\n\n    post(\"/events/:id\", EventController, :action)\n\nSee `match/5` for options.","ref":"Phoenix.Router.html#post/4"},{"type":"macro","title":"Phoenix.Router.put/4","doc":"Generates a route to handle a put request to the given path.\n\n    put(\"/events/:id\", EventController, :action)\n\nSee `match/5` for options.","ref":"Phoenix.Router.html#put/4"},{"type":"macro","title":"Phoenix.Router.resources/2","doc":"See `resources/4`.","ref":"Phoenix.Router.html#resources/2"},{"type":"macro","title":"Phoenix.Router.resources/3","doc":"See `resources/4`.","ref":"Phoenix.Router.html#resources/3"},{"type":"macro","title":"Phoenix.Router.resources/4","doc":"Defines \"RESTful\" routes for a resource.\n\nThe given definition:\n\n    resources \"/users\", UserController\n\nwill include routes to the following actions:\n\n  * `GET /users` => `:index`\n  * `GET /users/new` => `:new`\n  * `POST /users` => `:create`\n  * `GET /users/:id` => `:show`\n  * `GET /users/:id/edit` => `:edit`\n  * `PATCH /users/:id` => `:update`\n  * `PUT /users/:id` => `:update`\n  * `DELETE /users/:id` => `:delete`","ref":"Phoenix.Router.html#resources/4"},{"type":"macro","title":"Options - Phoenix.Router.resources/4","doc":"This macro accepts a set of options:\n\n  * `:only` - a list of actions to generate routes for, for example: `[:show, :edit]`\n  * `:except` - a list of actions to exclude generated routes from, for example: `[:delete]`\n  * `:param` - the name of the parameter for this resource, defaults to `\"id\"`\n  * `:name` - the prefix for this resource. This is used for the named helper\n    and as the prefix for the parameter in nested resources. The default value\n    is automatically derived from the controller name, i.e. `UserController` will\n    have name `\"user\"`\n  * `:as` - configures the named helper. If `nil`, does not generate\n    a helper. Has no effect when using verified routes exclusively\n  * `:singleton` - defines routes for a singleton resource that is looked up by\n    the client without referencing an ID. Read below for more information","ref":"Phoenix.Router.html#resources/4-options"},{"type":"macro","title":"Singleton resources - Phoenix.Router.resources/4","doc":"When a resource needs to be looked up without referencing an ID, because\nit contains only a single entry in the given context, the `:singleton`\noption can be used to generate a set of routes that are specific to\nsuch single resource:\n\n  * `GET /user` => `:show`\n  * `GET /user/new` => `:new`\n  * `POST /user` => `:create`\n  * `GET /user/edit` => `:edit`\n  * `PATCH /user` => `:update`\n  * `PUT /user` => `:update`\n  * `DELETE /user` => `:delete`\n\nUsage example:\n\n    resources \"/account\", AccountController, only: [:show], singleton: true","ref":"Phoenix.Router.html#resources/4-singleton-resources"},{"type":"macro","title":"Nested Resources - Phoenix.Router.resources/4","doc":"This macro also supports passing a nested block of route definitions.\nThis is helpful for nesting children resources within their parents to\ngenerate nested routes.\n\nThe given definition:\n\n    resources \"/users\", UserController do\n      resources \"/posts\", PostController\n    end\n\nwill include the following routes:\n\n    user_post_path  GET     /users/:user_id/posts           PostController :index\n    user_post_path  GET     /users/:user_id/posts/:id/edit  PostController :edit\n    user_post_path  GET     /users/:user_id/posts/new       PostController :new\n    user_post_path  GET     /users/:user_id/posts/:id       PostController :show\n    user_post_path  POST    /users/:user_id/posts           PostController :create\n    user_post_path  PATCH   /users/:user_id/posts/:id       PostController :update\n                    PUT     /users/:user_id/posts/:id       PostController :update\n    user_post_path  DELETE  /users/:user_id/posts/:id       PostController :delete","ref":"Phoenix.Router.html#resources/4-nested-resources"},{"type":"function","title":"Phoenix.Router.route_info/4","doc":"Returns the compile-time route info and runtime path params for a request.\n\nThe `path` can be either a string or the `path_info` segments.\n\nA map of metadata is returned with the following keys:\n\n  * `:log` - the configured log level. For example `:debug`\n  * `:path_params` - the map of runtime path params\n  * `:pipe_through` - the list of pipelines for the route's scope, for example `[:browser]`\n  * `:plug` - the plug to dispatch the route to, for example `AppWeb.PostController`\n  * `:plug_opts` - the options to pass when calling the plug, for example: `:index`\n  * `:route` - the string route pattern, such as `\"/posts/:id\"`","ref":"Phoenix.Router.html#route_info/4"},{"type":"function","title":"Examples - Phoenix.Router.route_info/4","doc":"iex> Phoenix.Router.route_info(AppWeb.Router, \"GET\", \"/posts/123\", \"myhost\")\n    %{\n      log: :debug,\n      path_params: %{\"id\" => \"123\"},\n      pipe_through: [:browser],\n      plug: AppWeb.PostController,\n      plug_opts: :show,\n      route: \"/posts/:id\",\n    }\n\n    iex> Phoenix.Router.route_info(MyRouter, \"GET\", \"/not-exists\", \"myhost\")\n    :error","ref":"Phoenix.Router.html#route_info/4-examples"},{"type":"function","title":"Phoenix.Router.routes/1","doc":"Returns all routes information from the given router.","ref":"Phoenix.Router.html#routes/1"},{"type":"macro","title":"Phoenix.Router.scope/2","doc":"Defines a scope in which routes can be nested.","ref":"Phoenix.Router.html#scope/2"},{"type":"macro","title":"Examples - Phoenix.Router.scope/2","doc":"scope path: \"/api/v1\", alias: API.V1 do\n      get \"/pages/:id\", PageController, :show\n    end\n\nThe generated route above will match on the path `\"/api/v1/pages/:id\"`\nand will dispatch to `:show` action in `API.V1.PageController`. A named\nhelper `api_v1_page_path` will also be generated.","ref":"Phoenix.Router.html#scope/2-examples"},{"type":"macro","title":"Options - Phoenix.Router.scope/2","doc":"The supported options are:\n\n  * `:path` - a string containing the path scope.\n  * `:as` - a string or atom containing the named helper scope. When set to\n    false, it resets the nested helper scopes. Has no effect when using verified\n    routes exclusively\n  * `:alias` - an alias (atom) containing the controller scope. When set to\n    false, it resets all nested aliases.\n  * `:host` - a string or list of strings containing the host scope, or prefix host scope,\n    ie `\"foo.bar.com\"`, `\"foo.\"`\n  * `:private` - a map of private data to merge into the connection when a route matches\n  * `:assigns` - a map of data to merge into the connection when a route matches\n  * `:log` - the level to log the route dispatching under, may be set to false. Defaults to\n    `:debug`. Route dispatching contains information about how the route is handled (which controller\n    action is called, what parameters are available and which pipelines are used) and is separate from\n    the plug level logging. To alter the plug log level, please see\n    https://hexdocs.pm/phoenix/Phoenix.Logger.html#module-dynamic-log-level.","ref":"Phoenix.Router.html#scope/2-options"},{"type":"macro","title":"Phoenix.Router.scope/3","doc":"Define a scope with the given path.\n\nThis function is a shortcut for:\n\n    scope path: path do\n      ...\n    end","ref":"Phoenix.Router.html#scope/3"},{"type":"macro","title":"Examples - Phoenix.Router.scope/3","doc":"scope \"/v1\", host: \"api.\" do\n      get \"/pages/:id\", PageController, :show\n    end","ref":"Phoenix.Router.html#scope/3-examples"},{"type":"macro","title":"Phoenix.Router.scope/4","doc":"Defines a scope with the given path and alias.\n\nThis function is a shortcut for:\n\n    scope path: path, alias: alias do\n      ...\n    end","ref":"Phoenix.Router.html#scope/4"},{"type":"macro","title":"Examples - Phoenix.Router.scope/4","doc":"scope \"/v1\", API.V1, host: \"api.\" do\n      get \"/pages/:id\", PageController, :show\n    end","ref":"Phoenix.Router.html#scope/4-examples"},{"type":"function","title":"Phoenix.Router.scoped_alias/2","doc":"Returns the full alias with the current scope's aliased prefix.\n\nUseful for applying the same short-hand alias handling to\nother values besides the second argument in route definitions.","ref":"Phoenix.Router.html#scoped_alias/2"},{"type":"function","title":"Examples - Phoenix.Router.scoped_alias/2","doc":"scope \"/\", MyPrefix do\n      get \"/\", ProxyPlug, controller: scoped_alias(__MODULE__, MyController)\n    end","ref":"Phoenix.Router.html#scoped_alias/2-examples"},{"type":"function","title":"Phoenix.Router.scoped_path/2","doc":"Returns the full path with the current scope's path prefix.","ref":"Phoenix.Router.html#scoped_path/2"},{"type":"macro","title":"Phoenix.Router.trace/4","doc":"Generates a route to handle a trace request to the given path.\n\n    trace(\"/events/:id\", EventController, :action)\n\nSee `match/5` for options.","ref":"Phoenix.Router.html#trace/4"},{"type":"behaviour","title":"Phoenix.Socket","doc":"A socket implementation that multiplexes messages over channels.\n\n`Phoenix.Socket` is used as a module for establishing a connection\nbetween client and server. Once the connection is established,\nthe initial state is stored in the `Phoenix.Socket` struct.\n\nThe same socket can be used to receive events from different transports.\nPhoenix supports `websocket` and `longpoll` options when invoking\n`Phoenix.Endpoint.socket/3` in your endpoint. `websocket` is set by default\nand `longpoll` can also be configured explicitly.\n\n    socket \"/socket\", MyAppWeb.Socket, websocket: true, longpoll: false\n\nThe command above means incoming socket connections can be made via\na WebSocket connection. Incoming and outgoing events are routed to\nchannels by topic:\n\n    channel \"room:lobby\", MyAppWeb.LobbyChannel\n\nSee `Phoenix.Channel` for more information on channels.","ref":"Phoenix.Socket.html"},{"type":"behaviour","title":"Socket Behaviour - Phoenix.Socket","doc":"Socket handlers are mounted in Endpoints and must define two callbacks:\n\n  * `connect/3` - receives the socket params, connection info if any, and\n    authenticates the connection. Must return a `Phoenix.Socket` struct,\n    often with custom assigns\n\n  * `id/1` - receives the socket returned by `connect/3` and returns the\n    id of this connection as a string. The `id` is used to identify socket\n    connections, often to a particular user, allowing us to force disconnections.\n    For sockets requiring no authentication, `nil` can be returned","ref":"Phoenix.Socket.html#module-socket-behaviour"},{"type":"behaviour","title":"Examples - Phoenix.Socket","doc":"defmodule MyAppWeb.UserSocket do\n      use Phoenix.Socket\n\n      channel \"room:*\", MyAppWeb.RoomChannel\n\n      def connect(params, socket, _connect_info) do\n        {:ok, assign(socket, :user_id, params[\"user_id\"])}\n      end\n\n      def id(socket), do: \"users_socket:#{socket.assigns.user_id}\"\n    end\n\n    # Disconnect all user's socket connections and their multiplexed channels\n    MyAppWeb.Endpoint.broadcast(\"users_socket:\" <> user.id, \"disconnect\", %{})","ref":"Phoenix.Socket.html#module-examples"},{"type":"behaviour","title":"Socket fields - Phoenix.Socket","doc":"* `:id` - The string id of the socket\n  * `:assigns` - The map of socket assigns, default: `%{}`\n  * `:channel` - The current channel module\n  * `:channel_pid` - The channel pid\n  * `:endpoint` - The endpoint module where this socket originated, for example: `MyAppWeb.Endpoint`\n  * `:handler` - The socket module where this socket originated, for example: `MyAppWeb.UserSocket`\n  * `:joined` - If the socket has effectively joined the channel\n  * `:join_ref` - The ref sent by the client when joining\n  * `:ref` - The latest ref sent by the client\n  * `:pubsub_server` - The registered name of the socket's pubsub server\n  * `:topic` - The string topic, for example `\"room:123\"`\n  * `:transport` - An identifier for the transport, used for logging\n  * `:transport_pid` - The pid of the socket's transport process\n  * `:serializer` - The serializer for socket messages","ref":"Phoenix.Socket.html#module-socket-fields"},{"type":"behaviour","title":"Using options - Phoenix.Socket","doc":"On `use Phoenix.Socket`, the following options are accepted:\n\n  * `:log` - the default level to log socket actions. Defaults\n    to `:info`. May be set to `false` to disable it\n\n  * `:partitions` - each channel is spawned under a supervisor.\n    This option controls how many supervisors will be spawned\n    to handle channels. Defaults to the number of cores.","ref":"Phoenix.Socket.html#module-using-options"},{"type":"behaviour","title":"Garbage collection - Phoenix.Socket","doc":"It's possible to force garbage collection in the transport process after\nprocessing large messages. For example, to trigger such from your channels,\nrun:\n\n    send(socket.transport_pid, :garbage_collect)\n\nAlternatively, you can configure your endpoint socket to trigger more\nfullsweep garbage collections more frequently, by setting the `:fullsweep_after`\noption for websockets. See `Phoenix.Endpoint.socket/3` for more info.","ref":"Phoenix.Socket.html#module-garbage-collection"},{"type":"behaviour","title":"Client-server communication - Phoenix.Socket","doc":"The encoding of server data and the decoding of client data is done\naccording to a serializer, defined in `Phoenix.Socket.Serializer`.\nBy default, JSON encoding is used to broker messages to and from clients.\n\nThe serializer `decode!` function must return a `Phoenix.Socket.Message`\nwhich is forwarded to channels except:\n\n  * `\"heartbeat\"` events in the \"phoenix\" topic - should just emit an OK reply\n  * `\"phx_join\"` on any topic - should join the topic\n  * `\"phx_leave\"` on any topic - should leave the topic\n\nEach message also has a `ref` field which is used to track responses.\n\nThe server may send messages or replies back. For messages, the\nref uniquely identifies the message. For replies, the ref matches\nthe original message. Both data-types also include a join_ref that\nuniquely identifies the currently joined channel.\n\nThe `Phoenix.Socket` implementation may also send special messages\nand replies:\n\n  * `\"phx_error\"` - in case of errors, such as a channel process\n    crashing, or when attempting to join an already joined channel\n\n  * `\"phx_close\"` - the channel was gracefully closed\n\nPhoenix ships with a JavaScript implementation of both websocket\nand long polling that interacts with Phoenix.Socket and can be\nused as reference for those interested in implementing custom clients.","ref":"Phoenix.Socket.html#module-client-server-communication"},{"type":"behaviour","title":"Custom sockets and transports - Phoenix.Socket","doc":"See the `Phoenix.Socket.Transport` documentation for more information on\nwriting your own socket that does not leverage channels or for writing\nyour own transports that interacts with other sockets.","ref":"Phoenix.Socket.html#module-custom-sockets-and-transports"},{"type":"behaviour","title":"Custom channels - Phoenix.Socket","doc":"You can list any module as a channel as long as it implements\na `child_spec/1` function. The `child_spec/1` function receives\nthe caller as argument and it must return a child spec that\ninitializes a process.\n\nOnce the process is initialized, it will receive the following\nmessage:\n\n    {Phoenix.Channel, auth_payload, from, socket}\n\nA custom channel implementation MUST invoke\n`GenServer.reply(from, {:ok | :error, reply_payload})` during its\ninitialization with a custom `reply_payload` that will be sent as\na reply to the client. Failing to do so will block the socket forever.\n\nA custom channel receives `Phoenix.Socket.Message` structs as regular\nmessages from the transport. Replies to those messages and custom\nmessages can be sent to the socket at any moment by building an\nappropriate `Phoenix.Socket.Reply` and `Phoenix.Socket.Message`\nstructs, encoding them with the serializer and dispatching the\nserialized result to the transport.\n\nFor example, to handle \"phx_leave\" messages, which is recommended\nto be handled by all channel implementations, one may do:\n\n    def handle_info(\n          %Message{topic: topic, event: \"phx_leave\"} = message,\n          %{topic: topic, serializer: serializer, transport_pid: transport_pid} = socket\n        ) do\n      send transport_pid, serializer.encode!(build_leave_reply(message))\n      {:stop, {:shutdown, :left}, socket}\n    end\n\nA special message delivered to all channels is a Broadcast with\nevent \"phx_drain\", which is sent when draining the socket during\napplication shutdown. Typically it is handled by sending a drain\nmessage to the transport, causing it to shutdown:\n\n    def handle_info(\n          %Broadcast{event: \"phx_drain\"},\n          %{transport_pid: transport_pid} = socket\n        ) do\n      send(transport_pid, :socket_drain)\n      {:stop, {:shutdown, :draining}, socket}\n    end\n\nWe also recommend all channels to monitor the `transport_pid`\non `init` and exit if the transport exits. We also advise to rewrite\n`:normal` exit reasons (usually due to the socket being closed)\nto the `{:shutdown, :closed}` to guarantee links are broken on\nthe channel exit (as a `:normal` exit does not break links):\n\n    def handle_info({:DOWN, _, _, transport_pid, reason}, %{transport_pid: transport_pid} = socket) do\n      reason = if reason == :normal, do: {:shutdown, :closed}, else: reason\n      {:stop, reason, socket}\n    end\n\nAny process exit is treated as an error by the socket layer unless\na `{:socket_close, pid, reason}` message is sent to the socket before\nshutdown.\n\nCustom channel implementations cannot be tested with `Phoenix.ChannelTest`.","ref":"Phoenix.Socket.html#module-custom-channels"},{"type":"function","title":"Phoenix.Socket.assign/2","doc":"","ref":"Phoenix.Socket.html#assign/2"},{"type":"function","title":"Phoenix.Socket.assign/3","doc":"Adds key-value pairs to socket assigns.\n\nA single key-value pair may be passed, a keyword list or map\nof assigns may be provided to be merged into existing socket\nassigns.","ref":"Phoenix.Socket.html#assign/3"},{"type":"function","title":"Examples - Phoenix.Socket.assign/3","doc":"iex> assign(socket, :name, \"Elixir\")\n    iex> assign(socket, name: \"Elixir\", logo: \"💧\")","ref":"Phoenix.Socket.html#assign/3-examples"},{"type":"macro","title":"Phoenix.Socket.channel/3","doc":"Defines a channel matching the given topic and transports.\n\n  * `topic_pattern` - The string pattern, for example `\"room:*\"`, `\"users:*\"`,\n    or `\"system\"`\n  * `module` - The channel module handler, for example `MyAppWeb.RoomChannel`\n  * `opts` - The optional list of options, see below","ref":"Phoenix.Socket.html#channel/3"},{"type":"macro","title":"Options - Phoenix.Socket.channel/3","doc":"* `:assigns` - the map of socket assigns to merge into the socket on join","ref":"Phoenix.Socket.html#channel/3-options"},{"type":"macro","title":"Examples - Phoenix.Socket.channel/3","doc":"channel \"topic1:*\", MyChannel","ref":"Phoenix.Socket.html#channel/3-examples"},{"type":"macro","title":"Topic Patterns - Phoenix.Socket.channel/3","doc":"The `channel` macro accepts topic patterns in two flavors. A splat (the `*`\ncharacter) argument can be provided as the last character to indicate a\n`\"topic:subtopic\"` match. If a plain string is provided, only that topic will\nmatch the channel handler. Most use-cases will use the `\"topic:*\"` pattern to\nallow more versatile topic scoping.\n\nSee `Phoenix.Channel` for more information","ref":"Phoenix.Socket.html#channel/3-topic-patterns"},{"type":"callback","title":"Phoenix.Socket.connect/2","doc":"Shortcut version of `connect/3` which does not receive `connect_info`.\n\nProvided for backwards compatibility.","ref":"Phoenix.Socket.html#c:connect/2"},{"type":"callback","title":"Phoenix.Socket.connect/3","doc":"Receives the socket params and authenticates the connection.","ref":"Phoenix.Socket.html#c:connect/3"},{"type":"callback","title":"Socket params and assigns - Phoenix.Socket.connect/3","doc":"Socket params are passed from the client and can\nbe used to verify and authenticate a user. After\nverification, you can put default assigns into\nthe socket that will be set for all channels, ie\n\n    {:ok, assign(socket, :user_id, verified_user_id)}\n\nTo deny connection, return `:error` or `{:error, term}`. To control the\nresponse the client receives in that case, [define an error handler in the\nwebsocket\nconfiguration](https://hexdocs.pm/phoenix/Phoenix.Endpoint.html#socket/3-websocket-configuration).\n\nSee `Phoenix.Token` documentation for examples in\nperforming token verification on connect.","ref":"Phoenix.Socket.html#c:connect/3-socket-params-and-assigns"},{"type":"callback","title":"Phoenix.Socket.id/1","doc":"Identifies the socket connection.\n\nSocket IDs are topics that allow you to identify all sockets for a given user:\n\n    def id(socket), do: \"users_socket:#{socket.assigns.user_id}\"\n\nWould allow you to broadcast a `\"disconnect\"` event and terminate\nall active sockets and channels for a given user:\n\n    MyAppWeb.Endpoint.broadcast(\"users_socket:\" <> user.id, \"disconnect\", %{})\n\nReturning `nil` makes this socket anonymous.","ref":"Phoenix.Socket.html#c:id/1"},{"type":"type","title":"Phoenix.Socket.t/0","doc":"","ref":"Phoenix.Socket.html#t:t/0"},{"type":"module","title":"Phoenix.Token","doc":"Conveniences to sign/encrypt data inside tokens\nfor use in Channels, API authentication, and more.\n\nThe data stored in the token is signed to prevent tampering, and is\noptionally encrypted. This means that, so long as the\nkey (see below) remains secret, you can be assured that the data\nstored in the token has not been tampered with by a third party.\nHowever, unless the token is encrypted, it is not safe to use this\ntoken to store private information, such as a user's sensitive\nidentification data, as it can be trivially decoded. If the\ntoken is encrypted, its contents will be kept secret from the\nclient, but it is still a best practice to encode as little secret\ninformation as possible, to minimize the impact of key leakage.","ref":"Phoenix.Token.html"},{"type":"module","title":"Example - Phoenix.Token","doc":"When generating a unique token for use in an API or Channel\nit is advised to use a unique identifier for the user, typically\nthe id from a database. For example:\n\n    iex> user_id = 1\n    iex> token = Phoenix.Token.sign(MyAppWeb.Endpoint, \"user auth\", user_id)\n    iex> Phoenix.Token.verify(MyAppWeb.Endpoint, \"user auth\", token, max_age: 86400)\n    {:ok, 1}\n\nIn that example we have a user's id, we generate a token and\nverify it using the secret key base configured in the given\n`endpoint`. We guarantee the token will only be valid for one day\nby setting a max age (recommended).\n\nThe first argument to `sign/4`, `verify/4`, `encrypt/4`, and\n`decrypt/4` can be one of:\n\n  * the module name of a Phoenix endpoint (shown above) - where\n    the secret key base is extracted from the endpoint\n  * `Plug.Conn` - where the secret key base is extracted from the\n    endpoint stored in the connection\n  * `Phoenix.Socket` or `Phoenix.LiveView.Socket` - where the secret\n    key base is extracted from the endpoint stored in the socket\n  * a string, representing the secret key base itself. A key base\n    with at least 20 randomly generated characters should be used\n    to provide adequate entropy\n\nThe second argument is a [cryptographic salt](https://en.wikipedia.org/wiki/Salt_(cryptography))\nwhich must be the same in both calls to `sign/4` and `verify/4`, or\nboth calls to `encrypt/4` and `decrypt/4`. For instance, it may be\ncalled \"user auth\" and treated as namespace when generating a token\nthat will be used to authenticate users on channels or on your APIs.\n\nThe third argument can be any term (string, int, list, etc.)\nthat you wish to codify into the token. Upon valid verification,\nthis same term will be extracted from the token.","ref":"Phoenix.Token.html#module-example"},{"type":"module","title":"Usage - Phoenix.Token","doc":"Once a token is signed, we can send it to the client in multiple ways.\n\nOne is via the meta tag:\n\n    <%= tag :meta, name: \"channel_token\",\n                   content: Phoenix.Token.sign(@conn, \"user auth\", @current_user.id) %>\n\nOr an endpoint that returns it:\n\n    def create(conn, params) do\n      user = User.create(params)\n      render(conn, \"user.json\",\n             %{token: Phoenix.Token.sign(conn, \"user auth\", user.id), user: user})\n    end\n\nOnce the token is sent, the client may now send it back to the server\nas an authentication mechanism. For example, we can use it to authenticate\na user on a Phoenix channel:\n\n    defmodule MyApp.UserSocket do\n      use Phoenix.Socket\n\n      def connect(%{\"token\" => token}, socket, _connect_info) do\n        case Phoenix.Token.verify(socket, \"user auth\", token, max_age: 86400) do\n          {:ok, user_id} ->\n            socket = assign(socket, :user, Repo.get!(User, user_id))\n            {:ok, socket}\n          {:error, _} ->\n            :error\n        end\n      end\n\n      def connect(_params, _socket, _connect_info), do: :error\n    end\n\nIn this example, the phoenix.js client will send the token in the\n`connect` command which is then validated by the server.\n\n`Phoenix.Token` can also be used for validating APIs, handling\npassword resets, e-mail confirmation and more.","ref":"Phoenix.Token.html#module-usage"},{"type":"function","title":"Phoenix.Token.decrypt/4","doc":"Decrypts the original data from the token and verifies its integrity.\n\nIts usage is identical to `verify/4` but for encrypted tokens.","ref":"Phoenix.Token.html#decrypt/4"},{"type":"function","title":"Options - Phoenix.Token.decrypt/4","doc":"* `:key_iterations` - option passed to `Plug.Crypto.KeyGenerator`\n    when generating the encryption and signing keys. Defaults to 1000\n  * `:key_length` - option passed to `Plug.Crypto.KeyGenerator`\n    when generating the encryption and signing keys. Defaults to 32\n  * `:key_digest` - option passed to `Plug.Crypto.KeyGenerator`\n    when generating the encryption and signing keys. Defaults to `:sha256`\n  * `:max_age` - verifies the token only if it has been generated\n    \"max age\" ago in seconds. Defaults to the max age signed in the\n    token by `encrypt/4`.","ref":"Phoenix.Token.html#decrypt/4-options"},{"type":"function","title":"Phoenix.Token.encrypt/4","doc":"Encodes, encrypts, and signs data into a token you can send to\nclients. Its usage is identical to that of `sign/4`, but the data\nis extracted using `decrypt/4`, rather than `verify/4`.","ref":"Phoenix.Token.html#encrypt/4"},{"type":"function","title":"Options - Phoenix.Token.encrypt/4","doc":"* `:key_iterations` - option passed to `Plug.Crypto.KeyGenerator`\n    when generating the encryption and signing keys. Defaults to 1000\n  * `:key_length` - option passed to `Plug.Crypto.KeyGenerator`\n    when generating the encryption and signing keys. Defaults to 32\n  * `:key_digest` - option passed to `Plug.Crypto.KeyGenerator`\n    when generating the encryption and signing keys. Defaults to `:sha256`\n  * `:signed_at` - set the timestamp of the token in seconds.\n    Defaults to `System.os_time(:millisecond)`\n  * `:max_age` - the default maximum age of the token. Defaults to\n    86400 seconds (1 day) and it may be overridden on `decrypt/4`.","ref":"Phoenix.Token.html#encrypt/4-options"},{"type":"function","title":"Phoenix.Token.sign/4","doc":"Encodes and signs data into a token you can send to clients.","ref":"Phoenix.Token.html#sign/4"},{"type":"function","title":"Options - Phoenix.Token.sign/4","doc":"* `:key_iterations` - option passed to `Plug.Crypto.KeyGenerator`\n    when generating the encryption and signing keys. Defaults to 1000\n  * `:key_length` - option passed to `Plug.Crypto.KeyGenerator`\n    when generating the encryption and signing keys. Defaults to 32\n  * `:key_digest` - option passed to `Plug.Crypto.KeyGenerator`\n    when generating the encryption and signing keys. Defaults to `:sha256`\n  * `:signed_at` - set the timestamp of the token in seconds.\n    Defaults to `System.os_time(:millisecond)`\n  * `:max_age` - the default maximum age of the token. Defaults to\n    86400 seconds (1 day) and it may be overridden on `verify/4`.","ref":"Phoenix.Token.html#sign/4-options"},{"type":"function","title":"Phoenix.Token.verify/4","doc":"Decodes the original data from the token and verifies its integrity.","ref":"Phoenix.Token.html#verify/4"},{"type":"function","title":"Examples - Phoenix.Token.verify/4","doc":"In this scenario we will create a token, sign it, then provide it to a client\napplication. The client will then use this token to authenticate requests for\nresources from the server. See `Phoenix.Token` summary for more info about\ncreating tokens.\n\n    iex> user_id    = 99\n    iex> secret     = \"kjoy3o1zeidquwy1398juxzldjlksahdk3\"\n    iex> namespace  = \"user auth\"\n    iex> token      = Phoenix.Token.sign(secret, namespace, user_id)\n\nThe mechanism for passing the token to the client is typically through a\ncookie, a JSON response body, or HTTP header. For now, assume the client has\nreceived a token it can use to validate requests for protected resources.\n\nWhen the server receives a request, it can use `verify/4` to determine if it\nshould provide the requested resources to the client:\n\n    iex> Phoenix.Token.verify(secret, namespace, token, max_age: 86400)\n    {:ok, 99}\n\nIn this example, we know the client sent a valid token because `verify/4`\nreturned a tuple of type `{:ok, user_id}`. The server can now proceed with\nthe request.\n\nHowever, if the client had sent an expired token, an invalid token, or `nil`,\n`verify/4` would have returned an error instead:\n\n    iex> Phoenix.Token.verify(secret, namespace, expired, max_age: 86400)\n    {:error, :expired}\n\n    iex> Phoenix.Token.verify(secret, namespace, invalid, max_age: 86400)\n    {:error, :invalid}\n\n    iex> Phoenix.Token.verify(secret, namespace, nil, max_age: 86400)\n    {:error, :missing}","ref":"Phoenix.Token.html#verify/4-examples"},{"type":"function","title":"Options - Phoenix.Token.verify/4","doc":"* `:key_iterations` - option passed to `Plug.Crypto.KeyGenerator`\n    when generating the encryption and signing keys. Defaults to 1000\n  * `:key_length` - option passed to `Plug.Crypto.KeyGenerator`\n    when generating the encryption and signing keys. Defaults to 32\n  * `:key_digest` - option passed to `Plug.Crypto.KeyGenerator`\n    when generating the encryption and signing keys. Defaults to `:sha256`\n  * `:max_age` - verifies the token only if it has been generated\n    \"max age\" ago in seconds. Defaults to the max age signed in the\n    token by `sign/4`.","ref":"Phoenix.Token.html#verify/4-options"},{"type":"type","title":"Phoenix.Token.context/0","doc":"","ref":"Phoenix.Token.html#t:context/0"},{"type":"type","title":"Phoenix.Token.max_age_opt/0","doc":"","ref":"Phoenix.Token.html#t:max_age_opt/0"},{"type":"type","title":"Phoenix.Token.shared_opt/0","doc":"","ref":"Phoenix.Token.html#t:shared_opt/0"},{"type":"type","title":"Phoenix.Token.signed_at_opt/0","doc":"","ref":"Phoenix.Token.html#t:signed_at_opt/0"},{"type":"module","title":"Phoenix.VerifiedRoutes","doc":"Provides route generation with compile-time verification.\n\nUse of the `sigil_p` macro allows paths and URLs throughout your\napplication to be compile-time verified against your Phoenix router(s).\nFor example, the following path and URL usages:\n\n    <.link href={~p\"/sessions/new\"} method=\"post\">Log in</.link>\n\n    redirect(to: url(~p\"/posts/#{post}\"))\n\nWill be verified against your standard `Phoenix.Router` definitions:\n\n    get \"/posts/:post_id\", PostController, :show\n    post \"/sessions/new\", SessionController, :create\n\nUnmatched routes will issue compiler warnings:\n\n    warning: no route path for AppWeb.Router matches \"/postz/#{post}\"\n      lib/app_web/controllers/post_controller.ex:100: AppWeb.PostController.show/2\n\nAdditionally, interpolated ~p values are encoded via the `Phoenix.Param` protocol.\nFor example, a `%Post{}` struct in your application may derive the `Phoenix.Param`\nprotocol to generate slug-based paths rather than ID based ones. This allows you to\nuse `~p\"/posts/#{post}\"` rather than `~p\"/posts/#{post.slug}\"` throughout your\napplication. See the `Phoenix.Param` documentation for more details.\n\nQuery strings are also supported in verified routes, either in traditional query\nstring form:\n\n    ~p\"/posts?page=#{page}\"\n\nOr as a keyword list or map of values:\n\n    params = %{page: 1, direction: \"asc\"}\n    ~p\"/posts?#{params}\"\n\nLike path segments, query strings params are proper URL encoded and may be interpolated\ndirectly into the ~p string.","ref":"Phoenix.VerifiedRoutes.html"},{"type":"module","title":"Options - Phoenix.VerifiedRoutes","doc":"To verify routes in your application modules, such as controller, templates, and views,\n`use Phoenix.VerifiedRoutes`, which supports the following options:\n\n  * `:router` - The required router to verify ~p paths against\n  * `:endpoint` - The optional endpoint for ~p script_name and URL generation\n  * `:statics` - The optional list of static directories to treat as verified paths\n\nFor example:\n\n    use Phoenix.VerifiedRoutes,\n      router: AppWeb.Router,\n      endpoint: AppWeb.Endpoint,\n      statics: ~w(images)","ref":"Phoenix.VerifiedRoutes.html#module-options"},{"type":"module","title":"Usage - Phoenix.VerifiedRoutes","doc":"The majority of path and URL generation needs your application will be met\nwith `~p` and `url/1`, where all information necessary to construct the path\nor URL is provided by the compile-time information stored in the Endpoint\nand Router passed to `use Phoenix.VerifiedRoutes`.\n\nThat said, there are some circumstances where `path/2`, `path/3`, `url/2`, and `url/3`\nare required:\n\n  * When the runtime values of the `%Plug.Conn{}`, `%Phoenix.LiveSocket{}`, or a `%URI{}`\n    dictate the formation of the path or URL, which happens under the following scenarios:\n\n    - `Phoenix.Controller.put_router_url/2` is used to override the endpoint's URL\n    - `Phoenix.Controller.put_static_url/2` is used to override the endpoint's static URL\n\n  * When the Router module differs from the one passed to `use Phoenix.VerifiedRoutes`,\n    such as library code, or application code that relies on multiple routers. In such cases,\n    the router module can be provided explicitly to `path/3` and `url/3`.","ref":"Phoenix.VerifiedRoutes.html#module-usage"},{"type":"module","title":"Tracking Warnings - Phoenix.VerifiedRoutes","doc":"All static path segments must start with forward slash, and you must have a static segment\nbetween dynamic interpolations in order for a route to be verified without warnings.\nFor example, the following path generates proper warnings\n\n    ~p\"/media/posts/#{post}\"\n\nWhile this one will not allow the compiler to see the full path:\n\n    type = \"posts\"\n    ~p\"/media/#{type}/#{post}\"\n\nIn such cases, it's better to write a function such as `media_path/1` which branches\non different `~p`'s to handle each type.\n\nLike any other compilation warning, the Elixir compiler will warn any time the file\nthat a ~p resides in changes, or if the router is changed. To view previously issued\nwarnings for files that lack new changes, the `--all-warnings` flag may be passed to\nthe `mix compile` task. For the following will show all warnings the compiler\nhas previously encountered when compiling the current application code:\n\n    $ mix compile --all-warnings\n\n*Note: Elixir >= 1.14.0 is required for comprehensive warnings. Older versions\nwill compile properly, but no warnings will be issued.","ref":"Phoenix.VerifiedRoutes.html#module-tracking-warnings"},{"type":"macro","title":"Phoenix.VerifiedRoutes.path/2","doc":"Generates the router path with route verification.\n\nSee `sigil_p/2` for more information.\n\nWarns when the provided path does not match against the router specified\nin `use Phoenix.VerifiedRoutes` or the `@router` module attribute.","ref":"Phoenix.VerifiedRoutes.html#path/2"},{"type":"macro","title":"Examples - Phoenix.VerifiedRoutes.path/2","doc":"import Phoenix.VerifiedRoutes\n\n    redirect(to: path(conn, ~p\"/users/top\"))\n\n    redirect(to: path(conn, ~p\"/users/#{@user}\"))\n\n    ~H\"\"\"\n    <.link href={path(@uri, \"/users?page=#{@page}\")}>profile</.link>\n    <.link href={path(@uri, \"/users?#{@params}\")}>profile</.link>\n    \"\"\"","ref":"Phoenix.VerifiedRoutes.html#path/2-examples"},{"type":"macro","title":"Phoenix.VerifiedRoutes.path/3","doc":"Generates the router path with route verification.\n\nSee `sigil_p/2` for more information.\n\nWarns when the provided path does not match against the router specified\nin the router argument.","ref":"Phoenix.VerifiedRoutes.html#path/3"},{"type":"macro","title":"Examples - Phoenix.VerifiedRoutes.path/3","doc":"import Phoenix.VerifiedRoutes\n\n    redirect(to: path(conn, MyAppWeb.Router, ~p\"/users/top\"))\n\n    redirect(to: path(conn, MyAppWeb.Router, ~p\"/users/#{@user}\"))\n\n    ~H\"\"\"\n    <.link href={path(@uri, MyAppWeb.Router, \"/users?page=#{@page}\")}>profile</.link>\n    <.link href={path(@uri, MyAppWeb.Router, \"/users?#{@params}\")}>profile</.link>\n    \"\"\"","ref":"Phoenix.VerifiedRoutes.html#path/3-examples"},{"type":"macro","title":"Phoenix.VerifiedRoutes.sigil_p/2","doc":"Generates the router path with route verification.\n\nInterpolated named parameters are encoded via the `Phoenix.Param` protocol.\n\nWarns when the provided path does not match against the router specified\nin `use Phoenix.VerifiedRoutes` or the `@router` module attribute.","ref":"Phoenix.VerifiedRoutes.html#sigil_p/2"},{"type":"macro","title":"Examples - Phoenix.VerifiedRoutes.sigil_p/2","doc":"use Phoenix.VerifiedRoutes, endpoint: MyAppWeb.Endpoint, router: MyAppWeb.Router\n\n    redirect(to: ~p\"/users/top\")\n\n    redirect(to: ~p\"/users/#{@user}\")\n\n    ~H\"\"\"\n    <.link href={~p\"/users?page=#{@page}\"}>profile</.link>\n\n    <.link href={~p\"/users?#{@params}\"}>profile</.link>\n    \"\"\"","ref":"Phoenix.VerifiedRoutes.html#sigil_p/2-examples"},{"type":"function","title":"Phoenix.VerifiedRoutes.static_integrity/2","doc":"Generates an integrity hash to a static asset given its file path.\n\nSee `Phoenix.Endpoint.static_integrity/1` for more information.","ref":"Phoenix.VerifiedRoutes.html#static_integrity/2"},{"type":"function","title":"Examples - Phoenix.VerifiedRoutes.static_integrity/2","doc":"iex> static_integrity(conn, \"/assets/app.js\")\n    \"813dfe33b5c7f8388bccaaa38eec8382\"\n\n    iex> static_integrity(socket, \"/assets/app.js\")\n    \"813dfe33b5c7f8388bccaaa38eec8382\"\n\n    iex> static_integrity(AppWeb.Endpoint, \"/assets/app.js\")\n    \"813dfe33b5c7f8388bccaaa38eec8382\"","ref":"Phoenix.VerifiedRoutes.html#static_integrity/2-examples"},{"type":"function","title":"Phoenix.VerifiedRoutes.static_path/2","doc":"Generates path to a static asset given its file path.\n\nSee `Phoenix.Endpoint.static_path/1` for more information.","ref":"Phoenix.VerifiedRoutes.html#static_path/2"},{"type":"function","title":"Examples - Phoenix.VerifiedRoutes.static_path/2","doc":"iex> static_path(conn, \"/assets/app.js\")\n    \"/assets/app-813dfe33b5c7f8388bccaaa38eec8382.js\"\n\n    iex> static_path(socket, \"/assets/app.js\")\n    \"/assets/app-813dfe33b5c7f8388bccaaa38eec8382.js\"\n\n    iex> static_path(AppWeb.Endpoint, \"/assets/app.js\")\n    \"/assets/app-813dfe33b5c7f8388bccaaa38eec8382.js\"\n\n    iex> static_path(%URI{path: \"/subresource\"}, \"/assets/app.js\")\n    \"/subresource/assets/app-813dfe33b5c7f8388bccaaa38eec8382.js\"","ref":"Phoenix.VerifiedRoutes.html#static_path/2-examples"},{"type":"function","title":"Phoenix.VerifiedRoutes.static_url/2","doc":"Generates url to a static asset given its file path.\n\nSee `Phoenix.Endpoint.static_url/0` and `Phoenix.Endpoint.static_path/1` for more information.","ref":"Phoenix.VerifiedRoutes.html#static_url/2"},{"type":"function","title":"Examples - Phoenix.VerifiedRoutes.static_url/2","doc":"iex> static_url(conn, \"/assets/app.js\")\n    \"https://example.com/assets/app-813dfe33b5c7f8388bccaaa38eec8382.js\"\n\n    iex> static_url(socket, \"/assets/app.js\")\n    \"https://example.com/assets/app-813dfe33b5c7f8388bccaaa38eec8382.js\"\n\n    iex> static_url(AppWeb.Endpoint, \"/assets/app.js\")\n    \"https://example.com/assets/app-813dfe33b5c7f8388bccaaa38eec8382.js\"","ref":"Phoenix.VerifiedRoutes.html#static_url/2-examples"},{"type":"function","title":"Phoenix.VerifiedRoutes.unverified_path/4","doc":"Returns the path with relevant script name prefixes without verification.","ref":"Phoenix.VerifiedRoutes.html#unverified_path/4"},{"type":"function","title":"Examples - Phoenix.VerifiedRoutes.unverified_path/4","doc":"iex> unverified_path(conn, AppWeb.Router, \"/posts\")\n    \"/posts\"\n\n    iex> unverified_path(conn, AppWeb.Router, \"/posts\", page: 1)\n    \"/posts?page=1\"","ref":"Phoenix.VerifiedRoutes.html#unverified_path/4-examples"},{"type":"function","title":"Phoenix.VerifiedRoutes.unverified_url/3","doc":"Returns the URL for the endpoint from the path without verification.","ref":"Phoenix.VerifiedRoutes.html#unverified_url/3"},{"type":"function","title":"Examples - Phoenix.VerifiedRoutes.unverified_url/3","doc":"iex> unverified_url(conn, \"/posts\")\n    \"https://example.com/posts\"\n\n    iex> unverified_url(conn, \"/posts\", page: 1)\n    \"https://example.com/posts?page=1\"","ref":"Phoenix.VerifiedRoutes.html#unverified_url/3-examples"},{"type":"macro","title":"Phoenix.VerifiedRoutes.url/1","doc":"Generates the router url with route verification.\n\nSee `sigil_p/2` for more information.\n\nWarns when the provided path does not match against the router specified\nin `use Phoenix.VerifiedRoutes` or the `@router` module attribute.","ref":"Phoenix.VerifiedRoutes.html#url/1"},{"type":"macro","title":"Examples - Phoenix.VerifiedRoutes.url/1","doc":"use Phoenix.VerifiedRoutes, endpoint: MyAppWeb.Endpoint, router: MyAppWeb.Router\n\n    redirect(to: url(conn, ~p\"/users/top\"))\n\n    redirect(to: url(conn, ~p\"/users/#{@user}\"))\n\n    ~H\"\"\"\n    <.link href={url(@uri, \"/users?#{[page: @page]}\")}>profile</.link>\n    \"\"\"\n\nThe router may also be provided in cases where you want to verify routes for a\nrouter other than the one passed to `use Phoenix.VerifiedRoutes`:\n\n    redirect(to: url(conn, OtherRouter, ~p\"/users\"))\n\nForwarded routes are also resolved automatically. For example, imagine you\nhave a forward path to an admin router in your main router:\n\n    defmodule AppWeb.Router do\n      ...\n      forward \"/admin\", AppWeb.AdminRouter\n    end\n\n    defmodule AppWeb.AdminRouter do\n      ...\n      get \"/users\", AppWeb.Admin.UserController\n    end\n\nForwarded paths in your main application router will be verified as usual,\nsuch as `~p\"/admin/users\"`.","ref":"Phoenix.VerifiedRoutes.html#url/1-examples"},{"type":"macro","title":"Phoenix.VerifiedRoutes.url/2","doc":"Generates the router url with route verification from the connection, socket, or URI.\n\nSee `url/1` for more information.","ref":"Phoenix.VerifiedRoutes.html#url/2"},{"type":"macro","title":"Phoenix.VerifiedRoutes.url/3","doc":"Generates the url with route verification from the connection, socket, or URI and router.\n\nSee `url/1` for more information.","ref":"Phoenix.VerifiedRoutes.html#url/3"},{"type":"module","title":"Phoenix.ChannelTest","doc":"Conveniences for testing Phoenix channels.\n\nIn channel tests, we interact with channels via process\ncommunication, sending and receiving messages. It is also\ncommon to subscribe to the same topic the channel subscribes\nto, allowing us to assert if a given message was broadcast\nor not.","ref":"Phoenix.ChannelTest.html"},{"type":"module","title":"Channel testing - Phoenix.ChannelTest","doc":"To get started, define the module attribute `@endpoint`\nin your test case pointing to your application endpoint.\n\nThen you can directly create a socket and\n`subscribe_and_join/4` topics and channels:\n\n    {:ok, _, socket} =\n      socket(UserSocket, \"user:id\", %{some_assigns: 1})\n      |> subscribe_and_join(RoomChannel, \"room:lobby\", %{\"id\" => 3})\n\nYou usually want to set the same ID and assigns your\n`UserSocket.connect/3` callback would set. Alternatively,\nyou can use the `connect/3` helper to call your `UserSocket.connect/3`\ncallback and initialize the socket with the socket id:\n\n    {:ok, socket} = connect(UserSocket, %{\"some\" => \"params\"}, %{})\n    {:ok, _, socket} = subscribe_and_join(socket, \"room:lobby\", %{\"id\" => 3})\n\nOnce called, `subscribe_and_join/4` will subscribe the\ncurrent test process to the \"room:lobby\" topic and start a\nchannel in another process. It returns `{:ok, reply, socket}`\nor `{:error, reply}`.\n\nNow, in the same way the channel has a socket representing\ncommunication it will push to the client. Our test has a\nsocket representing communication to be pushed to the server.\n\nFor example, we can use the `push/3` function in the test\nto push messages to the channel (it will invoke `handle_in/3`):\n\n    push(socket, \"my_event\", %{\"some\" => \"data\"})\n\nSimilarly, we can broadcast messages from the test itself\non the topic that both test and channel are subscribed to,\ntriggering `handle_out/3` on the channel:\n\n    broadcast_from(socket, \"my_event\", %{\"some\" => \"data\"})\n\n> Note only `broadcast_from/3` and `broadcast_from!/3` are\navailable in tests to avoid broadcast messages to be resent\nto the test process.\n\nWhile the functions above are pushing data to the channel\n(server) we can use `assert_push/3` to verify the channel\npushed a message to the client:\n\n    assert_push \"my_event\", %{\"some\" => \"data\"}\n\nOr even assert something was broadcast into pubsub:\n\n    assert_broadcast \"my_event\", %{\"some\" => \"data\"}\n\nFinally, every time a message is pushed to the channel,\na reference is returned. We can use this reference to\nassert a particular reply was sent from the server:\n\n    ref = push(socket, \"counter\", %{})\n    assert_reply ref, :ok, %{\"counter\" => 1}","ref":"Phoenix.ChannelTest.html#module-channel-testing"},{"type":"module","title":"Checking side-effects - Phoenix.ChannelTest","doc":"Often one may want to do side-effects inside channels,\nlike writing to the database, and verify those side-effects\nduring their tests.\n\nImagine the following `handle_in/3` inside a channel:\n\n    def handle_in(\"publish\", %{\"id\" => id}, socket) do\n      Repo.get!(Post, id) |> Post.publish() |> Repo.update!()\n      {:noreply, socket}\n    end\n\nBecause the whole communication is asynchronous, the\nfollowing test would be very brittle:\n\n    push(socket, \"publish\", %{\"id\" => 3})\n    assert Repo.get_by(Post, id: 3, published: true)\n\nThe issue is that we have no guarantees the channel has\ndone processing our message after calling `push/3`. The\nbest solution is to assert the channel sent us a reply\nbefore doing any other assertion. First change the\nchannel to send replies:\n\n    def handle_in(\"publish\", %{\"id\" => id}, socket) do\n      Repo.get!(Post, id) |> Post.publish() |> Repo.update!()\n      {:reply, :ok, socket}\n    end\n\nThen expect them in the test:\n\n    ref = push(socket, \"publish\", %{\"id\" => 3})\n    assert_reply ref, :ok\n    assert Repo.get_by(Post, id: 3, published: true)","ref":"Phoenix.ChannelTest.html#module-checking-side-effects"},{"type":"module","title":"Leave and close - Phoenix.ChannelTest","doc":"This module also provides functions to simulate leaving\nand closing a channel. Once you leave or close a channel,\nbecause the channel is linked to the test process on join,\nit will crash the test process:\n\n    leave(socket)\n    ** (EXIT from #PID<...>) {:shutdown, :leave}\n\nYou can avoid this by unlinking the channel process in\nthe test:\n\n    Process.unlink(socket.channel_pid)\n\nNotice `leave/1` is async, so it will also return a\nreference which you can use to check for a reply:\n\n    ref = leave(socket)\n    assert_reply ref, :ok\n\nOn the other hand, close is always sync and it will\nreturn only after the channel process is guaranteed to\nhave been terminated:\n\n    :ok = close(socket)\n\nThis mimics the behaviour existing in clients.\n\nTo assert that your channel closes or errors asynchronously,\nyou can monitor the channel process with the tools provided\nby Elixir, and wait for the `:DOWN` message.\nImagine an implementation of the `handle_info/2` function\nthat closes the channel when it receives `:some_message`:\n\n    def handle_info(:some_message, socket) do\n      {:stop, :normal, socket}\n    end\n\nIn your test, you can assert that the close happened by:\n\n    Process.monitor(socket.channel_pid)\n    send(socket.channel_pid, :some_message)\n    assert_receive {:DOWN, _, _, _, :normal}","ref":"Phoenix.ChannelTest.html#module-leave-and-close"},{"type":"macro","title":"Phoenix.ChannelTest.assert_broadcast/3","doc":"Asserts the channel has broadcast a message within `timeout`.\n\nBefore asserting anything was broadcast, we must first\nsubscribe to the topic of the channel in the test process:\n\n    @endpoint.subscribe(\"foo:ok\")\n\nNow we can match on event and payload as patterns:\n\n    assert_broadcast \"some_event\", %{\"data\" => _}\n\nIn the assertion above, we don't particularly care about\nthe data being sent, as long as something was sent.\n\nThe timeout is in milliseconds and defaults to the `:assert_receive_timeout`\nset on the `:ex_unit` application (which defaults to 100ms).","ref":"Phoenix.ChannelTest.html#assert_broadcast/3"},{"type":"macro","title":"Phoenix.ChannelTest.assert_push/3","doc":"Asserts the channel has pushed a message back to the client\nwith the given event and payload within `timeout`.\n\nNotice event and payload are patterns. This means one can write:\n\n    assert_push \"some_event\", %{\"data\" => _}\n\nIn the assertion above, we don't particularly care about\nthe data being sent, as long as something was sent.\n\nThe timeout is in milliseconds and defaults to the `:assert_receive_timeout`\nset on the `:ex_unit` application (which defaults to 100ms).\n\n**NOTE:** Because event and payload are patterns, they will be matched.  This\nmeans that if you wish to assert that the received payload is equivalent to\nan existing variable, you need to pin the variable in the assertion\nexpression.\n\nGood:\n\n    expected_payload = %{foo: \"bar\"}\n    assert_push \"some_event\", ^expected_payload\n\nBad:\n\n    expected_payload = %{foo: \"bar\"}\n    assert_push \"some_event\", expected_payload\n    # The code above does not assert the payload matches the described map.","ref":"Phoenix.ChannelTest.html#assert_push/3"},{"type":"macro","title":"Phoenix.ChannelTest.assert_reply/4","doc":"Asserts the channel has replied to the given message within\n`timeout`.\n\nNotice status and payload are patterns. This means one can write:\n\n    ref = push(channel, \"some_event\")\n    assert_reply ref, :ok, %{\"data\" => _}\n\nIn the assertion above, we don't particularly care about\nthe data being sent, as long as something was replied.\n\nThe timeout is in milliseconds and defaults to the `:assert_receive_timeout`\nset on the `:ex_unit` application (which defaults to 100ms).","ref":"Phoenix.ChannelTest.html#assert_reply/4"},{"type":"function","title":"Phoenix.ChannelTest.broadcast_from/3","doc":"Broadcast event from pid to all subscribers of the socket topic.\n\nThe test process will not receive the published message. This triggers\nthe `handle_out/3` callback in the channel.","ref":"Phoenix.ChannelTest.html#broadcast_from/3"},{"type":"function","title":"Examples - Phoenix.ChannelTest.broadcast_from/3","doc":"iex> broadcast_from(socket, \"new_message\", %{id: 1, content: \"hello\"})\n    :ok","ref":"Phoenix.ChannelTest.html#broadcast_from/3-examples"},{"type":"function","title":"Phoenix.ChannelTest.broadcast_from!/3","doc":"Same as `broadcast_from/3`, but raises if broadcast fails.","ref":"Phoenix.ChannelTest.html#broadcast_from!/3"},{"type":"function","title":"Phoenix.ChannelTest.close/2","doc":"Emulates the client closing the socket.\n\nClosing socket is synchronous and has a default timeout\nof 5000 milliseconds.","ref":"Phoenix.ChannelTest.html#close/2"},{"type":"macro","title":"Phoenix.ChannelTest.connect/3","doc":"Initiates a transport connection for the socket handler.\n\nUseful for testing UserSocket authentication. Returns\nthe result of the handler's `connect/3` callback.","ref":"Phoenix.ChannelTest.html#connect/3"},{"type":"function","title":"Phoenix.ChannelTest.join/2","doc":"See `join/4`.","ref":"Phoenix.ChannelTest.html#join/2"},{"type":"function","title":"Phoenix.ChannelTest.join/3","doc":"See `join/4`.","ref":"Phoenix.ChannelTest.html#join/3"},{"type":"function","title":"Phoenix.ChannelTest.join/4","doc":"Joins the channel under the given topic and payload.\n\nThe given channel is joined in a separate process\nwhich is linked to the test process.\n\nIt returns `{:ok, reply, socket}` or `{:error, reply}`.","ref":"Phoenix.ChannelTest.html#join/4"},{"type":"function","title":"Phoenix.ChannelTest.leave/1","doc":"Emulates the client leaving the channel.","ref":"Phoenix.ChannelTest.html#leave/1"},{"type":"function","title":"Phoenix.ChannelTest.push/3","doc":"Pushes a message into the channel.\n\nThe triggers the `handle_in/3` callback in the channel.","ref":"Phoenix.ChannelTest.html#push/3"},{"type":"function","title":"Examples - Phoenix.ChannelTest.push/3","doc":"iex> push(socket, \"new_message\", %{id: 1, content: \"hello\"})\n    reference","ref":"Phoenix.ChannelTest.html#push/3-examples"},{"type":"macro","title":"Phoenix.ChannelTest.refute_broadcast/3","doc":"Asserts the channel has not broadcast a message within `timeout`.\n\nLike `assert_broadcast`, the event and payload are patterns.\n\nThe timeout is in milliseconds and defaults to the `:refute_receive_timeout`\nset on the `:ex_unit` application (which defaults to 100ms).\nKeep in mind this macro will block the test by the\ntimeout value, so use it only when necessary as overuse\nwill certainly slow down your test suite.","ref":"Phoenix.ChannelTest.html#refute_broadcast/3"},{"type":"macro","title":"Phoenix.ChannelTest.refute_push/3","doc":"Asserts the channel has not pushed a message to the client\nmatching the given event and payload within `timeout`.\n\nLike `assert_push`, the event and payload are patterns.\n\nThe timeout is in milliseconds and defaults to the `:refute_receive_timeout`\nset on the `:ex_unit` application (which defaults to 100ms).\nKeep in mind this macro will block the test by the\ntimeout value, so use it only when necessary as overuse\nwill certainly slow down your test suite.","ref":"Phoenix.ChannelTest.html#refute_push/3"},{"type":"macro","title":"Phoenix.ChannelTest.refute_reply/4","doc":"Asserts the channel has not replied with a matching payload within\n`timeout`.\n\nLike `assert_reply`, the event and payload are patterns.\n\nThe timeout is in milliseconds and defaults to the `:refute_receive_timeout`\nset on the `:ex_unit` application (which defaults to 100ms).\nKeep in mind this macro will block the test by the\ntimeout value, so use it only when necessary as overuse\nwill certainly slow down your test suite.","ref":"Phoenix.ChannelTest.html#refute_reply/4"},{"type":"macro","title":"Phoenix.ChannelTest.socket/1","doc":"Builds a socket for the given `socket_module`.\n\nThe socket is then used to subscribe and join channels.\nUse this function when you want to create a blank socket\nto pass to functions like `UserSocket.connect/3`.\n\nOtherwise, use `socket/4` if you want to build a socket with\nexisting id and assigns.","ref":"Phoenix.ChannelTest.html#socket/1"},{"type":"macro","title":"Examples - Phoenix.ChannelTest.socket/1","doc":"socket(MyApp.UserSocket)","ref":"Phoenix.ChannelTest.html#socket/1-examples"},{"type":"macro","title":"Phoenix.ChannelTest.socket/4","doc":"Builds a socket for the given `socket_module` with given id and assigns.","ref":"Phoenix.ChannelTest.html#socket/4"},{"type":"macro","title":"Examples - Phoenix.ChannelTest.socket/4","doc":"socket(MyApp.UserSocket, \"user_id\", %{some: :assign})\n\nIf you need to access the socket in another process than the test process,\nyou can give the `pid` of the test process in the 4th argument.","ref":"Phoenix.ChannelTest.html#socket/4-examples"},{"type":"macro","title":"Examples - Phoenix.ChannelTest.socket/4","doc":"test \"connect in a task\" do\n      pid = self()\n      task = Task.async(fn -> \n        socket = socket(MyApp.UserSocket, \"user_id\", %{some: :assign}, test_process: pid)\n        broadcast_from!(socket, \"default\", %{\"foo\" => \"bar\"})\n        assert_push \"default\", %{\"foo\" => \"bar\"}\n      end)\n      Task.await(task)\n    end","ref":"Phoenix.ChannelTest.html#socket/4-examples"},{"type":"function","title":"Phoenix.ChannelTest.subscribe_and_join/2","doc":"See `subscribe_and_join/4`.","ref":"Phoenix.ChannelTest.html#subscribe_and_join/2"},{"type":"function","title":"Phoenix.ChannelTest.subscribe_and_join/3","doc":"See `subscribe_and_join/4`.","ref":"Phoenix.ChannelTest.html#subscribe_and_join/3"},{"type":"function","title":"Phoenix.ChannelTest.subscribe_and_join/4","doc":"Subscribes to the given topic and joins the channel\nunder the given topic and payload.\n\nBy subscribing to the topic, we can use `assert_broadcast/3`\nto verify a message has been sent through the pubsub layer.\n\nBy joining the channel, we can interact with it directly.\nThe given channel is joined in a separate process which is\nlinked to the test process.\n\nIf no channel module is provided, the socket's handler is used to\nlookup the matching channel for the given topic.\n\nIt returns `{:ok, reply, socket}` or `{:error, reply}`.","ref":"Phoenix.ChannelTest.html#subscribe_and_join/4"},{"type":"function","title":"Phoenix.ChannelTest.subscribe_and_join!/2","doc":"See `subscribe_and_join!/4`.","ref":"Phoenix.ChannelTest.html#subscribe_and_join!/2"},{"type":"function","title":"Phoenix.ChannelTest.subscribe_and_join!/3","doc":"See `subscribe_and_join!/4`.","ref":"Phoenix.ChannelTest.html#subscribe_and_join!/3"},{"type":"function","title":"Phoenix.ChannelTest.subscribe_and_join!/4","doc":"Same as `subscribe_and_join/4`, but returns either the socket\nor throws an error.\n\nThis is helpful when you are not testing joining the channel\nand just need the socket.","ref":"Phoenix.ChannelTest.html#subscribe_and_join!/4"},{"type":"module","title":"Phoenix.ConnTest","doc":"Conveniences for testing Phoenix endpoints and connection related helpers.\n\nYou likely want to use this module or make it part of your `ExUnit.CaseTemplate`.\nOnce used, this module automatically imports all functions defined here as\nwell as the functions in `Plug.Conn`.","ref":"Phoenix.ConnTest.html"},{"type":"module","title":"Endpoint testing - Phoenix.ConnTest","doc":"`Phoenix.ConnTest` typically works against endpoints. That's the preferred way\nto test anything that your router dispatches to:\n\n    @endpoint MyAppWeb.Endpoint\n\n    test \"says welcome on the home page\" do\n      conn = get(build_conn(), \"/\")\n      assert conn.resp_body =~ \"Welcome!\"\n    end\n\n    test \"logs in\" do\n      conn = post(build_conn(), \"/login\", [username: \"john\", password: \"doe\"])\n      assert conn.resp_body =~ \"Logged in!\"\n    end\n\nThe `@endpoint` module attribute contains the endpoint under testing,\nmost commonly your application endpoint itself. If you are using the\nMyApp.ConnCase generated by Phoenix, it is automatically set for you.\n\nAs in your router and controllers, the connection is the main abstraction\nin testing. `build_conn()` returns a new connection and functions in this\nmodule can be used to manipulate the connection before dispatching\nto the endpoint.\n\nFor example, one could set the accepts header for json requests as\nfollows:\n\n    build_conn()\n    |> put_req_header(\"accept\", \"application/json\")\n    |> get(\"/\")\n\nYou can also create your own helpers, such as `json_conn()` that uses\n`build_conn/0` and `put_req_header/3`, so you avoid repeating the connection\nsetup throughout your tests.","ref":"Phoenix.ConnTest.html#module-endpoint-testing"},{"type":"module","title":"Controller testing - Phoenix.ConnTest","doc":"The functions in this module can also be used for controller testing.\nWhile endpoint testing is preferred over controller testing, especially\nsince the controller in Phoenix plays an integration role between your\ndomain and your views, unit testing controllers may be helpful in some\nsituations.\n\nFor such cases, you need to set the `@endpoint` attribute to your controller\nand pass an atom representing the action to dispatch:\n\n    @endpoint MyAppWeb.HomeController\n\n    test \"says welcome on the home page\" do\n      conn = get(build_conn(), :index)\n      assert conn.resp_body =~ \"Welcome!\"\n    end\n\nKeep in mind that, once the `@endpoint` variable is set, all tests after\nsetting it will be affected.","ref":"Phoenix.ConnTest.html#module-controller-testing"},{"type":"module","title":"Views testing - Phoenix.ConnTest","doc":"Under other circumstances, you may be testing a view or another layer that\nrequires a connection for processing. For such cases, a connection can be\ncreated using the `build_conn/3` helper:\n\n    MyApp.UserView.render(\"hello.html\", conn: build_conn(:get, \"/\"))\n\nWhile `build_conn/0` returns a connection with no request information to it,\n`build_conn/3` returns a connection with the given request information already\nfilled in.","ref":"Phoenix.ConnTest.html#module-views-testing"},{"type":"module","title":"Recycling - Phoenix.ConnTest","doc":"Browsers implement a storage by using cookies. When a cookie is set in the\nresponse, the browser stores it and sends it in the next request.\n\nTo emulate this behaviour, this module provides the idea of recycling.\nThe `recycle/1` function receives a connection and returns a new connection,\nsimilar to the one returned by `build_conn/0` with all the response cookies\nfrom the previous connection defined as request headers. This is useful when\ntesting multiple routes that require cookies or session to work.\n\nKeep in mind Phoenix will automatically recycle the connection between\ndispatches. This usually works out well most times, but it may discard\ninformation if you are modifying the connection before the next dispatch:\n\n    # No recycling as the connection is fresh\n    conn = get(build_conn(), \"/\")\n\n    # The connection is recycled, creating a new one behind the scenes\n    conn = post(conn, \"/login\")\n\n    # We can also recycle manually in case we want custom headers\n    conn =\n      conn\n      |> recycle()\n      |> put_req_header(\"x-special\", \"nice\")\n\n    # No recycling as we did it explicitly\n    conn = delete(conn, \"/logout\")\n\nRecycling also recycles the \"accept\" and \"authorization\" headers,\nas well as peer data information.","ref":"Phoenix.ConnTest.html#module-recycling"},{"type":"function","title":"Phoenix.ConnTest.assert_error_sent/2","doc":"Asserts an error was wrapped and sent with the given status.\n\nUseful for testing actions that you expect raise an error and have\nthe response wrapped in an HTTP status, with content usually rendered\nby your MyAppWeb.ErrorHTML view.\n\nThe function accepts a status either as an integer HTTP status or\natom, such as `500` or `:internal_server_error`. The list of allowed atoms is available\nin `Plug.Conn.Status`. If an error is raised, a 3-tuple of the wrapped\nresponse is returned matching the status, headers, and body of the response:\n\n    {500, [{\"content-type\", \"text/html\"} | _], \"Internal Server Error\"}","ref":"Phoenix.ConnTest.html#assert_error_sent/2"},{"type":"function","title":"Examples - Phoenix.ConnTest.assert_error_sent/2","doc":"assert_error_sent :internal_server_error, fn ->\n      get(build_conn(), \"/broken/route\")\n    end\n\n    response = assert_error_sent 500, fn ->\n      get(build_conn(), \"/broken/route\")\n    end\n    assert {500, [_h | _t], \"Internal Server Error\"} = response\n\nThis can also be used to test a route resulted in an error that was translated to a\nspecific response by the `Plug.Status` protocol, such as `Ecto.NoResultsError`:\n\n    assert_error_sent :not_found, fn ->\n      get(build_conn(), \"/something-that-raises-no-results-error\")\n    end\n\n*Note*: for routes that don't raise an error, but instead return a status, you should test the\nresponse directly:\n\n    conn = get(build_conn(), \"/users/not-found\")\n    assert response(conn, 404)","ref":"Phoenix.ConnTest.html#assert_error_sent/2-examples"},{"type":"function","title":"Phoenix.ConnTest.build_conn/0","doc":"Creates a connection to be used in upcoming requests.","ref":"Phoenix.ConnTest.html#build_conn/0"},{"type":"function","title":"Phoenix.ConnTest.build_conn/3","doc":"Creates a connection to be used in upcoming requests\nwith a preset method, path and body.\n\nThis is useful when a specific connection is required\nfor testing a plug or a particular function.","ref":"Phoenix.ConnTest.html#build_conn/3"},{"type":"function","title":"Phoenix.ConnTest.bypass_through/1","doc":"Calls the Endpoint and Router pipelines.\n\nUseful for unit testing Plugs where Endpoint and/or router pipeline\nplugs are required for proper setup.\n\nNote the use of `get(\"/\")` following `bypass_through` in the examples below.\nTo execute the plug pipelines, you must issue a request against the router.\nMost often, you can simply send a GET request against the root path, but you\nmay also specify a different method or path which your pipelines may operate\nagainst.","ref":"Phoenix.ConnTest.html#bypass_through/1"},{"type":"function","title":"Examples - Phoenix.ConnTest.bypass_through/1","doc":"For example, imagine you are testing an authentication plug in\nisolation, but you need to invoke the Endpoint plugs and router\npipelines to set up session and flash related dependencies.\nOne option is to invoke an existing route that uses the proper\npipelines. You can do so by passing the connection and the\nrouter name to `bypass_through`:\n\n    conn =\n      conn\n      |> bypass_through(MyAppWeb.Router)\n      |> get(\"/some_url\")\n      |> MyApp.RequireAuthentication.call([])\n    assert conn.halted\n\nYou can also specify which pipelines you want to run:\n\n    conn =\n      conn\n      |> bypass_through(MyAppWeb.Router, [:browser])\n      |> get(\"/\")\n      |> MyApp.RequireAuthentication.call([])\n    assert conn.halted\n\nAlternatively, you could only invoke the Endpoint's plugs:\n\n    conn =\n      conn\n      |> bypass_through()\n      |> get(\"/\")\n      |> MyApp.RequireAuthentication.call([])\n\n    assert conn.halted","ref":"Phoenix.ConnTest.html#bypass_through/1-examples"},{"type":"function","title":"Phoenix.ConnTest.bypass_through/2","doc":"Calls the Endpoint and Router pipelines for the current route.\n\nSee `bypass_through/1`.","ref":"Phoenix.ConnTest.html#bypass_through/2"},{"type":"function","title":"Phoenix.ConnTest.bypass_through/3","doc":"Calls the Endpoint and the given Router pipelines.\n\nSee `bypass_through/1`.","ref":"Phoenix.ConnTest.html#bypass_through/3"},{"type":"function","title":"Phoenix.ConnTest.clear_flash/1","doc":"Clears up the flash storage.","ref":"Phoenix.ConnTest.html#clear_flash/1"},{"type":"macro","title":"Phoenix.ConnTest.connect/3","doc":"Dispatches to the current endpoint.\n\nSee `dispatch/5` for more information.","ref":"Phoenix.ConnTest.html#connect/3"},{"type":"macro","title":"Phoenix.ConnTest.delete/3","doc":"Dispatches to the current endpoint.\n\nSee `dispatch/5` for more information.","ref":"Phoenix.ConnTest.html#delete/3"},{"type":"function","title":"Phoenix.ConnTest.delete_req_cookie/2","doc":"Deletes a request cookie.","ref":"Phoenix.ConnTest.html#delete_req_cookie/2"},{"type":"function","title":"Phoenix.ConnTest.dispatch/5","doc":"Dispatches the connection to the given endpoint.\n\nWhen invoked via `get/3`, `post/3` and friends, the endpoint\nis automatically retrieved from the `@endpoint` module\nattribute, otherwise it must be given as an argument.\n\nThe connection will be configured with the given `method`,\n`path_or_action` and `params_or_body`.\n\nIf `path_or_action` is a string, it is considered to be the\nrequest path and stored as so in the connection. If an atom,\nit is assumed to be an action and the connection is dispatched\nto the given action.","ref":"Phoenix.ConnTest.html#dispatch/5"},{"type":"function","title":"Parameters and body - Phoenix.ConnTest.dispatch/5","doc":"This function, as well as `get/3`, `post/3` and friends, accepts the\nrequest body or parameters as last argument:\n\n      get(build_conn(), \"/\", some: \"param\")\n      get(build_conn(), \"/\", \"some=param&url=encoded\")\n\nThe allowed values are:\n\n  * `nil` - meaning there is no body\n\n  * a binary - containing a request body. For such cases, `:headers`\n    must be given as option with a content-type\n\n  * a map or list - containing the parameters which will automatically\n    set the content-type to multipart. The map or list may contain\n    other lists or maps and all entries will be normalized to string\n    keys\n\n  * a struct - unlike other maps, a struct will be passed through as-is\n    without normalizing its entries","ref":"Phoenix.ConnTest.html#dispatch/5-parameters-and-body"},{"type":"function","title":"Phoenix.ConnTest.ensure_recycled/1","doc":"Ensures the connection is recycled if it wasn't already.\n\nSee `recycle/1` for more information.","ref":"Phoenix.ConnTest.html#ensure_recycled/1"},{"type":"function","title":"Phoenix.ConnTest.fetch_flash/1","doc":"Fetches the flash storage.","ref":"Phoenix.ConnTest.html#fetch_flash/1"},{"type":"macro","title":"Phoenix.ConnTest.get/3","doc":"Dispatches to the current endpoint.\n\nSee `dispatch/5` for more information.","ref":"Phoenix.ConnTest.html#get/3"},{"type":"function","title":"Phoenix.ConnTest.get_flash/1","doc":"Gets the whole flash storage.","ref":"Phoenix.ConnTest.html#get_flash/1"},{"type":"function","title":"Phoenix.ConnTest.get_flash/2","doc":"Gets the given key from the flash storage.","ref":"Phoenix.ConnTest.html#get_flash/2"},{"type":"macro","title":"Phoenix.ConnTest.head/3","doc":"Dispatches to the current endpoint.\n\nSee `dispatch/5` for more information.","ref":"Phoenix.ConnTest.html#head/3"},{"type":"function","title":"Phoenix.ConnTest.html_response/2","doc":"Asserts the given status code, that we have an html response and\nreturns the response body if one was set or sent.","ref":"Phoenix.ConnTest.html#html_response/2"},{"type":"function","title":"Examples - Phoenix.ConnTest.html_response/2","doc":"assert html_response(conn, 200) =~ \" \"","ref":"Phoenix.ConnTest.html#html_response/2-examples"},{"type":"function","title":"Phoenix.ConnTest.init_test_session/2","doc":"Inits a session used exclusively for testing.","ref":"Phoenix.ConnTest.html#init_test_session/2"},{"type":"function","title":"Phoenix.ConnTest.json_response/2","doc":"Asserts the given status code, that we have a json response and\nreturns the decoded JSON response if one was set or sent.","ref":"Phoenix.ConnTest.html#json_response/2"},{"type":"function","title":"Examples - Phoenix.ConnTest.json_response/2","doc":"body = json_response(conn, 200)\n    assert \"can't be blank\" in body[\"errors\"]","ref":"Phoenix.ConnTest.html#json_response/2-examples"},{"type":"macro","title":"Phoenix.ConnTest.options/3","doc":"Dispatches to the current endpoint.\n\nSee `dispatch/5` for more information.","ref":"Phoenix.ConnTest.html#options/3"},{"type":"macro","title":"Phoenix.ConnTest.patch/3","doc":"Dispatches to the current endpoint.\n\nSee `dispatch/5` for more information.","ref":"Phoenix.ConnTest.html#patch/3"},{"type":"function","title":"Phoenix.ConnTest.path_params/2","doc":"Returns the matched params of the URL for the `%Plug.Conn{}`'s router.\n\nUseful for extracting path params out of returned URLs, such as those\nreturned by `Phoenix.LiveViewTest`'s redirected results.","ref":"Phoenix.ConnTest.html#path_params/2"},{"type":"function","title":"Examples - Phoenix.ConnTest.path_params/2","doc":"assert {:error, {:redirect, %{to: \"/posts/123\" = to}}} = live(conn, \"/path\")\n    assert %{id: \"123\"} = path_params(conn, to)","ref":"Phoenix.ConnTest.html#path_params/2-examples"},{"type":"macro","title":"Phoenix.ConnTest.post/3","doc":"Dispatches to the current endpoint.\n\nSee `dispatch/5` for more information.","ref":"Phoenix.ConnTest.html#post/3"},{"type":"macro","title":"Phoenix.ConnTest.put/3","doc":"Dispatches to the current endpoint.\n\nSee `dispatch/5` for more information.","ref":"Phoenix.ConnTest.html#put/3"},{"type":"function","title":"Phoenix.ConnTest.put_flash/3","doc":"Puts the given value under key in the flash storage.","ref":"Phoenix.ConnTest.html#put_flash/3"},{"type":"function","title":"Phoenix.ConnTest.put_req_cookie/3","doc":"Puts a request cookie.","ref":"Phoenix.ConnTest.html#put_req_cookie/3"},{"type":"function","title":"Phoenix.ConnTest.recycle/2","doc":"Recycles the connection.\n\nRecycling receives a connection and returns a new connection,\ncontaining cookies and relevant information from the given one.\n\nThis emulates behaviour performed by browsers where cookies\nreturned in the response are available in following requests.\n\nBy default, only the headers \"accept\", \"accept-language\", and\n\"authorization\" are recycled. However, a custom set of headers\ncan be specified by passing a list of strings representing its\nnames as the second argument of the function.\n\nNote `recycle/1` is automatically invoked when dispatching\nto the endpoint, unless the connection has already been\nrecycled.","ref":"Phoenix.ConnTest.html#recycle/2"},{"type":"function","title":"Phoenix.ConnTest.redirected_params/2","doc":"Returns the matched params from the URL the connection was redirected to.\n\nUses the provided `%Plug.Conn{}`s router matched in the previous request.\nRaises if the response's location header is not set or if the response does\nnot match the redirect status code (defaults to 302).","ref":"Phoenix.ConnTest.html#redirected_params/2"},{"type":"function","title":"Examples - Phoenix.ConnTest.redirected_params/2","doc":"assert redirected_to(conn) =~ \"/posts/123\"\n    assert %{id: \"123\"} = redirected_params(conn)\n    assert %{id: \"123\"} = redirected_params(conn, 303)","ref":"Phoenix.ConnTest.html#redirected_params/2-examples"},{"type":"function","title":"Phoenix.ConnTest.redirected_to/2","doc":"Returns the location header from the given redirect response.\n\nRaises if the response does not match the redirect status code\n(defaults to 302).","ref":"Phoenix.ConnTest.html#redirected_to/2"},{"type":"function","title":"Examples - Phoenix.ConnTest.redirected_to/2","doc":"assert redirected_to(conn) =~ \"/foo/bar\"\n    assert redirected_to(conn, 301) =~ \"/foo/bar\"\n    assert redirected_to(conn, :moved_permanently) =~ \"/foo/bar\"","ref":"Phoenix.ConnTest.html#redirected_to/2-examples"},{"type":"function","title":"Phoenix.ConnTest.response/2","doc":"Asserts the given status code and returns the response body\nif one was set or sent.","ref":"Phoenix.ConnTest.html#response/2"},{"type":"function","title":"Examples - Phoenix.ConnTest.response/2","doc":"conn = get(build_conn(), \"/\")\n    assert response(conn, 200) =~ \"hello world\"","ref":"Phoenix.ConnTest.html#response/2-examples"},{"type":"function","title":"Phoenix.ConnTest.response_content_type/2","doc":"Returns the content type as long as it matches the given format.","ref":"Phoenix.ConnTest.html#response_content_type/2"},{"type":"function","title":"Examples - Phoenix.ConnTest.response_content_type/2","doc":"# Assert we have an html response with utf-8 charset\n    assert response_content_type(conn, :html) =~ \"charset=utf-8\"","ref":"Phoenix.ConnTest.html#response_content_type/2-examples"},{"type":"function","title":"Phoenix.ConnTest.text_response/2","doc":"Asserts the given status code, that we have a text response and\nreturns the response body if one was set or sent.","ref":"Phoenix.ConnTest.html#text_response/2"},{"type":"function","title":"Examples - Phoenix.ConnTest.text_response/2","doc":"assert text_response(conn, 200) =~ \"hello\"","ref":"Phoenix.ConnTest.html#text_response/2-examples"},{"type":"macro","title":"Phoenix.ConnTest.trace/3","doc":"Dispatches to the current endpoint.\n\nSee `dispatch/5` for more information.","ref":"Phoenix.ConnTest.html#trace/3"},{"type":"module","title":"Phoenix.CodeReloader","doc":"A plug and module to handle automatic code reloading.\n\nTo avoid race conditions, all code reloads are funneled through a\nsequential call operation.","ref":"Phoenix.CodeReloader.html"},{"type":"function","title":"Phoenix.CodeReloader.call/2","doc":"API used by Plug to invoke the code reloader on every request.","ref":"Phoenix.CodeReloader.html#call/2"},{"type":"function","title":"Phoenix.CodeReloader.init/1","doc":"API used by Plug to start the code reloader.","ref":"Phoenix.CodeReloader.html#init/1"},{"type":"function","title":"Phoenix.CodeReloader.reload/2","doc":"Reloads code for the current Mix project by invoking the\n`:reloadable_compilers` on the list of `:reloadable_apps`.\n\nThis is configured in your application environment like:\n\n    config :your_app, YourAppWeb.Endpoint,\n      reloadable_compilers: [:gettext, :elixir],\n      reloadable_apps: [:ui, :backend]\n\nKeep in mind `:reloadable_compilers` must be a subset of the\n`:compilers` specified in `project/0` in your `mix.exs`.\n\nThe `:reloadable_apps` defaults to `nil`. In such case\ndefault behaviour is to reload the current project if it\nconsists of a single app, or all applications within an umbrella\nproject. You can set `:reloadable_apps` to a subset of default\napplications to reload only some of them, an empty list - to\neffectively disable the code reloader, or include external\napplications from library dependencies.\n\nThis function is a no-op and returns `:ok` if Mix is not available.","ref":"Phoenix.CodeReloader.html#reload/2"},{"type":"function","title":"Options - Phoenix.CodeReloader.reload/2","doc":"* `:reloadable_args` - additional CLI args to pass to the compiler tasks.\n    Defaults to `[\"--no-all-warnings\"]` so only warnings related to the\n    files being compiled are printed","ref":"Phoenix.CodeReloader.html#reload/2-options"},{"type":"function","title":"Phoenix.CodeReloader.reload!/2","doc":"Same as `reload/1` but it will raise if Mix is not available.","ref":"Phoenix.CodeReloader.html#reload!/2"},{"type":"function","title":"Phoenix.CodeReloader.sync/0","doc":"Synchronizes with the code server if it is alive.\n\nIt returns `:ok`. If it is not running, it also returns `:ok`.","ref":"Phoenix.CodeReloader.html#sync/0"},{"type":"module","title":"Phoenix.Endpoint.Cowboy2Adapter","doc":"The Cowboy2 adapter for Phoenix.","ref":"Phoenix.Endpoint.Cowboy2Adapter.html"},{"type":"module","title":"Endpoint configuration - Phoenix.Endpoint.Cowboy2Adapter","doc":"This adapter uses the following endpoint configuration:\n\n  * `:http` - the configuration for the HTTP server. It accepts all options\n    as defined by [`Plug.Cowboy`](https://hexdocs.pm/plug_cowboy/). Defaults\n    to `false`\n\n  * `:https` - the configuration for the HTTPS server. It accepts all options\n    as defined by [`Plug.Cowboy`](https://hexdocs.pm/plug_cowboy/). Defaults\n    to `false`\n\n  * `:drainer` - a drainer process that triggers when your application is\n    shutting down to wait for any on-going request to finish. It accepts all\n    options as defined by [`Plug.Cowboy.Drainer`](https://hexdocs.pm/plug_cowboy/Plug.Cowboy.Drainer.html).\n    Defaults to `[]`, which will start a drainer process for each configured endpoint,\n    but can be disabled by setting it to `false`.","ref":"Phoenix.Endpoint.Cowboy2Adapter.html#module-endpoint-configuration"},{"type":"module","title":"Custom dispatch options - Phoenix.Endpoint.Cowboy2Adapter","doc":"You can provide custom dispatch options in order to use Phoenix's\nbuiltin Cowboy server with custom handlers. For example, to handle\nraw WebSockets [as shown in Cowboy's docs](https://github.com/ninenines/cowboy/tree/master/examples)).\n\nThe options are passed to both `:http` and `:https` keys in the\nendpoint configuration. However, once you pass your custom dispatch\noptions, you will need to manually wire the Phoenix endpoint by\nadding the following rule:\n\n    {:_, Plug.Cowboy.Handler, {MyAppWeb.Endpoint, []}}\n\nFor example:\n\n    config :myapp, MyAppWeb.Endpoint,\n      http: [dispatch: [\n              {:_, [\n                  {\"/foo\", MyAppWeb.CustomHandler, []},\n                  {:_, Plug.Cowboy.Handler, {MyAppWeb.Endpoint, []}}\n                ]}]]\n\nIt is also important to specify your handlers first, otherwise\nPhoenix will intercept the requests before they get to your handler.","ref":"Phoenix.Endpoint.Cowboy2Adapter.html#module-custom-dispatch-options"},{"type":"function","title":"Phoenix.Endpoint.Cowboy2Adapter.server_info/2","doc":"","ref":"Phoenix.Endpoint.Cowboy2Adapter.html#server_info/2"},{"type":"module","title":"Phoenix.Endpoint.SyncCodeReloadPlug","doc":"Wraps an Endpoint, attempting to sync with Phoenix's code reloader if \nan exception is raising which indicates that we may be in the middle of a reload.\n\nWe detect this by looking at the raised exception and seeing if it indicates\nthat the endpoint is not defined. This indicates that the code reloader may be \nmid way through a compile, and that we should attempt to retry the request\nafter the compile has completed. This is also why this must be implemented in\na separate module (one that is not recompiled in a typical code reload cycle),\nsince otherwise it may be the case that the endpoint itself is not defined.","ref":"Phoenix.Endpoint.SyncCodeReloadPlug.html"},{"type":"function","title":"Phoenix.Endpoint.SyncCodeReloadPlug.call/2","doc":"","ref":"Phoenix.Endpoint.SyncCodeReloadPlug.html#call/2"},{"type":"function","title":"Phoenix.Endpoint.SyncCodeReloadPlug.init/1","doc":"","ref":"Phoenix.Endpoint.SyncCodeReloadPlug.html#init/1"},{"type":"behaviour","title":"Phoenix.Digester.Compressor","doc":"Defines the `Phoenix.Digester.Compressor` behaviour for\nimplementing static file compressors.\n\nA custom compressor expects 2 functions to be implemented.\n\nBy default, Phoenix uses only `Phoenix.Digester.Gzip` to compress\nstatic files, but additional compressors can be defined and added\nto the digest process.","ref":"Phoenix.Digester.Compressor.html"},{"type":"behaviour","title":"Example - Phoenix.Digester.Compressor","doc":"If you wanted to compress files using an external brotli compression\nlibrary, you could define a new module implementing the behaviour and add the\nmodule to the list of configured Phoenix static compressors.\n\n    defmodule MyApp.BrotliCompressor do\n      @behaviour Phoenix.Digester.Compressor\n\n      def compress_file(file_path, content) do\n        valid_extension = Path.extname(file_path) in Application.fetch_env!(:phoenix, :gzippable_exts)\n        {:ok, compressed_content} = :brotli.encode(content)\n\n        if valid_extension && byte_size(compressed_content) < byte_size(content) do\n          {:ok, compressed_content}\n        else\n          :error\n        end\n      end\n\n      def file_extensions do\n        [\".br\"]\n      end\n    end\n\n    # config/config.exs\n    config :phoenix,\n      static_compressors: [Phoenix.Digester.Gzip, MyApp.BrotliCompressor],\n      # ...","ref":"Phoenix.Digester.Compressor.html#module-example"},{"type":"callback","title":"Phoenix.Digester.Compressor.compress_file/2","doc":"","ref":"Phoenix.Digester.Compressor.html#c:compress_file/2"},{"type":"callback","title":"Phoenix.Digester.Compressor.file_extensions/0","doc":"","ref":"Phoenix.Digester.Compressor.html#c:file_extensions/0"},{"type":"module","title":"Phoenix.Digester.Gzip","doc":"Gzip compressor for Phoenix.Digester","ref":"Phoenix.Digester.Gzip.html"},{"type":"function","title":"Phoenix.Digester.Gzip.compress_file/2","doc":"","ref":"Phoenix.Digester.Gzip.html#compress_file/2"},{"type":"function","title":"Phoenix.Digester.Gzip.file_extensions/0","doc":"","ref":"Phoenix.Digester.Gzip.html#file_extensions/0"},{"type":"module","title":"Phoenix.Socket.Broadcast","doc":"Defines a message sent from pubsub to channels and vice-versa.\n\nThe message format requires the following keys:\n\n  * `:topic` - The string topic or topic:subtopic pair namespace, for example \"messages\", \"messages:123\"\n  * `:event`- The string event name, for example \"phx_join\"\n  * `:payload` - The message payload","ref":"Phoenix.Socket.Broadcast.html"},{"type":"type","title":"Phoenix.Socket.Broadcast.t/0","doc":"","ref":"Phoenix.Socket.Broadcast.html#t:t/0"},{"type":"module","title":"Phoenix.Socket.Message","doc":"Defines a message dispatched over transport to channels and vice-versa.\n\nThe message format requires the following keys:\n\n  * `:topic` - The string topic or topic:subtopic pair namespace, for\n    example \"messages\", \"messages:123\"\n  * `:event`- The string event name, for example \"phx_join\"\n  * `:payload` - The message payload\n  * `:ref` - The unique string ref\n  * `:join_ref` - The unique string ref when joining","ref":"Phoenix.Socket.Message.html"},{"type":"function","title":"Phoenix.Socket.Message.from_map!/1","doc":"Converts a map with string keys into a message struct.\n\nRaises `Phoenix.Socket.InvalidMessageError` if not valid.","ref":"Phoenix.Socket.Message.html#from_map!/1"},{"type":"type","title":"Phoenix.Socket.Message.t/0","doc":"","ref":"Phoenix.Socket.Message.html#t:t/0"},{"type":"module","title":"Phoenix.Socket.Reply","doc":"Defines a reply sent from channels to transports.\n\nThe message format requires the following keys:\n\n  * `:topic` - The string topic or topic:subtopic pair namespace, for example \"messages\", \"messages:123\"\n  * `:status` - The reply status as an atom\n  * `:payload` - The reply payload\n  * `:ref` - The unique string ref\n  * `:join_ref` - The unique string ref when joining","ref":"Phoenix.Socket.Reply.html"},{"type":"type","title":"Phoenix.Socket.Reply.t/0","doc":"","ref":"Phoenix.Socket.Reply.html#t:t/0"},{"type":"behaviour","title":"Phoenix.Socket.Serializer","doc":"A behaviour that serializes incoming and outgoing socket messages.\n\nBy default Phoenix provides a serializer that encodes to JSON and\ndecodes JSON messages.\n\nCustom serializers may be configured in the socket.","ref":"Phoenix.Socket.Serializer.html"},{"type":"callback","title":"Phoenix.Socket.Serializer.decode!/2","doc":"Decodes iodata into `Phoenix.Socket.Message` struct.","ref":"Phoenix.Socket.Serializer.html#c:decode!/2"},{"type":"callback","title":"Phoenix.Socket.Serializer.encode!/1","doc":"Encodes `Phoenix.Socket.Message` and `Phoenix.Socket.Reply` structs to push format.","ref":"Phoenix.Socket.Serializer.html#c:encode!/1"},{"type":"callback","title":"Phoenix.Socket.Serializer.fastlane!/1","doc":"Encodes a `Phoenix.Socket.Broadcast` struct to fastlane format.","ref":"Phoenix.Socket.Serializer.html#c:fastlane!/1"},{"type":"behaviour","title":"Phoenix.Socket.Transport","doc":"Outlines the Socket <-> Transport communication.\n\nEach transport, such as websockets and longpolling, must interact\nwith a socket. This module defines said behaviour.\n\n`Phoenix.Socket` is just one possible implementation of a socket\nthat multiplexes events over multiple channels. If you implement\nthis behaviour, then a transport can directly invoke your\nimplementation, without passing through channels.\n\nThis module also provides convenience functions for implementing\ntransports.","ref":"Phoenix.Socket.Transport.html"},{"type":"behaviour","title":"Example - Phoenix.Socket.Transport","doc":"Here is a simple echo socket implementation:\n\n    defmodule EchoSocket do\n      @behaviour Phoenix.Socket.Transport\n\n      def child_spec(opts) do\n        # We won't spawn any process, so let's ignore the child spec\n        :ignore\n      end\n\n      def connect(state) do\n        # Callback to retrieve relevant data from the connection.\n        # The map contains options, params, transport and endpoint keys.\n        {:ok, state}\n      end\n\n      def init(state) do\n        # Now we are effectively inside the process that maintains the socket.\n        {:ok, state}\n      end\n\n      def handle_in({text, _opts}, state) do\n        {:reply, :ok, {:text, text}, state}\n      end\n\n      def handle_info(_, state) do\n        {:ok, state}\n      end\n\n      def terminate(_reason, _state) do\n        :ok\n      end\n    end\n\nIt can be mounted in your endpoint like any other socket:\n\n    socket \"/socket\", EchoSocket, websocket: true, longpoll: true\n\nYou can now interact with the socket under `/socket/websocket`\nand `/socket/longpoll`.","ref":"Phoenix.Socket.Transport.html#module-example"},{"type":"behaviour","title":"Custom transports - Phoenix.Socket.Transport","doc":"Sockets are operated by a transport. When a transport is defined,\nit usually receives a socket module and the module will be invoked\nwhen certain events happen at the transport level.\n\nWhenever the transport receives a new connection, it should invoke\nthe `c:connect/1` callback with a map of metadata. Different sockets\nmay require different metadata.\n\nIf the connection is accepted, the transport can move the connection\nto another process, if so desires, or keep using the same process. The\nprocess responsible for managing the socket should then call `c:init/1`.\n\nFor each message received from the client, the transport must call\n`c:handle_in/2` on the socket. For each informational message the\ntransport receives, it should call `c:handle_info/2` on the socket.\n\nTransports can optionally implement `c:handle_control/2` for handling\ncontrol frames such as `:ping` and `:pong`.\n\nOn termination, `c:terminate/2` must be called. A special atom with\nreason `:closed` can be used to specify that the client terminated\nthe connection.","ref":"Phoenix.Socket.Transport.html#module-custom-transports"},{"type":"behaviour","title":"Booting - Phoenix.Socket.Transport","doc":"Whenever your endpoint starts, it will automatically invoke the\n`child_spec/1` on each listed socket and start that specification\nunder the endpoint supervisor.\n\nSince the socket supervision tree is started by the endpoint,\nany custom transport must be started after the endpoint in a\nsupervision tree.","ref":"Phoenix.Socket.Transport.html#module-booting"},{"type":"function","title":"Phoenix.Socket.Transport.check_origin/5","doc":"Checks the origin request header against the list of allowed origins.\n\nShould be called by transports before connecting when appropriate.\nIf the origin header matches the allowed origins, no origin header was\nsent or no origin was configured, it will return the given connection.\n\nOtherwise a 403 Forbidden response will be sent and the connection halted.\nIt is a noop if the connection has been halted.","ref":"Phoenix.Socket.Transport.html#check_origin/5"},{"type":"function","title":"Phoenix.Socket.Transport.check_subprotocols/2","doc":"Checks the Websocket subprotocols request header against the allowed subprotocols.\n\nShould be called by transports before connecting when appropriate.\nIf the sec-websocket-protocol header matches the allowed subprotocols,\nit will put sec-websocket-protocol response header and return the given connection.\nIf no sec-websocket-protocol header was sent it will return the given connection.\n\nOtherwise a 403 Forbidden response will be sent and the connection halted.\nIt is a noop if the connection has been halted.","ref":"Phoenix.Socket.Transport.html#check_subprotocols/2"},{"type":"callback","title":"Phoenix.Socket.Transport.child_spec/1","doc":"Returns a child specification for socket management.\n\nThis is invoked only once per socket regardless of\nthe number of transports and should be responsible\nfor setting up any process structure used exclusively\nby the socket regardless of transports.\n\nEach socket connection is started by the transport\nand the process that controls the socket likely\nbelongs to the transport. However, some sockets spawn\nnew processes, such as `Phoenix.Socket` which spawns\nchannels, and this gives the ability to start a\nsupervision tree associated to the socket.\n\nIt receives the socket options from the endpoint,\nfor example:\n\n    socket \"/my_app\", MyApp.Socket, shutdown: 5000\n\nmeans `child_spec([shutdown: 5000])` will be invoked.\n\n`:ignore` means no child spec is necessary for this socket.","ref":"Phoenix.Socket.Transport.html#c:child_spec/1"},{"type":"function","title":"Phoenix.Socket.Transport.code_reload/3","doc":"Runs the code reloader if enabled.","ref":"Phoenix.Socket.Transport.html#code_reload/3"},{"type":"callback","title":"Phoenix.Socket.Transport.connect/1","doc":"Connects to the socket.\n\nThe transport passes a map of metadata and the socket\nreturns `{:ok, state}`, `{:error, reason}` or `:error`.\nThe state must be stored by the transport and returned\nin all future operations. When `{:error, reason}` is\nreturned, some transports - such as WebSockets - allow\ncustomizing the response based on `reason` via a custom\n`:error_handler`.\n\nThis function is used for authorization purposes and it\nmay be invoked outside of the process that effectively\nruns the socket.\n\nIn the default `Phoenix.Socket` implementation, the\nmetadata expects the following keys:\n\n  * `:endpoint` - the application endpoint\n  * `:transport` - the transport name\n  * `:params` - the connection parameters\n  * `:options` - a keyword list of transport options, often\n    given by developers when configuring the transport.\n    It must include a `:serializer` field with the list of\n    serializers and their requirements","ref":"Phoenix.Socket.Transport.html#c:connect/1"},{"type":"function","title":"Phoenix.Socket.Transport.connect_info/3","doc":"Extracts connection information from `conn` and returns a map.\n\nKeys are retrieved from the optional transport option `:connect_info`.\nThis functionality is transport specific. Please refer to your transports'\ndocumentation for more information.\n\nThe supported keys are:\n\n  * `:peer_data` - the result of `Plug.Conn.get_peer_data/1`\n\n  * `:trace_context_headers` - a list of all trace context headers\n\n  * `:x_headers` - a list of all request headers that have an \"x-\" prefix\n\n  * `:uri` - a `%URI{}` derived from the conn\n\n  * `:user_agent` - the value of the \"user-agent\" request header","ref":"Phoenix.Socket.Transport.html#connect_info/3"},{"type":"callback","title":"Phoenix.Socket.Transport.drainer_spec/1","doc":"Returns a child specification for terminating the socket.\n\nThis is a process that is started late in the supervision\ntree with the specific goal of draining connections on\napplication shutdown.\n\nSimilar to `child_spec/1`, it receives the socket options\nfrom the endpoint.","ref":"Phoenix.Socket.Transport.html#c:drainer_spec/1"},{"type":"callback","title":"Phoenix.Socket.Transport.handle_control/2","doc":"Handles incoming control frames.\n\nThe message is represented as `{payload, options}`. It must\nreturn one of:\n\n  * `{:ok, state}` - continues the socket with no reply\n  * `{:reply, status, reply, state}` - continues the socket with reply\n  * `{:stop, reason, state}` - stops the socket\n\nControl frames only supported when using websockets.\n\nThe `options` contains an `opcode` key, this will be either `:ping` or\n`:pong`.\n\nIf a control frame doesn't have a payload, then the payload value\nwill be `nil`.","ref":"Phoenix.Socket.Transport.html#c:handle_control/2"},{"type":"callback","title":"Phoenix.Socket.Transport.handle_in/2","doc":"Handles incoming socket messages.\n\nThe message is represented as `{payload, options}`. It must\nreturn one of:\n\n  * `{:ok, state}` - continues the socket with no reply\n  * `{:reply, status, reply, state}` - continues the socket with reply\n  * `{:stop, reason, state}` - stops the socket\n\nThe `reply` is a tuple contain an `opcode` atom and a message that can\nbe any term. The built-in websocket transport supports both `:text` and\n`:binary` opcode and the message must be always iodata. Long polling only\nsupports text opcode.","ref":"Phoenix.Socket.Transport.html#c:handle_in/2"},{"type":"callback","title":"Phoenix.Socket.Transport.handle_info/2","doc":"Handles info messages.\n\nThe message is a term. It must return one of:\n\n  * `{:ok, state}` - continues the socket with no reply\n  * `{:push, reply, state}` - continues the socket with reply\n  * `{:stop, reason, state}` - stops the socket\n\nThe `reply` is a tuple contain an `opcode` atom and a message that can\nbe any term. The built-in websocket transport supports both `:text` and\n`:binary` opcode and the message must be always iodata. Long polling only\nsupports text opcode.","ref":"Phoenix.Socket.Transport.html#c:handle_info/2"},{"type":"callback","title":"Phoenix.Socket.Transport.init/1","doc":"Initializes the socket state.\n\nThis must be executed from the process that will effectively\noperate the socket.","ref":"Phoenix.Socket.Transport.html#c:init/1"},{"type":"callback","title":"Phoenix.Socket.Transport.terminate/2","doc":"Invoked on termination.\n\nIf `reason` is `:closed`, it means the client closed the socket. This is\nconsidered a `:normal` exit signal, so linked process will not automatically\nexit. See `Process.exit/2` for more details on exit signals.","ref":"Phoenix.Socket.Transport.html#c:terminate/2"},{"type":"function","title":"Phoenix.Socket.Transport.transport_log/2","doc":"Logs the transport request.\n\nAvailable for transports that generate a connection.","ref":"Phoenix.Socket.Transport.html#transport_log/2"},{"type":"type","title":"Phoenix.Socket.Transport.state/0","doc":"","ref":"Phoenix.Socket.Transport.html#t:state/0"},{"type":"exception","title":"Phoenix.ActionClauseError","doc":"","ref":"Phoenix.ActionClauseError.html"},{"type":"exception","title":"Phoenix.MissingParamError","doc":"Raised when a key is expected to be present in the request parameters,\nbut is not.\n\nThis exception is raised by `Phoenix.Controller.scrub_params/2` which:\n\n  * Checks to see if the required_key is present (can be empty)\n  * Changes all empty parameters to nils (\"\" -> nil)\n\nIf you are seeing this error, you should handle the error and surface it\nto the end user. It means that there is a parameter missing from the request.","ref":"Phoenix.MissingParamError.html"},{"type":"exception","title":"Phoenix.NotAcceptableError","doc":"Raised when one of the `accept*` headers is not accepted by the server.\n\nThis exception is commonly raised by `Phoenix.Controller.accepts/2`\nwhich negotiates the media types the server is able to serve with\nthe contents the client is able to render.\n\nIf you are seeing this error, you should check if you are listing\nthe desired formats in your `:accepts` plug or if you are setting\nthe proper accept header in the client. The exception contains the\nacceptable mime types in the `accepts` field.","ref":"Phoenix.NotAcceptableError.html"},{"type":"exception","title":"Phoenix.Router.MalformedURIError","doc":"Exception raised when the URI is malformed on matching.","ref":"Phoenix.Router.MalformedURIError.html"},{"type":"exception","title":"Phoenix.Router.NoRouteError","doc":"Exception raised when no route is found.","ref":"Phoenix.Router.NoRouteError.html"},{"type":"exception","title":"Phoenix.Socket.InvalidMessageError","doc":"Raised when the socket message is invalid.","ref":"Phoenix.Socket.InvalidMessageError.html"},{"type":"extras","title":"Changelog for v1.7","doc":"# Changelog for v1.7\n\nSee the [upgrade guide](https://gist.github.com/chrismccord/00a6ea2a96bc57df0cce526bd20af8a7) to upgrade from Phoenix 1.6.x.\n\nPhoenix v1.7 requires Elixir v1.11+ & Erlang v22.1+.","ref":"changelog.html"},{"type":"extras","title":"Introduction of Verified Routes - Changelog for v1.7","doc":"Phoenix 1.7 includes a new `Phoenix.VerifiedRoutes` feature which provides `~p`\nfor route generation with compile-time verification.\n\nUse of the `sigil_p` macro allows paths and URLs throughout your\napplication to be compile-time verified against your Phoenix router(s).\nFor example the following path and URL usages:\n\n    <.link href={~p\"/sessions/new\"} method=\"post\">Log in</.link>\n\n    redirect(to: url(~p\"/posts/#{post}\"))\n\nWill be verified against your standard `Phoenix.Router` definitions:\n\n    get \"/posts/:post_id\", PostController, :show\n    post \"/sessions/new\", SessionController, :create\n\nUnmatched routes will issue compiler warnings:\n\n    warning: no route path for AppWeb.Router matches \"/postz/#{post}\"\n      lib/app_web/controllers/post_controller.ex:100: AppWeb.PostController.show/2\n\n*Note: Elixir v1.14+ is required for comprehensive warnings. Older versions\nwill work properly and warn on new compilations, but changes to the router file\nwill not issue new warnings.*\n\nThis feature replaces the `Helpers` module generated in your Phoenix router, but helpers\nwill continue to work and be generated. You can disable router helpers by passing the\n`helpers: false` option to `use Phoenix.Router`.","ref":"changelog.html#introduction-of-verified-routes"},{"type":"extras","title":"phx.new revamp - Changelog for v1.7","doc":"The `phx.new` application generator has been improved to rely on function components for\nboth Controller and LiveView rendering, ultimately simplifying the rendering stack of\nPhoenix applications and providing better reuse.\n\nNew applications come with a collection of well-documented and accessible core components,\nstyled with Tailwind CSS by default. You can opt-out of Tailwind CSS with the `--no-tailwind`\nflag (the Tailwind CSS classes are kept in the generated components as reference for\nfuture styling).","ref":"changelog.html#phx-new-revamp"},{"type":"extras","title":"1.7.14 (2024-06-18) - Changelog for v1.7","doc":"","ref":"changelog.html#1-7-14-2024-06-18"},{"type":"extras","title":"Bug fixes - Changelog for v1.7","doc":"* Revert \"Add `follow_redirect/2` to Phoenix.ConnTest\" (#5797) as this conflicts with `follow_redirect/2` in LiveView, which is imported with ConnTest by default","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"1.7.13 (2024-06-18) - Changelog for v1.7","doc":"","ref":"changelog.html#1-7-13-2024-06-18"},{"type":"extras","title":"Bug fixes - Changelog for v1.7","doc":"* Fix Elixir 1.17 warning in Cowboy2Adapter\n  * Fix verified routes emitting diagnostics without file and position","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"JavaScript Client Bug Fixes - Changelog for v1.7","doc":"* Fix error when `sessionStorage` is not available on global namespace","ref":"changelog.html#javascript-client-bug-fixes"},{"type":"extras","title":"Enhancements - Changelog for v1.7","doc":"* Add `follow_redirect/2` to Phoenix.ConnTest\n  * Use LiveView 1.0.0-rc for newly generated applications\n  * Use new `Phoenix.Component.used_input?` for form errors in generated `core_components.ex`\n  * Allow `mix ecto.setup` from the umbrella root\n  * Bump Endpoint static cache manifest on `config_change` callback","ref":"changelog.html#enhancements"},{"type":"extras","title":"1.7.12 (2024-04-11) - Changelog for v1.7","doc":"","ref":"changelog.html#1-7-12-2024-04-11"},{"type":"extras","title":"JavaScript Client Bug Fixes - Changelog for v1.7","doc":"* Fix all unjoined channels from being removed from the socket when channel leave is called on any single unjoined channel instance","ref":"changelog.html#javascript-client-bug-fixes"},{"type":"extras","title":"Enhancements - Changelog for v1.7","doc":"* [phx.gen.auth] Add enhanced session fixation protection.\n    For applications whichs previously used `phx.gen.auth`, the following line can be added to the `renew_session` function in the auth module:\n\n    ```diff\n      defp renew_session(conn) do\n    +   delete_csrf_token()\n\n        conn\n        |> configure_session(renew: true)\n        |> clear_session()\n    ```\n\n    *Note*: because the session id is in a http-only cookie by default, the only way to perform this attack prior to this change is if your application was already vulnerable to an XSS attack, which itself grants more escalated \"privileges” than the CSRF fixation.","ref":"changelog.html#enhancements"},{"type":"extras","title":"JavaScript Client Enhancements - Changelog for v1.7","doc":"* Only memorize longpoll fallback for browser session if WebSocket never had a successful connection","ref":"changelog.html#javascript-client-enhancements"},{"type":"extras","title":"1.7.11 (2024-02-01) - Changelog for v1.7","doc":"","ref":"changelog.html#1-7-11-2024-02-01"},{"type":"extras","title":"Enhancements - Changelog for v1.7","doc":"* [phx.new] Default to the [Bandit webserver](https://github.com/mtrudel/bandit) for newly generated applications\n  * [phx.new] Enable longpoll transport by default and auto fallback when websocket fails for newly generated applications","ref":"changelog.html#enhancements"},{"type":"extras","title":"JavaScript Client Enhancements - Changelog for v1.7","doc":"* Support new `longPollFallbackMs` option to auto fallback when websocket fails to connect\n  * Support new `debug` option to enable verbose logging","ref":"changelog.html#javascript-client-enhancements"},{"type":"extras","title":"Deprecations - Changelog for v1.7","doc":"* Deprecate the `c:init/2` callback in endpoints in favor of `config/runtime.exs` or in favor of `{Phoenix.Endpoint, options}`","ref":"changelog.html#deprecations"},{"type":"extras","title":"1.7.10 (2023-11-03) - Changelog for v1.7","doc":"","ref":"changelog.html#1-7-10-2023-11-03"},{"type":"extras","title":"Bug fixes - Changelog for v1.7","doc":"* [phx.new] Fix `CoreComponents.flash` generating incorrect id's causing flash messages to fail to be closed when clicked","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Enhancements - Changelog for v1.7","doc":"* [Phoenix.Endpoint] Support dynamic port for `Endpoint.url/0`","ref":"changelog.html#enhancements"},{"type":"extras","title":"1.7.9 (2023-10-11) - Changelog for v1.7","doc":"","ref":"changelog.html#1-7-9-2023-10-11"},{"type":"extras","title":"Bug fixes - Changelog for v1.7","doc":"* [Phoenix.CodeReloader] - Fix error in code reloader causing compilation errors\n  * [phx.new] – fix LiveView debug heex configuration being generated when `--no-html` pas passed","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"1.7.8 (2023-10-09) - Changelog for v1.7","doc":"","ref":"changelog.html#1-7-8-2023-10-09"},{"type":"extras","title":"Bug fixes - Changelog for v1.7","doc":"* [Phoenix.ChannelTest] Stringify lists when pushing data\n  * [Phoenix.Controller] Fix filename when sending downloads with non-ascii names\n  * [Phoenix.CodeReloader] Remove duplicate warnings on recent Elixir versions\n  * [Phoenix.CodeReloader] Do not crash code reloader if file information is missing from diagnostic\n  * [Phoenix.Logger] Do not crash when status is atom\n  * [phx.gen.release] Fix `mix phx.gen.release --docker` failing with `:http_util` error on Elixir v1.15\n  * [phx.gen.*] Skip map inputs in generated forms as there is no trivial matching input\n  * [phx.new] Fix tailwind/esbuild config and paths in umbrella projects\n  * [phx.new] Do not render `th` for actions if actions are empty","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Enhancements - Changelog for v1.7","doc":"* [Phoenix] Allow latest `plug_crypto`\n  * [Phoenix.Endpoint] Support dynamic socket drainer configuration\n  * [Phoenix.Logger] Change socket serializer/version logs to warning\n  * [Phoenix.VerifiedRoutes] Add support for static resources with fragments in `~p`\n  * [phx.gen.schema] Support `--repo` and `--migration-dir` flags\n  * [phx.new] Allow `<.input type=\"checkbox\">` without `value` attr in core components\n  * [phx.new] Allow UTC datetimes in the generators\n  * [phx.new] Automatically migrate when release starts when using sqlite 3\n  * [phx.new] Allow ID to be assigned in flash component\n  * [phx.new] Add `--adapter` flag for generating application with bandit\n  * [phx.new] Include DNSCluster for simple clustering\n  * [phx.routes] Support `--method` option","ref":"changelog.html#enhancements"},{"type":"extras","title":"1.7.7 (2023-07-10) - Changelog for v1.7","doc":"","ref":"changelog.html#1-7-7-2023-07-10"},{"type":"extras","title":"Enhancements - Changelog for v1.7","doc":"* Support incoming binary payloads to channels over longpoll transport","ref":"changelog.html#enhancements"},{"type":"extras","title":"1.7.6 (2023-06-16) - Changelog for v1.7","doc":"","ref":"changelog.html#1-7-6-2023-06-16"},{"type":"extras","title":"Bug Fixes - Changelog for v1.7","doc":"* Support websock_adapter 0.5.3","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Enhancements - Changelog for v1.7","doc":"*  Allow using Phoenix.ChannelTest socket/connect in another process","ref":"changelog.html#enhancements"},{"type":"extras","title":"1.7.5 (2023-06-15) - Changelog for v1.7","doc":"","ref":"changelog.html#1-7-5-2023-06-15"},{"type":"extras","title":"Bug Fixes - Changelog for v1.7","doc":"* Fix LongPoll error when draining connections","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"1.7.4 (2023-06-15) - Changelog for v1.7","doc":"","ref":"changelog.html#1-7-4-2023-06-15"},{"type":"extras","title":"Bug Fixes - Changelog for v1.7","doc":"* Fix the WebSocket draining sending incorrect close code when draining causing LiveViews to reload the page instead of reconnecting","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"1.7.3 (2023-05-30) - Changelog for v1.7","doc":"","ref":"changelog.html#1-7-3-2023-05-30"},{"type":"extras","title":"Enhancements - Changelog for v1.7","doc":"* Use LiveView 0.19 for new apps","ref":"changelog.html#enhancements"},{"type":"extras","title":"Bug Fixes - Changelog for v1.7","doc":"* Fix compilation error page on plug debugger showing obscure error when app fails to compile\n  * Fix warnings being printed twice in route verification","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"1.7.2 (2023-03-20) - Changelog for v1.7","doc":"","ref":"changelog.html#1-7-2-2023-03-20"},{"type":"extras","title":"Enhancements - Changelog for v1.7","doc":"* [Endpoint] Add socket draining for batched and orchestrated Channel/LiveView socket shutdown\n  * [code reloader] Improve the compilation error page to remove horizontal scrolling and include all warnings and errors from compilation\n  * [phx.new] Support the `--no-tailwind` and `--no-esbuild` flags\n  * [phx.new] Move heroicons to assets/vendor\n  * [phx.new] Simplify core modal to use the new JS.exec instruction to reduce footprint\n  * [sockets] Allow custom csrf_token_keys in WebSockets","ref":"changelog.html#enhancements"},{"type":"extras","title":"1.7.1 (2023-03-02) - Changelog for v1.7","doc":"","ref":"changelog.html#1-7-1-2023-03-02"},{"type":"extras","title":"Enhancements - Changelog for v1.7","doc":"* [phx.new] Embed heroicons in app.css bundle to optimize usage","ref":"changelog.html#enhancements"},{"type":"extras","title":"1.7.0 (2023-02-24) - Changelog for v1.7","doc":"","ref":"changelog.html#1-7-0-2023-02-24"},{"type":"extras","title":"Bug Fixes - Changelog for v1.7","doc":"* Fix race conditions in the longpoll transport by batching messages","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"1.7.0-rc.3 (2023-02-15) - Changelog for v1.7","doc":"","ref":"changelog.html#1-7-0-rc-3-2023-02-15"},{"type":"extras","title":"Enhancements - Changelog for v1.7","doc":"* Use stream based collections for `phx.gen.live` generators\n  * Update `phx.gen.live` generators to use `Phoenix.Component.to_form`","ref":"changelog.html#enhancements"},{"type":"extras","title":"1.7.0-rc.2 (2023-01-13) - Changelog for v1.7","doc":"","ref":"changelog.html#1-7-0-rc-2-2023-01-13"},{"type":"extras","title":"Bug Fixes - Changelog for v1.7","doc":"* [Router] Fix routing bug causing incorrect matching order on similar routes\n  * [phx.new] Fix installation hanging in some cases","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"1.7.0-rc.1 (2023-01-06) - Changelog for v1.7","doc":"","ref":"changelog.html#1-7-0-rc-1-2023-01-06"},{"type":"extras","title":"Enhancements - Changelog for v1.7","doc":"* Raise if using verified routes outside of functions\n  * Add tailwind.install/esbuild.install to mix setup","ref":"changelog.html#enhancements"},{"type":"extras","title":"Bug Fixes - Changelog for v1.7","doc":"* [Presence] fix task shutdown match causing occasional presence errors\n  * [VerifiedRoutes] Fix expansion causing more compile-time deps than necessary\n  * [phx.gen.auth] Add password inputs to password reset edit form\n  * [phx.gen.embedded] Fixes missing :references generation to phx.gen.embedded\n  * Fix textarea rendering in core components\n  * Halt all sockets on intercept to fix longpoll response already sent error","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"1.7.0-rc.0 (2022-11-07) - Changelog for v1.7","doc":"","ref":"changelog.html#1-7-0-rc-0-2022-11-07"},{"type":"extras","title":"Deprecations - Changelog for v1.7","doc":"* `Phoenix.Controller.get_flash` has been deprecated in favor of the new `Phoenix.Flash` module, which provides unified flash access","ref":"changelog.html#deprecations"},{"type":"extras","title":"Enhancements - Changelog for v1.7","doc":"* [Router] Add `Phoenix.VerifiedRoutes` for `~p`-based route generation with compile-time verification.\n  * [Router] Support `helpers: false` to `use Phoenix.Router` to disable helper generation\n  * [Router] Add `--info [url]` switch to `phx.routes` to get route information about a url/path\n  * [Flash] Add `Phoenix.Flash` for unfied flash access","ref":"changelog.html#enhancements"},{"type":"extras","title":"JavaScript Client Bug Fixes - Changelog for v1.7","doc":"* Fix heartbeat being sent after disconnect and causing abnormal disconnects","ref":"changelog.html#javascript-client-bug-fixes"},{"type":"extras","title":"v1.6 - Changelog for v1.7","doc":"The CHANGELOG for v1.6 releases can be found in the [v1.6 branch](https://github.com/phoenixframework/phoenix/blob/v1.6/CHANGELOG.md).","ref":"changelog.html#v1-6"},{"type":"extras","title":"Overview","doc":"# Overview\n\nPhoenix is a web development framework written in Elixir which implements the server-side Model View Controller (MVC) pattern. Many of its components and concepts will seem familiar to those of us with experience in other web frameworks like Ruby on Rails or Python's Django.\n\nPhoenix provides the best of both worlds - high developer productivity _and_ high application performance. It also has some interesting new twists like channels for implementing realtime features and pre-compiled templates for blazing speed.\n\nIf you are already familiar with Elixir, great! If not, there are a number of places to learn. The [Elixir guides](https://hexdocs.pm/elixir/introduction.html) and the [Elixir learning resources page](https://elixir-lang.org/learning.html) are two great places to start.\n\nThe guides that you are currently looking at provide an overview of all parts that make Phoenix. Here is a rundown of what they provide:\n\n  * Introduction - the guides you are currently reading. They will cover how to get your first application up and running\n\n  * Guides - in-depth guides covering the main components in Phoenix and Phoenix applications\n\n  * Authentication - in-depth guide covering how to use `mix phx.gen.auth`\n\n  * Real-time components - in-depth guides covering Phoenix's built-in real-time components\n\n  * Testing - in-depth guides about testing\n\n  * Deployment - in-depth guides about deployment\n\n  * How-to's - a collection of articles on how to achieve certain things with Phoenix\n\nIf you would prefer to read these guides as an EPUB, [click here!](Phoenix.epub)\n\nNote, these guides are not a step-by-step introduction to Phoenix. If you want a more structured approach to learning the framework, we have a large community and many books, courses, and screencasts available. See [our community page](community.html) for a complete list.\n\n[Let's get Phoenix installed](installation.html).","ref":"overview.html"},{"type":"extras","title":"Installation","doc":"# Installation\n\nIn order to build a Phoenix application, we will need a few dependencies installed in our Operating System:\n\n  * the Erlang VM and the Elixir programming language\n  * a database - Phoenix recommends PostgreSQL, but you can pick others or not use a database at all\n  * and other optional packages.\n\nPlease take a look at this list and make sure to install anything necessary for your system. Having dependencies installed in advance can prevent frustrating problems later on.","ref":"installation.html"},{"type":"extras","title":"Elixir 1.14 or later - Installation","doc":"Phoenix is written in Elixir, and our application code will also be written in Elixir. We won't get far in a Phoenix app without it! The Elixir site maintains a great [Installation Page](https://elixir-lang.org/install.html) to help.\n\nIf we have just installed Elixir for the first time, we will need to install the Hex package manager as well. Hex is necessary to get a Phoenix app running (by installing dependencies) and to install any extra dependencies we might need along the way.\n\nHere's the command to install Hex (If you have Hex already installed, it will upgrade Hex to the latest version):\n\n```console\n$ mix local.hex\n```","ref":"installation.html#elixir-1-14-or-later"},{"type":"extras","title":"Erlang 24 or later - Installation","doc":"Elixir code compiles to Erlang byte code to run on the Erlang virtual machine. Without Erlang, Elixir code has no virtual machine to run on, so we need to install Erlang as well.\n\nWhen we install Elixir using instructions from the Elixir [Installation Page](https://elixir-lang.org/install.html),  we will usually get Erlang too. If Erlang was not installed along with Elixir, please see the [Erlang Instructions](https://elixir-lang.org/install.html#installing-erlang) section of the Elixir Installation Page for instructions.","ref":"installation.html#erlang-24-or-later"},{"type":"extras","title":"Phoenix - Installation","doc":"To check that we are on Elixir 1.14 and Erlang 24 or later, run:\n\n```console\nelixir -v\nErlang/OTP 24 [erts-12.0] [source] [64-bit] [smp:8:8] [async-threads:10] [hipe] [kernel-poll:false] [dtrace]\n\nElixir 1.14.0\n```\n\nOnce we have Elixir and Erlang, we are ready to install the Phoenix application generator:\n\n```console\n$ mix archive.install hex phx_new\n```\n\nThe `phx.new` generator is now available to generate new applications in the next guide, called [Up and Running](up_and_running.html). The flags mentioned below are command line options to the generator; see all available options by calling `mix help phx.new`.","ref":"installation.html#phoenix"},{"type":"extras","title":"PostgreSQL - Installation","doc":"PostgreSQL is a relational database server. Phoenix configures applications to use it by default, but we can switch to MySQL, MSSQL, or SQLite3 by passing the `--database` flag when creating a new application.\n\nIn order to talk to databases, Phoenix applications use another Elixir package, called [Ecto](https://github.com/elixir-ecto/ecto). If you don't plan to use databases in your application, you can pass the `--no-ecto` flag.\n\nHowever, if you are just getting started with Phoenix, we recommend you to install PostgreSQL and make sure it is running. The PostgreSQL wiki has [installation guides](https://wiki.postgresql.org/wiki/Detailed_installation_guides) for a number of different systems.","ref":"installation.html#postgresql"},{"type":"extras","title":"inotify-tools (for Linux users) - Installation","doc":"Phoenix provides a very handy feature called Live Reloading. As you change your views or your assets, it automatically reloads the page in the browser. In order for this functionality to work, you need a filesystem watcher.\n\nmacOS and Windows users already have a filesystem watcher, but Linux users must install inotify-tools. Please consult the [inotify-tools wiki](https://github.com/rvoicilas/inotify-tools/wiki) for distribution-specific installation instructions.","ref":"installation.html#inotify-tools-for-linux-users"},{"type":"extras","title":"Summary - Installation","doc":"At the end of this section, you must have installed Elixir, Hex, Phoenix, and PostgreSQL. Now that we have everything installed, let's create our first Phoenix application and get [up and running](up_and_running.html).","ref":"installation.html#summary"},{"type":"extras","title":"Up and Running","doc":"# Up and Running\n\nLet's get a Phoenix application up and running as quickly as possible.\n\nBefore we begin, please take a minute to read the [Installation Guide](installation.html). By installing any necessary dependencies beforehand, we'll be able to get our application up and running smoothly.\n\nWe can run `mix phx.new` from any directory in order to bootstrap our Phoenix application. Phoenix will accept either an absolute or relative path for the directory of our new project. Assuming that the name of our application is `hello`, let's run the following command:\n\n```console\n$ mix phx.new hello\n```\n\n> By default, `mix phx.new` includes a number of optional dependencies, for example:\n>\n> - [Ecto](ecto.html) for communicating with a data store, such as PostgreSQL, MySQL, and others. You can skip this with `--no-ecto`.\n>\n> - [Phoenix.HTML](https://hexdocs.pm/phoenix_html/Phoenix.HTML.html), [TailwindCSS](https://tailwindcss.com), and [Esbuild](https://esbuild.github.io) for HTML applications. You can skip them with the `--no-html` and `--no-assets` flags.\n>\n> - [Phoenix.LiveView](https://hexdocs.pm/phoenix_live_view/) for building realtime and interactive web applications. You can skip this with `--no-live`.\n>\n> Read the [Mix Tasks Guide](mix_tasks.html#phoenix-specific-mix-tasks) for the full list of things that can be excluded, among other options.\n\n```console\nmix phx.new hello\n* creating hello/config/config.exs\n* creating hello/config/dev.exs\n* creating hello/config/prod.exs\n...\n\nFetch and install dependencies? [Yn]\n```\n\nPhoenix generates the directory structure and all the files we will need for our application.\n\n> Phoenix promotes the usage of git as version control software: among the generated files we find a `.gitignore`. We can `git init` our repository, and immediately add and commit all that hasn't been marked ignored.\n\nWhen it's done, it will ask us if we want it to install our dependencies for us. Let's say yes to that.\n\n```console\nFetch and install dependencies? [Yn] Y\n* running mix deps.get\n* running mix assets.setup\n* running mix deps.compile\n\nWe are almost there! The following steps are missing:\n\n    $ cd hello\n\nThen configure your database in config/dev.exs and run:\n\n    $ mix ecto.create\n\nStart your Phoenix app with:\n\n    $ mix phx.server\n\nYou can also run your app inside IEx (Interactive Elixir) as:\n\n    $ iex -S mix phx.server\n```\n\nOnce our dependencies are installed, the task will prompt us to change into our project directory and start our application.\n\nPhoenix assumes that our PostgreSQL database will have a `postgres` user account with the correct permissions and a password of \"postgres\". If that isn't the case, please see the [Mix Tasks Guide](mix_tasks.html#ecto-specific-mix-tasks) to learn more about the `mix ecto.create` task.\n\nOk, let's give it a try. First, we'll `cd` into the `hello/` directory we've just created:\n\n```console\n$ cd hello\n```\n\nNow we'll create our database:\n\n```console\n$ mix ecto.create\nCompiling 13 files (.ex)\nGenerated hello app\nThe database for Hello.Repo has been created\n```\n\nIn case the database could not be created, see the guides for the [`mix ecto.create`](mix_tasks.html#mix-ecto-create) for general troubleshooting.\n\n> Note: if this is the first time you are running this command, Phoenix may also ask to install Rebar. Go ahead with the installation as Rebar is used to build Erlang packages.\n\nAnd finally, we'll start the Phoenix server:\n\n```console\n$ mix phx.server\n[info] Running HelloWeb.Endpoint with cowboy 2.9.0 at 127.0.0.1:4000 (http)\n[info] Access HelloWeb.Endpoint at http://localhost:4000\n[watch] build finished, watching for changes...\n...\n```\n\nIf we choose not to have Phoenix install our dependencies when we generate a new application, the `mix phx.new` task will prompt us to take the necessary steps when we do want to install them.\n\n```console\nFetch and install dependencies? [Yn] n\n\nWe are almost there! The following steps are missing:\n\n    $ cd hello\n    $ mix deps.get\n\nThen configure your database in config/dev.exs and run:\n\n    $ mix ecto.create\n\nStart your Phoenix app with:\n\n    $ mix phx.server\n\nYou can also run your app inside IEx (Interactive Elixir) as:\n\n    $ iex -S mix phx.server\n```\n\nBy default, Phoenix accepts requests on port 4000. If we point our favorite web browser at [http://localhost:4000](http://localhost:4000), we should see the Phoenix Framework welcome page.\n\n![Phoenix Welcome Page](assets/images/welcome-to-phoenix.png)\n\nIf your screen looks like the image above, congratulations! You now have a working Phoenix application. In case you can't see the page above, try accessing it via [http://127.0.0.1:4000](http://127.0.0.1:4000) and later make sure your OS has defined \"localhost\" as \"127.0.0.1\".\n\nTo stop it, we hit `ctrl-c` twice.\n\nNow you are ready to explore the world provided by Phoenix! See [our community page](community.html) for books, screencasts, courses, and more.\n\nAlternatively, you can continue reading these guides to have a quick introduction into all the parts that make your Phoenix application. If that's the case, you can read the guides in any order or start with our guide that explains the [Phoenix directory structure](directory_structure.html).","ref":"up_and_running.html"},{"type":"extras","title":"Community","doc":"# Community\n\nThe Elixir and Phoenix communities are friendly and welcoming. All questions and comments are valuable, so please come join the discussion!\n\nThere are a number of places to connect with community members at all experience levels.\n\n  * We're on Libera IRC in the [\\#elixir](https://web.libera.chat/?channels=#elixir) channel.\n\n  * Feel free to join and check out the #phoenix channel on [Discord](https://discord.gg/elixir).\n\n  * Read about [bug reports](https://github.com/phoenixframework/phoenix/blob/main/CONTRIBUTING.md#bug-reports) or open an issue in the Phoenix [issue tracker](https://github.com/phoenixframework/phoenix/issues).\n\n  * Ask or answer questions about Phoenix on [Elixir Forum](https://elixirforum.com/c/phoenix-forum) or [Stack Overflow](https://stackoverflow.com/questions/tagged/phoenix-framework).\n\n  * Follow the Phoenix Framework on [Twitter](https://twitter.com/elixirphoenix).\n\nThe Security Working Group of the Erlang Ecosystem Foundation also publishes in-depth documents about [security best practices for Erlang, Elixir, and Phoenix](https://erlef.github.io/security-wg/web_app_security_best_practices_beam/).","ref":"community.html"},{"type":"extras","title":"Books - Community","doc":"* [Programming Phoenix LiveView - Interactive Elixir Web Programming Without Writing Any JavaScript - 2023 (by Bruce Tate and Sophie DeBenedetto)](https://pragprog.com/titles/liveview/programming-phoenix-liveview/)\n\n  * [Phoenix Tutorial (Phoenix 1.6)](https://thephoenixtutorial.org/) - [Free to read online](https://thephoenixtutorial.org/book)\n\n  * [Real-Time Phoenix - Build Highly Scalable Systems with Channels (by Stephen Bussey - 2020)](https://pragprog.com/titles/sbsockets/real-time-phoenix/)\n\n  * [Programming Phoenix 1.4 (by Bruce Tate, Chris McCord, and José Valim - 2019)](https://pragprog.com/titles/phoenix14/programming-phoenix-1-4/)\n\n  * [Phoenix in Action (by Geoffrey Lessel - 2019)](https://manning.com/books/phoenix-in-action)\n\n  * [Phoenix Inside Out - Book Series (by Shankar Dhanasekaran - 2017)](https://shankardevy.com/phoenix-book/). First book of the series Mastering Phoenix Framework is [free to read online](https://shankardevy.com/phoenix-inside-out-mpf/)\n\n  * [Functional Web Development with Elixir, OTP, and Phoenix Rethink the Modern Web App (by Lance Halvorsen - 2017)](https://pragprog.com/titles/lhelph/functional-web-development-with-elixir-otp-and-phoenix/)","ref":"community.html#books"},{"type":"extras","title":"Screencasts/Courses - Community","doc":"* [Phoenix LiveView Free Course (by The Pragmatic Studio - 2023)](https://pragmaticstudio.com/courses/phoenix-liveview)\n\n  * [Build It With Phoenix video course (by Geoffrey Lessel - 2023)](https://builditwithphoenix.com)\n\n  * [Free Crash Course: Phoenix LiveView (by Productive Programmer - 2023)](https://www.productiveprogrammer.com/learn-phoenix-liveview-free)\n\n  * [Phoenix on Rails: Elixir and Phoenix for Ruby on Rails developers (by George Arrowsmith - 2023)](https://phoenixonrails.com)\n\n  * [Groxio LiveView: Self Study Program (by Bruce Tate - 2020)](https://grox.io/language/liveview/course)\n\n  * [Alchemist Camp: Learn Elixir and Phoenix by building (2018-2022)](https://alchemist.camp/episodes)\n\n  * [The Complete Elixir and Phoenix Bootcamp Master Functional Programming Techniques with Elixir and Phoenix while Learning to Build Compelling Web Applications (by Stephen Grider - 2017)](https://www.udemy.com/the-complete-elixir-and-phoenix-bootcamp-and-tutorial/)\n\n  * [Discover Elixir & Phoenix (by Tristan Edwards - 2017)](https://www.ludu.co/course/discover-elixir-phoenix)\n\n  * [Phoenix Framework Tutorial (by Tensor Programming - 2017)](https://www.youtube.com/watch?v=irDC1nWKhZ8&index=6&list=PLJbE2Yu2zumAgKjSPyFtvYjP5LqgzafQq)\n\n  * [Getting Started with Phoenix (by Pluralsight - 2017)](https://www.pluralsight.com/courses/phoenix-getting-started)\n\n  * [LearnPhoenix.tv: Learn how to Build Fast, Dependable Web Apps with Phoenix (2017)](https://www.learnphoenix.tv/)\n\n  * [LearnPhoenix.io: Build Scalable, Real-Time Apps with Phoenix, React, and React Native (2016)](https://www.learnphoenix.io/)","ref":"community.html#screencasts-courses"},{"type":"extras","title":"Packages Glossary","doc":"# Packages Glossary\n\nBy default, Phoenix applications depend on several packages with different purposes.\nThis page is a quick reference of the different packages you may work with as a Phoenix\ndeveloper.\n\nThe main packages are:\n\n  * [Ecto](https://hexdocs.pm/ecto) - a language integrated query and\n    database wrapper\n\n  * [Phoenix](https://hexdocs.pm/phoenix) - the Phoenix web framework\n    (these docs)\n\n  * [Phoenix LiveView](https://hexdocs.pm/phoenix_live_view) - build rich,\n    real-time user experiences with server-rendered HTML. The LiveView\n    project also defines [`Phoenix.Component`](https://hexdocs.pm/phoenix_live_view/Phoenix.Component.html) and\n    [the HEEx template engine](https://hexdocs.pm/phoenix_live_view/Phoenix.Component.html#sigil_H/2),\n    used for rendering HTML content in both regular and real-time applications\n\n  * [Plug](https://hexdocs.pm/plug) - specification and conveniences for\n    building composable modules web applications. This is the package\n    responsible for the connection abstraction and the regular request-\n    response life-cycle\n\nYou will also work with the following:\n\n  * [ExUnit](https://hexdocs.pm/ex_unit) - Elixir's built-in test framework\n\n  * [Gettext](https://hexdocs.pm/gettext) - internationalization and\n    localization through [`gettext`](https://www.gnu.org/software/gettext/)\n\n  * [Swoosh](https://hexdocs.pm/swoosh) - a library for composing,\n    delivering and testing emails, also used by `mix phx.gen.auth`\n\nWhen peeking under the covers, you will find those libraries play\nan important role in Phoenix applications:\n\n  * [Phoenix HTML](https://hexdocs.pm/phoenix_html) - building blocks\n    for working with HTML and forms safely\n\n  * [Phoenix Ecto](https://hex.pm/packages/phoenix_ecto) - plugs and\n    protocol implementations for using phoenix with ecto\n\n  * [Phoenix PubSub](https://hexdocs.pm/phoenix_pubsub) - a distributed\n    pub/sub system with presence support\n\nWhen it comes to instrumentation and monitoring, check out:\n\n  * [Phoenix LiveDashboard](https://hexdocs.pm/phoenix_live_dashboard) -\n    real-time performance monitoring and debugging tools for Phoenix\n    developers\n\n  * [Telemetry Metrics](https://hexdocs.pm/telemetry_metrics) - common\n    interface for defining metrics based on Telemetry events","ref":"packages_glossary.html"},{"type":"extras","title":"Directory structure","doc":"# Directory structure\n\n> **Requirement**: This guide expects that you have gone through the [introductory guides](installation.html) and got a Phoenix application [up and running](up_and_running.html).\n\nWhen we use `mix phx.new` to generate a new Phoenix application, it builds a top-level directory structure like this:\n\n```console\n├── _build\n├── assets\n├── config\n├── deps\n├── lib\n│   ├── hello\n│   ├── hello.ex\n│   ├── hello_web\n│   └── hello_web.ex\n├── priv\n└── test\n```\n\nWe will go over those directories one by one:\n\n  * `_build` - a directory created by the `mix` command line tool that ships as part of Elixir that holds all compilation artifacts. As we have seen in \"[Up and Running](up_and_running.html)\", `mix` is the main interface to your application. We use Mix to compile our code, create databases, run our server, and more. This directory must not be checked into version control and it can be removed at any time. Removing it will force Mix to rebuild your application from scratch.\n\n  * `assets` - a directory that keeps source code for your front-end assets, typically JavaScript and CSS. These sources are automatically bundled by the `esbuild` tool. Static files like images and fonts go in `priv/static`.\n\n  * `config` - a directory that holds your project configuration. The `config/config.exs` file is the entry point for your configuration. At the end of the `config/config.exs`, it imports environment specific configuration, which can be found in `config/dev.exs`, `config/test.exs`, and `config/prod.exs`. Finally, `config/runtime.exs` is executed and it is the best place to read secrets and other dynamic configuration.\n\n  * `deps` - a directory with all of our Mix dependencies. You can find all dependencies listed in the `mix.exs` file, inside the `defp deps do` function definition. This directory must not be checked into version control and it can be removed at any time. Removing it will force Mix to download all deps from scratch.\n\n  * `lib` - a directory that holds your application source code. This directory is broken into two subdirectories, `lib/hello` and `lib/hello_web`. The `lib/hello` directory will be responsible to host all of your business logic and business domain. It typically interacts directly with the database - it is the \"Model\" in Model-View-Controller (MVC) architecture. `lib/hello_web` is responsible for exposing your business domain to the world, in this case, through a web application. It holds both the View and Controller from MVC. We will discuss the contents of these directories with more detail in the next sections.\n\n  * `priv` - a directory that keeps all resources that are necessary in production but are not directly part of your source code. You typically keep database scripts, translation files, images, and more in here. Generated assets, created from files in the `assets` directory, are placed in `priv/static/assets` by default.\n\n  * `test` - a directory with all of our application tests. It often mirrors the same structure found in `lib`.","ref":"directory_structure.html"},{"type":"extras","title":"The lib/hello directory - Directory structure","doc":"The `lib/hello` directory hosts all of your business domain. Since our project does not have any business logic yet, the directory is mostly empty. You will only find three files:\n\n```console\nlib/hello\n├── application.ex\n├── mailer.ex\n└── repo.ex\n```\n\nThe `lib/hello/application.ex` file defines an Elixir application named `Hello.Application`. That's because at the end of the day Phoenix applications are simply Elixir applications. The `Hello.Application` module defines which services are part of our application:\n\n```elixir\nchildren = [\n  HelloWeb.Telemetry,\n  Hello.Repo,\n  {Phoenix.PubSub, name: Hello.PubSub},\n  HelloWeb.Endpoint\n]\n```\n\nIf it is your first time with Phoenix, you don't need to worry about the details right now. For now, suffice it to say our application starts a database repository, a PubSub system for sharing messages across processes and nodes, and the application endpoint, which effectively serves HTTP requests. These services are started in the order they are defined and, whenever shutting down your application, they are stopped in the reverse order.\n\nYou can learn more about applications in [Elixir's official docs for Application](https://hexdocs.pm/elixir/Application.html).\n\nThe `lib/hello/mailer.ex` file holds the `Hello.Mailer` module, which defines the main interface to deliver e-mails:\n\n```elixir\ndefmodule Hello.Mailer do\n  use Swoosh.Mailer, otp_app: :hello\nend\n```\n\nIn the same `lib/hello` directory, we will find a `lib/hello/repo.ex`. It defines a `Hello.Repo` module which is our main interface to the database. If you are using Postgres (the default database), you will see something like this:\n\n```elixir\ndefmodule Hello.Repo do\n  use Ecto.Repo,\n    otp_app: :hello,\n    adapter: Ecto.Adapters.Postgres\nend\n```\n\nAnd that's it for now. As you work on your project, we will add files and modules to this directory.","ref":"directory_structure.html#the-lib-hello-directory"},{"type":"extras","title":"The lib/hello_web directory - Directory structure","doc":"The `lib/hello_web` directory holds the web-related parts of our application. It looks like this when expanded:\n\n```console\nlib/hello_web\n├── controllers\n│   ├── page_controller.ex\n│   ├── page_html.ex\n│   ├── error_html.ex\n│   ├── error_json.ex\n│   └── page_html\n│       └── home.html.heex\n├── components\n│   ├── core_components.ex\n│   ├── layouts.ex\n│   └── layouts\n│       ├── app.html.heex\n│       └── root.html.heex\n├── endpoint.ex\n├── gettext.ex\n├── router.ex\n└── telemetry.ex\n```\n\nAll of the files which are currently in the `controllers` and `components` directories are there to create the \"Welcome to Phoenix!\" page we saw in the \"[Up and running](up_and_running.html)\" guide.\n\nBy looking at `controller` and `components` directories, we can see Phoenix provides features for handling layouts and HTML and error pages out of the box.\n\nBesides the directories mentioned, `lib/hello_web` has four files at its root. `lib/hello_web/endpoint.ex` is the entry-point for HTTP requests. Once the browser accesses [http://localhost:4000](http://localhost:4000), the endpoint starts processing the data, eventually leading to the router, which is defined in `lib/hello_web/router.ex`. The router defines the rules to dispatch requests to \"controllers\", which calls a view module to render HTML pages back to clients. We explore these layers in length in other guides, starting with the \"[Request life-cycle](request_lifecycle.html)\" guide coming next.\n\nThrough _Telemetry_, Phoenix is able to collect metrics and send monitoring events of your application. The `lib/hello_web/telemetry.ex` file defines the supervisor responsible for managing the telemetry processes. You can find more information on this topic in the [Telemetry guide](telemetry.html).\n\nFinally, there is a `lib/hello_web/gettext.ex` file which provides internationalization through [Gettext](https://hexdocs.pm/gettext/Gettext.html). If you are not worried about internationalization, you can safely skip this file and its contents.","ref":"directory_structure.html#the-lib-hello_web-directory"},{"type":"extras","title":"The assets directory - Directory structure","doc":"The `assets` directory contains source files related to front-end assets, such as JavaScript and CSS. Since Phoenix v1.6, we use [`esbuild`](https://github.com/evanw/esbuild/) to compile assets, which is managed by the [`esbuild`](https://github.com/phoenixframework/esbuild) Elixir package. The integration with `esbuild` is baked into your app. The relevant config can be found in your `config/config.exs` file.\n\nYour other static assets are placed in the `priv/static` folder, where `priv/static/assets` is kept for generated assets. Everything in `priv/static` is served by the `Plug.Static` plug configured in `lib/hello_web/endpoint.ex`.  When running in dev mode (`MIX_ENV=dev`), Phoenix watches for any changes you make in the `assets` directory, and then takes care of updating your front end application in your browser as you work.\n\nNote that when you first create your Phoenix app using `mix phx.new` it is possible to specify options that will affect the presence and layout of the `assets` directory.  In fact, Phoenix apps can bring their own front end tools or not have a front-end at all (handy if you're writing an API for example).  For more information you can run `mix help phx.new` or see the documentation in [Mix tasks](mix_tasks.html).\n\nIf the default esbuild integration does not cover your needs, for example because you want to use another build tool, you can switch to a [custom assets build](asset_management.html#custom_builds).\n\nAs for CSS, Phoenix ships with the [Tailwind CSS Framework](https://tailwindcss.com/), providing a base setup for projects. You may move to any CSS framework of your choice. Additional references can be found in the [asset management](asset_management.md#css) guide.","ref":"directory_structure.html#the-assets-directory"},{"type":"extras","title":"Request life-cycle","doc":"# Request life-cycle\n\n> **Requirement**: This guide expects that you have gone through the [introductory guides](installation.html) and got a Phoenix application [up and running](up_and_running.html).\n\nThe goal of this guide is to talk about Phoenix's request life-cycle. This guide will take a practical approach where we will learn by doing: we will add two new pages to our Phoenix project and comment on how the pieces fit together along the way.\n\nLet's get on with our first new Phoenix page!","ref":"request_lifecycle.html"},{"type":"extras","title":"Adding a new page - Request life-cycle","doc":"When your browser accesses [http://localhost:4000/](http://localhost:4000/), it sends a HTTP request to whatever service is running on that address, in this case our Phoenix application. The HTTP request is made of a verb and a path. For example, the following browser requests translate into:\n\n| Browser address bar                 | Verb | Path          |\n|:------------------------------------|:-----|:--------------|\n|              | GET  | /             |\n|         | GET  | /hello        |\n|   | GET  | /hello/world  |\n\nThere are other HTTP verbs. For example, submitting a form typically uses the POST verb.\n\nWeb applications typically handle requests by mapping each verb/path pair into a specific part of your application. This matching in Phoenix is done by the router. For example, we may map \"/articles\" to a portion of our application that shows all articles. Therefore, to add a new page, our first task is to add a new route.","ref":"request_lifecycle.html#adding-a-new-page"},{"type":"extras","title":"A new route - Request life-cycle","doc":"The router maps unique HTTP verb/path pairs to controller/action pairs which will handle them. Controllers in Phoenix are simply Elixir modules. Actions are functions that are defined within these controllers.\n\nPhoenix generates a router file for us in new applications at `lib/hello_web/router.ex`. This is where we will be working for this section.\n\nThe route for our \"Welcome to Phoenix!\" page from the previous [Up And Running Guide](up_and_running.html) looks like this.\n\n```elixir\nget \"/\", PageController, :home\n```\n\nLet's digest what this route is telling us. Visiting [http://localhost:4000/](http://localhost:4000/) issues an HTTP `GET` request to the root path. All requests like this will be handled by the `home/2` function in the `HelloWeb.PageController` module defined in `lib/hello_web/controllers/page_controller.ex`.\n\nThe page we are going to build will say \"Hello World, from Phoenix!\" when we point our browser to [http://localhost:4000/hello](http://localhost:4000/hello).\n\nThe first thing we need to do is to create the page route for a new page. Let's open up `lib/hello_web/router.ex` in a text editor. For a brand new application, it looks like this:\n\n```elixir\ndefmodule HelloWeb.Router do\n  use HelloWeb, :router\n\n  pipeline :browser do\n    plug :accepts, [\"html\"]\n    plug :fetch_session\n    plug :fetch_live_flash\n    plug :put_root_layout, html: {HelloWeb.Layouts, :root}\n    plug :protect_from_forgery\n    plug :put_secure_browser_headers\n  end\n\n  pipeline :api do\n    plug :accepts, [\"json\"]\n  end\n\n  scope \"/\", HelloWeb do\n    pipe_through :browser\n\n    get \"/\", PageController, :home\n  end\n\n  # Other scopes may use custom stacks.\n  # scope \"/api\", HelloWeb do\n  #   pipe_through :api\n  # end\n\n  # ...\nend\n```\n\nFor now, we'll ignore the pipelines and the use of `scope` here and just focus on adding a route. We will discuss those in the [Routing guide](routing.html).\n\nLet's add a new route to the router that maps a `GET` request for `/hello` to the `index` action of a soon-to-be-created `HelloWeb.HelloController` inside the `scope \"/\" do` block of the router:\n\n```elixir\nscope \"/\", HelloWeb do\n  pipe_through :browser\n\n  get \"/\", PageController, :home\n  get \"/hello\", HelloController, :index\nend\n```","ref":"request_lifecycle.html#a-new-route"},{"type":"extras","title":"A new controller - Request life-cycle","doc":"Controllers are Elixir modules, and actions are Elixir functions defined in them. The purpose of actions is to gather the data and perform the tasks needed for rendering. Our route specifies that we need a `HelloWeb.HelloController` module with an `index/2` function.\n\nTo make the `index` action happen, let's create a new `lib/hello_web/controllers/hello_controller.ex` file, and make it look like the following:\n\n```elixir\ndefmodule HelloWeb.HelloController do\n  use HelloWeb, :controller\n\n  def index(conn, _params) do\n    render(conn, :index)\n  end\nend\n```\n\nWe'll save a discussion of `use HelloWeb, :controller` for the [Controllers guide](controllers.html). For now, let's focus on the `index` action.\n\nAll controller actions take two arguments. The first is `conn`, a struct which holds a ton of data about the request. The second is `params`, which are the request parameters. Here, we are not using `params`, and we avoid compiler warnings by prefixing it with `_`.\n\nThe core of this action is `render(conn, :index)`. It tells Phoenix to render the `index` template. The modules responsible for rendering are called views. By default, Phoenix views are named after the controller (`HelloController`) and format (`HTML` in this case), so Phoenix is expecting a `HelloWeb.HelloHTML` to exist and define an `index/1` function.","ref":"request_lifecycle.html#a-new-controller"},{"type":"extras","title":"A new view - Request life-cycle","doc":"Phoenix views act as the presentation layer. For example, we expect the output of rendering `index` to be a complete HTML page. To make our lives easier, we often use templates for creating those HTML pages.\n\nLet's create a new view. Create `lib/hello_web/controllers/hello_html.ex` and make it look like this:\n\n```elixir\ndefmodule HelloWeb.HelloHTML do\n  use HelloWeb, :html\nend\n```\n\nTo add templates to this view, we can define them as function components in the module or in separate files.\n\nLet's start by defining a function component:\n\n```elixir\ndefmodule HelloWeb.HelloHTML do\n  use HelloWeb, :html\n\n  def index(assigns) do\n    ~H\"\"\"\n    Hello!\n    \"\"\"\n  end\nend\n```\n\nWe defined a function that receives `assigns` as arguments and use [the `~H` sigil](https://hexdocs.pm/phoenix_live_view/Phoenix.Component.html#sigil_H/2) to put the contents we want to render. Inside the `~H` sigil, we use a templating language called HEEx, which stands for \"HTML+EEx\". `EEx` is a library for embedding Elixir that ships as part of Elixir itself. \"HTML+EEx\" is a Phoenix extension of EEx that is HTML aware, with support for HTML validation, components, and automatic escaping of values. The latter protects you from security vulnerabilities like Cross-Site-Scripting with no extra work on your part.\n\nA template file works in the same way. Function components are great for smaller templates and separate files are a good choice when you have a lot of markup or your functions start to feel unmanageable.\n\nLet's give it a try by defining a template in its own file. First delete our `def index(assigns)` function from above and replace it with an `embed_templates` declaration:\n\n```elixir\ndefmodule HelloWeb.HelloHTML do\n  use HelloWeb, :html\n\n  embed_templates \"hello_html/*\"\nend\n```\n\nHere we are telling `Phoenix.Component` to embed all `.heex` templates found in the sibling `hello_html` directory into our module as function definitions.\n\nNext, we need to add files to the `lib/hello_web/controllers/hello_html` directory.\n\nNote the controller name (`HelloController`), the view name (`HelloHTML`), and the template directory (`hello_html`) all follow the same naming convention and are named after each other. They are also collocated together in the directory tree:\n\n> **Note**: We can rename the `hello_html` directory to whatever we want and put it in a subdirectory of `lib/hello_web/controllers`, as long as we update the `embed_templates` setting accordingly. However, it's best to keep the same naming convention to prevent any confusion.\n\n```\nlib/hello_web\n├── controllers\n│   ├── hello_controller.ex\n│   ├── hello_html.ex\n│   ├── hello_html\n|       ├── index.html.heex\n```\n\nA template file has the following structure: `NAME.FORMAT.TEMPLATING_LANGUAGE`. In our case, let's create an `index.html.heex` file at `lib/hello_web/controllers/hello_html/index.html.heex`:\n\n```heex\n \n   Hello World, from Phoenix! \n \n```\n\nTemplate files are compiled into the module as function components themselves, there is no runtime or performance difference between the two styles.\n\nNow that we've got the route, controller, view, and template, we should be able to point our browsers at [http://localhost:4000/hello](http://localhost:4000/hello) and see our greeting from Phoenix! (In case you stopped the server along the way, the task to restart it is `mix phx.server`.)\n\n![Phoenix Greets Us](assets/images/hello-from-phoenix.png)\n\nThere are a couple of interesting things to notice about what we just did. We didn't need to stop and restart the server while we made these changes. Yes, Phoenix has hot code reloading! Also, even though our `index.html.heex` file consists of only a single `section` tag, the page we get is a full HTML document. Our index template is actually rendered into layouts: first it renders `lib/hello_web/components/layouts/root.html.heex` which renders `lib/hello_web/components/layouts/app.html.heex` which finally includes our contents. If you open those files, you'll see a line that looks like this at the bottom:\n\n```heex\n<%= @inner_content %>\n```\n\nWhich injects our template into the layout before the HTML is sent off to the browser. We will talk more about layouts in the Controllers guide.\n\n> A note on hot code reloading: Some editors with their automatic linters may prevent hot code reloading from working. If it's not working for you, please see the discussion in [this issue](https://github.com/phoenixframework/phoenix/issues/1165).","ref":"request_lifecycle.html#a-new-view"},{"type":"extras","title":"From endpoint to views - Request life-cycle","doc":"As we built our first page, we could start to understand how the request life-cycle is put together. Now let's take a more holistic look at it.\n\nAll HTTP requests start in our application endpoint. You can find it as a module named `HelloWeb.Endpoint` in `lib/hello_web/endpoint.ex`. Once you open up the endpoint file, you will see that, similar to the router, the endpoint has many calls to `plug`. `Plug` is a library and a specification for stitching web applications together. It is an essential part of how Phoenix handles requests and we will discuss it in detail in the [Plug guide](plug.html) coming next.\n\nFor now, it suffices to say that each plug defines a slice of request processing. In the endpoint you will find a skeleton roughly like this:\n\n```elixir\ndefmodule HelloWeb.Endpoint do\n  use Phoenix.Endpoint, otp_app: :hello\n\n  plug Plug.Static, ...\n  plug Plug.RequestId\n  plug Plug.Telemetry, ...\n  plug Plug.Parsers, ...\n  plug Plug.MethodOverride\n  plug Plug.Head\n  plug Plug.Session, ...\n  plug HelloWeb.Router\nend\n```\n\nEach of these plugs have a specific responsibility that we will learn later. The last plug is precisely the `HelloWeb.Router` module. This allows the endpoint to delegate all further request processing to the router. As we now know, its main responsibility is to map verb/path pairs to controllers. The controller then tells a view to render a template.\n\nAt this moment, you may be thinking this can be a lot of steps to simply render a page. However, as our application grows in complexity, we will see that each layer serves a distinct purpose:\n\n  * endpoint (`Phoenix.Endpoint`) - the endpoint contains the common and initial path that all requests go through. If you want something to happen on all requests, it goes to the endpoint.\n\n  * router (`Phoenix.Router`) - the router is responsible for dispatching verb/path to controllers. The router also allows us to scope functionality. For example, some pages in your application may require user authentication, others may not.\n\n  * controller (`Phoenix.Controller`) - the job of the controller is to retrieve request information, talk to your business domain, and prepare data for the presentation layer.\n\n  * view - the view handles the structured data from the controller and converts it to a presentation to be shown to users. Views are often named after the content format they are rendering.\n\nLet's do a quick recap on how the last three components work together by adding another page.","ref":"request_lifecycle.html#from-endpoint-to-views"},{"type":"extras","title":"Another new page - Request life-cycle","doc":"Let's add just a little complexity to our application. We're going to add a new page that will recognize a piece of the URL, label it as a \"messenger\" and pass it through the controller into the template so our messenger can say hello.\n\nAs we did last time, the first thing we'll do is create a new route.","ref":"request_lifecycle.html#another-new-page"},{"type":"extras","title":"Another new route - Request life-cycle","doc":"For this exercise, we're going to reuse `HelloController` created at the [previous step](request_lifecycle.html#a-new-controller) and add a new `show` action. We'll add a line just below our last route, like this:\n\n```elixir\nscope \"/\", HelloWeb do\n  pipe_through :browser\n\n  get \"/\", PageController, :home\n  get \"/hello\", HelloController, :index\n  get \"/hello/:messenger\", HelloController, :show\nend\n```\n\nNotice that we use the `:messenger` syntax in the path. Phoenix will take whatever value that appears in that position in the URL and convert it into a parameter. For example, if we point the browser at: `http://localhost:4000/hello/Frank`, the value of `\"messenger\"` will be `\"Frank\"`.","ref":"request_lifecycle.html#another-new-route"},{"type":"extras","title":"Another new action - Request life-cycle","doc":"Requests to our new route will be handled by the `HelloWeb.HelloController` `show` action. We already have the controller at `lib/hello_web/controllers/hello_controller.ex`, so all we need to do is edit that controller and add a `show` action to it. This time, we'll need to extract the messenger from the parameters so that we can pass it (the messenger) to the template. To do that, we add this show function to the controller:\n\n```elixir\ndef show(conn, %{\"messenger\" => messenger}) do\n  render(conn, :show, messenger: messenger)\nend\n```\n\nWithin the body of the `show` action, we also pass a third argument to the render function, a key-value pair where `:messenger` is the key, and the `messenger` variable is passed as the value.\n\nIf the body of the action needs access to the full map of parameters bound to the `params` variable, in addition to the bound messenger variable, we could define `show/2` like this:\n\n```elixir\ndef show(conn, %{\"messenger\" => messenger} = params) do\n  ...\nend\n```\n\nIt's good to remember that the keys of the `params` map will always be strings, and that the equals sign does not represent assignment, but is instead a [pattern match](https://hexdocs.pm/elixir/pattern-matching.html) assertion.","ref":"request_lifecycle.html#another-new-action"},{"type":"extras","title":"Another new template - Request life-cycle","doc":"For the last piece of this puzzle, we'll need a new template. Since it is for the `show` action of `HelloController`, it will go into the `lib/hello_web/controllers/hello_html` directory and be called `show.html.heex`. It will look surprisingly like our `index.html.heex` template, except that we will need to display the name of our messenger.\n\nTo do that, we'll use the special HEEx tags for executing Elixir expressions: `<%=  %>`. Notice that the initial tag has an equals sign like this: `<%=` . That means that any Elixir code that goes between those tags will be executed, and the resulting value will replace the tag in the HTML output. If the equals sign were missing, the code would still be executed, but the value would not appear on the page.\n\nRemember our templates are written in HEEx (HTML+EEx). HEEx is a superset of EEx which is why it shares the `<%= %>` syntax.\n\nAnd this is what the template should look like:\n\n```heex\n \n   Hello World, from <%= @messenger %>! \n \n```\n\nOur messenger appears as `@messenger`.\n\nThe values we passed to the view from the controller are collectively called our \"assigns\". We could access our messenger value via `assigns.messenger` but through some metaprogramming, Phoenix gives us the much cleaner `@` syntax for use in templates.\n\nWe're done. If you point your browser to [http://localhost:4000/hello/Frank](http://localhost:4000/hello/Frank), you should see a page that looks like this:\n\n![Frank Greets Us from Phoenix](assets/images/hello-world-from-frank.png)\n\nPlay around a bit. Whatever you put after `/hello/` will appear on the page as your messenger.","ref":"request_lifecycle.html#another-new-template"},{"type":"extras","title":"Plug","doc":"# Plug\n\n> **Requirement**: This guide expects that you have gone through the [introductory guides](installation.html) and got a Phoenix application [up and running](up_and_running.html).\n\n> **Requirement**: This guide expects that you have gone through the [Request life-cycle guide](request_lifecycle.html).\n\nPlug lives at the heart of Phoenix's HTTP layer, and Phoenix puts Plug front and center. We interact with plugs at every step of the request life-cycle, and the core Phoenix components like endpoints, routers, and controllers are all just plugs internally. Let's jump in and find out just what makes Plug so special.\n\n[Plug](https://github.com/elixir-lang/plug) is a specification for composable modules in between web applications. It is also an abstraction layer for connection adapters of different web servers. The basic idea of Plug is to unify the concept of a \"connection\" that we operate on. This differs from other HTTP middleware layers such as Rack, where the request and response are separated in the middleware stack.\n\nAt the simplest level, the Plug specification comes in two flavors: *function plugs* and *module plugs*.","ref":"plug.html"},{"type":"extras","title":"Function plugs - Plug","doc":"In order to act as a plug, a function needs to:\n\n1. accept a connection struct (`%Plug.Conn{}`) as its first argument, and connection options as its second one;\n2. return a connection struct.\n\nAny function that meets these two criteria will do. Here's an example.\n\n```elixir\ndef introspect(conn, _opts) do\n  IO.puts \"\"\"\n  Verb: #{inspect(conn.method)}\n  Host: #{inspect(conn.host)}\n  Headers: #{inspect(conn.req_headers)}\n  \"\"\"\n\n  conn\nend\n```\n\nThis function does the following:\n\n  1. It receives a connection and options (that we do not use)\n  2. It prints some connection information to the terminal\n  3. It returns the connection\n\nPretty simple, right? Let's see this function in action by adding it to our endpoint in `lib/hello_web/endpoint.ex`. We can plug it anywhere, so let's do it by inserting `plug :introspect` right before we delegate the request to the router:\n\n```elixir\ndefmodule HelloWeb.Endpoint do\n  ...\n\n  plug :introspect\n  plug HelloWeb.Router\n\n  def introspect(conn, _opts) do\n    IO.puts \"\"\"\n    Verb: #{inspect(conn.method)}\n    Host: #{inspect(conn.host)}\n    Headers: #{inspect(conn.req_headers)}\n    \"\"\"\n\n    conn\n  end\nend\n```\n\nFunction plugs are plugged by passing the function name as an atom. To try the plug out, go back to your browser and fetch [http://localhost:4000](http://localhost:4000). You should see something like this printed in your shell terminal:\n\n```console\nVerb: \"GET\"\nHost: \"localhost\"\nHeaders: [...]\n```\n\nOur plug simply prints information from the connection. Although our initial plug is very simple, you can do virtually anything you want inside of it. To learn about all fields available in the connection and all of the functionality associated to it, see the [documentation for `Plug.Conn`](https://hexdocs.pm/plug/Plug.Conn.html).\n\nNow let's look at the other plug variant, the module plugs.","ref":"plug.html#function-plugs"},{"type":"extras","title":"Module plugs - Plug","doc":"Module plugs are another type of plug that let us define a connection transformation in a module. The module only needs to implement two functions:\n\n- [`init/1`] which initializes any arguments or options to be passed to [`call/2`]\n- [`call/2`] which carries out the connection transformation. [`call/2`] is just a function plug that we saw earlier\n\nTo see this in action, let's write a module plug that puts the `:locale` key and value into the connection for downstream use in other plugs, controller actions, and our views. Put the contents below in a file named `lib/hello_web/plugs/locale.ex`:\n\n```elixir\ndefmodule HelloWeb.Plugs.Locale do\n  import Plug.Conn\n\n  @locales [\"en\", \"fr\", \"de\"]\n\n  def init(default), do: default\n\n  def call(%Plug.Conn{params: %{\"locale\" => loc}} = conn, _default) when loc in @locales do\n    assign(conn, :locale, loc)\n  end\n\n  def call(conn, default) do\n    assign(conn, :locale, default)\n  end\nend\n```\n\nTo give it a try, let's add this module plug to our router, by appending `plug HelloWeb.Plugs.Locale, \"en\"`  to our `:browser` pipeline in `lib/hello_web/router.ex`:\n\n```elixir\ndefmodule HelloWeb.Router do\n  use HelloWeb, :router\n\n  pipeline :browser do\n    plug :accepts, [\"html\"]\n    plug :fetch_session\n    plug :fetch_flash\n    plug :protect_from_forgery\n    plug :put_secure_browser_headers\n    plug HelloWeb.Plugs.Locale, \"en\"\n  end\n  ...\n```\n\nIn the [`init/1`] callback, we pass a default locale to use if none is present in the params. We also use pattern matching to define multiple [`call/2`] function heads to validate the locale in the params, and fall back to `\"en\"` if there is no match. The [`assign/3`] is a part of the `Plug.Conn` module and it's how we store values in the `conn` data structure.\n\nTo see the assign in action, go to the template in `lib/hello_web/controllers/page_html/home.html.heex` and add the following code after the closing of the ` ` tag:\n\n```heex\n Locale: <%= @locale %> \n```\n\nGo to [http://localhost:4000/](http://localhost:4000/) and you should see the locale exhibited. Visit [http://localhost:4000/?locale=fr](http://localhost:4000/?locale=fr) and you should see the assign changed to `\"fr\"`. Someone can use this information alongside [Gettext](https://hexdocs.pm/gettext/Gettext.html) to provide a fully internationalized web application.\n\nThat's all there is to Plug. Phoenix embraces the plug design of composable transformations all the way up and down the stack. Let's see some examples!","ref":"plug.html#module-plugs"},{"type":"extras","title":"Where to plug - Plug","doc":"The endpoint, router, and controllers in Phoenix accept plugs.","ref":"plug.html#where-to-plug"},{"type":"extras","title":"Endpoint plugs - Plug","doc":"Endpoints organize all the plugs common to every request, and apply them before dispatching into the router with its custom pipelines. We added a plug to the endpoint like this:\n\n```elixir\ndefmodule HelloWeb.Endpoint do\n  ...\n\n  plug :introspect\n  plug HelloWeb.Router\n```\n\nThe default endpoint plugs do quite a lot of work. Here they are in order:\n\n- `Plug.Static` - serves static assets. Since this plug comes before the logger, requests for static assets are not logged.\n\n- `Phoenix.LiveDashboard.RequestLogger` - sets up the *Request Logger* for Phoenix LiveDashboard, this will allow you to have the option to either pass a query parameter to stream requests logs or to enable/disable a cookie that streams requests logs from your dashboard.\n\n- `Plug.RequestId` - generates a unique request ID for each request.\n\n- `Plug.Telemetry` - adds instrumentation points so Phoenix can log the request path, status code and request time by default.\n\n- `Plug.Parsers` - parses the request body when a known parser is available. By default, this plug can handle URL-encoded, multipart and JSON content (with `Jason`). The request body is left untouched if the request content-type cannot be parsed.\n\n- `Plug.MethodOverride` - converts the request method to PUT, PATCH or DELETE for POST requests with a valid `_method` parameter.\n\n- `Plug.Head` - converts HEAD requests to GET requests.\n\n- `Plug.Session` - a plug that sets up session management. Note that `fetch_session/2` must still be explicitly called before using the session, as this plug just sets up how the session is fetched.\n\nIn the middle of the endpoint, there is also a conditional block:\n\n```elixir\n  if code_reloading? do\n    socket \"/phoenix/live_reload/socket\", Phoenix.LiveReloader.Socket\n    plug Phoenix.LiveReloader\n    plug Phoenix.CodeReloader\n    plug Phoenix.Ecto.CheckRepoStatus, otp_app: :hello\n  end\n```\n\nThis block is only executed in development. It enables:\n\n* live reloading - if you change a CSS file, they are updated in-browser without refreshing the page;\n* [code reloading](`Phoenix.CodeReloader`) - so we can see changes to our application without restarting the server;\n* check repo status - which makes sure our database is up to date, raising a readable and actionable error otherwise.","ref":"plug.html#endpoint-plugs"},{"type":"extras","title":"Router plugs - Plug","doc":"In the router, we can declare plugs inside pipelines:\n\n```elixir\ndefmodule HelloWeb.Router do\n  use HelloWeb, :router\n\n  pipeline :browser do\n    plug :accepts, [\"html\"]\n    plug :fetch_session\n    plug :fetch_live_flash\n    plug :put_root_layout, html: {HelloWeb.LayoutView, :root}\n    plug :protect_from_forgery\n    plug :put_secure_browser_headers\n    plug HelloWeb.Plugs.Locale, \"en\"\n  end\n\n  scope \"/\", HelloWeb do\n    pipe_through :browser\n\n    get \"/\", PageController, :index\n  end\n```\n\nRoutes are defined inside scopes and scopes may pipe through multiple pipelines. Once a route matches, Phoenix invokes all plugs defined in all pipelines associated to that route. For example, accessing \"/\" will pipe through the `:browser` pipeline, consequently invoking all of its plugs.\n\nAs we will see in the [routing guide](routing.html), the pipelines themselves are plugs. There, we will also discuss all plugs in the `:browser` pipeline.","ref":"plug.html#router-plugs"},{"type":"extras","title":"Controller plugs - Plug","doc":"Finally, controllers are plugs too, so we can do:\n\n```elixir\ndefmodule HelloWeb.PageController do\n  use HelloWeb, :controller\n\n  plug HelloWeb.Plugs.Locale, \"en\"\n```\n\nIn particular, controller plugs provide a feature that allows us to execute plugs only within certain actions. For example, you can do:\n\n```elixir\ndefmodule HelloWeb.PageController do\n  use HelloWeb, :controller\n\n  plug HelloWeb.Plugs.Locale, \"en\" when action in [:index]\n```\n\nAnd the plug will only be executed for the `index` action.","ref":"plug.html#controller-plugs"},{"type":"extras","title":"Plugs as composition - Plug","doc":"By abiding by the plug contract, we turn an application request into a series of explicit transformations. It doesn't stop there. To really see how effective Plug's design is, let's imagine a scenario where we need to check a series of conditions and then either redirect or halt if a condition fails. Without plug, we would end up with something like this:\n\n```elixir\ndefmodule HelloWeb.MessageController do\n  use HelloWeb, :controller\n\n  def show(conn, params) do\n    case Authenticator.find_user(conn) do\n      {:ok, user} ->\n        case find_message(params[\"id\"]) do\n          nil ->\n            conn |> put_flash(:info, \"That message wasn't found\") |> redirect(to: ~p\"/\")\n          message ->\n            if Authorizer.can_access?(user, message) do\n              render(conn, :show, page: message)\n            else\n              conn |> put_flash(:info, \"You can't access that page\") |> redirect(to: ~p\"/\")\n            end\n        end\n      :error ->\n        conn |> put_flash(:info, \"You must be logged in\") |> redirect(to: ~p\"/\")\n    end\n  end\nend\n```\n\nNotice how just a few steps of authentication and authorization require complicated nesting and duplication? Let's improve this with a couple of plugs.\n\n```elixir\ndefmodule HelloWeb.MessageController do\n  use HelloWeb, :controller\n\n  plug :authenticate\n  plug :fetch_message\n  plug :authorize_message\n\n  def show(conn, params) do\n    render(conn, :show, page: conn.assigns[:message])\n  end\n\n  defp authenticate(conn, _) do\n    case Authenticator.find_user(conn) do\n      {:ok, user} ->\n        assign(conn, :user, user)\n      :error ->\n        conn |> put_flash(:info, \"You must be logged in\") |> redirect(to: ~p\"/\") |> halt()\n    end\n  end\n\n  defp fetch_message(conn, _) do\n    case find_message(conn.params[\"id\"]) do\n      nil ->\n        conn |> put_flash(:info, \"That message wasn't found\") |> redirect(to: ~p\"/\") |> halt()\n      message ->\n        assign(conn, :message, message)\n    end\n  end\n\n  defp authorize_message(conn, _) do\n    if Authorizer.can_access?(conn.assigns[:user], conn.assigns[:message]) do\n      conn\n    else\n      conn |> put_flash(:info, \"You can't access that page\") |> redirect(to: ~p\"/\") |> halt()\n    end\n  end\nend\n```\n\nTo make this all work, we converted the nested blocks of code and used `halt(conn)` whenever we reached a failure path. The `halt(conn)` functionality is essential here: it tells Plug that the next plug should not be invoked.\n\nAt the end of the day, by replacing the nested blocks of code with a flattened series of plug transformations, we are able to achieve the same functionality in a much more composable, clear, and reusable way.\n\nTo learn more about plugs, see the documentation for the [Plug project](`Plug`), which provides many built-in plugs and functionalities.\n\n[`init/1`]: `c:Plug.init/1`\n[`call/2`]: `c:Plug.call/2`\n[`assign/3`]: `Plug.Conn.assign/3`","ref":"plug.html#plugs-as-composition"},{"type":"extras","title":"Routing","doc":"# Routing\n\n> **Requirement**: This guide expects that you have gone through the [introductory guides](installation.html) and got a Phoenix application [up and running](up_and_running.html).\n\n> **Requirement**: This guide expects that you have gone through the [Request life-cycle guide](request_lifecycle.html).\n\nRouters are the main hubs of Phoenix applications. They match HTTP requests to controller actions, wire up real-time channel handlers, and define a series of pipeline transformations scoped to a set of routes.\n\nThe router file that Phoenix generates, `lib/hello_web/router.ex`, will look something like this one:\n\n```elixir\ndefmodule HelloWeb.Router do\n  use HelloWeb, :router\n\n  pipeline :browser do\n    plug :accepts, [\"html\"]\n    plug :fetch_session\n    plug :fetch_live_flash\n    plug :put_root_layout, html: {HelloWeb.Layouts, :root}\n    plug :protect_from_forgery\n    plug :put_secure_browser_headers\n  end\n\n  pipeline :api do\n    plug :accepts, [\"json\"]\n  end\n\n  scope \"/\", HelloWeb do\n    pipe_through :browser\n\n    get \"/\", PageController, :home\n  end\n\n  # Other scopes may use custom stacks.\n  # scope \"/api\", HelloWeb do\n  #   pipe_through :api\n  # end\n  # ...\nend\n```\n\nBoth the router and controller module names will be prefixed with the name you gave your application suffixed with `Web`.\n\nThe first line of this module, `use HelloWeb, :router`, simply makes Phoenix router functions available in our particular router.\n\nScopes have their own section in this guide, so we won't spend time on the `scope \"/\", HelloWeb do` block here. The `pipe_through :browser` line will get a full treatment in the \"Pipelines\" section of this guide. For now, you only need to know that pipelines allow a set of plugs to be applied to different sets of routes.\n\nInside the scope block, however, we have our first actual route:\n\n```elixir\nget \"/\", PageController, :home\n```\n\n`get` is a Phoenix macro that corresponds to the HTTP verb GET. Similar macros exist for other HTTP verbs, including POST, PUT, PATCH, DELETE, OPTIONS, CONNECT, TRACE, and HEAD.\n\n> #### Why the macros? {: .info}\n>\n> Phoenix does its best to keep the usage of macros low. You may have noticed, however, that the `Phoenix.Router` relies heavily on macros. Why is that?\n>\n> We use `get`, `post`, `put`, and `delete` to define your routes. We use macros for two purposes:\n>\n>   * They define the routing engine, used on every request, to choose which controller to dispatch the request to. Thanks to macros, Phoenix compiles all of your routes to a huge case-statement with pattern matching rules, which is heavily optimized by the Erlang VM\n>\n>   * For each route you define, we also define metadata to implement `Phoenix.VerifiedRoutes`. As we will soon learn, verified routes allow us to reference any route as if it were a plain looking string, except that it is verified by the compiler to be valid (making it much harder to ship broken links, forms, mails, etc to production)\n>\n> In other words, the router relies on macros to build applications that are faster and safer. Also remember that macros in Elixir are compile-time only, which gives plenty of stability after the code is compiled. As we will learn next, Phoenix also provides introspection for all defined routes via `mix phx.routes`.","ref":"routing.html"},{"type":"extras","title":"Examining routes - Routing","doc":"Phoenix provides an excellent tool for investigating routes in an application: `mix phx.routes`.\n\nLet's see how this works. Go to the root of a newly-generated Phoenix application and run `mix phx.routes`. You should see something like the following, generated with all routes you currently have:\n\n```console\n$ mix phx.routes\nGET  /  HelloWeb.PageController :home\n...\n```\n\nThe route above tells us that any HTTP GET request for the root of the application will be handled by the `home` action of the `HelloWeb.PageController`.","ref":"routing.html#examining-routes"},{"type":"extras","title":"Resources - Routing","doc":"The router supports other macros besides those for HTTP verbs like [`get`](`Phoenix.Router.get/3`), [`post`](`Phoenix.Router.post/3`), and [`put`](`Phoenix.Router.put/3`). The most important among them is [`resources`](`Phoenix.Router.resources/4`). Let's add a resource to our `lib/hello_web/router.ex` file like this:\n\n```elixir\nscope \"/\", HelloWeb do\n  pipe_through :browser\n\n  get \"/\", PageController, :home\n  resources \"/users\", UserController\n  ...\nend\n```\n\nFor now it doesn't matter that we don't actually have a `HelloWeb.UserController`.\n\nRun `mix phx.routes` once again at the root of your project. You should see something like the following:\n\n```console\n...\nGET     /users           HelloWeb.UserController :index\nGET     /users/:id/edit  HelloWeb.UserController :edit\nGET     /users/new       HelloWeb.UserController :new\nGET     /users/:id       HelloWeb.UserController :show\nPOST    /users           HelloWeb.UserController :create\nPATCH   /users/:id       HelloWeb.UserController :update\nPUT     /users/:id       HelloWeb.UserController :update\nDELETE  /users/:id       HelloWeb.UserController :delete\n...\n```\n\nThis is the standard matrix of HTTP verbs, paths, and controller actions. For a while, this was known as RESTful routes, but most consider this a misnomer nowadays. Let's look at them individually.\n\n- A GET request to `/users` will invoke the `index` action to show all the users.\n- A GET request to `/users/:id/edit` will invoke the `edit` action with an ID to retrieve an individual user from the data store and present the information in a form for editing.\n- A GET request to `/users/new` will invoke the `new` action to present a form for creating a new user.\n- A GET request to `/users/:id` will invoke the `show` action with an id to show an individual user identified by that ID.\n- A POST request to `/users` will invoke the `create` action to save a new user to the data store.\n- A PATCH request to `/users/:id` will invoke the `update` action with an ID to save the updated user to the data store.\n- A PUT request to `/users/:id` will also invoke the `update` action with an ID to save the updated user to the data store.\n- A DELETE request to `/users/:id` will invoke the `delete` action with an ID to remove the individual user from the data store.\n\nIf we don't need all these routes, we can be selective using the `:only` and `:except` options to filter specific actions.\n\nLet's say we have a read-only posts resource. We could define it like this:\n\n```elixir\nresources \"/posts\", PostController, only: [:index, :show]\n```\n\nRunning `mix phx.routes` shows that we now only have the routes to the index and show actions defined.\n\n```console\nGET     /posts      HelloWeb.PostController :index\nGET     /posts/:id  HelloWeb.PostController :show\n```\n\nSimilarly, if we have a comments resource, and we don't want to provide a route to delete one, we could define a route like this.\n\n```elixir\nresources \"/comments\", CommentController, except: [:delete]\n```\n\nRunning `mix phx.routes` now shows that we have all the routes except the DELETE request to the delete action.\n\n```console\nGET    /comments           HelloWeb.CommentController :index\nGET    /comments/:id/edit  HelloWeb.CommentController :edit\nGET    /comments/new       HelloWeb.CommentController :new\nGET    /comments/:id       HelloWeb.CommentController :show\nPOST   /comments           HelloWeb.CommentController :create\nPATCH  /comments/:id       HelloWeb.CommentController :update\nPUT    /comments/:id       HelloWeb.CommentController :update\n```\n\nThe `Phoenix.Router.resources/4` macro describes additional options for customizing resource routes.","ref":"routing.html#resources"},{"type":"extras","title":"Verified Routes - Routing","doc":"Phoenix includes `Phoenix.VerifiedRoutes` module which provides compile-time checks of router paths against your router by using the `~p` sigil. For example, you can write paths in controllers, tests, and templates and the compiler will make sure those actually match routes defined in your router.\n\nLet's see it in action. Run `iex -S mix` at the root of the project. We'll define a throwaway example module that builds a couple `~p` route paths.\n\n```elixir\niex> defmodule RouteExample do\n...>   use HelloWeb, :verified_routes\n...>\n...>   def example do\n...>     ~p\"/comments\"\n...>     ~p\"/unknown/123\"\n...>   end\n...> end\nwarning: no route path for HelloWeb.Router matches \"/unknown/123\"\n  iex:5: RouteExample.example/0\n\n{:module, RouteExample, ...}\niex>\n```\n\nNotice how the first call to an existing route, `~p\"/comments\"` gave no warning, but a bad route path `~p\"/unknown/123\"` produced a compiler warning, just as it should. This is significant because it allows us to write otherwise hard-coded paths in our application and the compiler will let us know whenever we write a bad route or change our routing structure.\n\nPhoenix projects are set up out of the box to allow use of verified routes throughout your web layer, including tests. For example in your templates you can render `~p` links:\n\n```heex\n<.link href={~p\"/\"}>Welcome Page!</.link>\n<.link href={~p\"/comments\"}>View Comments</.link>\n```\n\nOr in a controller, issue a redirect:\n\n```elixir\nredirect(conn, to: ~p\"/comments/#{comment}\")\n```\n\nUsing `~p` for route paths ensures our application paths and URLs stay up to date with the router definitions. The compiler will catch bugs for us, and let us know when we change routes that are referenced elsewhere in our application.","ref":"routing.html#verified-routes"},{"type":"extras","title":"More on verified routes - Routing","doc":"What about paths with query strings? You can either add query string key values directly, or provide a dictionary of key-value pairs, for example:\n\n```elixir\n~p\"/users/17?admin=true&active=false\"\n\"/users/17?admin=true&active=false\"\n\n~p\"/users/17?#{[admin: true]}\"\n\"/users/17?admin=true\"\n```\n\nWhat if we need a full URL instead of a path? Just wrap your path with a call to `Phoenix.VerifiedRoutes.url/1`, which is imported everywhere that `~p` is available:\n\n```elixir\nurl(~p\"/users\")\n\"http://localhost:4000/users\"\n```\n\nThe `url` calls will get the host, port, proxy port, and SSL information needed to construct the full URL from the configuration parameters set for each environment. We'll talk about configuration in more detail in its own guide. For now, you can take a look at `config/dev.exs` file in your own project to see those values.","ref":"routing.html#more-on-verified-routes"},{"type":"extras","title":"Nested resources - Routing","doc":"It is also possible to nest resources in a Phoenix router. Let's say we also have a `posts` resource that has a many-to-one relationship with `users`. That is to say, a user can create many posts, and an individual post belongs to only one user. We can represent that by adding a nested route in `lib/hello_web/router.ex` like this:\n\n```elixir\nresources \"/users\", UserController do\n  resources \"/posts\", PostController\nend\n```\n\nWhen we run `mix phx.routes` now, in addition to the routes we saw for `users` above, we get the following set of routes:\n\n```elixir\n...\nGET     /users/:user_id/posts           HelloWeb.PostController :index\nGET     /users/:user_id/posts/:id/edit  HelloWeb.PostController :edit\nGET     /users/:user_id/posts/new       HelloWeb.PostController :new\nGET     /users/:user_id/posts/:id       HelloWeb.PostController :show\nPOST    /users/:user_id/posts           HelloWeb.PostController :create\nPATCH   /users/:user_id/posts/:id       HelloWeb.PostController :update\nPUT     /users/:user_id/posts/:id       HelloWeb.PostController :update\nDELETE  /users/:user_id/posts/:id       HelloWeb.PostController :delete\n...\n```\n\nWe see that each of these routes scopes the posts to a user ID. For the first one, we will invoke `PostController`'s `index` action, but we will pass in a `user_id`. This implies that we would display all the posts for that individual user only. The same scoping applies for all these routes.\n\nWhen building paths for nested routes, we will need to interpolate the IDs where they belong in route definition. For the following `show` route, `42` is the `user_id`, and `17` is the `post_id`.\n\n```elixir\nuser_id = 42\npost_id = 17\n~p\"/users/#{user_id}/posts/#{post_id}\"\n\"/users/42/posts/17\"\n```\n\nVerified routes also support the `Phoenix.Param` protocol, but we don't need to concern ourselves with Elixir protocols just yet. Just know that once we start building our application with structs like `%User{}` and `%Post{}`, we'll be able to interpolate those data structures directly into our `~p` paths and Phoenix will pluck out the correct fields to use in the route.\n\n```elixir\n~p\"/users/#{user}/posts/#{post}\"\n\"/users/42/posts/17\"\n```\n\nNotice how we didn't need to interpolate `user.id` or `post.id`? This is particularly nice if we decide later we want to make our URLs a little nicer and start using slugs instead. We don't need to change any of our `~p`'s!","ref":"routing.html#nested-resources"},{"type":"extras","title":"Scoped routes - Routing","doc":"Scopes are a way to group routes under a common path prefix and scoped set of plugs. We might want to do this for admin functionality, APIs, and especially for versioned APIs. Let's say we have user-generated reviews on a site, and that those reviews first need to be approved by an administrator. The semantics of these resources are quite different, and they might not share the same controller. Scopes enable us to segregate these routes.\n\nThe paths to the user-facing reviews would look like a standard resource.\n\n```console\n/reviews\n/reviews/1234\n/reviews/1234/edit\n...\n```\n\nThe administration review paths can be prefixed with `/admin`.\n\n```console\n/admin/reviews\n/admin/reviews/1234\n/admin/reviews/1234/edit\n...\n```\n\nWe accomplish this with a scoped route that sets a path option to `/admin` like this one. We can nest this scope inside another scope, but instead, let's set it by itself at the root, by adding to `lib/hello_web/router.ex` the following:\n\n```elixir\nscope \"/admin\", HelloWeb.Admin do\n  pipe_through :browser\n\n  resources \"/reviews\", ReviewController\nend\n```\n\nWe define a new scope where all routes are prefixed with `/admin` and all controllers are under the `HelloWeb.Admin` namespace.\n\nRunning `mix phx.routes` again, in addition to the previous set of routes we get the following:\n\n```console\n...\nGET     /admin/reviews           HelloWeb.Admin.ReviewController :index\nGET     /admin/reviews/:id/edit  HelloWeb.Admin.ReviewController :edit\nGET     /admin/reviews/new       HelloWeb.Admin.ReviewController :new\nGET     /admin/reviews/:id       HelloWeb.Admin.ReviewController :show\nPOST    /admin/reviews           HelloWeb.Admin.ReviewController :create\nPATCH   /admin/reviews/:id       HelloWeb.Admin.ReviewController :update\nPUT     /admin/reviews/:id       HelloWeb.Admin.ReviewController :update\nDELETE  /admin/reviews/:id       HelloWeb.Admin.ReviewController :delete\n...\n```\n\nThis looks good, but there is a problem here. Remember that we wanted both user-facing review routes `/reviews` and the admin ones `/admin/reviews`. If we now include the user-facing reviews in our router under the root scope like this:\n\n```elixir\nscope \"/\", HelloWeb do\n  pipe_through :browser\n\n  ...\n  resources \"/reviews\", ReviewController\nend\n\nscope \"/admin\", HelloWeb.Admin do\n  pipe_through :browser\n\n  resources \"/reviews\", ReviewController\nend\n```\n\nand we run `mix phx.routes`, we get output for each scoped route:\n\n```console\n...\nGET     /reviews                 HelloWeb.ReviewController :index\nGET     /reviews/:id/edit        HelloWeb.ReviewController :edit\nGET     /reviews/new             HelloWeb.ReviewController :new\nGET     /reviews/:id             HelloWeb.ReviewController :show\nPOST    /reviews                 HelloWeb.ReviewController :create\nPATCH   /reviews/:id             HelloWeb.ReviewController :update\nPUT     /reviews/:id             HelloWeb.ReviewController :update\nDELETE  /reviews/:id             HelloWeb.ReviewController :delete\n...\nGET     /admin/reviews           HelloWeb.Admin.ReviewController :index\nGET     /admin/reviews/:id/edit  HelloWeb.Admin.ReviewController :edit\nGET     /admin/reviews/new       HelloWeb.Admin.ReviewController :new\nGET     /admin/reviews/:id       HelloWeb.Admin.ReviewController :show\nPOST    /admin/reviews           HelloWeb.Admin.ReviewController :create\nPATCH   /admin/reviews/:id       HelloWeb.Admin.ReviewController :update\nPUT     /admin/reviews/:id       HelloWeb.Admin.ReviewController :update\nDELETE  /admin/reviews/:id       HelloWeb.Admin.ReviewController :delete\n```\n\nWhat if we had a number of resources that were all handled by admins? We could put all of them inside the same scope like this:\n\n```elixir\nscope \"/admin\", HelloWeb.Admin do\n  pipe_through :browser\n\n  resources \"/images\",  ImageController\n  resources \"/reviews\", ReviewController\n  resources \"/users\",   UserController\nend\n```\n\nHere's what `mix phx.routes` tells us:\n\n```console\n...\nGET     /admin/images            HelloWeb.Admin.ImageController :index\nGET     /admin/images/:id/edit   HelloWeb.Admin.ImageController :edit\nGET     /admin/images/new        HelloWeb.Admin.ImageController :new\nGET     /admin/images/:id        HelloWeb.Admin.ImageController :show\nPOST    /admin/images            HelloWeb.Admin.ImageController :create\nPATCH   /admin/images/:id        HelloWeb.Admin.ImageController :update\nPUT     /admin/images/:id        HelloWeb.Admin.ImageController :update\nDELETE  /admin/images/:id        HelloWeb.Admin.ImageController :delete\nGET     /admin/reviews           HelloWeb.Admin.ReviewController :index\nGET     /admin/reviews/:id/edit  HelloWeb.Admin.ReviewController :edit\nGET     /admin/reviews/new       HelloWeb.Admin.ReviewController :new\nGET     /admin/reviews/:id       HelloWeb.Admin.ReviewController :show\nPOST    /admin/reviews           HelloWeb.Admin.ReviewController :create\nPATCH   /admin/reviews/:id       HelloWeb.Admin.ReviewController :update\nPUT     /admin/reviews/:id       HelloWeb.Admin.ReviewController :update\nDELETE  /admin/reviews/:id       HelloWeb.Admin.ReviewController :delete\nGET     /admin/users             HelloWeb.Admin.UserController :index\nGET     /admin/users/:id/edit    HelloWeb.Admin.UserController :edit\nGET     /admin/users/new         HelloWeb.Admin.UserController :new\nGET     /admin/users/:id         HelloWeb.Admin.UserController :show\nPOST    /admin/users             HelloWeb.Admin.UserController :create\nPATCH   /admin/users/:id         HelloWeb.Admin.UserController :update\nPUT     /admin/users/:id         HelloWeb.Admin.UserController :update\nDELETE  /admin/users/:id         HelloWeb.Admin.UserController :delete\n```\n\nThis is great, exactly what we want. Note how every route and controller is properly namespaced.\n\nScopes can also be arbitrarily nested, but you should do it carefully as nesting can sometimes make our code confusing and less clear. With that said, suppose that we had a versioned API with resources defined for images, reviews, and users. Then technically, we could set up routes for the versioned API like this:\n\n```elixir\nscope \"/api\", HelloWeb.Api, as: :api do\n  pipe_through :api\n\n  scope \"/v1\", V1, as: :v1 do\n    resources \"/images\",  ImageController\n    resources \"/reviews\", ReviewController\n    resources \"/users\",   UserController\n  end\nend\n```\n\nYou can run `mix phx.routes` to see how these definitions will look like.\n\nInterestingly, we can use multiple scopes with the same path as long as we are careful not to duplicate routes. The following router is perfectly fine with two scopes defined for the same path:\n\n```elixir\ndefmodule HelloWeb.Router do\n  use Phoenix.Router\n  ...\n  scope \"/\", HelloWeb do\n    pipe_through :browser\n\n    resources \"/users\", UserController\n  end\n\n  scope \"/\", AnotherAppWeb do\n    pipe_through :browser\n\n    resources \"/posts\", PostController\n  end\n  ...\nend\n```\n\nIf we do duplicate a route — which means two routes having the same path — we'll get this familiar warning:\n\n```console\nwarning: this clause cannot match because a previous clause at line 16 always matches\n```","ref":"routing.html#scoped-routes"},{"type":"extras","title":"Pipelines - Routing","doc":"We have come quite a long way in this guide without talking about one of the first lines we saw in the router: `pipe_through :browser`. It's time to fix that.\n\nPipelines are a series of plugs that can be attached to specific scopes. If you are not familiar with plugs, we have an [in-depth guide about them](plug.html).\n\nRoutes are defined inside scopes and scopes may pipe through multiple pipelines. Once a route matches, Phoenix invokes all plugs defined in all pipelines associated to that route. For example, accessing `/` will pipe through the `:browser` pipeline, consequently invoking all of its plugs.\n\nPhoenix defines two pipelines by default, `:browser` and `:api`, which can be used for a number of common tasks. In turn we can customize them as well as create new pipelines to meet our needs.","ref":"routing.html#pipelines"},{"type":"extras","title":"The `:browser` and `:api` pipelines - Routing","doc":"As their names suggest, the `:browser` pipeline prepares for routes which render requests for a browser, and the `:api` pipeline prepares for routes which produce data for an API.\n\nThe `:browser` pipeline has six plugs: The `plug :accepts, [\"html\"]` defines the accepted request format or formats. `:fetch_session`, which, naturally, fetches the session data and makes it available in the connection. `:fetch_live_flash`, which fetches any flash messages from LiveView and merges them with the controller flash messages. Then, the plug `:put_root_layout` will store the root layout for rendering purposes. Later `:protect_from_forgery` and `:put_secure_browser_headers`, protects form posts from cross-site forgery.\n\nCurrently, the `:api` pipeline only defines `plug :accepts, [\"json\"]`.\n\nThe router invokes a pipeline on a route defined within a scope. Routes outside of a scope have no pipelines. Although the use of nested scopes is discouraged (see above the versioned API example), if we call `pipe_through` within a nested scope, the router will invoke all `pipe_through`'s from parent scopes, followed by the nested one.\n\nThose are a lot of words bunched up together. Let's take a look at some examples to untangle their meaning.\n\nHere's another look at the router from a newly generated Phoenix application, this time with the `/api` scope uncommented back in and a route added.\n\n```elixir\ndefmodule HelloWeb.Router do\n  use HelloWeb, :router\n\n  pipeline :browser do\n    plug :accepts, [\"html\"]\n    plug :fetch_session\n    plug :fetch_live_flash\n    plug :put_root_layout, html: {HelloWeb.Layouts, :root}\n    plug :protect_from_forgery\n    plug :put_secure_browser_headers\n  end\n\n  pipeline :api do\n    plug :accepts, [\"json\"]\n  end\n\n  scope \"/\", HelloWeb do\n    pipe_through :browser\n\n    get \"/\", PageController, :home\n  end\n\n  # Other scopes may use custom stacks.\n  scope \"/api\", HelloWeb do\n    pipe_through :api\n\n    resources \"/reviews\", ReviewController\n  end\n  # ...\nend\n```\n\nWhen the server accepts a request, the request will always first pass through the plugs in our endpoint, after which it will attempt to match on the path and HTTP verb.\n\nLet's say that the request matches our first route: a GET to `/`. The router will first pipe that request through the `:browser` pipeline - which will fetch the session data, fetch the flash, and execute forgery protection - before it dispatches the request to `PageController`'s `home` action.\n\nConversely, suppose the request matches any of the routes defined by the [`resources/2`](`Phoenix.Router.resources/2`) macro. In that case, the router will pipe it through the `:api` pipeline — which currently only performs content negotiation — before it dispatches further to the correct action of the `HelloWeb.ReviewController`.\n\nIf no route matches, no pipeline is invoked and a 404 error is raised.","ref":"routing.html#the-browser-and-api-pipelines"},{"type":"extras","title":"Creating new pipelines - Routing","doc":"Phoenix allows us to create our own custom pipelines anywhere in the router. To do so, we call the [`pipeline/2`](`Phoenix.Router.pipeline/2`) macro with these arguments: an atom for the name of our new pipeline and a block with all the plugs we want in it.\n\n```elixir\ndefmodule HelloWeb.Router do\n  use HelloWeb, :router\n\n  pipeline :browser do\n    plug :accepts, [\"html\"]\n    plug :fetch_session\n    plug :fetch_live_flash\n    plug :put_root_layout, html: {HelloWeb.Layouts, :root}\n    plug :protect_from_forgery\n    plug :put_secure_browser_headers\n  end\n\n  pipeline :auth do\n    plug HelloWeb.Authentication\n  end\n\n  scope \"/reviews\", HelloWeb do\n    pipe_through [:browser, :auth]\n\n    resources \"/\", ReviewController\n  end\nend\n```\n\nThe above assumes there is a plug called `HelloWeb.Authentication` that performs authentication and is now part of the `:auth` pipeline.\n\nNote that pipelines themselves are plugs, so we can plug a pipeline inside another pipeline. For example, we could rewrite the `auth` pipeline above to automatically invoke `browser`, simplifying the downstream pipeline call:\n\n```elixir\n  pipeline :auth do\n    plug :browser\n    plug :ensure_authenticated_user\n    plug :ensure_user_owns_review\n  end\n\n  scope \"/reviews\", HelloWeb do\n    pipe_through :auth\n\n    resources \"/\", ReviewController\n  end\n```","ref":"routing.html#creating-new-pipelines"},{"type":"extras","title":"How to organize my routes? - Routing","doc":"In Phoenix, we tend to define several pipelines, that provide specific functionality. For example, the `:browser` and `:api` pipelines are meant to be accessed by specific clients, browsers and http clients respectively.\n\nPerhaps more importantly, it is also very common to define pipelines specific to authentication and authorization. For example, you might have a pipeline that requires all users are authenticated. Another pipeline may enforce only admin users can access certain routes.\n\nOnce your pipelines are defined, you reuse the pipelines in the desired scopes, grouping your routes around their pipelines. For example, going back to our reviews example. Let's say anyone can read a review, but only authenticated users can create them. Your routes could look like this:\n\n```elixir\npipeline :browser do\n  ...\nend\n\npipeline :auth do\n  plug HelloWeb.Authentication\nend\n\nscope \"/\" do\n  pipe_through [:browser]\n\n  get \"/reviews\", PostController, :index\n  get \"/reviews/:id\", PostController, :show\nend\n\nscope \"/\" do\n  pipe_through [:browser, :auth]\n\n  get \"/reviews/new\", PostController, :new\n  post \"/reviews\", PostController, :create\nend\n```\n\nNote in the above how the routes are split across different scopes. While the separation can be confusing at first, it has one big upside: it is very easy to inspect your routes and see all routes that, for example, require authentication and which ones do not. This helps with auditing and making sure your routes have the proper scope.\n\nYou can create as few or as many scopes as you want. Because pipelines are reusable across scopes, they help encapsulate common functionality and you can compose them as necessary on each scope you define.","ref":"routing.html#how-to-organize-my-routes"},{"type":"extras","title":"Forward - Routing","doc":"The `Phoenix.Router.forward/4` macro can be used to send all requests that start with a particular path to a particular plug. Let's say we have a part of our system that is responsible (it could even be a separate application or library) for running jobs in the background, it could have its own web interface for checking the status of the jobs. We can forward to this admin interface using:\n\n```elixir\ndefmodule HelloWeb.Router do\n  use HelloWeb, :router\n\n  ...\n\n  scope \"/\", HelloWeb do\n    ...\n  end\n\n  forward \"/jobs\", BackgroundJob.Plug\nend\n```\n\nThis means that all routes starting with `/jobs` will be sent to the `HelloWeb.BackgroundJob.Plug` module. Inside the plug, you can match on subroutes, such as `/pending` and `/active` that shows the status of certain jobs.\n\nWe can even mix the [`forward/4`](`Phoenix.Router.forward/4`) macro with pipelines. If we wanted to ensure that the user was authenticated and was an administrator in order to see the jobs page, we could use the following in our router.\n\n```elixir\ndefmodule HelloWeb.Router do\n  use HelloWeb, :router\n\n  ...\n\n  scope \"/\" do\n    pipe_through [:authenticate_user, :ensure_admin]\n    forward \"/jobs\", BackgroundJob.Plug\n  end\nend\n```\n\nThis means the plugs in the `authenticate_user` and `ensure_admin` pipelines will be called before the `BackgroundJob.Plug` allowing them to send an appropriate response and halt the request accordingly.\n\nThe `opts` that are received in the `init/1` callback of the Module Plug can be passed as a third argument. For example, maybe the background job lets you set the name of your application to be displayed on the page. This could be passed with:\n\n```elixir\nforward \"/jobs\", BackgroundJob.Plug, name: \"Hello Phoenix\"\n```\n\nThere is a fourth `router_opts` argument that can be passed. These options are outlined in the `Phoenix.Router.scope/2` documentation.\n\n`BackgroundJob.Plug` can be implemented as any Module Plug discussed in the [Plug guide](plug.html). Note though it is not advised to forward to another Phoenix endpoint. This is because plugs defined by your app and the forwarded endpoint would be invoked twice, which may lead to errors.","ref":"routing.html#forward"},{"type":"extras","title":"Summary - Routing","doc":"Routing is a big topic, and we have covered a lot of ground here. The important points to take away from this guide are:\n\n- Routes which begin with an HTTP verb name expand to a single clause of the match function.\n- Routes declared with `resources` expand to 8 clauses of the match function.\n- Resources may restrict the number of match function clauses by using the `only:` or `except:` options.\n- Any of these routes may be nested.\n- Any of these routes may be scoped to a given path.\n- Using verified routes with `~p` for compile-time route checks","ref":"routing.html#summary"},{"type":"extras","title":"Controllers","doc":"# Controllers\n\n> **Requirement**: This guide expects that you have gone through the [introductory guides](installation.html) and got a Phoenix application [up and running](up_and_running.html).\n\n> **Requirement**: This guide expects that you have gone through the [request life-cycle guide](request_lifecycle.html).\n\nPhoenix controllers act as intermediary modules. Their functions — called actions — are invoked from the router in response to HTTP requests. The actions, in turn, gather all the necessary data and perform all the necessary steps before invoking the view layer to render a template or returning a JSON response.\n\nPhoenix controllers also build on the Plug package, and are themselves plugs. Controllers provide the functions to do almost anything we need to in an action. If we do find ourselves looking for something that Phoenix controllers don't provide, we might find what we're looking for in Plug itself. Please see the [Plug guide](plug.html) or the [Plug documentation](`Plug`) for more information.\n\nA newly generated Phoenix app will have a single controller named `PageController`, which can be found at `lib/hello_web/controllers/page_controller.ex` which looks like this:\n\n```elixir\ndefmodule HelloWeb.PageController do\n  use HelloWeb, :controller\n\n  def home(conn, _params) do\n    render(conn, :home, layout: false)\n  end\nend\n```\n\nThe first line below the module definition invokes the `__using__/1` macro of the `HelloWeb` module, which imports some useful modules.\n\n`PageController` gives us the `home` action to display the Phoenix [welcome page] associated with the default route Phoenix defines in the router.","ref":"controllers.html"},{"type":"extras","title":"Actions - Controllers","doc":"Controller actions are just functions. We can name them anything we like as long as they follow Elixir's naming rules. The only requirement we must fulfill is that the action name matches a route defined in the router.\n\nFor example, in `lib/hello_web/router.ex` we could change the action name in the default route that Phoenix gives us in a new app from `home`:\n\n```elixir\nget \"/\", PageController, :home\n```\n\nto `index`:\n\n```elixir\nget \"/\", PageController, :index\n```\n\nas long as we change the action name in `PageController` to `index` as well, the [welcome page] will load as before.\n\n```elixir\ndefmodule HelloWeb.PageController do\n  ...\n\n  def index(conn, _params) do\n    render(conn, :index)\n  end\nend\n```\n\nWhile we can name our actions whatever we like, there are conventions for action names which we should follow whenever possible. We went over these in the [routing guide](routing.html), but we'll take another quick look here.\n\n- index   - renders a list of all items of the given resource type\n- show    - renders an individual item by ID\n- new     - renders a form for creating a new item\n- create  - receives parameters for one new item and saves it in a data store\n- edit    - retrieves an individual item by ID and displays it in a form for editing\n- update  - receives parameters for one edited item and saves the item to a data store\n- delete  - receives an ID for an item to be deleted and deletes it from a data store\n\nEach of these actions takes two parameters, which will be provided by Phoenix behind the scenes.\n\nThe first parameter is always `conn`, a struct which holds information about the request such as the host, path elements, port, query string, and much more. `conn` comes to Phoenix via Elixir's Plug middleware framework. More detailed information about `conn` can be found in the [Plug.Conn documentation](`Plug.Conn`).\n\nThe second parameter is `params`. Not surprisingly, this is a map which holds any parameters passed along in the HTTP request. It is a good practice to pattern match against parameters in the function signature to provide data in a simple package we can pass on to rendering. We saw this in the [request life-cycle guide](request_lifecycle.html) when we added a messenger parameter to our `show` route in `lib/hello_web/controllers/hello_controller.ex`.\n\n```elixir\ndefmodule HelloWeb.HelloController do\n  ...\n\n  def show(conn, %{\"messenger\" => messenger}) do\n    render(conn, :show, messenger: messenger)\n  end\nend\n```\n\nIn some cases — often in `index` actions, for instance — we don't care about parameters because our behavior doesn't depend on them. In those cases, we don't use the incoming parameters, and simply prefix the variable name with an underscore, calling it `_params`. This will keep the compiler from complaining about the unused variable while still keeping the correct arity.","ref":"controllers.html#actions"},{"type":"extras","title":"Rendering - Controllers","doc":"Controllers can render content in several ways. The simplest is to render some plain text using the [`text/2`] function which Phoenix provides.\n\nFor example, let's rewrite the `show` action from `HelloController` to return text instead. For that, we could do the following.\n\n```elixir\ndef show(conn, %{\"messenger\" => messenger}) do\n  text(conn, \"From messenger #{messenger}\")\nend\n```\n\nNow [`/hello/Frank`] in your browser should display `From messenger Frank` as plain text without any HTML.\n\nA step beyond this is rendering pure JSON with the [`json/2`] function. We need to pass it something that the [Jason library](`Jason`) can decode into JSON, such as a map. (Jason is one of Phoenix's dependencies.)\n\n```elixir\ndef show(conn, %{\"messenger\" => messenger}) do\n  json(conn, %{id: messenger})\nend\n```\n\nIf we again visit [`/hello/Frank`] in the browser, we should see a block of JSON with the key `id` mapped to the string `\"Frank\"`.\n\n```json\n{\"id\": \"Frank\"}\n```\n\nThe [`json/2`] function is useful for writing APIs and there is also the [`html/2`] function for rendering HTML, but most of the times we use Phoenix views to build our responses. For this, Phoenix includes the [`render/3`] function. It is specially important for HTML responses, as Phoenix Views provide performance and security benefits.\n\nLet's rollback our `show` action to what we originally wrote in the [request life-cycle guide](request_lifecycle.html):\n\n```elixir\ndefmodule HelloWeb.HelloController do\n  use HelloWeb, :controller\n\n  def show(conn, %{\"messenger\" => messenger}) do\n    render(conn, :show, messenger: messenger)\n  end\nend\n```\n\nIn order for the [`render/3`] function to work correctly, the controller and view must share the same root name (in this case `Hello`), and the `HelloHTML` module must include an `embed_templates` definition specifying where its templates live. By default the controller, view module, and templates are collocated together in the same controller directory. In other words, `HelloController` requires `HelloHTML`, and `HelloHTML` requires the existence of the `lib/hello_web/controllers/hello_html/` directory, which must contain the `show.html.heex` template.\n\n[`render/3`] will also pass the value which the `show` action received for `messenger` from the parameters as an assign.\n\nIf we need to pass values into the template when using `render`, that's easy. We can pass a keyword like we've seen with `messenger: messenger`, or we can use `Plug.Conn.assign/3`, which conveniently returns `conn`.\n\n```elixir\n  def show(conn, %{\"messenger\" => messenger}) do\n    conn\n    |> Plug.Conn.assign(:messenger, messenger)\n    |> render(:show)\n  end\n```\n\nNote: Using `Phoenix.Controller` imports `Plug.Conn`, so shortening the call to [`assign/3`] works just fine.\n\nPassing more than one value to our template is as simple as connecting [`assign/3`] functions together:\n\n```elixir\n  def show(conn, %{\"messenger\" => messenger}) do\n    conn\n    |> assign(:messenger, messenger)\n    |> assign(:receiver, \"Dweezil\")\n    |> render(:show)\n  end\n```\n\nOr you can pass the assigns directly to `render` instead:\n\n```elixir\n  def show(conn, %{\"messenger\" => messenger}) do\n    render(conn, :show, messenger: messenger, receiver: \"Dweezil\")\n  end\n```\n\nGenerally speaking, once all assigns are configured, we invoke the view layer. The view layer (`HelloWeb.HelloHTML`) then renders `show.html` alongside the layout and a response is sent back to the browser.\n\n[Components and HEEx templates](components.html) have their own guide, so we won't spend much time on them here. What we will look at is how to render different formats from inside a controller action.","ref":"controllers.html#rendering"},{"type":"extras","title":"New rendering formats - Controllers","doc":"Rendering HTML through a template is fine, but what if we need to change the rendering format on the fly? Let's say that sometimes we need HTML, sometimes we need plain text, and sometimes we need JSON. Then what?\n\nThe view's job is not only to render HTML templates. Views are about data presentation. Given a bag of data, the view's purpose is to present that in a meaningful way given some format, be it HTML, JSON, CSV, or others. Many web apps today return JSON to remote clients, and Phoenix views are *great* for JSON rendering.\n\nAs an example, let's take `PageController`'s `home` action from a newly generated app. Out of the box, this has the right view `PageHTML`, the embedded templates from (`lib/hello_web/controllers/page_html`), and the right template for rendering HTML (`home.html.heex`.)\n\n```elixir\ndef home(conn, _params) do\n  render(conn, :home, layout: false)\nend\n```\n\nWhat it doesn't have is a view for rendering JSON. Phoenix Controller hands off to a view module to render templates, and it does so per format. We already have a view for the HTML format, but we need to instruct Phoenix how to render the JSON format as well. By default, you can see which formats your controllers support in `lib/hello_web.ex`:\n\n```elixir\n  def controller do\n    quote do\n      use Phoenix.Controller,\n        formats: [:html, :json],\n        layouts: [html: HelloWeb.Layouts]\n      ...\n    end\n  end\n```\n\nSo out of the box Phoenix will look for a `HTML` and `JSON` view modules based on the request format and the controller name. We can also explicitly tell Phoenix in our controller which view(s) to use for each format. For example, what Phoenix does by default can be explicitly set with the following in your controller:\n\n```elixir\nplug :put_view, html: HelloWeb.PageHTML, json: HelloWeb.PageJSON\n```\n\nLet's add a `PageJSON` view module at `lib/hello_web/controllers/page_json.ex`:\n\n```elixir\ndefmodule HelloWeb.PageJSON do\n  def home(_assigns) do\n    %{message: \"this is some JSON\"}\n  end\nend\n```\n\nSince the Phoenix View layer is simply a function that the controller renders, passing connection assigns, we can define a regular `home/1` function and return a map to be serialized as JSON.\n\nThere are just a few more things we need to do to make this work. Because we want to render both HTML and JSON from the same controller, we need to tell our router that it should accept the `json` format. We do that by adding `json` to the list of accepted formats in the `:browser` pipeline. Let's open up `lib/hello_web/router.ex` and change `plug :accepts` to include `json` as well as `html` like this.\n\n```elixir\ndefmodule HelloWeb.Router do\n  use HelloWeb, :router\n\n  pipeline :browser do\n    plug :accepts, [\"html\", \"json\"]\n    plug :fetch_session\n    plug :fetch_live_flash\n    plug :put_root_layout, html: {HelloWeb.LayoutView, :root}\n    plug :protect_from_forgery\n    plug :put_secure_browser_headers\n  end\n...\n```\n\nPhoenix allows us to change formats on the fly with the `_format` query string parameter. If we go to [`http://localhost:4000/?_format=json`](http://localhost:4000/?_format=json), we will see `%{\"message\": \"this is some JSON\"}`.\n\nIn practice, however, applications that need to render both formats typically use two distinct pipelines for each, such as the `pipeline :api` already defined in your router file. To learn more, see [our JSON and APIs guide](json_and_apis.md).","ref":"controllers.html#new-rendering-formats"},{"type":"extras","title":"Sending responses directly - Controllers","doc":"If none of the rendering options above quite fits our needs, we can compose our own using some of the functions that `Plug` gives us. Let's say we want to send a response with a status of \"201\" and no body whatsoever. We can do that with the `Plug.Conn.send_resp/3` function.\n\nEdit the `home` action of `PageController` in `lib/hello_web/controllers/page_controller.ex` to look like this:\n\n```elixir\ndef home(conn, _params) do\n  send_resp(conn, 201, \"\")\nend\n```\n\nReloading [http://localhost:4000](http://localhost:4000) should show us a completely blank page. The network tab of our browser's developer tools should show a response status of \"201\" (Created). Some browsers (Safari) will download the response, as the content type is not set.\n\nTo be specific about the content type, we can use [`put_resp_content_type/2`] in conjunction with [`send_resp/3`].\n\n```elixir\ndef home(conn, _params) do\n  conn\n  |> put_resp_content_type(\"text/plain\")\n  |> send_resp(201, \"\")\nend\n```\n\nUsing `Plug` functions in this way, we can craft just the response we need.","ref":"controllers.html#sending-responses-directly"},{"type":"extras","title":"Setting the content type - Controllers","doc":"Analogous to the `_format` query string param, we can render any sort of format we want by modifying the HTTP Content-Type Header and providing the appropriate template.\n\nIf we wanted to render an XML version of our `home` action, we might implement the action like this in `lib/hello_web/page_controller.ex`.\n\n```elixir\ndef home(conn, _params) do\n  conn\n  |> put_resp_content_type(\"text/xml\")\n  |> render(:home, content: some_xml_content)\nend\n```\n\nWe would then need to provide an `home.xml.eex` template which created valid XML, and we would be done.\n\nFor a list of valid content mime-types, please see the `MIME` library.","ref":"controllers.html#setting-the-content-type"},{"type":"extras","title":"Setting the HTTP Status - Controllers","doc":"We can also set the HTTP status code of a response similarly to the way we set the content type. The `Plug.Conn` module, imported into all controllers, has a `put_status/2` function to do this.\n\n`Plug.Conn.put_status/2` takes `conn` as the first parameter and as the second parameter either an integer or a \"friendly name\" used as an atom for the status code we want to set. The list of status code atom representations can be found in `Plug.Conn.Status.code/1` documentation.\n\nLet's change the status in our `PageController` `home` action.\n\n```elixir\ndef home(conn, _params) do\n  conn\n  |> put_status(202)\n  |> render(:home, layout: false)\nend\n```\n\nThe status code we provide must be a valid number.","ref":"controllers.html#setting-the-http-status"},{"type":"extras","title":"Redirection - Controllers","doc":"Often, we need to redirect to a new URL in the middle of a request. A successful `create` action, for instance, will usually redirect to the `show` action for the resource we just created. Alternately, it could redirect to the `index` action to show all the things of that same type. There are plenty of other cases where redirection is useful as well.\n\nWhatever the circumstance, Phoenix controllers provide the handy [`redirect/2`] function to make redirection easy. Phoenix differentiates between redirecting to a path within the application and redirecting to a URL — either within our application or external to it.\n\nIn order to try out [`redirect/2`], let's create a new route in `lib/hello_web/router.ex`.\n\n```elixir\ndefmodule HelloWeb.Router do\n  ...\n\n  scope \"/\", HelloWeb do\n    ...\n    get \"/\", PageController, :home\n    get \"/redirect_test\", PageController, :redirect_test\n    ...\n  end\nend\n```\n\nThen we'll change `PageController`'s `home` action of our controller to do nothing but to redirect to our new route.\n\n```elixir\ndefmodule HelloWeb.PageController do\n  use HelloWeb, :controller\n\n  def home(conn, _params) do\n    redirect(conn, to: ~p\"/redirect_test\")\n  end\nend\n\n```\n\nWe made use of `Phoenix.VerifiedRoutes.sigil_p/2` to build our redirect path, which is the preferred approach to reference any path within our application. We learned about verified routes in the [routing guide](routing.html).\n\nFinally, let's define in the same file the action we redirect to, which simply renders the home, but now under a new address:\n\n```elixir\ndef redirect_test(conn, _params) do\n  render(conn, :home, layout: false)\nend\n```\n\nWhen we reload our [welcome page], we see that we've been redirected to `/redirect_test` which shows the original welcome page. It works!\n\nIf we care to, we can open up our developer tools, click on the network tab, and visit our root route again. We see two main requests for this page - a get to `/` with a status of `302`, and a get to `/redirect_test` with a status of `200`.\n\nNotice that the redirect function takes `conn` as well as a string representing a relative path within our application. For security reasons, the `:to` option can only redirect to paths within your application. If you want to redirect to a fully-qualified path or an external URL, you should use `:external` instead:\n\n```elixir\ndef home(conn, _params) do\n  redirect(conn, external: \"https://elixir-lang.org/\")\nend\n```","ref":"controllers.html#redirection"},{"type":"extras","title":"Flash messages - Controllers","doc":"Sometimes we need to communicate with users during the course of an action. Maybe there was an error updating a schema, or maybe we just want to welcome them back to the application. For this, we have flash messages.\n\nThe `Phoenix.Controller` module provides the [`put_flash/3`] to set flash messages as a key-value pair and placing them into a `@flash` assign in the connection. Let's set two flash messages in our `HelloWeb.PageController` to try this out.\n\nTo do this we modify the `home` action as follows:\n\n```elixir\ndefmodule HelloWeb.PageController do\n  ...\n  def home(conn, _params) do\n    conn\n    |> put_flash(:error, \"Let's pretend we have an error.\")\n    |> render(:home, layout: false)\n  end\nend\n```\n\nIn order to see our flash messages, we need to be able to retrieve them and display them in a template layout. We can do that using [`Phoenix.Flash.get/2`] which takes the flash data and the key we care about. It then returns the value for that key.\n\nFor our convenience, a `flash_group` component is already available and added to the beginning of our [welcome page]\n\n```heex\n<.flash_group flash={@flash} />\n```\n\nWhen we reload the [welcome page], our message should appear in the top right corner of the page.\n\nThe flash functionality is handy when mixed with redirects. Perhaps you want to redirect to a page with some extra information. If we reuse the redirect action from the previous section, we can do:\n\n```elixir\n  def home(conn, _params) do\n    conn\n    |> put_flash(:error, \"Let's pretend we have an error.\")\n    |> redirect(to: ~p\"/redirect_test\")\n  end\n```\n\nNow if you reload the [welcome page], you will be redirected and the flash message will be shown once more.\n\nBesides [`put_flash/3`], the `Phoenix.Controller` module has another useful function worth knowing about. [`clear_flash/1`] takes only `conn` and removes any flash messages which might be stored in the session.\n\nPhoenix does not enforce which keys are stored in the flash. As long as we are internally consistent, all will be well. `:info` and `:error`, however, are common and are handled by default in our templates.","ref":"controllers.html#flash-messages"},{"type":"extras","title":"Error pages - Controllers","doc":"Phoenix has two views called `ErrorHTML` and `ErrorJSON` which live in `lib/hello_web/controllers/`. The purpose of these views is to handle errors in a general way for incoming HTML or JSON requests. Similar to the views we built in this guide, error views can return both HTML and JSON responses. See the [Custom Error Pages How-To](custom_error_pages.html) for more information.\n\n[`render/4`]: `Phoenix.Template.render/4`\n[`/hello/Frank`]:  http://localhost:4000/hello/Frank\n[`assign/3`]: `Plug.Conn.assign/3`\n[`clear_flash/1`]: `Phoenix.Controller.clear_flash/1`\n[`Phoenix.Flash.get/2`]: `Phoenix.Flash.get/2`\n[`html/2`]: `Phoenix.Controller.html/2`\n[`json/2`]: `Phoenix.Controller.json/2`\n[`put_flash/3`]: `Phoenix.Controller.put_flash/3`\n[`put_resp_content_type/2`]: `Plug.Conn.put_resp_content_type/2`\n[`put_root_layout/2`]: `Phoenix.Controller.put_root_layout/2`\n[`redirect/2`]: `Phoenix.Controller.redirect/2`\n[`render/3`]: `Phoenix.Controller.render/3`\n[`send_resp/3`]: `Plug.Conn.send_resp/3`\n[`text/2`]: `Phoenix.Controller.text/2`\n[welcome page]: http://localhost:4000/","ref":"controllers.html#error-pages"},{"type":"extras","title":"Components and HEEx","doc":"# Components and HEEx\n\n> **Requirement**: This guide expects that you have gone through the [introductory guides](installation.html) and got a Phoenix application [up and running](up_and_running.html).\n\n> **Requirement**: This guide expects that you have gone through the [request life-cycle guide](request_lifecycle.html).\n\nThe Phoenix endpoint pipeline takes a request, routes it to a controller, and calls a view module to render a template. The view interface from the controller is simple – the controller calls a view function with the connections assigns, and the function's job is to return a HEEx template. We call any function that accepts an `assigns` parameter and returns a HEEx template a *function component*. Function components are defined with the help of the [`Phoenix.Component`](https://hexdocs.pm/phoenix_live_view/Phoenix.Component.html) module.\n\nFunction components are the essential building block for any kind of markup-based template rendering you'll perform in Phoenix. They serve as a shared abstraction for the standard MVC controller-based applications, LiveView applications, layouts, and smaller UI definitions you'll use throughout other templates.\n\nIn this chapter, we will recap how components were used in previous chapters and find new use cases for them.","ref":"components.html"},{"type":"extras","title":"Function components - Components and HEEx","doc":"At the end of the Request life-cycle chapter, we created a template at `lib/hello_web/controllers/hello_html/show.html.heex`, let's open it up:\n\n```heex\n \n   Hello World, from <%= @messenger %>! \n \n```\n\nThis template, is embedded as part of `HelloHTML`, at `lib/hello_web/controllers/hello_html.ex`:\n\n```elixir\ndefmodule HelloWeb.HelloHTML do\n  use HelloWeb, :html\n\n  embed_templates \"hello_html/*\"\nend\n```\n\nThat's simple enough. There's only two lines, `use HelloWeb, :html`. This line calls the `html/0` function defined in `HelloWeb` which sets up the basic imports and configuration for our function components and templates.\n\nAll of the imports and aliases we make in our module will also be available in our templates. That's because templates are effectively compiled into functions inside their respective module. For example, if you define a function in your module, you will be able to invoke it directly from the template. Let's see this in practice.\n\nImagine we want to refactor our `show.html.heex` to move the rendering of ` Hello World, from <%= @messenger %>! ` to its own function. We can move it to a function component inside `HelloHTML`, let's do so:\n\n```elixir\ndefmodule HelloWeb.HelloHTML do\n  use HelloWeb, :html\n\n  embed_templates \"hello_html/*\"\n\n  attr :messenger, :string, required: true\n\n  def greet(assigns) do\n    ~H\"\"\"\n     Hello World, from <%= @messenger %>! \n    \"\"\"\n  end\nend\n```\n\nWe declared the attributes we accept via the `attr/3` macro provided by `Phoenix.Component`, then we defined our `greet/1` function which returns the HEEx template.\n\nNext we need to update `show.html.heex`:\n\n```elixir\n \n  <.greet messenger={@messenger} />\n \n```\n\nWhen we reload `http://localhost:4000/hello/Frank`, we should see the same content as before.\n\nSince templates are embedded inside the `HelloHTML` module, we were able to invoke the view function simply as `<.greet messenger=\"...\" />`.\n\nIf the component was defined elsewhere, we can also type ` `.\n\nBy declaring attributes as required, Phoenix will warn at compile time if we call the `<.greet />` component without passing attributes. If an attribute is optional, you can specify the `:default` option with a value:\n\n```\nattr :messenger, :string, default: nil\n```\n\nAlthough this is a quick example, it shows the different roles function components play in Phoenix:\n\n* Function components can be defined as functions that receive `assigns` as argument and call the `~H` sigil, as we did in `greet/1`\n\n* Function components can be embedded from template files, that's how we load `show.html.heex` into `HelloWeb.HelloHTML`\n\n* Function components can declare which attributes are expected, which are validated at compilation time\n\n* Function components can be directly rendered from controllers\n\n* Function components can be directly rendered from other function components, as we called `<.greet messenger={@messenger} />` from `show.html.heex`\n\nAnd there's more. Before we go deeper, let's fully understand the expressive power behind the HEEx template language.","ref":"components.html#function-components"},{"type":"extras","title":"HEEx - Components and HEEx","doc":"Function components and templates files are powered by [the HEEx template language](https://hexdocs.pm/phoenix_live_view/Phoenix.Component.html#sigil_H/2), which stands for  \"HTML+EEx\". EEx is an Elixir library that uses `<%= expression %>` to execute Elixir expressions and interpolate their results into the template. This is frequently used to display assigns we have set by way of the `@` shortcut. In your controller, if you invoke:\n\n```elixir\n  render(conn, :show, username: \"joe\")\n```\n\nThen you can access said username in the templates as `<%= @username %>`. In addition to displaying assigns and functions, we can use pretty much any Elixir expression. For example, in order to have conditionals:\n\n```heex\n<%= if some_condition? do %>\n   Some condition is true for user: <%= @username %> \n<% else %>\n   Some condition is false for user: <%= @username %> \n<% end %>\n```\n\nor even loops:\n\n```heex\n \n   \n     Number \n     Power \n   \n  <%= for number <- 1..10 do %>\n     \n       <%= number %> \n       <%= number * number %> \n     \n  <% end %>\n \n```\n\nDid you notice the use of `<%= %>` versus `<% %>` above? All expressions that output something to the template **must** use the equals sign (`=`). If this is not included the code will still be executed but nothing will be inserted into the template.\n\nHEEx also comes with handy HTML extensions we will learn next.","ref":"components.html#heex"},{"type":"extras","title":"HTML extensions - Components and HEEx","doc":"Besides allowing interpolation of Elixir expressions via `<%= %>`, `.heex` templates come with HTML-aware extensions. For example, let's see what happens if you try to interpolate a value with \"<\" or \">\" in it, which would lead to HTML injection:\n\n```heex\n<%= \" Bold? \" %>\n```\n\nOnce you render the template, you will see the literal ` ` on the page. This means users cannot inject HTML content on the page. If you want to allow them to do so, you can call `raw`, but do so with extreme care:\n\n```heex\n<%= raw \" Bold? \" %>\n```\n\nAnother super power of HEEx templates is validation of HTML and lean interpolation syntax of attributes. You can write:\n\n```heex\n \n   Hello <%= @username %> \n \n```\n\nNotice how you could simply use `key={value}`. HEEx will automatically handle special values such as `false` to remove the attribute or a list of classes.\n\nTo interpolate a dynamic number of attributes in a keyword list or map, do:\n\n```heex\n \n   Hello <%= @username %> \n \n```\n\nAlso, try removing the closing ` ` or renaming it to ` `. HEEx templates will let you know about your error.\n\nHEEx also supports shorthand syntax for `if` and `for` expressions via the special `:if` and `:for` attributes. For example, rather than this:\n\n```heex\n<%= if @some_condition do %>\n   ... \n<% end %>\n```\n\nYou can write:\n\n```heex\n ... \n```\n\nLikewise, for comprehensions may be written as:\n\n```heex\n \n   <%= item.name %> \n \n```","ref":"components.html#html-extensions"},{"type":"extras","title":"Layouts - Components and HEEx","doc":"Layouts are just function components. They are defined in a module, just like all other function component templates. In a newly generated app, this is `lib/hello_web/components/layouts.ex`. You will also find a `layouts` folder with two built-in layouts generated by Phoenix. The default _root layout_ is called `root.html.heex`, and it is the layout into which all templates will be rendered by default. The second is the _app layout_, called `app.html.heex`, which is rendered within the root layout and includes our contents.\n\nYou may be wondering how the string resulting from a rendered view ends up inside a layout. That's a great question! If we look at `lib/hello_web/components/layouts/root.html.heex`, just about at the end of the ` `, we will see this.\n\n```heex\n<%= @inner_content %>\n```\n\nIn other words, after rendering your page, the result is placed in the `@inner_content` assign.\n\nPhoenix provides all kinds of conveniences to control which layout should be rendered. For example, the `Phoenix.Controller` module provides the `put_root_layout/2` function for us to switch _root layouts_. This takes `conn` as its first argument and a keyword list of formats and their layouts. You can set it to `false` to disable the layout altogether.\n\nYou can edit the `index` action of `HelloController` in `lib/hello_web/controllers/hello_controller.ex` to look like this.\n\n```elixir\ndef index(conn, _params) do\n  conn\n  |> put_root_layout(html: false)\n  |> render(:index)\nend\n```\n\nAfter reloading [http://localhost:4000/hello](http://localhost:4000/hello), we should see a very different page, one with no title or CSS styling at all.\n\nTo customize the application layout, we invoke a similar function named `put_layout/2`. Let's actually create another layout and render the index template into it. As an example, let's say we had a different layout for the admin section of our application which didn't have the logo image. To do this, copy the existing `app.html.heex` to a new file `admin.html.heex` in the same directory `lib/hello_web/components/layouts`. Then remove everything inside the ` ... ` tags (or change it to whatever you desire) in the new file.\n\nNow, in the `index` action of the controller of `lib/hello_web/controllers/hello_controller.ex`, add the following:\n\n```elixir\ndef index(conn, _params) do\n  conn\n  |> put_layout(html: :admin)\n  |> render(:index)\nend\n```\n\nWhen we load the page, we should be rendering the admin layout without the header (or a custom one that you wrote).\n\nAt this point, you may be wondering, why does Phoenix have two layouts?\n\nFirst of all, it gives us flexibility. In practice, we will hardly have multiple root layouts, as they often contain only HTML headers. This allows us to focus on different application layouts with only the parts that changes between them. Second of all, Phoenix ships with a feature called LiveView, which allows us to build rich and real-time user experiences with server-rendered HTML. LiveView is capable of dynamically changing the contents of the page, but it only ever changes the app layout, never the root layout. Check out [the LiveView documentation](https://hexdocs.pm/phoenix_live_view) to learn more.","ref":"components.html#layouts"},{"type":"extras","title":"CoreComponents - Components and HEEx","doc":"In a new Phoenix application, you will also find a `core_components.ex` module inside the `components` folder. This module is a great example of defining function components to be reused throughout our application. This guarantees that, as our application evolves, our components will look consistent.\n\nIf you look inside `def html` in `HelloWeb` placed at `lib/hello_web.ex`, you will see that `CoreComponents` are automatically imported into all HTML views via `use HelloWeb, :html`. This is also the reason why `CoreComponents` itself performs `use Phoenix.Component` instead `use HelloWeb, :html` at the top: doing the latter would cause a deadlock as we would try to import `CoreComponents` into itself.\n\nCoreComponents also play an important role in Phoenix code generators, as the code generators assume those components are available in order to quickly scaffold your application. In case you want to learn more about all of these pieces, you may:\n\n  * Explore the generated `CoreComponents` module to learn more from practical examples\n\n  * Read the official documentation for [`Phoenix.Component`](https://hexdocs.pm/phoenix_live_view/Phoenix.Component.html)\n\n  * Read the official documentation for [HEEx and the ~H sigils](https://hexdocs.pm/phoenix_live_view/Phoenix.Component.html#sigil_H/2)","ref":"components.html#corecomponents"},{"type":"extras","title":"Ecto","doc":"# Ecto\n\n> **Requirement**: This guide expects that you have gone through the [introductory guides](installation.html) and got a Phoenix application [up and running](up_and_running.html).\n\nMost web applications today need some form of data validation and persistence. In the Elixir ecosystem, we have `Ecto` to enable this. Before we jump into building database-backed web features, we're going to focus on the finer details of Ecto to give a solid base to build our web features on top of. Let's get started!\n\nPhoenix uses Ecto to provide builtin support to the following databases:\n\n* PostgreSQL (via [`postgrex`](https://github.com/elixir-ecto/postgrex))\n* MySQL (via [`myxql`](https://github.com/elixir-ecto/myxql))\n* MSSQL (via [`tds`](https://github.com/livehelpnow/tds))\n* ETS (via [`etso`](https://github.com/evadne/etso))\n* SQLite3 (via [`ecto_sqlite3`](https://github.com/elixir-sqlite/ecto_sqlite3))\n\nNewly generated Phoenix projects include Ecto with the PostgreSQL adapter by default. You can pass the `--database` option to change or `--no-ecto` flag to exclude this.\n\nEcto also provides support for other databases and it has many learning resources available. Please check out [Ecto's README](https://github.com/elixir-ecto/ecto) for general information.\n\nThis guide assumes that we have generated our new application with Ecto integration and that we will be using PostgreSQL. The introductory guides cover how to get your first application up and running. For using other databases, see the [Using other databases](#using-other-databases) section.","ref":"ecto.html"},{"type":"extras","title":"Using the schema and migration generator - Ecto","doc":"Once we have Ecto and PostgreSQL installed and configured, the easiest way to use Ecto is to generate an Ecto *schema* through the `phx.gen.schema` task. Ecto schemas are a way for us to specify how Elixir data types map to and from external sources, such as database tables. Let's generate a `User` schema with `name`, `email`, `bio`, and `number_of_pets` fields.\n\n```console\n$ mix phx.gen.schema User users name:string email:string \\\nbio:string number_of_pets:integer\n\n* creating ./lib/hello/user.ex\n* creating priv/repo/migrations/20170523151118_create_users.exs\n\nRemember to update your repository by running migrations:\n\n   $ mix ecto.migrate\n```\n\nA couple of files were generated with this task. First, we have a `user.ex` file, containing our Ecto schema with our schema definition of the fields we passed to the task. Next, a migration file was generated inside `priv/repo/migrations/` which will create our database table that our schema maps to.\n\nWith our files in place, let's follow the instructions and run our migration:\n\n```console\n$ mix ecto.migrate\nCompiling 1 file (.ex)\nGenerated hello app\n\n[info] == Running Hello.Repo.Migrations.CreateUsers.change/0 forward\n\n[info] create table users\n\n[info] == Migrated in 0.0s\n```\n\nMix assumes that we are in the development environment unless we tell it otherwise with `MIX_ENV=prod mix ecto.migrate`.\n\nIf we log in to our database server, and connect to our `hello_dev` database, we should see our `users` table. Ecto assumes that we want an integer column called `id` as our primary key, so we should see a sequence generated for that as well.\n\n```console\n$ psql -U postgres\n\nType \"help\" for help.\n\npostgres=# \\connect hello_dev\nYou are now connected to database \"hello_dev\" as user \"postgres\".\nhello_dev=# \\d\n                List of relations\n Schema |       Name        |   Type   |  Owner\n--------+-------------------+----------+----------\n public | schema_migrations | table    | postgres\n public | users             | table    | postgres\n public | users_id_seq      | sequence | postgres\n(3 rows)\nhello_dev=# \\q\n```\n\nIf we take a look at the migration generated by `phx.gen.schema` in `priv/repo/migrations/`, we'll see that it will add the columns we specified. It will also add timestamp columns for `inserted_at` and `updated_at` which come from the [`timestamps/1`] function.\n\n```elixir\ndefmodule Hello.Repo.Migrations.CreateUsers do\n  use Ecto.Migration\n\n  def change do\n    create table(:users) do\n      add :name, :string\n      add :email, :string\n      add :bio, :string\n      add :number_of_pets, :integer\n\n      timestamps()\n    end\n  end\nend\n```\n\nAnd here's what that translates to in the actual `users` table.\n\n```console\n$ psql\nhello_dev=# \\d users\nTable \"public.users\"\nColumn         |            Type             | Modifiers\n---------------+-----------------------------+----------------------------------------------------\nid             | bigint                      | not null default nextval('users_id_seq'::regclass)\nname           | character varying(255)      |\nemail          | character varying(255)      |\nbio            | character varying(255)      |\nnumber_of_pets | integer                     |\ninserted_at    | timestamp without time zone | not null\nupdated_at     | timestamp without time zone | not null\nIndexes:\n\"users_pkey\" PRIMARY KEY, btree (id)\n```\n\nNotice that we do get an `id` column as our primary key by default, even though it isn't listed as a field in our migration.","ref":"ecto.html#using-the-schema-and-migration-generator"},{"type":"extras","title":"Repo configuration - Ecto","doc":"Our `Hello.Repo` module is the foundation we need to work with databases in a Phoenix application. Phoenix generated it for us in `lib/hello/repo.ex`, and this is what it looks like.\n\n```elixir\ndefmodule Hello.Repo do\n  use Ecto.Repo,\n    otp_app: :hello,\n    adapter: Ecto.Adapters.Postgres\nend\n```\n\nIt begins by defining the repository module. Then it configures our `otp_app` name, and the `adapter` – `Postgres`, in our case.\n\nOur repo has three main tasks - to bring in all the common query functions from [`Ecto.Repo`], to set the `otp_app` name equal to our application name, and to configure our database adapter. We'll talk more about how to use `Hello.Repo` in a bit.\n\nWhen `phx.new` generated our application, it included some basic repository configuration as well. Let's look at `config/dev.exs`.\n\n```elixir\n...\n# Configure your database\nconfig :hello, Hello.Repo,\n  username: \"postgres\",\n  password: \"postgres\",\n  hostname: \"localhost\",\n  database: \"hello_dev\",\n  show_sensitive_data_on_connection_error: true,\n  pool_size: 10\n...\n```\n\nWe also have similar configuration in `config/test.exs` and `config/runtime.exs` (formerly `config/prod.secret.exs`) which can also be changed to match your actual credentials.","ref":"ecto.html#repo-configuration"},{"type":"extras","title":"The schema - Ecto","doc":"Ecto schemas are responsible for mapping Elixir values to external data sources, as well as mapping external data back into Elixir data structures. We can also define relationships to other schemas in our applications. For example, our `User` schema might have many posts, and each post would belong to a user. Ecto also handles data validation and type casting with changesets, which we'll discuss in a moment.\n\nHere's the `User` schema that Phoenix generated for us.\n\n```elixir\ndefmodule Hello.User do\n  use Ecto.Schema\n  import Ecto.Changeset\n\n  schema \"users\" do\n    field :bio, :string\n    field :email, :string\n    field :name, :string\n    field :number_of_pets, :integer\n\n    timestamps()\n  end\n\n  @doc false\n  def changeset(user, attrs) do\n    user\n    |> cast(attrs, [:name, :email, :bio, :number_of_pets])\n    |> validate_required([:name, :email, :bio, :number_of_pets])\n  end\nend\n```\n\nEcto schemas at their core are simply Elixir structs. Our `schema` block is what tells Ecto how to cast our `%User{}` struct fields to and from the external `users` table. Often, the ability to simply cast data to and from the database isn't enough and extra data validation is required. This is where Ecto changesets come in. Let's dive in!","ref":"ecto.html#the-schema"},{"type":"extras","title":"Changesets and validations - Ecto","doc":"Changesets define a pipeline of transformations our data needs to undergo before it will be ready for our application to use. These transformations might include type-casting, user input validation, and filtering out any extraneous parameters. Often we'll use changesets to validate user input before writing it to the database. Ecto repositories are also changeset-aware, which allows them not only to refuse invalid data, but also perform the minimal database updates possible by inspecting the changeset to know which fields have changed.\n\nLet's take a closer look at our default changeset function.\n\n```elixir\ndef changeset(user, attrs) do\n  user\n  |> cast(attrs, [:name, :email, :bio, :number_of_pets])\n  |> validate_required([:name, :email, :bio, :number_of_pets])\nend\n```\n\nRight now, we have two transformations in our pipeline. In the first call, we invoke `Ecto.Changeset.cast/3`, passing in our external parameters and marking which fields are required for validation.\n\n[`cast/3`] first takes a struct, then the parameters (the proposed updates), and then the final field is the list of columns to be updated. [`cast/3`] also will only take fields that exist in the schema.\n\nNext, `Ecto.Changeset.validate_required/3` checks that this list of fields is present in the changeset that [`cast/3`] returns. By default with the generator, all fields are required.\n\nWe can verify this functionality in `IEx`. Let's fire up our application inside IEx by running `iex -S mix`. In order to minimize typing and make this easier to read, let's alias our `Hello.User` struct.\n\n```console\n$ iex -S mix\n\niex> alias Hello.User\nHello.User\n```\n\nNext, let's build a changeset from our schema with an empty `User` struct, and an empty map of parameters.\n\n```elixir\niex> changeset = User.changeset(%User{}, %{})\n#Ecto.Changeset ,\n  valid?: false\n>\n```\n\nOnce we have a changeset, we can check if it is valid.\n\n```elixir\niex> changeset.valid?\nfalse\n```\n\nSince this one is not valid, we can ask it what the errors are.\n\n```elixir\niex> changeset.errors\n[\n  name: {\"can't be blank\", [validation: :required]},\n  email: {\"can't be blank\", [validation: :required]},\n  bio: {\"can't be blank\", [validation: :required]},\n  number_of_pets: {\"can't be blank\", [validation: :required]}\n]\n```\n\nNow, let's make `number_of_pets` optional. In order to do this, we simply remove it from the list in the `changeset/2` function, in `Hello.User`.\n\n```elixir\n    |> validate_required([:name, :email, :bio])\n```\n\nNow casting the changeset should tell us that only `name`, `email`, and `bio` can't be blank. We can test that by running `recompile()` inside IEx and then rebuilding our changeset.\n\n```elixir\niex> recompile()\nCompiling 1 file (.ex)\n:ok\n\niex> changeset = User.changeset(%User{}, %{})\n#Ecto.Changeset ,\n  valid?: false\n>\n\niex> changeset.errors\n[\n  name: {\"can't be blank\", [validation: :required]},\n  email: {\"can't be blank\", [validation: :required]},\n  bio: {\"can't be blank\", [validation: :required]}\n]\n```\n\nWhat happens if we pass a key-value pair that is neither defined in the schema nor required?\n\nInside our existing IEx shell, let's create a `params` map with valid values plus an extra `random_key: \"random value\"`.\n\n```elixir\niex> params = %{name: \"Joe Example\", email: \"joe@example.com\", bio: \"An example to all\", number_of_pets: 5, random_key: \"random value\"}\n%{\n  bio: \"An example to all\",\n  email: \"joe@example.com\",\n  name: \"Joe Example\",\n  number_of_pets: 5,\n  random_key: \"random value\"\n}\n```\n\nNext, let's use our new `params` map to create another changeset.\n\n```elixir\niex> changeset = User.changeset(%User{}, params)\n#Ecto.Changeset ,\n  valid?: true\n>\n```\n\nOur new changeset is valid.\n\n```elixir\niex> changeset.valid?\ntrue\n```\n\nWe can also check the changeset's changes - the map we get after all of the transformations are complete.\n\n```elixir\niex(9)> changeset.changes\n%{bio: \"An example to all\", email: \"joe@example.com\", name: \"Joe Example\",\n  number_of_pets: 5}\n```\n\nNotice that our `random_key` key and `\"random_value\"` value have been removed from the final changeset. Changesets allow us to cast external data, such as user input on a web form or data from a CSV file into valid data into our system. Invalid parameters will be stripped and bad data that is unable to be cast according to our schema will be highlighted in the changeset errors.\n\nWe can validate more than just whether a field is required or not. Let's take a look at some finer-grained validations.\n\nWhat if we had a requirement that all biographies in our system must be at least two characters long? We can do this easily by adding another transformation to the pipeline in our changeset which validates the length of the `bio` field.\n\n```elixir\ndef changeset(user, attrs) do\n  user\n  |> cast(attrs, [:name, :email, :bio, :number_of_pets])\n  |> validate_required([:name, :email, :bio, :number_of_pets])\n  |> validate_length(:bio, min: 2)\nend\n```\n\nNow, if we try to cast data containing a value of `\"A\"` for our user's `bio`, we should see the failed validation in the changeset's errors.\n\n```elixir\niex> recompile()\n\niex> changeset = User.changeset(%User{}, %{bio: \"A\"})\n\niex> changeset.errors[:bio]\n{\"should be at least %{count} character(s)\",\n [count: 2, validation: :length, kind: :min, type: :string]}\n```\n\nIf we also have a requirement for the maximum length that a bio can have, we can simply add another validation.\n\n```elixir\ndef changeset(user, attrs) do\n  user\n  |> cast(attrs, [:name, :email, :bio, :number_of_pets])\n  |> validate_required([:name, :email, :bio, :number_of_pets])\n  |> validate_length(:bio, min: 2)\n  |> validate_length(:bio, max: 140)\nend\n```\n\nLet's say we want to perform at least some rudimentary format validation on the `email` field. All we want to check for is the presence of the `@`. The `Ecto.Changeset.validate_format/3` function is just what we need.\n\n```elixir\ndef changeset(user, attrs) do\n  user\n  |> cast(attrs, [:name, :email, :bio, :number_of_pets])\n  |> validate_required([:name, :email, :bio, :number_of_pets])\n  |> validate_length(:bio, min: 2)\n  |> validate_length(:bio, max: 140)\n  |> validate_format(:email, ~r/@/)\nend\n```\n\nIf we try to cast a user with an email of `\"example.com\"`, we should see an error message like the following:\n\n```elixir\niex> recompile()\n\niex> changeset = User.changeset(%User{}, %{email: \"example.com\"})\n\niex> changeset.errors[:email]\n{\"has invalid format\", [validation: :format]}\n```\n\nThere are many more validations and transformations we can perform in a changeset. Please see the [Ecto Changeset documentation](https://hexdocs.pm/ecto/Ecto.Changeset.html) for more information.","ref":"ecto.html#changesets-and-validations"},{"type":"extras","title":"Data persistence - Ecto","doc":"We've explored migrations and schemas, but we haven't yet persisted any of our schemas or changesets. We briefly looked at our repository module in `lib/hello/repo.ex` earlier, and now it's time to put it to use.\n\nEcto repositories are the interface into a storage system, be it a database like PostgreSQL or an external service like a RESTful API. The `Repo` module's purpose is to take care of the finer details of persistence and data querying for us. As the caller, we only care about fetching and persisting data. The `Repo` module takes care of the underlying database adapter communication, connection pooling, and error translation for database constraint violations.\n\nLet's head back over to IEx with `iex -S mix`, and insert a couple of users into the database.\n\n```elixir\niex> alias Hello.{Repo, User}\n[Hello.Repo, Hello.User]\n\niex> Repo.insert(%User{email: \"user1@example.com\"})\n[debug] QUERY OK db=6.5ms queue=0.5ms idle=1358.3ms\nINSERT INTO \"users\" (\"email\",\"inserted_at\",\"updated_at\") VALUES ($1,$2,$3) RETURNING \"id\" [\"user1@example.com\", ~N[2021-02-25 01:58:55], ~N[2021-02-25 01:58:55]]\n{:ok,\n %Hello.User{\n   __meta__: #Ecto.Schema.Metadata<:loaded, \"users\">,\n   bio: nil,\n   email: \"user1@example.com\",\n   id: 1,\n   inserted_at: ~N[2021-02-25 01:58:55],\n   name: nil,\n   number_of_pets: nil,\n   updated_at: ~N[2021-02-25 01:58:55]\n }}\n\niex> Repo.insert(%User{email: \"user2@example.com\"})\n[debug] QUERY OK db=1.3ms idle=1402.7ms\nINSERT INTO \"users\" (\"email\",\"inserted_at\",\"updated_at\") VALUES ($1,$2,$3) RETURNING \"id\" [\"user2@example.com\", ~N[2021-02-25 02:03:28], ~N[2021-02-25 02:03:28]]\n{:ok,\n %Hello.User{\n   __meta__: #Ecto.Schema.Metadata<:loaded, \"users\">,\n   bio: nil,\n   email: \"user2@example.com\",\n   id: 2,\n   inserted_at: ~N[2021-02-25 02:03:28],\n   name: nil,\n   number_of_pets: nil,\n   updated_at: ~N[2021-02-25 02:03:28]\n }}\n```\n\nWe started by aliasing our `User` and `Repo` modules for easy access. Next, we called [`Repo.insert/2`] with a User struct. Since we are in the `dev` environment, we can see the debug logs for the query our repository performed when inserting the underlying `%User{}` data. We received a two-element tuple back with `{:ok, %User{}}`, which lets us know the insertion was successful.\n\nWe could also insert a user by passing a changeset to [`Repo.insert/2`]. If the changeset is valid, the repository will use an optimized database query to insert the record, and return a two-element tuple back, as above. If the changeset is not valid, we receive a two-element tuple consisting of `:error` plus the invalid changeset.\n\nWith a couple of users inserted, let's fetch them back out of the repo.\n\n```elixir\niex> Repo.all(User)\n[debug] QUERY OK source=\"users\" db=5.8ms queue=1.4ms idle=1672.0ms\nSELECT u0.\"id\", u0.\"bio\", u0.\"email\", u0.\"name\", u0.\"number_of_pets\", u0.\"inserted_at\", u0.\"updated_at\" FROM \"users\" AS u0 []\n[\n  %Hello.User{\n    __meta__: #Ecto.Schema.Metadata<:loaded, \"users\">,\n    bio: nil,\n    email: \"user1@example.com\",\n    id: 1,\n    inserted_at: ~N[2021-02-25 01:58:55],\n    name: nil,\n    number_of_pets: nil,\n    updated_at: ~N[2021-02-25 01:58:55]\n  },\n  %Hello.User{\n    __meta__: #Ecto.Schema.Metadata<:loaded, \"users\">,\n    bio: nil,\n    email: \"user2@example.com\",\n    id: 2,\n    inserted_at: ~N[2021-02-25 02:03:28],\n    name: nil,\n    number_of_pets: nil,\n    updated_at: ~N[2021-02-25 02:03:28]\n  }\n]\n```\n\nThat was easy! `Repo.all/1` takes a data source, our `User` schema in this case, and translates that to an underlying SQL query against our database. After it fetches the data, the Repo then uses our Ecto schema to map the database values back into Elixir data structures according to our `User` schema. We're not just limited to basic querying – Ecto includes a full-fledged query DSL for advanced SQL generation. In addition to a natural Elixir DSL, Ecto's query engine gives us multiple great features, such as SQL injection protection and compile-time optimization of queries. Let's try it out.\n\n```elixir\niex> import Ecto.Query\nEcto.Query\n\niex> Repo.all(from u in User, select: u.email)\n[debug] QUERY OK source=\"users\" db=0.8ms queue=0.9ms idle=1634.0ms\nSELECT u0.\"email\" FROM \"users\" AS u0 []\n[\"user1@example.com\", \"user2@example.com\"]\n```\n\nFirst, we imported [`Ecto.Query`], which imports the [`from/2`] macro of Ecto's Query DSL. Next, we built a query which selects all the email addresses in our users table. Let's try another example.\n\n```elixir\niex> Repo.one(from u in User, where: ilike(u.email, \"%1%\"),\n                               select: count(u.id))\n[debug] QUERY OK source=\"users\" db=1.6ms SELECT count(u0.\"id\") FROM \"users\" AS u0 WHERE (u0.\"email\" ILIKE '%1%') []\n1\n```\n\nNow we're starting to get a taste of Ecto's rich querying capabilities. We used [`Repo.one/2`] to fetch the count of all users with an email address containing `1`, and received the expected count in return. This just scratches the surface of Ecto's query interface, and much more is supported such as sub-querying, interval queries, and advanced select statements. For example, let's build a query to fetch a map of all user id's to their email addresses.\n\n```elixir\niex> Repo.all(from u in User, select: %{u.id => u.email})\n[debug] QUERY OK source=\"users\" db=0.9ms\nSELECT u0.\"id\", u0.\"email\" FROM \"users\" AS u0 []\n[\n  %{1 => \"user1@example.com\"},\n  %{2 => \"user2@example.com\"}\n]\n```\n\nThat little query packed a big punch. It both fetched all user emails from the database and efficiently built a map of the results in one go. You should browse the [Ecto.Query documentation](https://hexdocs.pm/ecto/Ecto.Query.html#content) to see the breadth of supported query features.\n\nIn addition to inserts, we can also perform updates and deletes with [`Repo.update/2`] and [`Repo.delete/2`] to update or delete a single schema. Ecto also supports bulk persistence with the [`Repo.insert_all/3`], [`Repo.update_all/3`], and [`Repo.delete_all/2`] functions.\n\nThere is quite a bit more that Ecto can do and we've only barely scratched the surface. With a solid Ecto foundation in place, we're now ready to continue building our app and integrate the web-facing application with our backend persistence. Along the way, we'll expand our Ecto knowledge and learn how to properly isolate our web interface from the underlying details of our system. Please take a look at the [Ecto documentation](https://hexdocs.pm/ecto/) for the rest of the story.\n\nIn our [contexts guide](contexts.html), we'll find out how to wrap up our Ecto access and business logic behind modules that group related functionality. We'll see how Phoenix helps us design maintainable applications, and we'll find out about other neat Ecto features along the way.","ref":"ecto.html#data-persistence"},{"type":"extras","title":"Using other databases - Ecto","doc":"Phoenix applications are configured to use PostgreSQL by default, but what if we want to use another database, such as MySQL? In this section, we'll walk through changing that default whether we are about to create a new application, or whether we have an existing one configured for PostgreSQL.\n\nIf we are about to create a new application, configuring our application to use MySQL is easy. We can simply pass the `--database mysql` flag to `phx.new` and everything will be configured correctly.\n\n```console\n$ mix phx.new hello_phoenix --database mysql\n```\n\nThis will set up all the correct dependencies and configuration for us automatically. Once we install those dependencies with `mix deps.get`, we'll be ready to begin working with Ecto in our application.\n\nIf we have an existing application, all we need to do is switch adapters and make some small configuration changes.\n\nTo switch adapters, we need to remove the Postgrex dependency and add a new one for MyXQL instead.\n\nLet's open up our `mix.exs` file and do that now.\n\n```elixir\ndefmodule HelloPhoenix.MixProject do\n  use Mix.Project\n\n  . . .\n  # Specifies your project dependencies.\n  #\n  # Type `mix help deps` for examples and options.\n  defp deps do\n    [\n      {:phoenix, \"~> 1.4.0\"},\n      {:phoenix_ecto, \"~> 4.4\"},\n      {:ecto_sql, \"~> 3.10\"},\n      {:myxql, \">= 0.0.0\"},\n      ...\n    ]\n  end\nend\n```\n\nNext, we need to configure our adapter to use the default MySQL credentials by updating `config/dev.exs`:\n\n```elixir\nconfig :hello_phoenix, HelloPhoenix.Repo,\n  username: \"root\",\n  password: \"\",\n  database: \"hello_phoenix_dev\"\n```\n\nIf we have an existing configuration block for our `HelloPhoenix.Repo`, we can simply change the values to match our new ones. You also need to configure the correct values in the `config/test.exs` and `config/runtime.exs` (formerly `config/prod.secret.exs`) files as well.\n\nThe last change is to open up `lib/hello_phoenix/repo.ex` and make sure to set the `:adapter` to `Ecto.Adapters.MyXQL`.\n\nNow all we need to do is fetch our new dependency, and we'll be ready to go.\n\n```console\n$ mix deps.get\n```\n\nWith our new adapter installed and configured, we're ready to create our database.\n\n```console\n$ mix ecto.create\n```\n\nThe database for HelloPhoenix.Repo has been created.\nWe're also ready to run any migrations, or do anything else with Ecto that we may choose.\n\n```console\n$ mix ecto.migrate\n[info] == Running HelloPhoenix.Repo.Migrations.CreateUser.change/0 forward\n[info] create table users\n[info] == Migrated in 0.2s\n```","ref":"ecto.html#using-other-databases"},{"type":"extras","title":"Other options - Ecto","doc":"While Phoenix uses the `Ecto` project to interact with the data access layer, there are many other data access options, some even built into the Erlang standard library. [ETS](https://www.erlang.org/doc/man/ets.html) – available in Ecto via [`etso`](https://hexdocs.pm/etso/) – and [DETS](https://www.erlang.org/doc/man/dets.html) are key-value data stores built into [OTP](https://www.erlang.org/doc/). OTP also provides a relational database called [Mnesia](https://www.erlang.org/doc/man/mnesia.html) with its own query language called QLC. Both Elixir and Erlang also have a number of libraries for working with a wide range of popular data stores.\n\nThe data world is your oyster, but we won't be covering these options in these guides.\n\n[`cast/3`]: `Ecto.Changeset.cast/3`\n[`from/2`]: `Ecto.Query.from/2`\n[`Repo.delete_all/2`]: `c:Ecto.Repo.delete_all/2`\n[`Repo.delete/2`]: `c:Ecto.Repo.delete/2`\n[`Repo.insert_all/3`]: `c:Ecto.Repo.insert_all/3`\n[`Repo.insert/2`]: `c:Ecto.Repo.insert/2`\n[`Repo.one/2`]: `c:Ecto.Repo.one/2`\n[`Repo.update_all/3`]: `c:Ecto.Repo.update_all/3`\n[`Repo.update/2`]: `c:Ecto.Repo.update/2`\n[`timestamps/1`]: `Ecto.Migration.timestamps/1`","ref":"ecto.html#other-options"},{"type":"extras","title":"Contexts","doc":"# Contexts\n\n> **Requirement**: This guide expects that you have gone through the [introductory guides](installation.html) and got a Phoenix application [up and running](up_and_running.html).\n\n> **Requirement**: This guide expects that you have gone through the [Request life-cycle guide](request_lifecycle.html).\n\n> **Requirement**: This guide expects that you have gone through the [Ecto guide](ecto.html).\n\nSo far, we've built pages, wired up controller actions through our routers, and learned how Ecto allows data to be validated and persisted. Now it's time to tie it all together by writing web-facing features that interact with our greater Elixir application.\n\nWhen building a Phoenix project, we are first and foremost building an Elixir application. Phoenix's job is to provide a web interface into our Elixir application. Naturally, we compose our applications with modules and functions, but we often assign specific responsibilities to certain modules and give them names: such as controllers, routers, and live views.\n\nAs everything else, contexts in Phoenix are modules, but with the distinct reponsibility of drawing boundaries and grouping functionality. In other words, they allow us to reason and discuss about application design.","ref":"contexts.html"},{"type":"extras","title":"Thinking about contexts - Contexts","doc":"Contexts are dedicated modules that expose and group related functionality. For example, anytime you call Elixir's standard library, be it `Logger.info/1` or `Stream.map/2`, you are accessing different contexts. Internally, Elixir's logger is made of multiple modules, but we never interact with those modules directly. We call the `Logger` module the context, exactly because it exposes and groups all of the logging functionality.\n\nBy giving modules that expose and group related functionality the name **contexts**, we help developers identify these patterns and talk about them. At the end of the day, contexts are just modules, as are your controllers, views, etc.\n\nIn Phoenix, contexts often encapsulate data access and data validation. They often talk to a database or APIs. Overall, think of them as boundaries to decouple and isolate parts of your application. Let's use these ideas to build out our web application. Our goal is to build an ecommerce system where we can showcase products, allow users to add products to their cart, and complete their orders.\n\n> How to read this guide: Using the context generators is a great way for beginners and intermediate Elixir programmers alike to get up and running quickly while thoughtfully writing their applications. This guide focuses on those readers.","ref":"contexts.html#thinking-about-contexts"},{"type":"extras","title":"Adding a Catalog Context - Contexts","doc":"An ecommerce platform has wide-reaching coupling across a codebase so it's important to think about writing well-defined modules. With that in mind, our goal is to build a product catalog API that handles creating, updating, and deleting the products available in our system. We'll start off with the basic features of showcasing our products, and we will add shopping cart features later. We'll see how starting with a solid foundation with isolated boundaries allows us to grow our application naturally as we add functionality.\n\nPhoenix includes the `mix phx.gen.html`, `mix phx.gen.json`, `mix phx.gen.live`, and `mix phx.gen.context` generators that apply the ideas of isolating functionality in our applications into contexts. These generators are a great way to hit the ground running while Phoenix nudges you in the right direction to grow your application. Let's put these tools to use for our new product catalog context.\n\nIn order to run the context generators, we need to come up with a module name that groups the related functionality that we're building. In the [Ecto guide](ecto.html), we saw how we can use Changesets and Repos to validate and persist user schemas, but we didn't integrate this with our application at large. In fact, we didn't think about where a \"user\" in our application should live at all. Let's take a step back and think about the different parts of our system. We know that we'll have products to showcase on pages for sale, along with descriptions, pricing, etc. Along with selling products, we know we'll need to support carting, order checkout, and so on. While the products being purchased are related to the cart and checkout processes, showcasing a product and managing the *exhibition* of our products is distinctly different than tracking what a user has placed in their cart or how an order is placed. A `Catalog` context is a natural place for the management of our product details and the showcasing of those products we have for sale.\n\n> #### Naming things is hard {: .tip}\n> If you're stuck when trying to come up with a context name when the grouped functionality in your system isn't yet clear, you can simply use the plural form of the resource you're creating. For example, a `Products` context for managing products. As you grow your application and the parts of your system become clear, you can simply rename the context to a more refined one.\n\nTo jump-start our catalog context, we'll use `mix phx.gen.html` which creates a context module that wraps up Ecto access for creating, updating, and deleting products, along with web files like controllers and templates for the web interface into our context. Run the following command at your project root:\n\n```console\n$ mix phx.gen.html Catalog Product products title:string \\\ndescription:string price:decimal views:integer\n\n* creating lib/hello_web/controllers/product_controller.ex\n* creating lib/hello_web/controllers/product_html/edit.html.heex\n* creating lib/hello_web/controllers/product_html/index.html.heex\n* creating lib/hello_web/controllers/product_html/new.html.heex\n* creating lib/hello_web/controllers/product_html/show.html.heex\n* creating lib/hello_web/controllers/product_html/product_form.html.heex\n* creating lib/hello_web/controllers/product_html.ex\n* creating test/hello_web/controllers/product_controller_test.exs\n* creating lib/hello/catalog/product.ex\n* creating priv/repo/migrations/20210201185747_create_products.exs\n* creating lib/hello/catalog.ex\n* injecting lib/hello/catalog.ex\n* creating test/hello/catalog_test.exs\n* injecting test/hello/catalog_test.exs\n* creating test/support/fixtures/catalog_fixtures.ex\n* injecting test/support/fixtures/catalog_fixtures.ex\n\nAdd the resource to your browser scope in lib/hello_web/router.ex:\n\n    resources \"/products\", ProductController\n\n\nRemember to update your repository by running migrations:\n\n    $ mix ecto.migrate\n```\n\nPhoenix generated the web files as expected in `lib/hello_web/`. We can also see our context files were generated inside a `lib/hello/catalog.ex` file and our product schema in the directory of the same name. Note the difference between `lib/hello` and `lib/hello_web`. We have a `Catalog` module to serve as the public API for product catalog functionality, as well as a `Catalog.Product` struct, which is an Ecto schema for casting and validating product data. Phoenix also provided web and context tests for us, it also included test helpers for creating entities via the `Hello.Catalog` context, which we'll look at later. For now, let's follow the instructions and add the route according to the console instructions, in `lib/hello_web/router.ex`:\n\n```diff\n  scope \"/\", HelloWeb do\n    pipe_through :browser\n\n    get \"/\", PageController, :index\n+   resources \"/products\", ProductController\n  end\n```\n\nWith the new route in place, Phoenix reminds us to update our repo by running `mix ecto.migrate`, but first we need to make a few tweaks to the generated migration in `priv/repo/migrations/*_create_products.exs`:\n\n```elixir\n  def change do\n    create table(:products) do\n      add :title, :string\n      add :description, :string\n-     add :price, :decimal\n+     add :price, :decimal, precision: 15, scale: 6, null: false\n-     add :views, :integer\n+     add :views, :integer, default: 0, null: false\n\n      timestamps()\n    end\n```\n\nWe modified our price column to a specific precision of 15, scale of 6, along with a not-null constraint. This ensures we store currency with proper precision for any mathematical operations we may perform. Next, we added a default value and not-null constraint to our views count. With our changes in place, we're ready to migrate up our database. Let's do that now:\n\n```console\n$ mix ecto.migrate\n14:09:02.260 [info] == Running 20210201185747 Hello.Repo.Migrations.CreateProducts.change/0 forward\n\n14:09:02.262 [info] create table products\n\n14:09:02.273 [info] == Migrated 20210201185747 in 0.0s\n```\n\nBefore we jump into the generated code, let's start the server with `mix phx.server` and visit [http://localhost:4000/products](http://localhost:4000/products). Let's follow the \"New Product\" link and click the \"Save\" button without providing any input. We should be greeted with the following output:\n\n```text\nOops, something went wrong! Please check the errors below.\n```\n\nWhen we submit the form, we can see all the validation errors inline with the inputs. Nice! Out of the box, the context generator included the schema fields in our form template and we can see our default validations for required inputs are in effect. Let's enter some example product data and resubmit the form:\n\n```text\nProduct created successfully.\n\nTitle: Metaprogramming Elixir\nDescription: Write Less Code, Get More Done (and Have Fun!)\nPrice: 15.000000\nViews: 0\n```\n\nIf we follow the \"Back\" link, we get a list of all products, which should contain the one we just created. Likewise, we can update this record or delete it. Now that we've seen how it works in the browser, it's time to take a look at the generated code.","ref":"contexts.html#adding-a-catalog-context"},{"type":"extras","title":"Starting with generators - Contexts","doc":"That little `mix phx.gen.html` command packed a surprising punch. We got a lot of functionality out-of-the-box for creating, updating, and deleting products in our catalog. This is far from a full-featured app, but remember, generators are first and foremost learning tools and a starting point for you to begin building real features. Code generation can't solve all your problems, but it will teach you the ins and outs of Phoenix and nudge you towards the proper mindset when designing your application.\n\nLet's first check out the `ProductController` that was generated in `lib/hello_web/controllers/product_controller.ex`:\n\n```elixir\ndefmodule HelloWeb.ProductController do\n  use HelloWeb, :controller\n\n  alias Hello.Catalog\n  alias Hello.Catalog.Product\n\n  def index(conn, _params) do\n    products = Catalog.list_products()\n    render(conn, :index, products: products)\n  end\n\n  def new(conn, _params) do\n    changeset = Catalog.change_product(%Product{})\n    render(conn, :new, changeset: changeset)\n  end\n\n  def create(conn, %{\"product\" => product_params}) do\n    case Catalog.create_product(product_params) do\n      {:ok, product} ->\n        conn\n        |> put_flash(:info, \"Product created successfully.\")\n        |> redirect(to: ~p\"/products/#{product}\")\n\n      {:error, %Ecto.Changeset{} = changeset} ->\n        render(conn, :new, changeset: changeset)\n    end\n  end\n\n  def show(conn, %{\"id\" => id}) do\n    product = Catalog.get_product!(id)\n    render(conn, :show, product: product)\n  end\n  ...\nend\n```\n\nWe've seen how controllers work in our [controller guide](controllers.html), so the code probably isn't too surprising. What is worth noticing is how our controller calls into the `Catalog` context. We can see that the `index` action fetches a list of products with `Catalog.list_products/0`, and how products are persisted in the `create` action with `Catalog.create_product/1`. We haven't yet looked at the catalog context, so we don't yet know how product fetching and creation is happening under the hood – *but that's the point*. Our Phoenix controller is the web interface into our greater application. It shouldn't be concerned with the details of how products are fetched from the database or persisted into storage. We only care about telling our application to perform some work for us. This is great because our business logic and storage details are decoupled from the web layer of our application. If we move to a full-text storage engine later for fetching products instead of a SQL query, our controller doesn't need to be changed. Likewise, we can reuse our context code from any other interface in our application, be it a channel, mix task, or long-running process importing CSV data.\n\nIn the case of our `create` action, when we successfully create a product, we use `Phoenix.Controller.put_flash/3` to show a success message, and then we redirect to the router's product show page. Conversely, if `Catalog.create_product/1` fails, we render our `\"new.html\"` template and pass along the Ecto changeset for the template to lift error messages from.\n\nNext, let's dig deeper and check out our `Catalog` context in `lib/hello/catalog.ex`:\n\n```elixir\ndefmodule Hello.Catalog do\n  @moduledoc \"\"\"\n  The Catalog context.\n  \"\"\"\n\n  import Ecto.Query, warn: false\n  alias Hello.Repo\n\n  alias Hello.Catalog.Product\n\n  @doc \"\"\"\n  Returns the list of products.","ref":"contexts.html#starting-with-generators"},{"type":"extras","title":"Examples - Contexts","doc":"iex> list_products()\n      [%Product{}, ...]\n\n  \"\"\"\n  def list_products do\n    Repo.all(Product)\n  end\n  ...\nend\n```\n\nThis module will be the public API for all product catalog functionality in our system. For example, in addition to product detail management, we may also handle product category classification and product variants for things like optional sizing, trims, etc. If we look at the `list_products/0` function, we can see the private details of product fetching. And it's super simple. We have a call to `Repo.all(Product)`. We saw how Ecto repo queries worked in the [Ecto guide](ecto.html), so this call should look familiar. Our `list_products` function is a generalized function name specifying the *intent* of our code – namely to list products. The details of that intent where we use our Repo to fetch the products from our PostgreSQL database is hidden from our callers. This is a common theme we'll see re-iterated as we use the Phoenix generators. Phoenix will push us to think about where we have different responsibilities in our application, and then to wrap up those different areas behind well-named modules and functions that make the intent of our code clear, while encapsulating the details.\n\nNow we know how data is fetched, but how are products persisted? Let's take a look at the `Catalog.create_product/1` function:\n\n```elixir\n  @doc \"\"\"\n  Creates a product.","ref":"contexts.html#examples"},{"type":"extras","title":"Examples - Contexts","doc":"iex> create_product(%{field: value})\n      {:ok, %Product{}}\n\n      iex> create_product(%{field: bad_value})\n      {:error, %Ecto.Changeset{}}\n\n  \"\"\"\n  def create_product(attrs \\\\ %{}) do\n    %Product{}\n    |> Product.changeset(attrs)\n    |> Repo.insert()\n  end\n```\n\nThere's more documentation than code here, but a couple of things are important to highlight. First, we can see again that our Ecto Repo is used under the hood for database access. You probably also noticed the call to `Product.changeset/2`. We talked about changesets before, and now we see them in action in our context.\n\nIf we open up the `Product` schema in `lib/hello/catalog/product.ex`, it will look immediately familiar:\n\n```elixir\ndefmodule Hello.Catalog.Product do\n  use Ecto.Schema\n  import Ecto.Changeset\n\n  schema \"products\" do\n    field :description, :string\n    field :price, :decimal\n    field :title, :string\n    field :views, :integer\n\n    timestamps()\n  end\n\n  @doc false\n  def changeset(product, attrs) do\n    product\n    |> cast(attrs, [:title, :description, :price, :views])\n    |> validate_required([:title, :description, :price, :views])\n  end\nend\n```\n\nThis is just what we saw before when we ran `mix phx.gen.schema`, except here we see a `@doc false` above our `changeset/2` function. This tells us that while this function is publicly callable, it's not part of the public context API. Callers that build changesets do so via the context API. For example, `Catalog.create_product/1` calls into our `Product.changeset/2` to build the changeset from user input. Callers, such as our controller actions, do not access `Product.changeset/2` directly. All interaction with our product changesets is done through the public `Catalog` context.","ref":"contexts.html#examples"},{"type":"extras","title":"Adding Catalog functions - Contexts","doc":"As we've seen, your context modules are dedicated modules that expose and group related functionality. Phoenix generates generic functions, such as `list_products` and `update_product`, but they only serve as a basis for you to grow your business logic and application from. Let's add one of the basic features of our catalog by tracking product page view count.\n\nFor any ecommerce system, the ability to track how many times a product page has been viewed is essential for marketing, suggestions, ranking, etc. While we could try to use the existing `Catalog.update_product` function, along the lines of `Catalog.update_product(product, %{views: product.views + 1})`, this would not only be prone to race conditions, but it would also require the caller to know too much about our Catalog system. To see why the race condition exists, let's walk through the possible execution of events:\n\nIntuitively, you would assume the following events:\n\n  1. User 1 loads the product page with count of 13\n  2. User 1 saves the product page with count of 14\n  3. User 2 loads the product page with count of 14\n  4. User 2 saves the product page with count of 15\n\nWhile in practice this would happen:\n\n  1. User 1 loads the product page with count of 13\n  2. User 2 loads the product page with count of 13\n  3. User 1 saves the product page with count of 14\n  4. User 2 saves the product page with count of 14\n\nThe race conditions would make this an unreliable way to update the existing table since multiple callers may be updating out of date view values. There's a better way.\n\nLet's think of a function that describes what we want to accomplish. Here's how we would like to use it:\n\n```elixir\nproduct = Catalog.inc_page_views(product)\n```\n\nThat looks great. Our callers will have no confusion over what this function does, and we can wrap up the increment in an atomic operation to prevent race conditions.\n\nOpen up your catalog context (`lib/hello/catalog.ex`), and add this new function:\n\n```elixir\n  def inc_page_views(%Product{} = product) do\n    {1, [%Product{views: views}]} =\n      from(p in Product, where: p.id == ^product.id, select: [:views])\n      |> Repo.update_all(inc: [views: 1])\n\n    put_in(product.views, views)\n  end\n```\n\nWe built a query for fetching the current product given its ID which we pass to `Repo.update_all`. Ecto's `Repo.update_all` allows us to perform batch updates against the database, and is perfect for atomically updating values, such as incrementing our views count. The result of the repo operation returns the number of updated records, along with the selected schema values specified by the `select` option. When we receive the new product views, we use `put_in(product.views, views)` to place the new view count within the product struct.\n\nWith our context function in place, let's make use of it in our product controller. Update your `show` action in `lib/hello_web/controllers/product_controller.ex` to call our new function:\n\n```elixir\n  def show(conn, %{\"id\" => id}) do\n    product =\n      id\n      |> Catalog.get_product!()\n      |> Catalog.inc_page_views()\n\n    render(conn, :show, product: product)\n  end\n```\n\nWe modified our `show` action to pipe our fetched product into `Catalog.inc_page_views/1`, which will return the updated product. Then we rendered our template just as before. Let's try it out. Refresh one of your product pages a few times and watch the view count increase.\n\nWe can also see our atomic update in action in the ecto debug logs:\n\n```text\n[debug] QUERY OK source=\"products\" db=0.5ms idle=834.5ms\nUPDATE \"products\" AS p0 SET \"views\" = p0.\"views\" + $1 WHERE (p0.\"id\" = $2) RETURNING p0.\"views\" [1, 1]\n```\n\nGood work!\n\nAs we've seen, designing with contexts gives you a solid foundation to grow your application from. Using discrete, well-defined APIs that expose the intent of your system allows you to write more maintainable applications with reusable code. Now that we know how to start extending our context API, lets explore handling relationships within a context.","ref":"contexts.html#adding-catalog-functions"},{"type":"extras","title":"In-context relationships - Contexts","doc":"Our basic catalog features are nice, but let's take it up a notch by categorizing products. Many ecommerce solutions allow products to be categorized in different ways, such as a product being marked for fashion, power tools, and so on. Starting with a one-to-one relationship between product and categories will cause major code changes later if we need to start supporting multiple categories. Let's set up a category association that will allow us to start off tracking a single category per product, but easily support more later as we grow our features.\n\nFor now, categories will contain only textual information. Our first order of business is to decide where categories live in the application. We have our `Catalog` context, which manages the exhibition of our products. Product categorization is a natural fit here. Phoenix is also smart enough to generate code inside an existing context, which makes adding new resources to a context a breeze. Run the following command at your project root:\n\n> Sometimes it may be tricky to determine if two resources belong to the same context or not. In those cases, prefer distinct contexts per resource and refactor later if necessary. Otherwise you can easily end up with large contexts of loosely related entities. Also keep in mind that the fact two resources are related does not necessarily mean they belong to the same context, otherwise you would quickly end up with one large context, as the majority of resources in an application are connected to each other. To sum it up: if you are unsure, you should prefer separate modules (contexts).\n\n```console\n$ mix phx.gen.context Catalog Category categories \\\ntitle:string:unique\n\nYou are generating into an existing context.\n...\nWould you like to proceed? [Yn] y\n* creating lib/hello/catalog/category.ex\n* creating priv/repo/migrations/20210203192325_create_categories.exs\n* injecting lib/hello/catalog.ex\n* injecting test/hello/catalog_test.exs\n* injecting test/support/fixtures/catalog_fixtures.ex\n\nRemember to update your repository by running migrations:\n\n    $ mix ecto.migrate\n```\n\nThis time around, we used `mix phx.gen.context`, which is just like `mix phx.gen.html`, except it doesn't generate the web files for us. Since we already have controllers and templates for managing products, we can integrate the new category features into our existing web form and product show page. We can see we now have a new `Category` schema alongside our product schema at `lib/hello/catalog/category.ex`, and Phoenix told us it was *injecting* new functions in our existing Catalog context for the category functionality. The injected functions will look very familiar to our product functions, with new functions like `create_category`, `list_categories`, and so on. Before we migrate up, we need to do a second bit of code generation. Our category schema is great for representing an individual category in the system, but we need to support a many-to-many relationship between products and categories. Fortunately, ecto allows us to do this simply with a join table, so let's generate that now with the `ecto.gen.migration` command:\n\n```console\n$ mix ecto.gen.migration create_product_categories\n\n* creating priv/repo/migrations/20210203192958_create_product_categories.exs\n```\n\nNext, let's open up the new migration file and add the following code to the `change` function:\n\n```elixir\n\ndefmodule Hello.Repo.Migrations.CreateProductCategories do\n  use Ecto.Migration\n\n  def change do\n    create table(:product_categories, primary_key: false) do\n      add :product_id, references(:products, on_delete: :delete_all)\n      add :category_id, references(:categories, on_delete: :delete_all)\n    end\n\n    create index(:product_categories, [:product_id])\n    create unique_index(:product_categories, [:category_id, :product_id])\n  end\nend\n```\n\nWe created a `product_categories` table and used the `primary_key: false` option since our join table does not need a primary key. Next we defined our `:product_id` and `:category_id` foreign key fields, and passed `on_delete: :delete_all` to ensure the database prunes our join table records if a linked product or category is deleted. By using a database constraint, we enforce data integrity at the database level, rather than relying on ad-hoc and error-prone application logic.\n\nNext, we created indexes for our foreign keys, one of which is a unique index to ensure a product cannot have duplicate categories. Note that we do not necessarily need single-column index for `category_id` because it is in the leftmost prefix of multicolumn index, which is enough for the database optimizer. Adding a redundant index, on the other hand, only adds overhead on write.\n\nWith our migrations in place, we can migrate up.\n\n```console\n$ mix ecto.migrate\n\n18:20:36.489 [info] == Running 20210222231834 Hello.Repo.Migrations.CreateCategories.change/0 forward\n\n18:20:36.493 [info] create table categories\n\n18:20:36.508 [info] create index categories_title_index\n\n18:20:36.512 [info] == Migrated 20210222231834 in 0.0s\n\n18:20:36.547 [info] == Running 20210222231930 Hello.Repo.Migrations.CreateProductCategories.change/0 forward\n\n18:20:36.547 [info] create table product_categories\n\n18:20:36.557 [info] create index product_categories_product_id_index\n\n18:20:36.560 [info]  create index product_categories_category_id_product_id_index\n\n18:20:36.562 [info] == Migrated 20210222231930 in 0.0s\n```\n\nNow that we have a `Catalog.Product` schema and a join table to associate products and categories, we're nearly ready to start wiring up our new features. Before we dive in, we first need real categories to select in our web UI. Let's quickly seed some new categories in the application. Add the following code to your seeds file in `priv/repo/seeds.exs`:\n\n```elixir\nfor title <- [\"Home Improvement\", \"Power Tools\", \"Gardening\", \"Books\", \"Education\"] do\n  {:ok, _} = Hello.Catalog.create_category(%{title: title})\nend\n```\n\nWe simply enumerate over a list of category titles and use the generated `create_category/1` function of our catalog context to persist the new records. We can run the seeds with `mix run`:\n\n```console\n$ mix run priv/repo/seeds.exs\n\n[debug] QUERY OK db=3.1ms decode=1.1ms queue=0.7ms idle=2.2ms\nINSERT INTO \"categories\" (\"title\",\"inserted_at\",\"updated_at\") VALUES ($1,$2,$3) RETURNING \"id\" [\"Home Improvement\", ~N[2021-02-03 19:39:53], ~N[2021-02-03 19:39:53]]\n[debug] QUERY OK db=1.2ms queue=1.3ms idle=12.3ms\nINSERT INTO \"categories\" (\"title\",\"inserted_at\",\"updated_at\") VALUES ($1,$2,$3) RETURNING \"id\" [\"Power Tools\", ~N[2021-02-03 19:39:53], ~N[2021-02-03 19:39:53]]\n[debug] QUERY OK db=1.1ms queue=1.1ms idle=15.1ms\nINSERT INTO \"categories\" (\"title\",\"inserted_at\",\"updated_at\") VALUES ($1,$2,$3) RETURNING \"id\" [\"Gardening\", ~N[2021-02-03 19:39:53], ~N[2021-02-03 19:39:53]]\n[debug] QUERY OK db=2.4ms queue=1.0ms idle=17.6ms\nINSERT INTO \"categories\" (\"title\",\"inserted_at\",\"updated_at\") VALUES ($1,$2,$3) RETURNING \"id\" [\"Books\", ~N[2021-02-03 19:39:53], ~N[2021-02-03 19:39:53]]\n```\n\nPerfect. Before we integrate categories in the web layer, we need to let our context know how to associate products and categories. First, open up `lib/hello/catalog/product.ex` and add the following association:\n\n```diff\n+ alias Hello.Catalog.Category\n\n  schema \"products\" do\n    field :description, :string\n    field :price, :decimal\n    field :title, :string\n    field :views, :integer\n\n+   many_to_many :categories, Category, join_through: \"product_categories\", on_replace: :delete\n\n    timestamps()\n  end\n\n```\n\nWe used `Ecto.Schema`'s `many_to_many` macro to let Ecto know how to associate our product to multiple categories through the `\"product_categories\"` join table. We also used the `on_replace: :delete` option to declare that any existing join records should be deleted when we are changing our categories.\n\nWith our schema associations set up, we can implement the selection of categories in our product form. To do so, we need to translate the user input of catalog IDs from the front-end to our many-to-many association. Fortunately Ecto makes this a breeze now that our schema is set up. Open up your catalog context and make the following changes:\n\n```diff\n+ alias Hello.Catalog.Category\n\n- def get_product!(id), do: Repo.get!(Product, id)\n+ def get_product!(id) do\n+   Product |> Repo.get!(id) |> Repo.preload(:categories)\n+ end\n\n  def create_product(attrs \\\\ %{}) do\n    %Product{}\n-   |> Product.changeset(attrs)\n+   |> change_product(attrs)\n    |> Repo.insert()\n  end\n\n  def update_product(%Product{} = product, attrs) do\n    product\n-   |> Product.changeset(attrs)\n+   |> change_product(attrs)\n    |> Repo.update()\n  end\n\n  def change_product(%Product{} = product, attrs \\\\ %{}) do\n-   Product.changeset(product, attrs)\n+   categories = list_categories_by_id(attrs[\"category_ids\"])\n\n+   product\n+   |> Repo.preload(:categories)\n+   |> Product.changeset(attrs)\n+   |> Ecto.Changeset.put_assoc(:categories, categories)\n  end\n\n+ def list_categories_by_id(nil), do: []\n+ def list_categories_by_id(category_ids) do\n+   Repo.all(from c in Category, where: c.id in ^category_ids)\n+ end\n```\n\nFirst, we added `Repo.preload` to preload our categories when we fetch a product. This will allow us to reference `product.categories` in our controllers, templates, and anywhere else we want to make use of category information. Next, we modified our `create_product` and `update_product` functions to call into our existing `change_product` function to produce a changeset. Within `change_product` we added a lookup to find all categories if the `\"category_ids\"` attribute is present. Then we preloaded categories and called `Ecto.Changeset.put_assoc` to place the fetched categories into the changeset. Finally, we implemented the `list_categories_by_id/1` function to query the categories matching the category IDs, or return an empty list if no `\"category_ids\"` attribute is present. Now our `create_product` and `update_product` functions receive a changeset with the category associations all ready to go once we attempt an insert or update against our repo.\n\nNext, let's expose our new feature to the web by adding the category input to our product form. To keep our form template tidy, let's write a new function to wrap up the details of rendering a category select input for our product. Open up your `ProductHTML` view in `lib/hello_web/controllers/product_html.ex` and key this in:\n\n```elixir\n  def category_opts(changeset) do\n    existing_ids =\n      changeset\n      |> Ecto.Changeset.get_change(:categories, [])\n      |> Enum.map(& &1.data.id)\n\n    for cat <- Hello.Catalog.list_categories(),\n        do: [key: cat.title, value: cat.id, selected: cat.id in existing_ids]\n  end\n```\n\nWe added a new `category_opts/1` function which generates the select options for a multiple select tag we will add soon. We calculated the existing category IDs from our changeset, then used those values when we generate the select options for the input tag. We did this by enumerating over all of our categories and returning the appropriate `key`, `value`, and `selected` values. We marked an option as selected if the category ID was found in those category IDs in our changeset.\n\nWith our `category_opts` function in place, we can open up `lib/hello_web/controllers/product_html/product_form.html.heex` and add:\n\n```diff\n  ...\n  <.input field={f[:views]} type=\"number\" label=\"Views\" />\n\n+ <.input field={f[:category_ids]} type=\"select\" multiple={true} options={category_opts(@changeset)} />\n\n  <:actions>\n    <.button>Save Product</.button>\n  </:actions>\n```\n\nWe added a `category_select` above our save button. Now let's try it out. Next, let's show the product's categories in the product show template. Add the following code to the list in `lib/hello_web/controllers/product_html/show.html.heex`:\n\n```heex\n<.list>\n  ...\n+ <:item title=\"Categories\">\n+   <%= for cat <- @product.categories do %>\n+     <%= cat.title %>\n+      \n+   <% end %>\n+ </:item>\n</.list>\n```\n\nNow if we start the server with `mix phx.server` and visit [http://localhost:4000/products/new](http://localhost:4000/products/new), we'll see the new category multiple select input. Enter some valid product details, select a category or two, and click save.\n\n```text\nTitle: Elixir Flashcards\nDescription: Flash card set for the Elixir programming language\nPrice: 5.000000\nViews: 0\nCategories:\nEducation\nBooks\n```\n\nIt's not much to look at yet, but it works! We added relationships within our context complete with data integrity enforced by the database. Not bad. Let's keep building!","ref":"contexts.html#in-context-relationships"},{"type":"extras","title":"Cross-context dependencies - Contexts","doc":"Now that we have the beginnings of our product catalog features, let's begin to work on the other main features of our application – carting products from the catalog. In order to properly track products that have been added to a user's cart, we'll need a new place to persist this information, along with point-in-time product information like the price at time of carting. This is necessary so we can detect product price changes in the future. We know what we need to build, but now we need to decide where the cart functionality lives in our application.\n\nIf we take a step back and think about the isolation of our application, the exhibition of products in our catalog distinctly differs from the responsibilities of managing a user's cart. A product catalog shouldn't care about the rules of our shopping cart system, and vice-versa. There's a clear need here for a separate context to handle the new cart responsibilities. Let's call it `ShoppingCart`.\n\nLet's create a `ShoppingCart` context to handle basic cart duties. Before we write code, let's imagine we have the following feature requirements:\n\n  1. Add products to a user's cart from the product show page\n  2. Store point-in-time product price information at time of carting\n  3. Store and update quantities in cart\n  4. Calculate and display sum of cart prices\n\nFrom the description, it's clear we need a `Cart` resource for storing the user's cart, along with a `CartItem` to track products in the cart. With our plan set, let's get to work. Run the following command to generate our new context:\n\n```console\n$ mix phx.gen.context ShoppingCart Cart carts user_uuid:uuid:unique\n\n* creating lib/hello/shopping_cart/cart.ex\n* creating priv/repo/migrations/20210205203128_create_carts.exs\n* creating lib/hello/shopping_cart.ex\n* injecting lib/hello/shopping_cart.ex\n* creating test/hello/shopping_cart_test.exs\n* injecting test/hello/shopping_cart_test.exs\n* creating test/support/fixtures/shopping_cart_fixtures.ex\n* injecting test/support/fixtures/shopping_cart_fixtures.ex\n\nSome of the generated database columns are unique. Please provide\nunique implementations for the following fixture function(s) in\ntest/support/fixtures/shopping_cart_fixtures.ex:\n\n    def unique_cart_user_uuid do\n      raise \"implement the logic to generate a unique cart user_uuid\"\n    end\n\nRemember to update your repository by running migrations:\n\n    $ mix ecto.migrate\n```\n\nWe generated our new context `ShoppingCart`, with a new `ShoppingCart.Cart` schema to tie a user to their cart which holds cart items. We don't have real users yet, so for now our cart will be tracked by an anonymous user UUID that we'll add to our plug session in a moment. With our cart in place, let's generate our cart items:\n\n```console\n$ mix phx.gen.context ShoppingCart CartItem cart_items \\\ncart_id:references:carts product_id:references:products \\\nprice_when_carted:decimal quantity:integer\n\nYou are generating into an existing context.\n...\nWould you like to proceed? [Yn] y\n* creating lib/hello/shopping_cart/cart_item.ex\n* creating priv/repo/migrations/20210205213410_create_cart_items.exs\n* injecting lib/hello/shopping_cart.ex\n* injecting test/hello/shopping_cart_test.exs\n* injecting test/support/fixtures/shopping_cart_fixtures.ex\n\nRemember to update your repository by running migrations:\n\n    $ mix ecto.migrate\n\n```\n\nWe generated a new resource inside our `ShoppingCart` named `CartItem`. This schema and table will hold references to a cart and product, along with the price at the time we added the item to our cart, and the quantity the user wishes to purchase. Let's touch up the generated migration file in `priv/repo/migrations/*_create_cart_items.ex`:\n\n```elixir\n    create table(:cart_items) do\n-     add :price_when_carted, :decimal\n+     add :price_when_carted, :decimal, precision: 15, scale: 6, null: false\n      add :quantity, :integer\n-     add :cart_id, references(:carts, on_delete: :nothing)\n+     add :cart_id, references(:carts, on_delete: :delete_all)\n-     add :product_id, references(:products, on_delete: :nothing)\n+     add :product_id, references(:products, on_delete: :delete_all)\n\n      timestamps()\n    end\n\n-   create index(:cart_items, [:cart_id])\n    create index(:cart_items, [:product_id])\n+   create unique_index(:cart_items, [:cart_id, :product_id])\n```\n\nWe used the `:delete_all` strategy again to enforce data integrity. This way, when a cart or product is deleted from the application, we don't have to rely on application code in our `ShoppingCart` or `Catalog` contexts to worry about cleaning up the records. This keeps our application code decoupled and the data integrity enforcement where it belongs – in the database. We also added a unique constraint to ensure a duplicate product is not allowed to be added to a cart. As with the `product_categories` table, using a multi-column index lets us remove the separate index for the leftmost field (`cart_id`). With our database tables in place, we can now migrate up:\n\n```console\n$ mix ecto.migrate\n\n16:59:51.941 [info] == Running 20210205203342 Hello.Repo.Migrations.CreateCarts.change/0 forward\n\n16:59:51.945 [info] create table carts\n\n16:59:51.949 [info] create index carts_user_uuid_index\n\n16:59:51.952 [info] == Migrated 20210205203342 in 0.0s\n\n16:59:51.988 [info] == Running 20210205213410 Hello.Repo.Migrations.CreateCartItems.change/0 forward\n\n16:59:51.988 [info] create table cart_items\n\n16:59:51.998 [info] create index cart_items_cart_id_index\n\n16:59:52.000 [info] create index cart_items_product_id_index\n\n16:59:52.001 [info] create index cart_items_cart_id_product_id_index\n\n16:59:52.002 [info] == Migrated 20210205213410 in 0.0s\n```\n\nOur database is ready to go with new `carts` and `cart_items` tables, but now we need to map that back into application code. You may be wondering how we can mix database foreign keys across different tables and how that relates to the context pattern of isolated, grouped functionality. Let's jump in and discuss the approaches and their tradeoffs.","ref":"contexts.html#cross-context-dependencies"},{"type":"extras","title":"Cross-context data - Contexts","doc":"So far, we've done a great job isolating the two main contexts of our application from each other, but now we have a necessary dependency to handle.\n\nOur `Catalog.Product` resource serves to keep the responsibilities of representing a product inside the catalog, but ultimately for an item to exist in the cart, a product from the catalog must be present. Given this, our `ShoppingCart` context will have a data dependency on the `Catalog` context. With that in mind, we have two options. One is to expose APIs on the `Catalog` context that allows us to efficiently fetch product data for use in the `ShoppingCart` system, which we would manually stitch together. Or we can use database joins to fetch the dependent data. Both are valid options given your tradeoffs and application size, but joining data from the database when you have a hard data dependency is just fine for a large class of applications and is the approach we will take here.\n\nNow that we know where our data dependencies exist, let's add our schema associations so we can tie shopping cart items to products. First, let's make a quick change to our cart schema in `lib/hello/shopping_cart/cart.ex` to associate a cart to its items:\n\n```elixir\n  schema \"carts\" do\n    field :user_uuid, Ecto.UUID\n\n+   has_many :items, Hello.ShoppingCart.CartItem\n\n    timestamps()\n  end\n```\n\nNow that our cart is associated to the items we place in it, let's set up the cart item associations inside `lib/hello/shopping_cart/cart_item.ex`:\n\n```elixir\n  schema \"cart_items\" do\n    field :price_when_carted, :decimal\n    field :quantity, :integer\n-   field :cart_id, :id\n-   field :product_id, :id\n\n+   belongs_to :cart, Hello.ShoppingCart.Cart\n+   belongs_to :product, Hello.Catalog.Product\n\n    timestamps()\n  end\n\n  @doc false\n  def changeset(cart_item, attrs) do\n    cart_item\n    |> cast(attrs, [:price_when_carted, :quantity])\n    |> validate_required([:price_when_carted, :quantity])\n+   |> validate_number(:quantity, greater_than_or_equal_to: 0, less_than: 100)\n  end\n```\n\nFirst, we replaced the `cart_id` field with a standard `belongs_to` pointing at our `ShoppingCart.Cart` schema. Next, we replaced our `product_id` field by adding our first cross-context data dependency with a `belongs_to` for the `Catalog.Product` schema. Here, we intentionally coupled the data boundaries because it provides exactly what we need: an isolated context API with the bare minimum knowledge necessary to reference a product in our system. Next, we added a new validation to our changeset. With `validate_number/3`, we ensure any quantity provided by user input is between 0 and 100.\n\nWith our schemas in place, we can start integrating the new data structures and `ShoppingCart` context APIs into our web-facing features.","ref":"contexts.html#cross-context-data"},{"type":"extras","title":"Adding Shopping Cart functions - Contexts","doc":"As we mentioned before, the context generators are only a starting point for our application. We can and should write well-named, purpose built functions to accomplish the goals of our context. We have a few new features to implement. First, we need to ensure every user of our application is granted a cart if one does not yet exist. From there, we can then allow users to add items to their cart, update item quantities, and calculate cart totals. Let's get started!\n\nWe won't focus on a real user authentication system at this point, but by the time we're done, you'll be able to naturally integrate one with what we've written here. To simulate a current user session, open up your `lib/hello_web/router.ex` and key this in:\n\n```elixir\n  pipeline :browser do\n    plug :accepts, [\"html\"]\n    plug :fetch_session\n    plug :fetch_live_flash\n    plug :put_root_layout, html: {HelloWeb.LayoutView, :root}\n    plug :protect_from_forgery\n    plug :put_secure_browser_headers\n+   plug :fetch_current_user\n+   plug :fetch_current_cart\n  end\n\n+ defp fetch_current_user(conn, _) do\n+   if user_uuid = get_session(conn, :current_uuid) do\n+     assign(conn, :current_uuid, user_uuid)\n+   else\n+     new_uuid = Ecto.UUID.generate()\n+\n+     conn\n+     |> assign(:current_uuid, new_uuid)\n+     |> put_session(:current_uuid, new_uuid)\n+   end\n+ end\n\n+ alias Hello.ShoppingCart\n+\n+ defp fetch_current_cart(conn, _opts) do\n+   if cart = ShoppingCart.get_cart_by_user_uuid(conn.assigns.current_uuid) do\n+     assign(conn, :cart, cart)\n+   else\n+     {:ok, new_cart} = ShoppingCart.create_cart(conn.assigns.current_uuid)\n+     assign(conn, :cart, new_cart)\n+   end\n+ end\n```\n\nWe added a new `:fetch_current_user` and `:fetch_current_cart` plug to our browser pipeline to run on all browser-based requests. Next, we implemented the `fetch_current_user` plug which simply checks the session for a user UUID that was previously added. If we find one, we add a `current_uuid` assign to the connection and we're done. In the case we haven't yet identified this visitor, we generate a unique UUID with `Ecto.UUID.generate()`, then we place that value in the `current_uuid` assign, along with a new session value to identify this visitor on future requests. A random, unique ID isn't much to represent a user, but it's enough for us to track and identify a visitor across requests, which is all we need for now. Later as our application becomes more complete, you'll be ready to migrate to a complete user authentication solution. With a guaranteed current user, we then implemented the `fetch_current_cart` plug which either finds a cart for the user UUID or creates a cart for the current user and assigns the result in the connection assigns. We'll need to implement our `ShoppingCart.get_cart_by_user_uuid/1` and modify the create cart function to accept a UUID, but let's add our routes first.\n\nWe'll need to implement a cart controller for handling cart operations like viewing a cart, updating quantities, and initiating the checkout process, as well as a cart items controller for adding and removing individual items to and from the cart. Add the following routes to your router in `lib/hello_web/router.ex`:\n\n```diff\n  scope \"/\", HelloWeb do\n    pipe_through :browser\n\n    get \"/\", PageController, :index\n    resources \"/products\", ProductController\n\n+   resources \"/cart_items\", CartItemController, only: [:create, :delete]\n\n+   get \"/cart\", CartController, :show\n+   put \"/cart\", CartController, :update\n  end\n```\n\nWe added a `resources` declaration for a `CartItemController`, which will wire up the routes for a create and delete action for adding and removing individual cart items. Next, we added two new routes pointing at a `CartController`. The first route, a GET request, will map to our show action, to show the cart contents. The second route, a PUT request, will handle the submission of a form for updating our cart quantities.\n\nWith our routes in place, let's add the ability to add an item to our cart from the product show page. Create a new file at `lib/hello_web/controllers/cart_item_controller.ex` and key this in:\n\n```elixir\ndefmodule HelloWeb.CartItemController do\n  use HelloWeb, :controller\n\n  alias Hello.ShoppingCart\n\n  def create(conn, %{\"product_id\" => product_id}) do\n    case ShoppingCart.add_item_to_cart(conn.assigns.cart, product_id) do\n      {:ok, _item} ->\n        conn\n        |> put_flash(:info, \"Item added to your cart\")\n        |> redirect(to: ~p\"/cart\")\n\n      {:error, _changeset} ->\n        conn\n        |> put_flash(:error, \"There was an error adding the item to your cart\")\n        |> redirect(to: ~p\"/cart\")\n    end\n  end\n\n  def delete(conn, %{\"id\" => product_id}) do\n    {:ok, _cart} = ShoppingCart.remove_item_from_cart(conn.assigns.cart, product_id)\n    redirect(conn, to: ~p\"/cart\")\n  end\nend\n```\n\nWe defined a new `CartItemController` with the create and delete actions that we declared in our router. For `create`, we call a `ShoppingCart.add_item_to_cart/2` function which we'll implement in a moment. If successful, we show a flash successful message and redirect to the cart show page; else, we show a flash error message and redirect to the cart show page. For `delete`, we'll call a `remove_item_from_cart` function which we'll implement on our `ShoppingCart` context  and then redirect back to the cart show page. We haven't implemented these two shopping cart functions yet, but notice how their names scream their intent: `add_item_to_cart` and `remove_item_from_cart` make it obvious what we are accomplishing here. It also allows us to spec out our web layer and context APIs without thinking about all the implementation details at once.\n\nLet's implement the new interface for the `ShoppingCart` context API in `lib/hello/shopping_cart.ex`:\n\n```elixir\n+  alias Hello.Catalog\n-  alias Hello.ShoppingCart.Cart\n+  alias Hello.ShoppingCart.{Cart, CartItem}\n\n+  def get_cart_by_user_uuid(user_uuid) do\n+    Repo.one(\n+      from(c in Cart,\n+        where: c.user_uuid == ^user_uuid,\n+        left_join: i in assoc(c, :items),\n+        left_join: p in assoc(i, :product),\n+        order_by: [asc: i.inserted_at],\n+        preload: [items: {i, product: p}]\n+      )\n+    )\n+  end\n\n- def create_cart(attrs \\\\ %{}) do\n-   %Cart{}\n-   |> Cart.changeset(attrs)\n+ def create_cart(user_uuid) do\n+   %Cart{user_uuid: user_uuid}\n+   |> Cart.changeset(%{})\n    |> Repo.insert()\n+   |> case do\n+     {:ok, cart} -> {:ok, reload_cart(cart)}\n+     {:error, changeset} -> {:error, changeset}\n+   end\n  end\n\n+  defp reload_cart(%Cart{} = cart), do: get_cart_by_user_uuid(cart.user_uuid)\n+\n+  def add_item_to_cart(%Cart{} = cart, product_id) do\n+    product = Catalog.get_product!(product_id)\n+\n+    %CartItem{quantity: 1, price_when_carted: product.price}\n+    |> CartItem.changeset(%{})\n+    |> Ecto.Changeset.put_assoc(:cart, cart)\n+    |> Ecto.Changeset.put_assoc(:product, product)\n+    |> Repo.insert(\n+      on_conflict: [inc: [quantity: 1]],\n+      conflict_target: [:cart_id, :product_id]\n+    )\n+  end\n+\n+  def remove_item_from_cart(%Cart{} = cart, product_id) do\n+    {1, _} =\n+      Repo.delete_all(\n+        from(i in CartItem,\n+          where: i.cart_id == ^cart.id,\n+          where: i.product_id == ^product_id\n+        )\n+      )\n+\n+    {:ok, reload_cart(cart)}\n+  end\n```\n\nWe started by implementing  `get_cart_by_user_uuid/1` which fetches our cart and joins the cart items, and their products so that we have the full cart populated with all preloaded data. Next, we modified our `create_cart` function to accept a user UUID instead of attributes, which we used to populate the `user_uuid` field. If the insert is successful, we reload the cart contents by calling a private `reload_cart/1` function, which simply calls `get_cart_by_user_uuid/1` to refetch data.\n\nNext, we wrote our new `add_item_to_cart/2` function which accepts a cart struct and a product id. We proceed to fetch the product with `Catalog.get_product!/1`, showing how contexts can naturally invoke other contexts if required. You could also have chosen to receive the product as argument and you would achieve similar results. Then we used an upsert operation against our repo to either insert a new cart item into the database, or increase the quantity by one if it already exists in the cart. This is accomplished via the `on_conflict` and `conflict_target` options, which tells our repo how to handle an insert conflict.\n\nFinally, we implemented `remove_item_from_cart/2` where we simply issue a `Repo.delete_all` call with a query to delete the cart item in our cart that matches the product ID. Finally, we reload the cart contents by calling `reload_cart/1`.\n\nWith our new cart functions in place, we can now expose the \"Add to cart\" button on the product catalog show page. Open up your template in `lib/hello_web/controllers/product_html/show.html.heex` and make the following changes:\n\n```diff\n...\n     <.link href={~p\"/products/#{@product}/edit\"}>\n       <.button>Edit product</.button>\n     </.link>\n+    <.link href={~p\"/cart_items?product_id=#{@product.id}\"} method=\"post\">\n+      <.button>Add to cart</.button>\n+    </.link>\n...\n```\n\nThe `link` function component from `Phoenix.Component` accepts a `:method` attribute to issue an HTTP verb when clicked, instead of the default GET request. With this link in place, the \"Add to cart\" link will issue a POST request, which will be matched by the route we defined in router which dispatches to the `CartItemController.create/2` function.\n\nLet's try it out. Start your server with `mix phx.server` and visit a product page. If we try clicking the add to cart link, we'll be greeted by an error page with the following logs in the console:\n\n```text\n[info] POST /cart_items\n[debug] Processing with HelloWeb.CartItemController.create/2\n  Parameters: %{\"_method\" => \"post\", \"product_id\" => \"1\", ...}\n  Pipelines: [:browser]\nINSERT INTO \"cart_items\" ...\n[info] Sent 302 in 24ms\n[info] GET /cart\n[debug] Processing with HelloWeb.CartController.show/2\n  Parameters: %{}\n  Pipelines: [:browser]\n[debug] QUERY OK source=\"carts\" db=1.9ms idle=1798.5ms\n\n[error] #PID<0.856.0> running HelloWeb.Endpoint (connection #PID<0.841.0>, stream id 5) terminated\nServer: localhost:4000 (http)\nRequest: GET /cart\n** (exit) an exception was raised:\n    ** (UndefinedFunctionError) function HelloWeb.CartController.init/1 is undefined\n       (module HelloWeb.CartController is not available)\n       ...\n```\n\nIt's working! Kind of. If we follow the logs, we see our POST to the `/cart_items` path. Next, we can see our `ShoppingCart.add_item_to_cart` function successfully inserted a row into the `cart_items` table, and then we issued a redirect to `/cart`. Before our error, we also see a query to the `carts` table, which means we're fetching the current user's cart. So far so good. We know our `CartItem` controller and new `ShoppingCart` context functions are doing their jobs, but we've hit our next unimplemented feature when the router attempts to dispatch to a nonexistent cart controller. Let's create the cart controller, view, and template to display and manage user carts.\n\nCreate a new file at `lib/hello_web/controllers/cart_controller.ex` and key this in:\n\n```elixir\ndefmodule HelloWeb.CartController do\n  use HelloWeb, :controller\n\n  alias Hello.ShoppingCart\n\n  def show(conn, _params) do\n    render(conn, :show, changeset: ShoppingCart.change_cart(conn.assigns.cart))\n  end\nend\n```\n\nWe defined a new cart controller to handle the `get \"/cart\"` route. For showing a cart, we render a `\"show.html\"` template which we'll create in a moment. We know we need to allow the cart items to be changed by quantity updates, so right away we know we'll need a cart changeset. Fortunately, the context generator included a `ShoppingCart.change_cart/1` function, which we'll use. We pass it our cart struct which is already in the connection assigns thanks to the `fetch_current_cart` plug we defined in the router.\n\nNext, we can implement the view and template. Create a new view file at `lib/hello_web/controllers/cart_html.ex` with the following content:\n\n```elixir\ndefmodule HelloWeb.CartHTML do\n  use HelloWeb, :html\n\n  alias Hello.ShoppingCart\n\n  embed_templates \"cart_html/*\"\n\n  def currency_to_str(%Decimal{} = val), do: \"$#{Decimal.round(val, 2)}\"\nend\n```\n\nWe created a view to render our `show.html` template and aliased our `ShoppingCart` context so it will be in scope for our template. We'll need to display the cart prices like product item price, cart total, etc, so we defined a `currency_to_str/1` which takes our decimal struct, rounds it properly for display, and prepends a USD dollar sign.\n\nNext we can create the template at `lib/hello_web/controllers/cart_html/show.html.heex`:\n\n```heex\n<%= if @cart.items == [] do %>\n  <.header>\n    My Cart\n    <:subtitle>Your cart is empty</:subtitle>\n  </.header>\n<% else %>\n  <.header>\n    My Cart\n  </.header>\n\n  <.simple_form :let={f} for={@changeset} action={~p\"/cart\"}>\n    <.inputs_for :let={item_form} field={f[:items]}>\n\t<% item = item_form.data %>\n      <.input field={item_form[:quantity]} type=\"number\" label={item.product.title} />\n      <%= currency_to_str(ShoppingCart.total_item_price(item)) %>\n    </.inputs_for>\n    <:actions>\n      <.button>Update cart</.button>\n    </:actions>\n  </.simple_form>\n\n   Total : <%= currency_to_str(ShoppingCart.total_cart_price(@cart)) %>\n<% end %>\n\n<.back navigate={~p\"/products\"}>Back to products</.back>\n```\n\nWe started by showing the empty cart message if our preloaded `cart.items` is empty. If we have items, we use the `simple_form` component provided by our `HelloWeb.CoreComponents` to take our cart changeset that we assigned in the `CartController.show/2` action and create a form which maps to our cart controller `update/2` action. Within the form, we use the [`inputs_for`](`Phoenix.Component.inputs_for/1`) component to render inputs for the nested cart items. This will allow us to map item inputs back together when the form is submitted. Next, we display a number input for the item quantity and label it with the product title. We finish the item form by converting the item price to string. We haven't written the `ShoppingCart.total_item_price/1` function yet, but again we employed the idea of clear, descriptive public interfaces for our contexts. After rendering inputs for all the cart items, we show an \"update cart\" submit button, along with the total price of the entire cart. This is accomplished with another new `ShoppingCart.total_cart_price/1` function which we'll implement in a moment. Finally, we added a `back` component to go back to our products page.\n\nWe're almost ready to try out our cart page, but first we need to implement our new currency calculation functions. Open up your shopping cart context at `lib/hello/shopping_cart.ex` and add these new functions:\n\n```elixir\n  def total_item_price(%CartItem{} = item) do\n    Decimal.mult(item.product.price, item.quantity)\n  end\n\n  def total_cart_price(%Cart{} = cart) do\n    Enum.reduce(cart.items, 0, fn item, acc ->\n      item\n      |> total_item_price()\n      |> Decimal.add(acc)\n    end)\n  end\n```\n\nWe implemented `total_item_price/1` which accepts a `%CartItem{}` struct. To calculate the total price, we simply take the preloaded product's price and multiply it by the item's quantity. We used `Decimal.mult/2` to take our decimal currency struct and multiply it with proper precision. Similarly for calculating the total cart price, we implemented a `total_cart_price/1` function which accepts the cart and sums the preloaded product prices for items in the cart. We again make use of the `Decimal` functions to add our decimal structs together.\n\nNow that we can calculate price totals, let's try it out! Visit [`http://localhost:4000/cart`](http://localhost:4000/cart) and you should already see your first item in the cart. Going back to the same product and clicking \"add to cart\" will show our upsert in action. Your quantity should now be two. Nice work!\n\nOur cart page is almost complete, but submitting the form will yield yet another error.\n\n```text\nRequest: POST /cart\n** (exit) an exception was raised:\n    ** (UndefinedFunctionError) function HelloWeb.CartController.update/2 is undefined or private\n```\n\nLet's head back to our `CartController` at `lib/hello_web/controllers/cart_controller.ex` and implement the update action:\n\n```elixir\n  def update(conn, %{\"cart\" => cart_params}) do\n    case ShoppingCart.update_cart(conn.assigns.cart, cart_params) do\n      {:ok, _cart} ->\n        redirect(conn, to: ~p\"/cart\")\n\n      {:error, _changeset} ->\n        conn\n        |> put_flash(:error, \"There was an error updating your cart\")\n        |> redirect(to: ~p\"/cart\")\n    end\n  end\n```\n\nWe started by plucking out the cart params from the form submit. Next, we call our existing `ShoppingCart.update_cart/2` function which was added by the context generator. We'll need to make some changes to this function, but the interface is good as is. If the update is successful, we redirect back to the cart page, otherwise we show a flash error message and send the user back to the cart page to fix any mistakes. Out-of-the-box, our `ShoppingCart.update_cart/2` function only concerned itself with casting the cart params into a changeset and updates it against our repo. For our purposes, we now need it to handle nested cart item associations, and most importantly, business logic for how to handle quantity updates like zero-quantity items being removed from the cart.\n\nHead back over to your shopping cart context in `lib/hello/shopping_cart.ex` and replace your `update_cart/2` function with the following implementation:\n\n```elixir\n  def update_cart(%Cart{} = cart, attrs) do\n    changeset =\n      cart\n      |> Cart.changeset(attrs)\n      |> Ecto.Changeset.cast_assoc(:items, with: &CartItem.changeset/2)\n\n    Ecto.Multi.new()\n    |> Ecto.Multi.update(:cart, changeset)\n    |> Ecto.Multi.delete_all(:discarded_items, fn %{cart: cart} ->\n      from(i in CartItem, where: i.cart_id == ^cart.id and i.quantity == 0)\n    end)\n    |> Repo.transaction()\n    |> case do\n      {:ok, %{cart: cart}} -> {:ok, cart}\n      {:error, :cart, changeset, _changes_so_far} -> {:error, changeset}\n    end\n  end\n```\n\nWe started much like how our out-of-the-box code started – we take the cart struct and cast the user input to a cart changeset, except this time we use `Ecto.Changeset.cast_assoc/3` to cast the nested item data into `CartItem` changesets. Remember the [`<.inputs_for />`](`Phoenix.Component.inputs_for/1`) call in our cart form template? That hidden ID data is what allows Ecto's `cast_assoc` to map item data back to existing item associations in the cart. Next we use `Ecto.Multi.new/0`, which you may not have seen before. Ecto's `Multi` is a feature that allows lazily defining a chain of named operations to eventually execute inside a database transaction. Each operation in the multi chain receives the values from the previous steps and executes until a failed step is encountered. When an operation fails, the transaction is rolled back and an error is returned, otherwise the transaction is committed.\n\nFor our multi operations, we start by issuing an update of our cart, which we named `:cart`. After the cart update is issued, we perform a multi `delete_all` operation, which takes the updated cart and applies our zero-quantity logic. We prune any items in the cart with zero quantity by returning an ecto query that finds all cart items for this cart with an empty quantity. Calling `Repo.transaction/1` with our multi will execute the operations in a new transaction and we return the success or failure result to the caller just like the original function.\n\nLet's head back to the browser and try it out. Add a few products to your cart, update the quantities, and watch the values changes along with the price calculations. Setting any quantity to 0 will also remove the item. Pretty neat!","ref":"contexts.html#adding-shopping-cart-functions"},{"type":"extras","title":"Adding an Orders context - Contexts","doc":"With our `Catalog` and `ShoppingCart` contexts, we're seeing first-hand how our well-considered modules and function names are yielding clear and maintainable code. Our last order of business is to allow the user to initiate the checkout process. We won't go as far as integrating payment processing or order fulfillment, but we'll get you started in that direction. Like before, we need to decide where code for completing an order should live. Is it part of the catalog? Clearly not, but what about the shopping cart? Shopping carts are related to orders – after all, the user has to add items in order to purchase any products – but should the order checkout process be grouped here?\n\nIf we stop and consider the order process, we'll see that orders involve related, but distinctly different data from the cart contents. Also, business rules around the checkout process are much different than carting. For example, we may allow a user to add a back-ordered item to their cart, but we could not allow an order with no inventory to be completed. Additionally, we need to capture point-in-time product information when an order is completed, such as the price of the items *at payment transaction time*. This is essential because a product price may change in the future, but the line items in our order must always record and display what we charged at time of purchase. For these reasons, we can start to see that ordering can stand on its own with its own data concerns and business rules.\n\nNaming wise, `Orders` clearly defines the scope of our context, so let's get started by again taking advantage of the context generators. Run the following command in your console:\n\n```console\n$ mix phx.gen.context Orders Order orders user_uuid:uuid total_price:decimal\n\n* creating lib/hello/orders/order.ex\n* creating priv/repo/migrations/20210209214612_create_orders.exs\n* creating lib/hello/orders.ex\n* injecting lib/hello/orders.ex\n* creating test/hello/orders_test.exs\n* injecting test/hello/orders_test.exs\n* creating test/support/fixtures/orders_fixtures.ex\n* injecting test/support/fixtures/orders_fixtures.ex\n\nRemember to update your repository by running migrations:\n\n    $ mix ecto.migrate\n```\n\nWe generated an `Orders` context. We added a `user_uuid` field to associate our placeholder current user to an order, along with a `total_price` column. With our starting point in place, let's open up the newly created migration in `priv/repo/migrations/*_create_orders.exs` and make the following changes:\n\n```elixir\n  def change do\n    create table(:orders) do\n      add :user_uuid, :uuid\n-     add :total_price, :decimal\n+     add :total_price, :decimal, precision: 15, scale: 6, null: false\n\n      timestamps()\n    end\n  end\n```\n\nLike we did previously, we gave appropriate precision and scale options for our decimal column which will allow us to store currency without precision loss. We also added a not-null constraint to enforce all orders to have a price.\n\nThe orders table alone doesn't hold much information, but we know we'll need to store point-in-time product price information of all the items in the order. For that, we'll add an additional struct for this context named `LineItem`. Line items will capture the price of the product *at payment transaction time*. Please run the following command:\n\n```console\n$ mix phx.gen.context Orders LineItem order_line_items \\\nprice:decimal quantity:integer \\\norder_id:references:orders product_id:references:products\n\nYou are generating into an existing context.\n...\nWould you like to proceed? [Yn] y\n* creating lib/hello/orders/line_item.ex\n* creating priv/repo/migrations/20210209215050_create_order_line_items.exs\n* injecting lib/hello/orders.ex\n* injecting test/hello/orders_test.exs\n* injecting test/support/fixtures/orders_fixtures.ex\n\nRemember to update your repository by running migrations:\n\n    $ mix ecto.migrate\n```\n\nWe used the `phx.gen.context` command to generate the `LineItem` Ecto schema and inject supporting functions into our orders context. Like before, let's modify the migration in `priv/repo/migrations/*_create_order_line_items.exs` and make the following decimal field changes:\n\n```elixir\n  def change do\n    create table(:order_line_items) do\n-     add :price, :decimal\n+     add :price, :decimal, precision: 15, scale: 6, null: false\n      add :quantity, :integer\n      add :order_id, references(:orders, on_delete: :nothing)\n      add :product_id, references(:products, on_delete: :nothing)\n\n      timestamps()\n    end\n\n    create index(:order_line_items, [:order_id])\n    create index(:order_line_items, [:product_id])\n  end\n```\n\nWith our migration in place, let's wire up our orders and line items associations in `lib/hello/orders/order.ex`:\n\n```elixir\n  schema \"orders\" do\n    field :total_price, :decimal\n    field :user_uuid, Ecto.UUID\n\n+   has_many :line_items, Hello.Orders.LineItem\n+   has_many :products, through: [:line_items, :product]\n\n    timestamps()\n  end\n```\n\nWe used `has_many :line_items` to associate orders and line items, just like we've seen before. Next, we used the `:through` feature of `has_many`, which allows us to instruct ecto how to associate resources across another relationship. In this case, we can associate products of an order by finding all products through associated line items. Next, let's wire up the association in the other direction in `lib/hello/orders/line_item.ex`:\n\n```elixir\n  schema \"order_line_items\" do\n    field :price, :decimal\n    field :quantity, :integer\n-   field :order_id, :id\n-   field :product_id, :id\n\n+   belongs_to :order, Hello.Orders.Order\n+   belongs_to :product, Hello.Catalog.Product\n\n    timestamps()\n  end\n```\n\nWe used `belongs_to` to associate line items to orders and products. With our associations in place, we can start integrating the web interface into our order process. Open up your router `lib/hello_web/router.ex` and add the following line:\n\n```elixir\n  scope \"/\", HelloWeb do\n    pipe_through :browser\n\n    ...\n+   resources \"/orders\", OrderController, only: [:create, :show]\n  end\n```\n\nWe wired up `create` and `show` routes for our generated `OrderController`, since these are the only actions we need at the moment. With our routes in place, we can now migrate up:\n\n```console\n$ mix ecto.migrate\n\n17:14:37.715 [info] == Running 20210209214612 Hello.Repo.Migrations.CreateOrders.change/0 forward\n\n17:14:37.720 [info] create table orders\n\n17:14:37.755 [info] == Migrated 20210209214612 in 0.0s\n\n17:14:37.784 [info] == Running 20210209215050 Hello.Repo.Migrations.CreateOrderLineItems.change/0 forward\n\n17:14:37.785 [info] create table order_line_items\n\n17:14:37.795 [info] create index order_line_items_order_id_index\n\n17:14:37.796 [info] create index order_line_items_product_id_index\n\n17:14:37.798 [info] == Migrated 20210209215050 in 0.0s\n```\n\nBefore we render information about our orders, we need to ensure our order data is fully populated and can be looked up by a current user. Open up your orders context in `lib/hello/orders.ex` and replace your `get_order!/1` function by a new `get_order!/2` definition:\n\n```elixir\n  def get_order!(user_uuid, id) do\n    Order\n    |> Repo.get_by!(id: id, user_uuid: user_uuid)\n    |> Repo.preload([line_items: [:product]])\n  end\n```\n\nWe rewrote the function to accept a user UUID and query our repo for an order matching the user's ID for a given order ID. Then we populated the order by preloading our line item and product associations.\n\nTo complete an order, our cart page can issue a POST to the `OrderController.create` action, but we need to implement the operations and logic to actually complete an order. Like before, we'll start at the web interface. Create a new file at `lib/hello_web/controllers/order_controller.ex` and key this in:\n\n```elixir\ndefmodule HelloWeb.OrderController do\n  use HelloWeb, :controller\n\n  alias Hello.Orders\n\n  def create(conn, _) do\n    case Orders.complete_order(conn.assigns.cart) do\n      {:ok, order} ->\n        conn\n        |> put_flash(:info, \"Order created successfully.\")\n        |> redirect(to: ~p\"/orders/#{order}\")\n\n      {:error, _reason} ->\n        conn\n        |> put_flash(:error, \"There was an error processing your order\")\n        |> redirect(to: ~p\"/cart\")\n    end\n  end\nend\n```\n\nWe wrote the `create` action to call an as-yet-implemented `Orders.complete_order/1` function. Our code is technically \"creating\" an order, but it's important to step back and consider the naming of your interfaces. The act of *completing* an order is extremely important in our system. Money changes hands in a transaction, physical goods could be automatically shipped, etc. Such an operation deserves a better, more obvious function name, such as `complete_order`. If the order is completed successfully we redirect to the show page, otherwise a flash error is shown as we redirect back to the cart page.\n\nHere is also a good opportunity to highlight that contexts can naturally work with data defined by other contexts too. This will be especially common with data that is used throughout the application, such as the cart here (but it can also be the current user or the current project, and so forth, depending on your project).\n\nNow we can implement our `Orders.complete_order/1` function. To complete an order, our job will require a few operations:\n\n  1. A new order record must be persisted with the total price of the order\n  2. All items in the cart must be transformed into new order line items records\n    with quantity and point-in-time product price information\n  3. After successful order insert (and eventual payment), items must be pruned\n    from the cart\n\nFrom our requirements alone, we can start to see why a generic `create_order` function doesn't cut it. Let's implement this new function in `lib/hello/orders.ex`:\n\n```elixir\n  alias Hello.Orders.LineItem\n  alias Hello.ShoppingCart\n\n  def complete_order(%ShoppingCart.Cart{} = cart) do\n    line_items =\n      Enum.map(cart.items, fn item ->\n        %{product_id: item.product_id, price: item.product.price, quantity: item.quantity}\n      end)\n\n    order =\n      Ecto.Changeset.change(%Order{},\n        user_uuid: cart.user_uuid,\n        total_price: ShoppingCart.total_cart_price(cart),\n        line_items: line_items\n      )\n\n    Ecto.Multi.new()\n    |> Ecto.Multi.insert(:order, order)\n    |> Ecto.Multi.run(:prune_cart, fn _repo, _changes ->\n      ShoppingCart.prune_cart_items(cart)\n    end)\n    |> Repo.transaction()\n    |> case do\n      {:ok, %{order: order}} -> {:ok, order}\n      {:error, name, value, _changes_so_far} -> {:error, {name, value}}\n    end\n  end\n```\n\nWe started by mapping the `%ShoppingCart.CartItem{}`'s in our shopping cart into a map of order line items structs. The job of the order line item record is to capture the price of the product *at payment transaction time*, so we reference the product's price here. Next, we create a bare order changeset with `Ecto.Changeset.change/2` and associate our user UUID, set our total price calculation, and place our order line items in the changeset. With a fresh order changeset ready to be inserted, we can again make use of `Ecto.Multi` to execute our operations in a database transaction. We start by inserting the order, followed by a `run` operation. The `Ecto.Multi.run/3` function allows us to run any code in the function which must either succeed with `{:ok, result}` or error, which halts and rolls back the transaction. Here, we simply call into our shopping cart context and ask it to prune all items in a cart. Running the transaction will execute the multi as before and we return the result to the caller.\n\nTo close out our order completion, we need to implement the `ShoppingCart.prune_cart_items/1` function in `lib/hello/shopping_cart.ex`:\n\n```elixir\n  def prune_cart_items(%Cart{} = cart) do\n    {_, _} = Repo.delete_all(from(i in CartItem, where: i.cart_id == ^cart.id))\n    {:ok, reload_cart(cart)}\n  end\n```\n\nOur new function accepts the cart struct and issues a `Repo.delete_all` which accepts a query of all items for the provided cart. We return a success result by simply reloading the pruned cart to the caller. With our context complete, we now need to show the user their completed order. Head back to your order controller and add the `show/2` action:\n\n```elixir\n  def show(conn, %{\"id\" => id}) do\n    order = Orders.get_order!(conn.assigns.current_uuid, id)\n    render(conn, :show, order: order)\n  end\n```\n\nWe added the show action to pass our `conn.assigns.current_uuid` to `get_order!` which authorizes orders to be viewable only by the owner of the order. Next, we can implement the view and template. Create a new view file at `lib/hello_web/controllers/order_html.ex` with the following content:\n\n```elixir\ndefmodule HelloWeb.OrderHTML do\n  use HelloWeb, :html\n\n  embed_templates \"order_html/*\"\nend\n```\nNext we can create the template at `lib/hello_web/controllers/order_html/show.html.heex`:\n\n```heex\n<.header>\n  Thank you for your order!\n  <:subtitle>\n      User uuid:  <%= @order.user_uuid %>\n  </:subtitle>\n</.header>\n\n<.table id=\"items\" rows={@order.line_items}>\n  <:col :let={item} label=\"Title\"><%= item.product.title %></:col>\n  <:col :let={item} label=\"Quantity\"><%= item.quantity %></:col>\n  <:col :let={item} label=\"Price\">\n    <%= HelloWeb.CartHTML.currency_to_str(item.price) %>\n  </:col>\n</.table>\n\n Total price: \n<%= HelloWeb.CartHTML.currency_to_str(@order.total_price) %>\n\n<.back navigate={~p\"/products\"}>Back to products</.back>\n```\n\nTo show our completed order, we displayed the order's user, followed by the line item listing with product title, quantity, and the price we \"transacted\" when completing the order, along with the total price.\n\nOur last addition will be to add the \"complete order\" button to our cart page to allow completing an order. Add the following button to the <.header> of the cart show template in `lib/hello_web/controllers/cart_html/show.html.heex`:\n\n```diff\n  <.header>\n    My Cart\n+    <:actions>\n+      <.link href={~p\"/orders\"} method=\"post\">\n+        <.button>Complete order</.button>\n+      </.link>\n+    </:actions>\n  </.header>\n```\n\nWe added a link with `method=\"post\"` to send a POST request to our `OrderController.create` action. If we head back to our cart page at [`http://localhost:4000/cart`](http://localhost:4000/cart) and complete an order, we'll be greeted by our rendered template:\n\n```text\nThank you for your order!\n\nUser uuid: 08964c7c-908c-4a55-bcd3-9811ad8b0b9d\nTitle                   Quantity Price\nMetaprogramming Elixir  2        $15.00\n\nTotal price: $30.00\n```\n\nNice work! We haven't added payments, but we can already see how our `ShoppingCart` and `Orders` context splitting is driving us towards a maintainable solution. With our cart items separated from our order line items, we are well equipped in the future to add payment transactions, cart price detection, and more.\n\nGreat work!","ref":"contexts.html#adding-an-orders-context"},{"type":"extras","title":"FAQ - Contexts","doc":"","ref":"contexts.html#faq"},{"type":"extras","title":"When to use code generators? - Contexts","doc":"In this guide, we have used code generators for schemas, contexts, controllers, and more. If you are happy to move forward with Phoenix defaults, feel free to rely on generators to scaffold large parts of your application. When using Phoenix generators, the main question you need to answer is: does this new functionality (with its schema, table, and fields) belong to one of the existing contexts or a new one?\n\nThis way, Phoenix generators guide you to use contexts to group related functionality, instead of having several dozens of schemas laying around without any structure. And remember: if you're stuck when trying to come up with a context name, you can simply use the plural form of the resource you're creating.","ref":"contexts.html#when-to-use-code-generators"},{"type":"extras","title":"How do I structure code inside contexts? - Contexts","doc":"You may wonder how to organize the code inside contexts. For example, should you define a module for changesets (such as ProductChangesets) and another module for queries (such as ProductQueries)?\n\nOne important benefit of contexts is that this decision does not matter much. The context is your public API, the other modules are private. Contexts isolate these modules into small groups so the surface area of your application is the context and not _all of your code_.\n\nSo while you and your team could establish patterns for organizing these private modules, it is also our opinion it is completely fine for them to be different. The major focus should be on how the contexts are defined and how they interact with each other (and with your web application).\n\nThink about it as a well-kept neighbourhood. Your contexts are houses, you want to keep them well-preserved, well-connected, etc. Inside the houses, they may all be a little bit different, and that's fine.","ref":"contexts.html#how-do-i-structure-code-inside-contexts"},{"type":"extras","title":"Returning Ecto structures from context APIs - Contexts","doc":"As we explored the context API, you might have wondered:\n\n> If one of the goals of our context is to encapsulate Ecto Repo access, why does `create_user/1` return an `Ecto.Changeset` struct when we fail to create a user?\n\nAlthough Changesets are part of Ecto, they are not tied to the database, and they can be used to map data from and to any source, which makes it a general and useful data structure for tracking field changes, perform validations, and generate error messages.\n\nFor those reasons, `%Ecto.Changeset{}` is a good choice to model the data changes between your contexts and your web layer - regardless if you are talking to an API or the database.\n\nFinally, note that your controllers and views are not hardcoded to work exclusively with Ecto either. Instead, Phoenix defines protocols such as `Phoenix.Param` and `Phoenix.HTML.FormData`, which allow any library to extend how Phoenix generates URL parameters or renders forms. Conveniently for us, the `phoenix_ecto` project implements those protocols, but you could as well bring your own data structures and implement them yourself.","ref":"contexts.html#returning-ecto-structures-from-context-apis"},{"type":"extras","title":"JSON and APIs","doc":"# JSON and APIs\n\n> **Requirement**: This guide expects that you have gone through the [introductory guides](installation.html) and got a Phoenix application [up and running](up_and_running.html).\n\n> **Requirement**: This guide expects that you have gone through the [Controllers guide](controllers.html).\n\nYou can also use the Phoenix Framework to build [Web APIs](https://en.wikipedia.org/wiki/Web_API). By default Phoenix supports JSON but you can bring any other rendering format you desire.","ref":"json_and_apis.html"},{"type":"extras","title":"The JSON API - JSON and APIs","doc":"For this guide let's create a simple JSON API to store our favourite links, that will support all the CRUD (Create, Read, Update, Delete) operations out of the box.\n\nFor this guide, we will use Phoenix generators to scaffold our API infrastructure:\n\n```console\nmix phx.gen.json Urls Url urls link:string title:string\n* creating lib/hello_web/controllers/url_controller.ex\n* creating lib/hello_web/controllers/url_json.ex\n* creating lib/hello_web/controllers/changeset_json.ex\n* creating test/hello_web/controllers/url_controller_test.exs\n* creating lib/hello_web/controllers/fallback_controller.ex\n* creating lib/hello/urls/url.ex\n* creating priv/repo/migrations/20221129120234_create_urls.exs\n* creating lib/hello/urls.ex\n* injecting lib/hello/urls.ex\n* creating test/hello/urls_test.exs\n* injecting test/hello/urls_test.exs\n* creating test/support/fixtures/urls_fixtures.ex\n* injecting test/support/fixtures/urls_fixtures.ex\n```\n\nWe will break those files into four categories:\n\n  * Files in `lib/hello_web` responsible for effectively rendering JSON\n  * Files in `lib/hello` responsible for defining our context and logic to persist links to the database\n  * Files in `priv/repo/migrations` responsible for updating our database\n  * Files in `test` to test our controllers and contexts\n\nIn this guide, we will explore only the first category of files. To learn more about how Phoenix stores and manage data, check out [the Ecto guide](ecto.md) and [the Contexts guide](contexts.md) for more information. We also have a whole section dedicated to testing.\n\nAt the end, the generator asks us to add the `/url` resource to our `:api` scope in `lib/hello_web/router.ex`:\n\n```elixir\nscope \"/api\", HelloWeb do\n  pipe_through :api\n  resources \"/urls\", UrlController, except: [:new, :edit]\nend\n```\n\nThe API scope uses the `:api` pipeline, which will run specific steps such as ensuring the client can handle JSON responses.\n\nThen we need to update our repository by running migrations:\n\n```console\nmix ecto.migrate\n```","ref":"json_and_apis.html#the-json-api"},{"type":"extras","title":"Trying out the JSON API - JSON and APIs","doc":"Before we go ahead and change those files, let's take a look at how our API behaves from the command line.\n\nFirst, we need to start the server:\n\n```console\nmix phx.server\n```\n\nNext, let's make a smoke test to check our API is working with:\n\n```console\ncurl -i http://localhost:4000/api/urls\n```\n\nIf everything went as planned we should get a `200` response:\n\n```console\nHTTP/1.1 200 OK\ncache-control: max-age=0, private, must-revalidate\ncontent-length: 11\ncontent-type: application/json; charset=utf-8\ndate: Fri, 06 May 2022 21:22:42 GMT\nserver: Cowboy\nx-request-id: Fuyg-wMl4S-hAfsAAAUk\n\n{\"data\":[]}\n```\n\nWe didn't get any data because we haven't populated the database with any yet. So let's add some links:\n\n```console\ncurl -iX POST http://localhost:4000/api/urls \\\n   -H 'Content-Type: application/json' \\\n   -d '{\"url\": {\"link\":\"https://phoenixframework.org\", \"title\":\"Phoenix Framework\"}}'\n\ncurl -iX POST http://localhost:4000/api/urls \\\n   -H 'Content-Type: application/json' \\\n   -d '{\"url\": {\"link\":\"https://elixir-lang.org\", \"title\":\"Elixir\"}}'\n```\n\nNow we can retrieve all links:\n\n```console\ncurl -i http://localhost:4000/api/urls\n```\n\nOr we can just retrieve a link by its `id`:\n\n```console\ncurl -i http://localhost:4000/api/urls/1\n```\n\nNext, we can update a link with:\n\n```console\ncurl -iX PUT http://localhost:4000/api/urls/2 \\\n   -H 'Content-Type: application/json' \\\n   -d '{\"url\": {\"title\":\"Elixir Programming Language\"}}'\n```\n\nThe response should be a `200` with the updated link in the body.\n\nFinally, we need to try out the removal of a link:\n\n```console\ncurl -iX DELETE http://localhost:4000/api/urls/2 \\\n   -H 'Content-Type: application/json'\n```\n\nA `204` response should be returned to indicate the successful removal of the link.","ref":"json_and_apis.html#trying-out-the-json-api"},{"type":"extras","title":"Rendering JSON - JSON and APIs","doc":"To understand how to render JSON, let's start with the `index` action from `UrlController` defined at `lib/hello_web/controllers/url_controller.ex`:\n\n```elixir\n  def index(conn, _params) do\n    urls = Urls.list_urls()\n    render(conn, :index, urls: urls)\n  end\n```\n\nAs we can see, this is not any different from how Phoenix renders HTML templates. We call `render/3`, passing the connection, the template we want our views to render (`:index`), and the data we want to make available to our views.\n\nPhoenix typically uses one view per rendering format. When rendering HTML, we would use `UrlHTML`. Now that we are rendering JSON, we will find a `UrlJSON` view collocated with the template at `lib/hello_web/controllers/url_json.ex`. Let's open it up:\n\n```elixir\ndefmodule HelloWeb.UrlJSON do\n  alias Hello.Urls.Url\n\n  @doc \"\"\"\n  Renders a list of urls.\n  \"\"\"\n  def index(%{urls: urls}) do\n    %{data: for(url <- urls, do: data(url))}\n  end\n\n  @doc \"\"\"\n  Renders a single url.\n  \"\"\"\n  def show(%{url: url}) do\n    %{data: data(url)}\n  end\n\n  defp data(%Url{} = url) do\n    %{\n      id: url.id,\n      link: url.link,\n      title: url.title\n    }\n  end\nend\n```\n\nThis view is very simple. The `index` function receives all URLs, and converts them into a list of maps. Those maps are placed inside the data key at the root, exactly as we saw when interfacing with our application from `cURL`. In other words, our JSON view converts our complex data into simple Elixir data-structures. Once our view layer returns, Phoenix uses the `Jason` library to encode JSON and send the response to the client.\n\nIf you explore the remaining the controller, you will learn the `show` action is similar to the `index` one. For `create`, `update`, and `delete` actions, Phoenix uses one other important feature, called \"Action fallback\".","ref":"json_and_apis.html#rendering-json"},{"type":"extras","title":"Action fallback - JSON and APIs","doc":"Action fallback allows us to centralize error handling code in plugs, which are called when a controller action fails to return a [`%Plug.Conn{}`](`t:Plug.Conn.t/0`) struct. These plugs receive both the `conn` which was originally passed to the controller action along with the return value of the action.\n\nLet's say we have a `show` action which uses [`with`](`with/1`) to fetch a blog post and then authorize the current user to view that blog post. In this example we might expect `fetch_post/1` to return `{:error, :not_found}` if the post is not found and `authorize_user/3` might return `{:error, :unauthorized}` if the user is unauthorized. We could use our `ErrorHTML` and `ErrorJSON` views which are generated by Phoenix for every new application to handle these error paths accordingly:\n\n```elixir\ndefmodule HelloWeb.MyController do\n  use Phoenix.Controller\n\n  def show(conn, %{\"id\" => id}, current_user) do\n    with {:ok, post} <- fetch_post(id),\n         :ok <- authorize_user(current_user, :view, post) do\n      render(conn, :show, post: post)\n    else\n      {:error, :not_found} ->\n        conn\n        |> put_status(:not_found)\n        |> put_view(html: HelloWeb.ErrorHTML, json: HelloWeb.ErrorJSON)\n        |> render(:\"404\")\n\n      {:error, :unauthorized} ->\n        conn\n        |> put_status(403)\n        |> put_view(html: HelloWeb.ErrorHTML, json: HelloWeb.ErrorJSON)\n        |> render(:\"403\")\n    end\n  end\nend\n```\n\nNow imagine you may need to implement similar logic for every controller and action handled by your API. This would result in a lot of repetition.\n\nInstead we can define a module plug which knows how to handle these error cases specifically. Since controllers are module plugs, let's define our plug as a controller:\n\n```elixir\ndefmodule HelloWeb.MyFallbackController do\n  use Phoenix.Controller\n\n  def call(conn, {:error, :not_found}) do\n    conn\n    |> put_status(:not_found)\n    |> put_view(json: HelloWeb.ErrorJSON)\n    |> render(:\"404\")\n  end\n\n  def call(conn, {:error, :unauthorized}) do\n    conn\n    |> put_status(403)\n    |> put_view(json: HelloWeb.ErrorJSON)\n    |> render(:\"403\")\n  end\nend\n```\n\nThen we can reference our new controller as the `action_fallback` and simply remove the `else` block from our `with`:\n\n```elixir\ndefmodule HelloWeb.MyController do\n  use Phoenix.Controller\n\n  action_fallback HelloWeb.MyFallbackController\n\n  def show(conn, %{\"id\" => id}, current_user) do\n    with {:ok, post} <- fetch_post(id),\n         :ok <- authorize_user(current_user, :view, post) do\n      render(conn, :show, post: post)\n    end\n  end\nend\n```\n\nWhenever the `with` conditions do not match, `HelloWeb.MyFallbackController` will receive the original `conn` as well as the result of the action and respond accordingly.","ref":"json_and_apis.html#action-fallback"},{"type":"extras","title":"FallbackController and ChangesetJSON - JSON and APIs","doc":"With this knowledge in hand, we can explore the `FallbackController` (`lib/hello_web/controllers/fallback_controller.ex`) generated by `mix phx.gen.json`. In particular, it handles one clause (the other is generated as an example):\n\n```elixir\n  def call(conn, {:error, %Ecto.Changeset{} = changeset}) do\n    conn\n    |> put_status(:unprocessable_entity)\n    |> put_view(json: HelloWeb.ChangesetJSON)\n    |> render(:error, changeset: changeset)\n  end\n```\n\nThe goal of this clause is to handle the `{:error, changeset}` return types from the `HelloWeb.Urls` context and render them into rendered errors via the `ChangesetJSON` view. Let's open up `lib/hello_web/controllers/changeset_json.ex` to learn more:\n\n```elixir\ndefmodule HelloWeb.ChangesetJSON do\n  @doc \"\"\"\n  Renders changeset errors.\n  \"\"\"\n  def error(%{changeset: changeset}) do\n    # When encoded, the changeset returns its errors\n    # as a JSON object. So we just pass it forward.\n    %{errors: Ecto.Changeset.traverse_errors(changeset, &translate_error/1)}\n  end\nend\n```\n\nAs we can see, it will convert the errors into a data structure, which will be rendered as JSON. The changeset is a data structure responsible for casting and validating data. For our example, it is defined in `Hello.Urls.Url.changeset/1`. Let's open up `lib/hello/urls/url.ex` and see its definition:\n\n```elixir\n  @doc false\n  def changeset(url, attrs) do\n    url\n    |> cast(attrs, [:link, :title])\n    |> validate_required([:link, :title])\n  end\n```\n\nAs you can see, the changeset requires both link and title to be given. This means we can try posting a url with no link and title and see how our API responds:\n\n```console\ncurl -iX POST http://localhost:4000/api/urls \\\n   -H 'Content-Type: application/json' \\\n   -d '{\"url\": {}}'\n\n{\"errors\": {\"link\": [\"can't be blank\"], \"title\": [\"can't be blank\"]}}\n```\n\nFeel free to modify the `changeset` function and see how your API behaves.","ref":"json_and_apis.html#fallbackcontroller-and-changesetjson"},{"type":"extras","title":"API-only applications - JSON and APIs","doc":"In case you want to generate a Phoenix application exclusively for APIs, you can pass\nseveral options when invoking `mix phx.new`. Let's check which `--no-*` flags we need\nto use to not generate the scaffolding that isn't necessary on our Phoenix application\nfor the REST API.\n\nFrom your terminal run:\n\n```console\nmix help phx.new\n```\n\nThe output should contain the following:\n\n```text\n  • --no-assets - equivalent to --no-esbuild and --no-tailwind\n  • --no-dashboard - do not include Phoenix.LiveDashboard\n  • --no-ecto - do not generate Ecto files\n  • --no-esbuild - do not include esbuild dependencies and\n    assets. We do not recommend setting this option, unless for API\n    only applications, as doing so requires you to manually add and\n    track JavaScript dependencies\n  • --no-gettext - do not generate gettext files\n  • --no-html - do not generate HTML views\n  • --no-live - comment out LiveView socket setup in your Endpoint\n    and assets/js/app.js. Automatically disabled if --no-html is given\n  • --no-mailer - do not generate Swoosh mailer files\n  • --no-tailwind - do not include tailwind dependencies and\n    assets. The generated markup will still include Tailwind CSS\n    classes, those are left-in as reference for the subsequent\n    styling of your layout and components\n```\n\nThe `--no-html` is the obvious one we want to use when creating any Phoenix application for an API in order to leave out all the unnecessary HTML scaffolding. You may also pass `--no-assets`, if you don't want any of the asset management bit, `--no-gettext` if you don't support internationalization, and so on.\n\nAlso bear in mind that nothing stops you to have a backend that supports simultaneously the REST API and a Web App (HTML, assets, internationalization and sockets).","ref":"json_and_apis.html#api-only-applications"},{"type":"extras","title":"Mix tasks","doc":"# Mix tasks\n\nThere are currently a number of built-in Phoenix-specific and Ecto-specific [Mix tasks](`Mix.Task`) available to us within a newly-generated application. We can also create our own application specific tasks.\n\n> Note to learn more about `mix`, you can read Elixir's official [Introduction to Mix](https://hexdocs.pm/elixir/introduction-to-mix.html).","ref":"mix_tasks.html"},{"type":"extras","title":"Phoenix tasks - Mix tasks","doc":"```console\n$ mix help --search \"phx\"\nmix local.phx          # Updates the Phoenix project generator locally\nmix phx                # Prints Phoenix help information\nmix phx.digest         # Digests and compresses static files\nmix phx.digest.clean   # Removes old versions of static assets.\nmix phx.gen.auth       # Generates authentication logic for a resource\nmix phx.gen.cert       # Generates a self-signed certificate for HTTPS testing\nmix phx.gen.channel    # Generates a Phoenix channel\nmix phx.gen.context    # Generates a context with functions around an Ecto schema\nmix phx.gen.embedded   # Generates an embedded Ecto schema file\nmix phx.gen.html       # Generates controller, views, and context for an HTML resource\nmix phx.gen.json       # Generates controller, views, and context for a JSON resource\nmix phx.gen.live       # Generates LiveView, templates, and context for a resource\nmix phx.gen.notifier   # Generates a notifier that delivers emails by default\nmix phx.gen.presence   # Generates a Presence tracker\nmix phx.gen.schema     # Generates an Ecto schema and migration file\nmix phx.gen.secret     # Generates a secret\nmix phx.gen.socket     # Generates a Phoenix socket handler\nmix phx.new            # Creates a new Phoenix application\nmix phx.new.ecto       # Creates a new Ecto project within an umbrella project\nmix phx.new.web        # Creates a new Phoenix web project within an umbrella project\nmix phx.routes         # Prints all routes\nmix phx.server         # Starts applications and their servers\n```\n\nWe have seen all of these at one point or another in the guides, but having all the information about them in one place seems like a good idea.\n\nWe will cover all Phoenix Mix tasks, except `phx.new`, `phx.new.ecto`, and `phx.new.web`, which are part of the Phoenix installer. You can learn more about them or any other task by calling `mix help TASK`.\n\n### `mix phx.gen.html`\n\nPhoenix offers the ability to generate all the code to stand up a complete HTML resource — Ecto migration, Ecto context, controller with all the necessary actions, view, and templates. This can be a tremendous time saver. Let's take a look at how to make this happen.\n\nThe `mix phx.gen.html` task takes the following arguments: the module name of the context, the module name of the schema, the resource name, and a list of column_name:type attributes. The module name we pass in must conform to the Elixir rules of module naming, following proper capitalization.\n\n```console\n$ mix phx.gen.html Blog Post posts body:string word_count:integer\n* creating lib/hello_web/controllers/post_controller.ex\n* creating lib/hello_web/controllers/post_html/edit.html.heex\n* creating lib/hello_web/controllers/post_html/post_form.html.heex\n* creating lib/hello_web/controllers/post_html/index.html.heex\n* creating lib/hello_web/controllers/post_html/new.html.heex\n* creating lib/hello_web/controllers/post_html/show.html.heex\n* creating lib/hello_web/controllers/post_html.ex\n* creating test/hello_web/controllers/post_controller_test.exs\n* creating lib/hello/blog/post.ex\n* creating priv/repo/migrations/20211001233016_create_posts.exs\n* creating lib/hello/blog.ex\n* injecting lib/hello/blog.ex\n* creating test/hello/blog_test.exs\n* injecting test/hello/blog_test.exs\n* creating test/support/fixtures/blog_fixtures.ex\n* injecting test/support/fixtures/blog_fixtures.ex\n```\n\nWhen `mix phx.gen.html` is done creating files, it helpfully tells us that we need to add a line to our router file as well as run our Ecto migrations.\n\n```console\nAdd the resource to your browser scope in lib/hello_web/router.ex:\n\n    resources \"/posts\", PostController\n\nRemember to update your repository by running migrations:\n\n    $ mix ecto.migrate\n```\n\nImportant: If we don't do this, we will see the following warnings in our logs, and our application will error when compiling.\n\n```console\n$ mix phx.server\nCompiling 17 files (.ex)\n\nwarning: no route path for HelloWeb.Router matches \\\"/posts\\\"\n  lib/hello_web/controllers/post_controller.ex:22: HelloWeb.PostController.index/2\n```\n\nIf we don't want to create a context or schema for our resource we can use the `--no-context` flag. Note that this still requires a context module name as a parameter.\n\n```console\n$ mix phx.gen.html Blog Post posts body:string word_count:integer --no-context\n* creating lib/hello_web/controllers/post_controller.ex\n* creating lib/hello_web/controllers/post_html/edit.html.heex\n* creating lib/hello_web/controllers/post_html/post_form.html.heex\n* creating lib/hello_web/controllers/post_html/index.html.heex\n* creating lib/hello_web/controllers/post_html/new.html.heex\n* creating lib/hello_web/controllers/post_html/show.html.heex\n* creating lib/hello_web/controllers/post_html.ex\n* creating test/hello_web/controllers/post_controller_test.exs\n```\n\nIt will tell us we need to add a line to our router file, but since we skipped the context, it won't mention anything about `ecto.migrate`.\n\n```console\nAdd the resource to your browser scope in lib/hello_web/router.ex:\n\n    resources \"/posts\", PostController\n```\n\nSimilarly, if we want a context created without a schema for our resource we can use the `--no-schema` flag.\n\n```console\n$ mix phx.gen.html Blog Post posts body:string word_count:integer --no-schema\n* creating lib/hello_web/controllers/post_controller.ex\n* creating lib/hello_web/controllers/post_html/edit.html.heex\n* creating lib/hello_web/controllers/post_html/post_form.html.heex\n* creating lib/hello_web/controllers/post_html/index.html.heex\n* creating lib/hello_web/controllers/post_html/new.html.heex\n* creating lib/hello_web/controllers/post_html/show.html.heex\n* creating lib/hello_web/controllers/post_html.ex\n* creating test/hello_web/controllers/post_controller_test.exs\n* creating lib/hello/blog.ex\n* injecting lib/hello/blog.ex\n* creating test/hello/blog_test.exs\n* injecting test/hello/blog_test.exs\n* creating test/support/fixtures/blog_fixtures.ex\n* injecting test/support/fixtures/blog_fixtures.ex\n```\n\nIt will tell us we need to add a line to our router file, but since we skipped the schema, it won't mention anything about `ecto.migrate`.\n\n### `mix phx.gen.json`\n\nPhoenix also offers the ability to generate all the code to stand up a complete JSON resource — Ecto migration, Ecto schema, controller with all the necessary actions and view. This command will not create any template for the app.\n\nThe `mix phx.gen.json` task takes the following arguments: the module name of the context, the module name of the schema, the resource name, and a list of column_name:type attributes. The module name we pass in must conform to the Elixir rules of module naming, following proper capitalization.\n\n```console\n$ mix phx.gen.json Blog Post posts title:string content:string\n* creating lib/hello_web/controllers/post_controller.ex\n* creating lib/hello_web/controllers/post_json.ex\n* creating test/hello_web/controllers/post_controller_test.exs\n* creating lib/hello_web/controllers/changeset_json.ex\n* creating lib/hello_web/controllers/fallback_controller.ex\n* creating lib/hello/blog/post.ex\n* creating priv/repo/migrations/20170906153323_create_posts.exs\n* creating lib/hello/blog.ex\n* injecting lib/hello/blog.ex\n* creating test/hello/blog/blog_test.exs\n* injecting test/hello/blog/blog_test.exs\n* creating test/support/fixtures/blog_fixtures.ex\n* injecting test/support/fixtures/blog_fixtures.ex\n```\n\nWhen `mix phx.gen.json` is done creating files, it helpfully tells us that we need to add a line to our router file as well as run our Ecto migrations.\n\n```console\nAdd the resource to the \"/api\" scope in lib/hello_web/router.ex:\n\n    resources \"/posts\", PostController, except: [:new, :edit]\n\nRemember to update your repository by running migrations:\n\n    $ mix ecto.migrate\n```\n\nImportant: If we don't do this, we'll get the following warning in our logs and the application will error when attempting to compile:\n\n```console\n$ mix phx.server\nCompiling 19 files (.ex)\n\nwarning: no route path for HelloWeb.Router matches \\\"/posts\\\"\n  lib/hello_web/controllers/post_controller.ex:22: HelloWeb.PostController.index/2\n```\n\n`mix phx.gen.json` also supports `--no-context`, `--no-schema`, and others, as in `mix phx.gen.html`.\n\n### `mix phx.gen.context`\n\nIf we don't need a complete HTML/JSON resource and only need a context, we can use the `mix phx.gen.context` task. It will generate a context, a schema, a migration and a test case.\n\nThe `mix phx.gen.context` task takes the following arguments: the module name of the context, the module name of the schema, the resource name, and a list of column_name:type attributes.\n\n```console\n$ mix phx.gen.context Accounts User users name:string age:integer\n* creating lib/hello/accounts/user.ex\n* creating priv/repo/migrations/20170906161158_create_users.exs\n* creating lib/hello/accounts.ex\n* injecting lib/hello/accounts.ex\n* creating test/hello/accounts/accounts_test.exs\n* injecting test/hello/accounts/accounts_test.exs\n* creating test/support/fixtures/accounts_fixtures.ex\n* injecting test/support/fixtures/accounts_fixtures.ex\n```\n\n> Note: If we need to namespace our resource we can simply namespace the first argument of the generator.\n\n```console\n$ mix phx.gen.context Admin.Accounts User users name:string age:integer\n* creating lib/hello/admin/accounts/user.ex\n* creating priv/repo/migrations/20170906161246_create_users.exs\n* creating lib/hello/admin/accounts.ex\n* injecting lib/hello/admin/accounts.ex\n* creating test/hello/admin/accounts_test.exs\n* injecting test/hello/admin/accounts_test.exs\n* creating test/support/fixtures/admin/accounts_fixtures.ex\n* injecting test/support/fixtures/admin/accounts_fixtures.ex\n```\n\n### `mix phx.gen.schema`\n\nIf we don't need a complete HTML/JSON resource and are not interested in generating or altering a context we can use the `mix phx.gen.schema` task. It will generate a schema, and a migration.\n\nThe `mix phx.gen.schema` task takes the following arguments: the module name of the schema (which may be namespaced), the resource name, and a list of column_name:type attributes.\n\n```console\n$ mix phx.gen.schema Accounts.Credential credentials email:string:unique user_id:references:users\n* creating lib/hello/accounts/credential.ex\n* creating priv/repo/migrations/20170906162013_create_credentials.exs\n```\n\n### `mix phx.gen.auth`\n\nPhoenix also offers the ability to generate all of the code to stand up a complete authentication system — Ecto migration, phoenix context, controllers, templates, etc. This can be a huge time saver, allowing you to quickly add authentication to your system and shift your focus back to the primary problems your application is trying to solve.\n\nThe `mix phx.gen.auth` task takes the following arguments: the module name of the context, the module name of the schema, and a plural version of the schema name used to generate database tables and route paths.\n\nHere is an example version of the command:\n\n```console\n$ mix phx.gen.auth Accounts User users\n* creating priv/repo/migrations/20201205184926_create_users_auth_tables.exs\n* creating lib/hello/accounts/user_notifier.ex\n* creating lib/hello/accounts/user.ex\n* creating lib/hello/accounts/user_token.ex\n* creating lib/hello_web/controllers/user_auth.ex\n* creating test/hello_web/controllers/user_auth_test.exs\n* creating lib/hello_web/controllers/user_confirmation_html.ex\n* creating lib/hello_web/templates/user_confirmation/new.html.heex\n* creating lib/hello_web/templates/user_confirmation/edit.html.heex\n* creating lib/hello_web/controllers/user_confirmation_controller.ex\n* creating test/hello_web/controllers/user_confirmation_controller_test.exs\n* creating lib/hello_web/templates/user_registration/new.html.heex\n* creating lib/hello_web/controllers/user_registration_controller.ex\n* creating test/hello_web/controllers/user_registration_controller_test.exs\n* creating lib/hello_web/controllers/user_registration_html.ex\n* creating lib/hello_web/controllers/user_reset_password_html.ex\n* creating lib/hello_web/controllers/user_reset_password_controller.ex\n* creating test/hello_web/controllers/user_reset_password_controller_test.exs\n* creating lib/hello_web/templates/user_reset_password/edit.html.heex\n* creating lib/hello_web/templates/user_reset_password/new.html.heex\n* creating lib/hello_web/controllers/user_session_html.ex\n* creating lib/hello_web/controllers/user_session_controller.ex\n* creating test/hello_web/controllers/user_session_controller_test.exs\n* creating lib/hello_web/templates/user_session/new.html.heex\n* creating lib/hello_web/controllers/user_settings_html.ex\n* creating lib/hello_web/templates/user_settings/edit.html.heex\n* creating lib/hello_web/controllers/user_settings_controller.ex\n* creating test/hello_web/controllers/user_settings_controller_test.exs\n* creating lib/hello/accounts.ex\n* injecting lib/hello/accounts.ex\n* creating test/hello/accounts_test.exs\n* injecting test/hello/accounts_test.exs\n* creating test/support/fixtures/accounts_fixtures.ex\n* injecting test/support/fixtures/accounts_fixtures.ex\n* injecting test/support/conn_case.ex\n* injecting config/test.exs\n* injecting mix.exs\n* injecting lib/hello_web/router.ex\n* injecting lib/hello_web/router.ex - imports\n* injecting lib/hello_web/router.ex - plug\n* injecting lib/hello_web/templates/layout/root.html.heex\n```\n\nWhen `mix phx.gen.auth` is done creating files, it helpfully tells us that we need to re-fetch our dependencies as well as run our Ecto migrations.\n\n```console\nPlease re-fetch your dependencies with the following command:\n\n    mix deps.get\n\nRemember to update your repository by running migrations:\n\n  $ mix ecto.migrate\n\nOnce you are ready, visit \"/users/register\"\nto create your account and then access to \"/dev/mailbox\" to\nsee the account confirmation email.\n```\n\nA more complete walk-through of how to get started with this generator is available in the [`mix phx.gen.auth` authentication guide](mix_phx_gen_auth.html).\n\n### `mix phx.gen.channel` and `mix phx.gen.socket`\n\nThis task will generate a basic Phoenix channel, the socket to power the channel (if you haven't created one yet), as well a test case for it. It takes the module name for the channel as the only argument:\n\n```console\n$ mix phx.gen.channel Room\n* creating lib/hello_web/channels/room_channel.ex\n* creating test/hello_web/channels/room_channel_test.exs\n```\n\nIf your application does not have a `UserSocket` yet, it will ask if you want to create one:\n\n```console\nThe default socket handler - HelloWeb.UserSocket - was not found\nin its default location.\n\nDo you want to create it? [Y/n]\n```\n\nBy confirming, a channel will be created, then you need to connect the socket in your endpoint:\n\n```console\nAdd the socket handler to your `lib/hello_web/endpoint.ex`, for example:\n\n    socket \"/socket\", HelloWeb.UserSocket,\n      websocket: true,\n      longpoll: false\n\nFor the front-end integration, you need to import the `user_socket.js`\nin your `assets/js/app.js` file:\n\n    import \"./user_socket.js\"\n```\n\nIn case a `UserSocket` already exists or you decide to not create one, the `channel` generator will tell you to add it to the Socket manually:\n\n```console\nAdd the channel to your `lib/hello_web/channels/user_socket.ex` handler, for example:\n\n    channel \"rooms:lobby\", HelloWeb.RoomChannel\n```\n\nYou can also create a socket any time by invoking `mix phx.gen.socket`.\n\n### `mix phx.gen.presence`\n\nThis task will generate a presence tracker. The module name can be passed as an argument,\n`Presence` is used if no module name is passed.\n\n```console\n$ mix phx.gen.presence Presence\n* lib/hello_web/channels/presence.ex\n\nAdd your new module to your supervision tree,\nin lib/hello/application.ex:\n\n    children = [\n      ...\n      HelloWeb.Presence\n    ]\n```\n\n### `mix phx.routes`\n\nThis task has a single purpose, to show us all the routes defined for a given router. We saw it used extensively in the [routing guide](routing.html).\n\nIf we don't specify a router for this task, it will default to the router Phoenix generated for us.\n\n```console\n$ mix phx.routes\nGET  /  TaskTester.PageController.index/2\n```\n\nWe can also specify an individual router if we have more than one for our application.\n\n```console\n$ mix phx.routes TaskTesterWeb.Router\nGET  /  TaskTesterWeb.PageController.index/2\n```\n\n### `mix phx.server`\n\nThis is the task we use to get our application running. It takes no arguments at all. If we pass any in, they will be silently ignored.\n\n```console\n$ mix phx.server\n[info] Running TaskTesterWeb.Endpoint with Cowboy on port 4000 (http)\n```\n\nIt will silently ignore our `DoesNotExist` argument:\n\n```console\n$ mix phx.server DoesNotExist\n[info] Running TaskTesterWeb.Endpoint with Cowboy on port 4000 (http)\n```\n\nIf we would like to start our application and also have an `IEx` session open to it, we can run the Mix task within `iex` like this, `iex -S mix phx.server`.\n\n```console\n$ iex -S mix phx.server\nErlang/OTP 17 [erts-6.4] [source] [64-bit] [smp:8:8] [async-threads:10] [hipe] [kernel-poll:false] [dtrace]\n\n[info] Running TaskTesterWeb.Endpoint with Cowboy on port 4000 (http)\nInteractive Elixir (1.0.4) - press Ctrl+C to exit (type h() ENTER for help)\niex(1)>\n```\n\n### `mix phx.digest`\n\nThis task does two things, it creates a digest for our static assets and then compresses them.\n\n\"Digest\" here refers to an MD5 digest of the contents of an asset which gets added to the filename of that asset. This creates a sort of fingerprint for it. If the digest doesn't change, browsers and CDNs will use a cached version. If it does change, they will re-fetch the new version.\n\nBefore we run this task let's inspect the contents of two directories in our hello application.\n\nFirst `priv/static/` which should look similar to this:\n\n```console\n├── assets\n│   ├── app.css\n│   └── app.js\n├── favicon.ico\n└── robots.txt\n```\n\nAnd then `assets/` which should look similar to this:\n\n```console\n├── css\n│   └── app.css\n├── js\n│   └── app.js\n├── tailwind.config.js\n└── vendor\n    └── topbar.js\n```\n\nAll of these files are our static assets. Now let's run the `mix phx.digest` task.\n\n```console\n$ mix phx.digest\nCheck your digested files at 'priv/static'.\n```\n\nWe can now do as the task suggests and inspect the contents of `priv/static/` directory. We'll see that all files from `assets/` have been copied over to `priv/static/` and also each file now has a couple of versions. Those versions are:\n\n* the original file\n* a compressed file with gzip\n* a file containing the original file name and its digest\n* a compressed file containing the file name and its digest\n\nWe can optionally determine which files should be gzipped by using the `:gzippable_exts` option in the config file:\n\n```elixir\nconfig :phoenix, :gzippable_exts, ~w(.js .css)\n```\n\n> Note: We can specify a different output folder where `mix phx.digest` will put processed files. The first argument is the path where the static files are located.\n\n```console\n$ mix phx.digest priv/static/ -o www/public/\nCheck your digested files at 'www/public/'\n```\n\n> Note: You can use `mix phx.digest.clean` to prune stale versions of the assets. If you want to remove all produced files, run `mix phx.digest.clean --all`.","ref":"mix_tasks.html#phoenix-tasks"},{"type":"extras","title":"Ecto tasks - Mix tasks","doc":"Newly generated Phoenix applications now include Ecto and Postgrex as dependencies by default (which is to say, unless we use `mix phx.new` with the `--no-ecto` flag). With those dependencies come Mix tasks to take care of common Ecto operations. Let's see which tasks we get out of the box.\n\n```console\n$ mix help --search \"ecto\"\nmix ecto               # Prints Ecto help information\nmix ecto.create        # Creates the repository storage\nmix ecto.drop          # Drops the repository storage\nmix ecto.dump          # Dumps the repository database structure\nmix ecto.gen.migration # Generates a new migration for the repo\nmix ecto.gen.repo      # Generates a new repository\nmix ecto.load          # Loads previously dumped database structure\nmix ecto.migrate       # Runs the repository migrations\nmix ecto.migrations    # Displays the repository migration status\nmix ecto.reset         # Alias defined in mix.exs\nmix ecto.rollback      # Rolls back the repository migrations\nmix ecto.setup         # Alias defined in mix.exs\n```\n\nNote: We can run any of the tasks above with the `--no-start` flag to execute the task without starting the application.\n\n### `mix ecto.create`\n\nThis task will create the database specified in our repo. By default it will look for the repo named after our application (the one generated with our app unless we opted out of Ecto), but we can pass in another repo if we want.\n\nHere's what it looks like in action.\n\n```console\n$ mix ecto.create\nThe database for Hello.Repo has been created.\n```\n\nThere are a few things that can go wrong with `ecto.create`. If our Postgres database doesn't have a \"postgres\" role (user), we'll get an error like this one.\n\n```console\n$ mix ecto.create\n** (Mix) The database for Hello.Repo couldn't be created, reason given: psql: FATAL:  role \"postgres\" does not exist\n```\n\nWe can fix this by creating the \"postgres\" role in the `psql` console with the permissions needed to log in and create a database.\n\n```console\n=# CREATE ROLE postgres LOGIN CREATEDB;\nCREATE ROLE\n```\n\nIf the \"postgres\" role does not have permission to log in to the application, we'll get this error.\n\n```console\n$ mix ecto.create\n** (Mix) The database for Hello.Repo couldn't be created, reason given: psql: FATAL:  role \"postgres\" is not permitted to log in\n```\n\nTo fix this, we need to change the permissions on our \"postgres\" user to allow login.\n\n```console\n=# ALTER ROLE postgres LOGIN;\nALTER ROLE\n```\n\nIf the \"postgres\" role does not have permission to create a database, we'll get this error.\n\n```console\n$ mix ecto.create\n** (Mix) The database for Hello.Repo couldn't be created, reason given: ERROR:  permission denied to create database\n```\n\nTo fix this, we need to change the permissions on our \"postgres\" user in the `psql` console  to allow database creation.\n\n```console\n=# ALTER ROLE postgres CREATEDB;\nALTER ROLE\n```\n\nIf the \"postgres\" role is using a password different from the default \"postgres\", we'll get this error.\n\n```console\n$ mix ecto.create\n** (Mix) The database for Hello.Repo couldn't be created, reason given: psql: FATAL:  password authentication failed for user \"postgres\"\n```\n\nTo fix this, we can change the password in the environment specific configuration file. For the development environment the password used can be found at the bottom of the `config/dev.exs` file.\n\nFinally, if we happen to have another repo called `OurCustom.Repo` that we want to create the database for, we can run this.\n\n```console\n$ mix ecto.create -r OurCustom.Repo\nThe database for OurCustom.Repo has been created.\n```\n\n### `mix ecto.drop`\n\nThis task will drop the database specified in our repo. By default it will look for the repo named after our application (the one generated with our app unless we opted out of Ecto). It will not prompt us to check if we're sure we want to drop the database, so do exercise caution.\n\n```console\n$ mix ecto.drop\nThe database for Hello.Repo has been dropped.\n```\n\nIf we happen to have another repo that we want to drop the database for, we can specify it with the `-r` flag.\n\n```console\n$ mix ecto.drop -r OurCustom.Repo\nThe database for OurCustom.Repo has been dropped.\n```\n\n### `mix ecto.gen.repo`\n\nMany applications require more than one data store. For each data store, we'll need a new repo, and we can generate them automatically with `ecto.gen.repo`.\n\nIf we name our repo `OurCustom.Repo`, this task will create it here `lib/our_custom/repo.ex`.\n\n```console\n$ mix ecto.gen.repo -r OurCustom.Repo\n* creating lib/our_custom\n* creating lib/our_custom/repo.ex\n* updating config/config.exs\nDon't forget to add your new repo to your supervision tree\n(typically in lib/hello/application.ex):\n\n    {OurCustom.Repo, []}\n```\n\nNotice that this task has updated `config/config.exs`. If we take a look, we'll see this extra configuration block for our new repo.\n\n```elixir\n. . .\nconfig :hello, OurCustom.Repo,\n  username: \"user\",\n  password: \"pass\",\n  hostname: \"localhost\",\n  database: \"hello_repo\",\n. . .\n```\n\nOf course, we'll need to change the login credentials to match what our database expects. We'll also need to change the config for other environments.\n\nWe certainly should follow the instructions and add our new repo to our supervision tree. In our `Hello` application, we would open up `lib/hello/application.ex`, and add our repo as a worker to the `children` list.\n\n```elixir\n. . .\nchildren = [\n  Hello.Repo,\n  # Our custom repo\n  OurCustom.Repo,\n  # Start the endpoint when the application starts\n  HelloWeb.Endpoint,\n]\n. . .\n```\n\n### `mix ecto.gen.migration`\n\nMigrations are a programmatic, repeatable way to affect changes to a database schema. Migrations are also just modules, and we can create them with the [`ecto.gen.migration`](`mix ecto.gen.migration`) task. Let's walk through the steps to create a migration for a new comments table.\n\nWe simply need to invoke the task with a `snake_case` version of the module name that we want. Preferably, the name will describe what we want the migration to do.\n\n```console\n$ mix ecto.gen.migration add_comments_table\n* creating priv/repo/migrations\n* creating priv/repo/migrations/20150318001628_add_comments_table.exs\n```\n\nNotice that the migration's filename begins with a string representation of the date and time the file was created.\n\nLet's take a look at the file `ecto.gen.migration` has generated for us at `priv/repo/migrations/20150318001628_add_comments_table.exs`.\n\n```elixir\ndefmodule Hello.Repo.Migrations.AddCommentsTable do\n  use Ecto.Migration\n\n  def change do\n  end\nend\n```\n\nNotice that there is a single function `change/0` which will handle both forward migrations and rollbacks. We'll define the schema changes that we want using Ecto's handy DSL, and Ecto will figure out what to do depending on whether we are rolling forward or rolling back. Very nice indeed.\n\nWhat we want to do is create a `comments` table with a `body` column, a `word_count` column, and timestamp columns for `inserted_at` and `updated_at`.\n\n```elixir\n. . .\ndef change do\n  create table(:comments) do\n    add :body, :string\n    add :word_count, :integer\n    timestamps()\n  end\nend\n. . .\n```\n\nAgain, we can run this task with the `-r` flag and another repo if we need to.\n\n```console\n$ mix ecto.gen.migration -r OurCustom.Repo add_users\n* creating priv/repo/migrations\n* creating priv/repo/migrations/20150318172927_add_users.exs\n```\n\nFor more information on how to modify your database schema please refer to the\n[Ecto's migration DSL docs](https://hexdocs.pm/ecto_sql/Ecto.Migration.html).\nFor example, to alter an existing schema see the documentation on Ecto’s\n[`alter/2`](`Ecto.Migration.alter/2`) function.\n\nThat's it! We're ready to run our migration.\n\n### `mix ecto.migrate`\n\nOnce we have our migration module ready, we can simply run `mix ecto.migrate` to have our changes applied to the database.\n\n```console\n$ mix ecto.migrate\n[info] == Running Hello.Repo.Migrations.AddCommentsTable.change/0 forward\n[info] create table comments\n[info] == Migrated in 0.1s\n```\n\nWhen we first run `ecto.migrate`, it will create a table for us called `schema_migrations`. This will keep track of all the migrations which we run by storing the timestamp portion of the migration's filename.\n\nHere's what the `schema_migrations` table looks like.\n\n```console\nhello_dev=# select * from schema_migrations;\nversion        |     inserted_at\n---------------+---------------------\n20150317170448 | 2015-03-17 21:07:26\n20150318001628 | 2015-03-18 01:45:00\n(2 rows)\n```\n\nWhen we roll back a migration, [`ecto.rollback`](#mix-ecto-rollback) will remove the record representing this migration from `schema_migrations`.\n\nBy default, `ecto.migrate` will execute all pending migrations. We can exercise more control over which migrations we run by specifying some options when we run the task.\n\nWe can specify the number of pending migrations we would like to run with the `-n` or `--step` options.\n\n```console\n$ mix ecto.migrate -n 2\n[info] == Running Hello.Repo.Migrations.CreatePost.change/0 forward\n[info] create table posts\n[info] == Migrated in 0.0s\n[info] == Running Hello.Repo.Migrations.AddCommentsTable.change/0 forward\n[info] create table comments\n[info] == Migrated in 0.0s\n```\n\nThe `--step` option will behave the same way.\n\n```console\nmix ecto.migrate --step 2\n```\n\nThe `--to` option will run all migrations up to and including given version.\n\n```console\nmix ecto.migrate --to 20150317170448\n```\n\n### `mix ecto.rollback`\n\nThe [`ecto.rollback`](`mix ecto.rollback`) task will reverse the last migration we have run, undoing the schema changes. [`ecto.migrate`](#mix-ecto-migrate) and `ecto.rollback` are mirror images of each other.\n\n```console\n$ mix ecto.rollback\n[info] == Running Hello.Repo.Migrations.AddCommentsTable.change/0 backward\n[info] drop table comments\n[info] == Migrated in 0.0s\n```\n\n`ecto.rollback` will handle the same options as `ecto.migrate`, so `-n`, `--step`, `-v`, and `--to` will behave as they do for `ecto.migrate`.","ref":"mix_tasks.html#ecto-tasks"},{"type":"extras","title":"Creating our own Mix task - Mix tasks","doc":"As we've seen throughout this guide, both Mix itself and the dependencies we bring in to our application provide a number of really useful tasks for free. Since neither of these could possibly anticipate all our individual application's needs, Mix allows us to create our own custom tasks. That's exactly what we are going to do now.\n\nThe first thing we need to do is create a `mix/tasks/` directory inside of `lib/`. This is where any of our application specific Mix tasks will go.\n\n```console\n$ mkdir -p lib/mix/tasks/\n```\n\nInside that directory, let's create a new file, `hello.greeting.ex`, that looks like this.\n\n```elixir\ndefmodule Mix.Tasks.Hello.Greeting do\n  use Mix.Task\n\n  @shortdoc \"Sends a greeting to us from Hello Phoenix\"\n\n  @moduledoc \"\"\"\n  This is where we would put any long form documentation and doctests.\n  \"\"\"\n\n  @impl Mix.Task\n  def run(_args) do\n    Mix.shell().info(\"Greetings from the Hello Phoenix Application!\")\n  end\n\n  # We can define other functions as needed here.\nend\n```\n\nLet's take a quick look at the moving parts involved in a working Mix task.\n\nThe first thing we need to do is name our module. All tasks must be defined in the `Mix.Tasks` namespace. We'd like to invoke this as `mix hello.greeting`, so we complete the module name with\n`Hello.Greeting`.\n\nThe `use Mix.Task` line brings in functionality from Mix that makes this module [behave as a Mix task](`Mix.Task`).\n\nThe `@shortdoc` module attribute holds a string which will describe our task when users invoke `mix help`.\n\n`@moduledoc` serves the same function that it does in any module. It's where we can put long-form documentation and doctests, if we have any.\n\nThe [`run/1`](`c:Mix.Task.run/1`) function is the critical heart of any Mix task. It's the function that does all the work when users invoke our task. In ours, all we do is send a greeting from our app, but we can implement our `run/1` function to do whatever we need it to. Note that [`Mix.shell().info/1`](`Mix.shell/0`) is the preferred way to print text back out to the user.\n\nOf course, our task is just a module, so we can define other private functions as needed to support our `run/1` function.\n\nNow that we have our task module defined, our next step is to compile the application.\n\n```console\n$ mix compile\nCompiled lib/tasks/hello.greeting.ex\nGenerated hello.app\n```\n\nNow our new task should be visible to `mix help`.\n\n```console\n$ mix help --search hello\nmix hello.greeting # Sends a greeting to us from Hello Phoenix\n```\n\nNotice that `mix help` displays the text we put into the `@shortdoc` along with the name of our task.\n\nSo far, so good, but does it work?\n\n```console\n$ mix hello.greeting\nGreetings from the Hello Phoenix Application!\n```\n\nIndeed it does.\n\nIf you want to make your new Mix task to use your application's infrastructure, you need to make sure the application is started and configure when Mix task is being executed. This is particularly useful if you need to access your database from within the Mix task. Thankfully, Mix makes it really easy for us via the `@requirements` module attribute:\n\n```elixir\n  @requirements [\"app.start\"]\n\n  @impl Mix.Task\n  def run(_args) do\n    Mix.shell().info(\"Now I have access to Repo and other goodies!\")\n    Mix.shell().info(\"Greetings from the Hello Phoenix Application!\")\n  end\n```","ref":"mix_tasks.html#creating-our-own-mix-task"},{"type":"extras","title":"Telemetry","doc":"# Telemetry\n\nIn this guide, we will show you how to instrument and report\non `:telemetry` events in your Phoenix application.\n\n> `te·lem·e·try` - the process of recording and transmitting\nthe readings of an instrument.\n\nAs you follow along with this guide, we will introduce you to\nthe core concepts of Telemetry, you will initialize a\nreporter to capture your application's events as they occur,\nand we will guide you through the steps to properly\ninstrument your own functions using `:telemetry`. Let's take\na closer look at how Telemetry works in your application.","ref":"telemetry.html"},{"type":"extras","title":"Overview - Telemetry","doc":"The `[:telemetry]` library allows you to emit events at various stages of an application's lifecycle. You can then respond to these events by, among other things, aggregating them as metrics and sending the metrics data to a reporting destination.\n\nTelemetry stores events by their name in an ETS table, along with the handler for each event. Then, when a given event is executed, Telemetry looks up its handler and invokes it.\n\nPhoenix's Telemetry tooling provides you with a supervisor that uses `Telemetry.Metrics` to define the list of Telemetry events to handle and how to handle those events, i.e. how to structure them as a certain type of metric. This supervisor works together with Telemetry reporters to respond to the specified Telemetry events by aggregating them as the appropriate metric and sending them to the correct reporting destination.","ref":"telemetry.html#overview"},{"type":"extras","title":"The Telemetry supervisor - Telemetry","doc":"Since v1.5, new Phoenix applications are generated with a\nTelemetry supervisor. This module is responsible for\nmanaging the lifecycle of your Telemetry processes. It also\ndefines a `metrics/0` function, which returns a list of\n[`Telemetry.Metrics`](https://hexdocs.pm/telemetry_metrics)\nthat you define for your application.\n\nBy default, the supervisor also starts\n[`:telemetry_poller`](https://hexdocs.pm/telemetry_poller).\nBy simply adding `:telemetry_poller` as a dependency, you\ncan receive VM-related events on a specified interval.\n\nIf you are coming from an older version of Phoenix, install\nthe `:telemetry_metrics` and `:telemetry_poller` packages:\n\n```elixir\n{:telemetry_metrics, \"~> 1.0\"},\n{:telemetry_poller, \"~> 1.0\"}\n```\n\nand create your Telemetry supervisor at\n`lib/my_app_web/telemetry.ex`:\n\n```elixir\n# lib/my_app_web/telemetry.ex\ndefmodule MyAppWeb.Telemetry do\n  use Supervisor\n  import Telemetry.Metrics\n\n  def start_link(arg) do\n    Supervisor.start_link(__MODULE__, arg, name: __MODULE__)\n  end\n\n  def init(_arg) do\n    children = [\n      {:telemetry_poller, measurements: periodic_measurements(), period: 10_000}\n      # Add reporters as children of your supervision tree.\n      # {Telemetry.Metrics.ConsoleReporter, metrics: metrics()}\n    ]\n\n    Supervisor.init(children, strategy: :one_for_one)\n  end\n\n  def metrics do\n    [\n      # Phoenix Metrics\n      summary(\"phoenix.endpoint.stop.duration\",\n        unit: {:native, :millisecond}\n      ),\n      summary(\"phoenix.router_dispatch.stop.duration\",\n        tags: [:route],\n        unit: {:native, :millisecond}\n      ),\n      # VM Metrics\n      summary(\"vm.memory.total\", unit: {:byte, :kilobyte}),\n      summary(\"vm.total_run_queue_lengths.total\"),\n      summary(\"vm.total_run_queue_lengths.cpu\"),\n      summary(\"vm.total_run_queue_lengths.io\")\n    ]\n  end\n\n  defp periodic_measurements do\n    [\n      # A module, function and arguments to be invoked periodically.\n      # This function must call :telemetry.execute/3 and a metric must be added above.\n      # {MyApp, :count_users, []}\n    ]\n  end\nend\n```\n\nMake sure to replace MyApp by your actual application name.\n\nThen add to your main application's supervision tree\n(usually in `lib/my_app/application.ex`):\n\n```elixir\nchildren = [\n  MyAppWeb.Telemetry,\n  MyApp.Repo,\n  MyAppWeb.Endpoint,\n  ...\n]\n```","ref":"telemetry.html#the-telemetry-supervisor"},{"type":"extras","title":"Telemetry Events - Telemetry","doc":"Many Elixir libraries (including Phoenix) are already using\nthe [`:telemetry`](https://hexdocs.pm/telemetry) package as a\nway to give users more insight into the behavior of their\napplications, by emitting events at key moments in the\napplication lifecycle.\n\nA Telemetry event is made up of the following:\n\n  * `name` - A string (e.g. `\"my_app.worker.stop\"`) or a\n    list of atoms that uniquely identifies the event.\n\n  * `measurements` - A map of atom keys (e.g. `:duration`)\n    and numeric values.\n\n  * `metadata` - A map of key-value pairs that can be used\n    for tagging metrics.","ref":"telemetry.html#telemetry-events"},{"type":"extras","title":"A Phoenix Example - Telemetry","doc":"Here is an example of an event from your endpoint:\n\n* `[:phoenix, :endpoint, :stop]` - dispatched by\n  `Plug.Telemetry`, one of the default plugs in your endpoint, whenever the response is\n  sent\n\n  * Measurement: `%{duration: native_time}`\n\n  * Metadata: `%{conn: Plug.Conn.t}`\n\nThis means that after each request, `Plug`, via `:telemetry`,\nwill emit a \"stop\" event, with a measurement of how long it\ntook to get the response:\n\n```elixir\n:telemetry.execute([:phoenix, :endpoint, :stop], %{duration: duration}, %{conn: conn})\n```","ref":"telemetry.html#a-phoenix-example"},{"type":"extras","title":"Phoenix Telemetry Events - Telemetry","doc":"A full list of all Phoenix telemetry events can be found in `Phoenix.Logger`","ref":"telemetry.html#phoenix-telemetry-events"},{"type":"extras","title":"Metrics - Telemetry","doc":"> Metrics are aggregations of Telemetry events with a\n> specific name, providing a view of the system's behaviour\n> over time.\n>\n> ― `Telemetry.Metrics`\n\nThe Telemetry.Metrics package provides a common interface\nfor defining metrics. It exposes a set of [five metric type functions](https://hexdocs.pm/telemetry_metrics/Telemetry.Metrics.html#module-metrics) that are responsible for structuring a given Telemetry event as a particular measurement.\n\nThe package does not perform any aggregation of the measurements itself. Instead, it provides a reporter with the Telemetry event-as-measurement definition and the reporter uses that definition to perform aggregations and report them.\n\nWe will discuss\nreporters in the next section.\n\nLet's take a look at some examples.\n\nUsing `Telemetry.Metrics`, you can define a counter metric,\nwhich counts how many HTTP requests were completed:\n\n```elixir\nTelemetry.Metrics.counter(\"phoenix.endpoint.stop.duration\")\n```\n\nor you could use a distribution metric to see how many\nrequests were completed in particular time buckets:\n\n```elixir\nTelemetry.Metrics.distribution(\"phoenix.endpoint.stop.duration\")\n```\n\nThis ability to introspect HTTP requests is really powerful --\nand this is but one of _many_ telemetry events emitted by\nthe Phoenix framework! We'll discuss more of these events,\nas well as specific patterns for extracting valuable data\nfrom Phoenix/Plug events in the\n[Phoenix Metrics](#phoenix-metrics) section later in this\nguide.\n\n> The full list of `:telemetry` events emitted from Phoenix,\nalong with their measurements and metadata, is available in\nthe \"Instrumentation\" section of the `Phoenix.Logger` module\ndocumentation.","ref":"telemetry.html#metrics"},{"type":"extras","title":"An Ecto Example - Telemetry","doc":"Like Phoenix, Ecto ships with built-in Telemetry events.\nThis means that you can gain introspection into your web\nand database layers using the same tools.\n\nHere is an example of a Telemetry event executed by Ecto when an Ecto repository starts:\n\n* `[:ecto, :repo, :init]` - dispatched by `Ecto.Repo`\n\n  * Measurement: `%{system_time: native_time}`\n\n  * Metadata: `%{repo: Ecto.Repo, opts: Keyword.t()}`\n\nThis means that whenever the `Ecto.Repo` starts, it will emit an event, via `:telemetry`,\nwith a measurement of the time at start-up.\n\n```elixir\n:telemetry.execute([:ecto, :repo, :init], %{system_time: System.system_time()}, %{repo: repo, opts: opts})\n```\n\nAdditional Telemetry events are executed by Ecto adapters.\n\nOne such adapter-specific event is the `[:my_app, :repo, :query]` event.\nFor instance, if you want to graph query execution time, you can use the `Telemetry.Metrics.summary/2` function to instruct your reporter to calculate statistics of the `[:my_app, :repo, :query]` event, like maximum, mean, percentiles etc.:\n\n```elixir\nTelemetry.Metrics.summary(\"my_app.repo.query.query_time\",\n  unit: {:native, :millisecond}\n)\n```\n\nOr you could use the `Telemetry.Metrics.distribution/2` function to define a histogram for another adapter-specific event: `[:my_app, :repo, :query, :queue_time]`, thus visualizing how long queries spend queued:\n\n```elixir\nTelemetry.Metrics.distribution(\"my_app.repo.query.queue_time\",\n  unit: {:native, :millisecond}\n)\n```\n\n> You can learn more about Ecto Telemetry in the \"Telemetry\nEvents\" section of the\n[`Ecto.Repo`](https://hexdocs.pm/ecto/Ecto.Repo.html) module\ndocumentation.\n\nSo far we have seen some of the Telemetry events common to\nPhoenix applications, along with some examples of their\nvarious measurements and metadata. With all of this data\njust waiting to be consumed, let's talk about reporters.","ref":"telemetry.html#an-ecto-example"},{"type":"extras","title":"Reporters - Telemetry","doc":"Reporters subscribe to Telemetry events using the common\ninterface provided by `Telemetry.Metrics`. They then\naggregate the measurements (data) into metrics to provide\nmeaningful information about your application.\n\nFor example, if the following `Telemetry.Metrics.summary/2` call is added to the `metrics/0` function of your Telemetry supervisor:\n\n```elixir\nsummary(\"phoenix.endpoint.stop.duration\",\n  unit: {:native, :millisecond}\n)\n```\n\nThen the reporter will attach a listener for the `\"phoenix.endpoint.stop.duration\"` event and will respond to this event by calculating a summary metric with the given event metadata and reporting on that metric to the appropriate source.","ref":"telemetry.html#reporters"},{"type":"extras","title":"Phoenix.LiveDashboard - Telemetry","doc":"For developers interested in real-time visualizations for\ntheir Telemetry metrics, you may be interested in installing\n[`LiveDashboard`](https://hexdocs.pm/phoenix_live_dashboard).\nLiveDashboard acts as a Telemetry.Metrics reporter to render\nyour data as beautiful, real-time charts on the dashboard.","ref":"telemetry.html#phoenix-livedashboard"},{"type":"extras","title":"Telemetry.Metrics.ConsoleReporter - Telemetry","doc":"`Telemetry.Metrics` ships with a `ConsoleReporter` that can\nbe used to print events and metrics to the terminal. You can\nuse this reporter to experiment with the metrics discussed in\nthis guide.\n\nUncomment or add the following to this list of children in\nyour Telemetry supervision tree (usually in\n`lib/my_app_web/telemetry.ex`):\n\n```elixir\n{Telemetry.Metrics.ConsoleReporter, metrics: metrics()}\n```\n\n> There are numerous reporters available, for services like\n> StatsD, Prometheus, and more. You can find them by\n> searching for \"telemetry_metrics\" on [hex.pm](https://hex.pm/packages?search=telemetry_metrics).","ref":"telemetry.html#telemetry-metrics-consolereporter"},{"type":"extras","title":"Phoenix Metrics - Telemetry","doc":"Earlier we looked at the \"stop\" event emitted by\n`Plug.Telemetry`, and used it to count the number of HTTP\nrequests. In reality, it's only somewhat helpful to be\nable to see just the total number of requests. What if you\nwanted to see the number of requests per route, or per route\n_and_ method?\n\nLet's take a look at another event emitted during the HTTP\nrequest lifecycle, this time from `Phoenix.Router`:\n\n* `[:phoenix, :router_dispatch, :stop]` - dispatched by\n  Phoenix.Router after successfully dispatching to a matched\n  route\n\n  * Measurement: `%{duration: native_time}`\n\n  * Metadata: `%{conn: Plug.Conn.t, route: binary, plug: module, plug_opts: term, path_params: map, pipe_through: [atom]}`\n\nLet's start by grouping these events by route. Add the\nfollowing (if it does not already exist) to the `metrics/0`\nfunction of your Telemetry supervisor (usually in\n`lib/my_app_web/telemetry.ex`):\n\n```elixir\n# lib/my_app_web/telemetry.ex\ndef metrics do\n  [\n    ...metrics...\n    summary(\"phoenix.router_dispatch.stop.duration\",\n      tags: [:route],\n      unit: {:native, :millisecond}\n    )\n  ]\nend\n```\n\nRestart your server, and then make requests to a page or two.\nIn your terminal, you should see the ConsoleReporter print\nlogs for the Telemetry events it received as a result of\nthe metrics definitions you provided.\n\nThe log line for each request contains the specific route\nfor that request. This is due to specifying the `:tags`\noption for the summary metric, which takes care of our first\nrequirement; we can use `:tags` to group metrics by route.\nNote that reporters will necessarily handle tags differently\ndepending on the underlying service in use.\n\nLooking more closely at the Router \"stop\" event, you can see\nthat the `Plug.Conn` struct representing the request is\npresent in the metadata, but how do you access the\nproperties in `conn`?\n\nFortunately, `Telemetry.Metrics` provides the following\noptions to help you classify your events:\n\n* `:tags` - A list of metadata keys for grouping;\n\n* `:tag_values` - A function which transforms the metadata\n  into the desired shape; Note that this function is called\n  for each event, so it's important to keep it fast if the\n  rate of events is high.\n\n> Learn about all the available metrics options in the\n`Telemetry.Metrics` module documentation.\n\nLet's find out how to extract more tags from events that\ninclude a `conn` in their metadata.","ref":"telemetry.html#phoenix-metrics"},{"type":"extras","title":"Extracting tag values from Plug.Conn - Telemetry","doc":"Let's add another metric for the route event, this time to\ngroup by route and method:\n\n```elixir\nsummary(\"phoenix.router_dispatch.stop.duration\",\n  tags: [:method, :route],\n  tag_values: &get_and_put_http_method/1,\n  unit: {:native, :millisecond}\n)\n```\n\nWe've introduced the `:tag_values` option here, because we\nneed to perform a transformation on the event metadata in\norder to get to the values we need.\n\nAdd the following private function to your Telemetry module\nto lift the `:method` value from the `Plug.Conn` struct:\n\n```elixir\n# lib/my_app_web/telemetry.ex\ndefp get_and_put_http_method(%{conn: %{method: method}} = metadata) do\n  Map.put(metadata, :method, method)\nend\n```\n\nRestart your server and make some more requests. You should\nbegin to see logs with tags for both the HTTP method and the\nroute.\n\nNote the `:tags` and `:tag_values` options can be applied to\nall `Telemetry.Metrics` types.","ref":"telemetry.html#extracting-tag-values-from-plug-conn"},{"type":"extras","title":"Renaming value labels using tag values - Telemetry","doc":"Sometimes when displaying a metric, the value label may need to be transformed\nto improve readability. Take for example the following metric that displays the\nduration of the each LiveView's `mount/3` callback by `connected?` status.\n\n```elixir\nsummary(\"phoenix.live_view.mount.stop.duration\",\n  unit: {:native, :millisecond},\n  tags: [:view, :connected?],\n  tag_values: &live_view_metric_tag_values/1\n)\n```\n\nThe following function lifts `metadata.socket.view` and\n`metadata.socket.connected?` to be top-level keys on `metadata`, as we did in\nthe previous example.\n\n```elixir\n# lib/my_app_web/telemetry.ex\ndefp live_view_metric_tag_values(metadata) do\n  metadata\n  |> Map.put(:view, metadata.socket.view)\n  |> Map.put(:connected?, Phoenix.LiveView.connected?(metadata.socket))\nend\n```\n\nHowever, when rendering these metrics in LiveDashboard, the value label is\noutput as `\"Elixir.Phoenix.LiveDashboard.MetricsLive true\"`.\n\nTo make the value label easier to read, we can update our private function to\ngenerate more user friendly names. We'll run the value of the `:view` through\n`inspect/1` to remove the `Elixir.` prefix and call another private function to\nconvert the `connected?` boolean into human readable text.\n\n```elixir\n# lib/my_app_web/telemetry.ex\ndefp live_view_metric_tag_values(metadata) do\n  metadata\n  |> Map.put(:view, inspect(metadata.socket.view))\n  |> Map.put(:connected?, get_connection_status(Phoenix.LiveView.connected?(metadata.socket)))\nend\n\ndefp get_connection_status(true), do: \"Connected\"\ndefp get_connection_status(false), do: \"Disconnected\"\n```\n\nNow the value label will be rendered like `\"Phoenix.LiveDashboard.MetricsLive\nConnected\"`.\n\nHopefully, this gives you some inspiration on how to use the `:tag_values`\noption. Just remember to keep this function fast since it is called on every\nevent.","ref":"telemetry.html#renaming-value-labels-using-tag-values"},{"type":"extras","title":"Periodic measurements - Telemetry","doc":"You might want to periodically measure key-value pairs within\nyour application. Fortunately the\n[`:telemetry_poller`](https://hexdocs.pm/telemetry_poller)\npackage provides a mechanism for custom measurements,\nwhich is useful for retrieving process information or for\nperforming custom measurements periodically.\n\nAdd the following to the list in your Telemetry supervisor's\n`periodic_measurements/0` function, which is a private\nfunction that returns a list of measurements to take on a\nspecified interval.\n\n```elixir\n# lib/my_app_web/telemetry.ex\ndefp periodic_measurements do\n  [\n    {MyApp, :measure_users, []},\n    {:process_info,\n      event: [:my_app, :my_server],\n      name: MyApp.MyServer,\n      keys: [:message_queue_len, :memory]}\n  ]\nend\n```\n\nwhere `MyApp.measure_users/0` could be written like this:\n\n```elixir\n# lib/my_app.ex\ndefmodule MyApp do\n  def measure_users do\n    :telemetry.execute([:my_app, :users], %{total: MyApp.users_count()}, %{})\n  end\nend\n```\n\nNow with measurements in place, you can define the metrics for the\nevents above:\n\n```elixir\n# lib/my_app_web/telemetry.ex\ndef metrics do\n  [\n    ...metrics...\n    # MyApp Metrics\n    last_value(\"my_app.users.total\"),\n    last_value(\"my_app.my_server.memory\", unit: :byte),\n    last_value(\"my_app.my_server.message_queue_len\")\n    summary(\"my_app.my_server.call.stop.duration\"),\n    counter(\"my_app.my_server.call.exception\")\n  ]\nend\n```\n\n> You will implement MyApp.MyServer in the\n[Custom Events](#custom-events) section.","ref":"telemetry.html#periodic-measurements"},{"type":"extras","title":"Libraries using Telemetry - Telemetry","doc":"Telemetry is quickly becoming the de-facto standard for\npackage instrumentation in Elixir. Here is a list of\nlibraries currently emitting `:telemetry` events.\n\nLibrary authors are actively encouraged to send a PR adding\ntheir own (in alphabetical order, please):\n\n* [Absinthe](https://hexdocs.pm/absinthe) - [Events](https://hexdocs.pm/absinthe/telemetry.html)\n* [Ash Framework](https://hexdocs.pm/ash) - [Events](https://hexdocs.pm/ash/monitoring.html)\n* [Broadway](https://hexdocs.pm/broadway) - [Events](https://hexdocs.pm/broadway/Broadway.html#module-telemetry)\n* [Ecto](https://hexdocs.pm/ecto) - [Events](https://hexdocs.pm/ecto/Ecto.Repo.html#module-telemetry-events)\n* [Oban](https://hexdocs.pm/oban) - [Events](https://hexdocs.pm/oban/Oban.Telemetry.html)\n* [Phoenix](https://hexdocs.pm/phoenix) - [Events](https://hexdocs.pm/phoenix/Phoenix.Logger.html#module-instrumentation)\n* [Plug](https://hexdocs.pm/plug) - [Events](https://hexdocs.pm/plug/Plug.Telemetry.html)\n* [Tesla](https://hexdocs.pm/tesla) - [Events](https://hexdocs.pm/tesla/Tesla.Middleware.Telemetry.html)","ref":"telemetry.html#libraries-using-telemetry"},{"type":"extras","title":"Custom Events - Telemetry","doc":"If you need custom metrics and instrumentation in your\napplication, you can utilize the `:telemetry` package\n( ) just like your favorite\nframeworks and libraries.\n\nHere is an example of a simple GenServer that emits telemetry\nevents. Create this file in your app at\n`lib/my_app/my_server.ex`:\n\n```elixir\n# lib/my_app/my_server.ex\ndefmodule MyApp.MyServer do\n  @moduledoc \"\"\"\n  An example GenServer that runs arbitrary functions and emits telemetry events when called.\n  \"\"\"\n  use GenServer\n\n  # A common prefix for :telemetry events\n  @prefix [:my_app, :my_server, :call]\n\n  def start_link(fun) do\n    GenServer.start_link(__MODULE__, fun, name: __MODULE__)\n  end\n\n  @doc \"\"\"\n  Runs the function contained within this server.","ref":"telemetry.html#custom-events"},{"type":"extras","title":"Events - Telemetry","doc":"The following events may be emitted:\n\n    * `[:my_app, :my_server, :call, :start]` - Dispatched\n      immediately before invoking the function. This event\n      is always emitted.\n\n      * Measurement: `%{system_time: system_time}`\n\n      * Metadata: `%{}`\n\n    * `[:my_app, :my_server, :call, :stop]` - Dispatched\n      immediately after successfully invoking the function.\n\n      * Measurement: `%{duration: native_time}`\n\n      * Metadata: `%{}`\n\n    * `[:my_app, :my_server, :call, :exception]` - Dispatched\n      immediately after invoking the function, in the event\n      the function throws or raises.\n\n      * Measurement: `%{duration: native_time}`\n\n      * Metadata: `%{kind: kind, reason: reason, stacktrace: stacktrace}`\n  \"\"\"\n  def call!, do: GenServer.call(__MODULE__, :called)\n\n  @impl true\n  def init(fun) when is_function(fun, 0), do: {:ok, fun}\n\n  @impl true\n  def handle_call(:called, _from, fun) do\n    # Wrap the function invocation in a \"span\"\n    result = telemetry_span(fun)\n\n    {:reply, result, fun}\n  end\n\n  # Emits telemetry events related to invoking the function\n  defp telemetry_span(fun) do\n    start_time = emit_start()\n\n    try do\n      fun.()\n    catch\n      kind, reason ->\n        stacktrace = System.stacktrace()\n        duration = System.monotonic_time() - start_time\n        emit_exception(duration, kind, reason, stacktrace)\n        :erlang.raise(kind, reason, stacktrace)\n    else\n      result ->\n        duration = System.monotonic_time() - start_time\n        emit_stop(duration)\n        result\n    end\n  end\n\n  defp emit_start do\n    start_time_mono = System.monotonic_time()\n\n    :telemetry.execute(\n      @prefix ++ [:start],\n      %{system_time: System.system_time()},\n      %{}\n    )\n\n    start_time_mono\n  end\n\n  defp emit_stop(duration) do\n    :telemetry.execute(\n      @prefix ++ [:stop],\n      %{duration: duration},\n      %{}\n    )\n  end\n\n  defp emit_exception(duration, kind, reason, stacktrace) do\n    :telemetry.execute(\n      @prefix ++ [:exception],\n      %{duration: duration},\n      %{\n        kind: kind,\n        reason: reason,\n        stacktrace: stacktrace\n      }\n    )\n  end\nend\n```\n\nand add it to your application's supervisor tree (usually in\n`lib/my_app/application.ex`), giving it a function to invoke\nwhen called:\n\n```elixir\n# lib/my_app/application.ex\nchildren = [\n  # Start a server that greets the world\n  {MyApp.MyServer, fn -> \"Hello, world!\" end},\n]\n```\n\nNow start an IEx session and call the server:\n\n```elixir\niex> MyApp.MyServer.call!\n```\n\nand you should see something like the following output:\n\n```text\n[Telemetry.Metrics.ConsoleReporter] Got new event!\nEvent name: my_app.my_server.call.stop\nAll measurements: %{duration: 4000}\nAll metadata: %{}\n\nMetric measurement: #Function<2.111777250/1 in Telemetry.Metrics.maybe_convert_measurement/2> (summary)\nWith value: 0.004 millisecond\nTag values: %{}\n\n\"Hello, world!\"\n```","ref":"telemetry.html#events"},{"type":"extras","title":"Asset Management","doc":"# Asset Management\n\nBeside producing HTML, most web applications have various assets (JavaScript, CSS, images, fonts and so on).\n\nFrom Phoenix v1.7, new applications use [esbuild](https://esbuild.github.io/) to prepare assets via the [Elixir esbuild wrapper](https://github.com/phoenixframework/esbuild), and [tailwindcss](https://tailwindcss.com) via the [Elixir tailwindcss wrapper](https://github.com/phoenixframework/tailwind) for CSS. The direct integration with `esbuild` and `tailwind` means that newly generated applications do not have dependencies on Node.js or an external build system (e.g. Webpack).\n\nYour JavaScript is typically placed at \"assets/js/app.js\" and `esbuild` will extract it to \"priv/static/assets/app.js\". In development, this is done automatically via the `esbuild` watcher. In production, this is done by running `mix assets.deploy`.\n\n`esbuild` can also handle your CSS files, but by default `tailwind` handles all CSS building.\n\nFinally, all other assets, that usually don't have to be preprocessed, go directly to \"priv/static\".","ref":"asset_management.html"},{"type":"extras","title":"Third-party JS packages - Asset Management","doc":"If you want to import JavaScript dependencies, you have at least three options to add them to your application:\n\n1. Vendor those dependencies inside your project and import them in your \"assets/js/app.js\" using a relative path:\n\n   ```js\n   import topbar from \"../vendor/topbar\"\n   ```\n\n2. Call `npm install topbar --save` inside your assets directory and `esbuild` will be able to automatically pick them up:\n\n   ```js\n   import topbar from \"topbar\"\n   ```\n\n3. Use Mix to track the dependency from a source repository:\n\n   ```elixir\n   # mix.exs\n   {:topbar, github: \"buunguyen/topbar\", app: false, compile: false}\n   ```\n\n   Run `mix deps.get` to fetch the dependency and then import it:\n\n   ```js\n   import topbar from \"topbar\"\n   ```\n\n   New applications use this third approach to import Heroicons, avoiding\n   vendoring a copy of all icons when you may only use a few or even none,\n   avoiding Node.js and `npm`, and tracking an explicit version that is easy to\n   update thanks to Mix. It is important to note that git dependencies cannot\n   be used by Hex packages, so if you intend to publish your project to Hex,\n   consider vendoring the files instead.","ref":"asset_management.html#third-party-js-packages"},{"type":"extras","title":"Images, fonts, and external files - Asset Management","doc":"If you reference an external file in your CSS or JavaScript files, `esbuild` will attempt to validate and manage them, unless told otherwise.\n\nFor example, imagine you want to reference `priv/static/images/bg.png`, served at `/images/bg.png`, from your CSS file:\n\n```css\nbody {\n  background-image: url(/images/bg.png);\n}\n```\n\nThe above may fail with the following message:\n\n```text\nerror: Could not resolve \"/images/bg.png\" (mark it as external to exclude it from the bundle)\n```\n\nGiven the images are already managed by Phoenix, you need to mark all resources from `/images` (and also `/fonts`) as external, as the error message says. This is what Phoenix does by default for new apps since v1.6.1+. In your `config/config.exs`, you will find:\n\n```elixir\nargs: ~w(js/app.js --bundle --target=es2017 --outdir=../priv/static/assets --external:/fonts/* --external:/images/*),\n```\n\nIf you need to reference other directories, you need to update the arguments above accordingly. Note running `mix phx.digest` will create digested files for all of the assets in `priv/static`, so your images and fonts are still cache-busted.","ref":"asset_management.html#images-fonts-and-external-files"},{"type":"extras","title":"Esbuild plugins - Asset Management","doc":"Phoenix's default configuration of `esbuild` (via the Elixir wrapper) does not allow you to use [esbuild plugins](https://esbuild.github.io/plugins/). If you want to use an esbuild plugin, for example to compile SASS files to CSS, you can replace the default build system with a custom build script.\n\nThe following is an example of a custom build using esbuild via Node.JS. First of all, you'll need to install Node.js in development and make it available for your production build step.\n\nThen you'll need to add `esbuild` to your Node.js packages and the Phoenix packages. Inside the `assets` directory, run:\n\n```console\n$ npm install esbuild --save-dev\n$ npm install ../deps/phoenix ../deps/phoenix_html ../deps/phoenix_live_view --save\n```\n\nor, for Yarn:\n\n```console\n$ yarn add --dev esbuild\n$ yarn add ../deps/phoenix ../deps/phoenix_html ../deps/phoenix_live_view\n```\n\nNext, add a custom JavaScript build script. We'll call the example `assets/build.js`:\n\n```js\nconst esbuild = require(\"esbuild\");\n\nconst args = process.argv.slice(2);\nconst watch = args.includes('--watch');\nconst deploy = args.includes('--deploy');\n\nconst loader = {\n  // Add loaders for images/fonts/etc, e.g. { '.svg': 'file' }\n};\n\nconst plugins = [\n  // Add and configure plugins here\n];\n\n// Define esbuild options\nlet opts = {\n  entryPoints: [\"js/app.js\"],\n  bundle: true,\n  logLevel: \"info\",\n  target: \"es2017\",\n  outdir: \"../priv/static/assets\",\n  external: [\"*.css\", \"fonts/*\", \"images/*\"],\n  nodePaths: [\"../deps\"],\n  loader: loader,\n  plugins: plugins,\n};\n\nif (deploy) {\n  opts = {\n    ...opts,\n    minify: true,\n  };\n}\n\nif (watch) {\n  opts = {\n    ...opts,\n    sourcemap: \"inline\",\n  };\n  esbuild\n    .context(opts)\n    .then((ctx) => {\n      ctx.watch();\n    })\n    .catch((_error) => {\n      process.exit(1);\n    });\n} else {\n  esbuild.build(opts);\n}\n```\n\nThis script covers following use cases:\n\n- `node build.js`: builds for development & testing (useful on CI)\n- `node build.js --watch`: like above, but watches for changes continuously\n- `node build.js --deploy`: builds minified assets for production\n\nModify `config/dev.exs` so that the script runs whenever you change files, replacing the existing `:esbuild` configuration under `watchers`:\n\n```elixir\nconfig :hello, HelloWeb.Endpoint,\n  ...\n  watchers: [\n    node: [\"build.js\", \"--watch\", cd: Path.expand(\"../assets\", __DIR__)]\n  ],\n  ...\n```\n\nModify the `aliases` task in `mix.exs` to install `npm` packages during `mix setup` and use the new `esbuild` on `mix assets.deploy`:\n\n```elixir\n  defp aliases do\n    [\n      setup: [\"deps.get\", \"ecto.setup\", \"cmd --cd assets npm install\"],\n      ...,\n      \"assets.deploy\": [\"cmd --cd assets node build.js --deploy\", \"phx.digest\"]\n    ]\n  end\n```\n\nFinally, remove the `esbuild` configuration from `config/config.exs` and remove the dependency from the `deps` function in your `mix.exs`, and you are done!","ref":"asset_management.html#esbuild-plugins"},{"type":"extras","title":"Alternative JS build tools - Asset Management","doc":"If you are writing an API or you want to use another asset build tool, you may want to remove the `esbuild` Hex package (see steps below). Then you must follow the additional steps required by the third-party tool.","ref":"asset_management.html#alternative-js-build-tools"},{"type":"extras","title":"Remove esbuild - Asset Management","doc":"1. Remove the `esbuild` configuration in `config/config.exs` and `config/dev.exs`,\n2. Remove the `assets.deploy` task defined in `mix.exs`,\n3. Remove the `esbuild` dependency from `mix.exs`,\n4. Unlock the `esbuild` dependency:\n\n```console\n$ mix deps.unlock esbuild\n```","ref":"asset_management.html#remove-esbuild"},{"type":"extras","title":"Alternative CSS frameworks - Asset Management","doc":"By default, Phoenix generates CSS with the `tailwind` library and its default plugins.\n\nIf you want to use external `tailwind` plugins or another CSS framework, you should replace the `tailwind` Hex package (see steps below). Then you can use an `esbuild` plugin (as outlined above) or even bring a separate framework altogether.","ref":"asset_management.html#alternative-css-frameworks"},{"type":"extras","title":"Remove tailwind - Asset Management","doc":"1. Remove the `tailwind` configuration in `config/config.exs` and `config/dev.exs`,\n2. Remove the `assets.deploy` task defined in `mix.exs`,\n3. Remove the `tailwind` dependency from `mix.exs`,\n4. Unlock the `tailwind` dependency:\n\n```console\n$ mix deps.unlock tailwind\n```\n\nYou may optionally remove and delete the `heroicons` dependency as well.","ref":"asset_management.html#remove-tailwind"},{"type":"extras","title":"mix phx.gen.auth","doc":"# mix phx.gen.auth\n\nThe `mix phx.gen.auth` command generates a flexible, pre-built authentication system into your Phoenix app. This generator allows you to quickly move past the task of adding authentication to your codebase and stay focused on the real-world problem your application is trying to solve.","ref":"mix_phx_gen_auth.html"},{"type":"extras","title":"Getting started - mix phx.gen.auth","doc":"> Before running this command, consider committing your work as it generates multiple files.\n\nLet's start by running the following command from the root of our app (or `apps/my_app_web` in an umbrella app):\n\n```console\n$ mix phx.gen.auth Accounts User users\n\nAn authentication system can be created in two different ways:\n- Using Phoenix.LiveView (default)\n- Using Phoenix.Controller only\n\nDo you want to create a LiveView based authentication system? [Y/n] Y\n```\n\nThe authentication generators support Phoenix LiveView, for enhanced UX, so we'll answer `Y` here. You may also answer `n` for a controller based authentication system.\n\nEither approach will create an `Accounts` context with an `Accounts.User` schema module. The final argument is the plural version of the schema module, which is used for generating database table names and route paths. The `mix phx.gen.auth` generator is similar to `mix phx.gen.html` except it does not accept a list of additional fields to add to the schema, and it generates many more context functions.\n\nSince this generator installed additional dependencies in `mix.exs`, let's fetch those:\n\n```console\n$ mix deps.get\n```\n\nNow we need to verify the database connection details for the development and test environments in `config/` so the migrator and tests can run properly. Then run the following to create the database:\n\n```console\n$ mix ecto.setup\n```\n\nLet's run the tests to make sure our new authentication system works as expected.\n\n```console\n$ mix test\n```\n\nAnd finally, let's start our Phoenix server and try it out.\n\n```console\n$ mix phx.server\n```","ref":"mix_phx_gen_auth.html#getting-started"},{"type":"extras","title":"Developer responsibilities - mix phx.gen.auth","doc":"Since Phoenix generates this code into your application instead of building these modules into Phoenix itself, you now have complete freedom to modify the authentication system, so it works best with your use case. The one caveat with using a generated authentication system is it will not be updated after it's been generated. Therefore, as improvements are made to the output of `mix phx.gen.auth`, it becomes your responsibility to determine if these changes need to be ported into your application. Security-related and other important improvements will be explicitly and clearly marked in the `CHANGELOG.md` file and upgrade notes.","ref":"mix_phx_gen_auth.html#developer-responsibilities"},{"type":"extras","title":"Generated code - mix phx.gen.auth","doc":"The following are notes about the generated authentication system.","ref":"mix_phx_gen_auth.html#generated-code"},{"type":"extras","title":"Password hashing - mix phx.gen.auth","doc":"The password hashing mechanism defaults to `bcrypt` for Unix systems and `pbkdf2` for Windows systems. Both systems use the [Comeonin interface](https://hexdocs.pm/comeonin/).\n\nThe password hashing mechanism can be overridden with the `--hashing-lib` option. The following values are supported:\n\n  * `bcrypt` - [bcrypt_elixir](https://hex.pm/packages/bcrypt_elixir)\n  * `pbkdf2` - [pbkdf2_elixir](https://hex.pm/packages/pbkdf2_elixir)\n  * `argon2` - [argon2_elixir](https://hex.pm/packages/argon2_elixir)\n\nWe recommend developers to consider using `argon2`, which is the most robust of all 3. The downside is that `argon2` is quite CPU and memory intensive, and you will need more powerful instances to run your applications on.\n\nFor more information about choosing these libraries, see the [Comeonin project](https://github.com/riverrun/comeonin).","ref":"mix_phx_gen_auth.html#password-hashing"},{"type":"extras","title":"Forbidding access - mix phx.gen.auth","doc":"The generated code ships with an authentication module with a handful of plugs that fetch the current user, require authentication and so on. For instance, in an app named Demo which had `mix phx.gen.auth Accounts User users` run on it, you will find a module named `DemoWeb.UserAuth` with plugs such as:\n\n  * `fetch_current_user` - fetches the current user information if available\n  * `require_authenticated_user` - must be invoked after `fetch_current_user` and requires that a current user exists and is authenticated\n  * `redirect_if_user_is_authenticated` - used for the few pages that must not be available to authenticated users","ref":"mix_phx_gen_auth.html#forbidding-access"},{"type":"extras","title":"Confirmation - mix phx.gen.auth","doc":"The generated functionality ships with an account confirmation mechanism, where users have to confirm their account, typically by email. However, the generated code does not forbid users from using the application if their accounts have not yet been confirmed. You can add this functionality by customizing the `require_authenticated_user` in the `Auth` module to check for the `confirmed_at` field (and any other property you desire).","ref":"mix_phx_gen_auth.html#confirmation"},{"type":"extras","title":"Notifiers - mix phx.gen.auth","doc":"The generated code is not integrated with any system to send SMSes or emails for confirming accounts, resetting passwords, etc. Instead, it simply logs a message to the terminal. It is your responsibility to integrate with the proper system after generation.\n\nNote that if you generated your Phoenix project with `mix phx.new`, your project is configured to use [Swoosh](https://hexdocs.pm/swoosh/Swoosh.html) mailer by default. To view notifier emails during development with Swoosh, navigate to `/dev/mailbox`.","ref":"mix_phx_gen_auth.html#notifiers"},{"type":"extras","title":"Tracking sessions - mix phx.gen.auth","doc":"All sessions and tokens are tracked in a separate table. This allows you to track how many sessions are active for each account. You could even expose this information to users if desired.\n\nNote that whenever the password changes (either via reset password or directly), all tokens are deleted, and the user has to log in again on all devices.","ref":"mix_phx_gen_auth.html#tracking-sessions"},{"type":"extras","title":"User Enumeration attacks - mix phx.gen.auth","doc":"A user enumeration attack allows someone to check if an email is registered in the application. The generated authentication code does not attempt to protect from such checks. For instance, when you register an account, if the email is already registered, the code will notify the user the email is already registered.\n\nIf your application is sensitive to enumeration attacks, you need to implement your own workflows, which tends to be very different from most applications, as you need to carefully balance security and user experience.\n\nFurthermore, if you are concerned about enumeration attacks, beware of timing attacks too. For example, registering a new account typically involves additional work (such as writing to the database, sending emails, etc) compared to when an account already exists. Someone could measure the time taken to execute those additional tasks to enumerate emails. This applies to all endpoints (registration, confirmation, password recovery, etc.) that may send email, in-app notifications, etc.","ref":"mix_phx_gen_auth.html#user-enumeration-attacks"},{"type":"extras","title":"Case sensitiveness - mix phx.gen.auth","doc":"The email lookup is made to be case-insensitive. Case-insensitive lookups are the default in MySQL and MSSQL. In SQLite3 we use [`COLLATE NOCASE`](https://www.sqlite.org/datatype3.html#collating_sequences) in the column definition to support it. In PostgreSQL, we use the [`citext` extension](https://www.postgresql.org/docs/current/citext.html).\n\nNote `citext` is part of PostgreSQL itself and is bundled with it in most operating systems and package managers. `mix phx.gen.auth` takes care of creating the extension and no extra work is necessary in the majority of cases. If by any chance your package manager splits `citext` into a separate package, you will get an error while migrating, and you can most likely solve it by installing the `postgres-contrib` package.","ref":"mix_phx_gen_auth.html#case-sensitiveness"},{"type":"extras","title":"Concurrent tests - mix phx.gen.auth","doc":"The generated tests run concurrently if you are using a database that supports concurrent tests, which is the case of PostgreSQL.","ref":"mix_phx_gen_auth.html#concurrent-tests"},{"type":"extras","title":"More about `mix phx.gen.auth` - mix phx.gen.auth","doc":"Check out `mix phx.gen.auth` for more details, such as using a different password hashing library, customizing the web module namespace, generating binary id type, configuring the default options, and using custom table names.","ref":"mix_phx_gen_auth.html#more-about-mix-phx-gen-auth"},{"type":"extras","title":"Additional resources - mix phx.gen.auth","doc":"The following links have more information regarding the motivation and design of the code this generates.\n\n  * Berenice Medel's blog post on generating LiveViews for authentication (rather than conventional Controllers & Views) - [Bringing Phoenix Authentication to Life](https://fly.io/phoenix-files/phx-gen-auth/)\n  * José Valim's blog post - [An upcoming authentication solution for Phoenix](https://dashbit.co/blog/a-new-authentication-solution-for-phoenix)\n  * The [original `phx_gen_auth` repo][phx_gen_auth repo] (for Phoenix 1.5 applications) - This is a great resource to see discussions around decisions that have been made in earlier versions of the project.\n  * [Original pull request on bare Phoenix app][auth PR]\n  * [Original design spec](https://github.com/dashbitco/mix_phx_gen_auth_demo/blob/auth/README.md)\n\n[phx_gen_auth repo]: https://github.com/aaronrenner/phx_gen_auth\n[auth PR]: https://github.com/dashbitco/mix_phx_gen_auth_demo/pull/1","ref":"mix_phx_gen_auth.html#additional-resources"},{"type":"extras","title":"API Authentication","doc":"# API Authentication\n\n> **Requirement**: This guide expects that you have gone through the [`mix phx.gen.auth`](mix_phx_gen_auth.html) guide.\n\nThis guide shows how to add API authentication on top of `mix phx.gen.auth`. Since the authentication generator already includes a token table, we use it to store API tokens too, following the best security practices.\n\nWe will break this guide in two parts: augmenting the context and the plug implementation. We will assume that the following `mix phx.gen.auth` command was executed:\n\n```\n$ mix phx.gen.auth Accounts User users\n```\n\nIf you ran something else, it should be trivial to adapt the names.","ref":"api_authentication.html"},{"type":"extras","title":"Adding API functions to the context - API Authentication","doc":"Our authentication system will require two functions. One to create the API token and another to verify it. Open up `lib/my_app/accounts.ex` and add these two new functions:\n\n```elixir","ref":"api_authentication.html#adding-api-functions-to-the-context"},{"type":"extras","title":"API - API Authentication","doc":"@doc \"\"\"\n  Creates a new api token for a user.\n\n  The token returned must be saved somewhere safe.\n  This token cannot be recovered from the database.\n  \"\"\"\n  def create_user_api_token(user) do\n    {encoded_token, user_token} = UserToken.build_email_token(user, \"api-token\")\n    Repo.insert!(user_token)\n    encoded_token\n  end\n\n  @doc \"\"\"\n  Fetches the user by API token.\n  \"\"\"\n  def fetch_user_by_api_token(token) do\n    with {:ok, query} <- UserToken.verify_email_token_query(token, \"api-token\"),\n         %User{} = user <- Repo.one(query) do\n      {:ok, user}\n    else\n      _ -> :error\n    end\n  end\n```\n\nThe new functions use the existing `UserToken` functionality to store a new type of token called \"api-token\". Because this is an email token, if the user changes their email, the tokens will be expired.\n\nAlso notice we called the second function `fetch_user_by_api_token`, instead of `get_user_by_api_token`. Because we want to render different status codes in our API, depending if a user was found or not, we return `{:ok, user}` or `:error`. Elixir's convention is to call these functions `fetch_*`, instead of `get_*` which would usually return `nil` instead of tuples.\n\nTo make sure our new functions work, let's write tests. Open up `test/my_app/accounts_test.exs` and add this new describe block:\n\n```elixir\n  describe \"create_user_api_token/1 and fetch_user_by_api_token/1\" do\n    test \"creates and fetches by token\" do\n      user = user_fixture()\n      token = Accounts.create_user_api_token(user)\n      assert Accounts.fetch_user_by_api_token(token) == {:ok, user}\n      assert Accounts.fetch_user_by_api_token(\"invalid\") == :error\n    end\n  end\n```\n\nIf you run the tests, they will actually fail. Something similar to this:\n\n```elixir\n1) test create_user_api_token/1 and fetch_user_by_api_token/1 creates and verify token (Demo.AccountsTest)\n   test/demo/accounts_test.exs:21\n   ** (FunctionClauseError) no function clause matching in Demo.Accounts.UserToken.days_for_context/1\n\n   The following arguments were given to Demo.Accounts.UserToken.days_for_context/1:\n\n       # 1\n       \"api-token\"\n\n   Attempted function clauses (showing 2 out of 2):\n\n       defp days_for_context(\"confirm\")\n       defp days_for_context(\"reset_password\")\n\n   code: assert Accounts.verify_api_token(token) == {:ok, user}\n   stacktrace:\n     (demo 0.1.0) lib/demo/accounts/user_token.ex:129: Demo.Accounts.UserToken.days_for_context/1\n     (demo 0.1.0) lib/demo/accounts/user_token.ex:114: Demo.Accounts.UserToken.verify_email_token_query/2\n     (demo 0.1.0) lib/demo/accounts.ex:301: Demo.Accounts.verify_api_token/1\n     test/demo/accounts_test.exs:24: (test)\n```\n\nIf you prefer, try looking at the error and fixing it yourself. The explanation will come next.\n\nThe `UserToken` module expects us to declare the validity of each token and we haven't defined one for \"api-token\". The length is going to depend on your application and how sensitive it is in terms of security. For this example, let's say the token is valid for 365 days.\n\nOpen up `lib/my_app/accounts/user_token.ex`, find where `defp days_for_context` is defined, and add a new clause, like this:\n\n```elixir\n  defp days_for_context(\"api-token\"), do: 365\n  defp days_for_context(\"confirm\"), do: @confirm_validity_in_days\n  defp days_for_context(\"reset_password\"), do: @reset_password_validity_in_days\n```\n\nNow tests should pass and we are ready to move forward!","ref":"api_authentication.html#api"},{"type":"extras","title":"API authentication plug - API Authentication","doc":"The last part is to add authentication to our API.\n\nWhen we ran `mix phx.gen.auth`, it generated a `MyAppWeb.UserAuth` module with several plugs, which are small functions that receive the `conn` and customize our request/response life-cycle. Open up `lib/my_app_web/user_auth.ex` and add this new function:\n\n```elixir\ndef fetch_api_user(conn, _opts) do\n  with [\"Bearer \" <> token] <- get_req_header(conn, \"authorization\"),\n       {:ok, user} <- Accounts.fetch_user_by_api_token(token) do\n    assign(conn, :current_user, user)\n  else\n    _ ->\n      conn\n      |> send_resp(:unauthorized, \"No access for you\")\n      |> halt()\n  end\nend\n```\n\nOur function receives the connection and checks if the \"authorization\" header has been set with \"Bearer TOKEN\", where \"TOKEN\" is the value returned by `Accounts.create_user_api_token/1`. In case the token is not valid or there is no such user, we abort the request.\n\nFinally, we need to add this `plug` to our pipeline. Open up `lib/my_app_web/router.ex` and you will find a pipeline for API. Let's add our new plug under it, like this:\n\n```elixir\n  pipeline :api do\n    plug :accepts, [\"json\"]\n    plug :fetch_api_user\n  end\n```\n\nNow you are ready to receive and validate API requests. Feel free to open up `test/my_app_web/user_auth_test.exs` and write your own test. You can use the tests for other plugs as templates!","ref":"api_authentication.html#api-authentication-plug"},{"type":"extras","title":"Your turn - API Authentication","doc":"The overall API authentication flow will depend on your application.\n\nIf you want to use this token in a JavaScript client, you will need to slightly alter the `UserSessionController` to invoke `Accounts.create_user_api_token/1` and return a JSON response and include the token returned it.\n\nIf you want to provide APIs for 3rd-party users, you will need to allow them to create tokens, and show the result of `Accounts.create_user_api_token/1` to them. They must save these tokens somewhere safe and include them as part of their requests using the \"authorization\" header.","ref":"api_authentication.html#your-turn"},{"type":"extras","title":"Channels","doc":"# Channels\n\n> **Requirement**: This guide expects that you have gone through the [introductory guides](installation.html) and got a Phoenix application [up and running](up_and_running.html).\n\nChannels are an exciting part of Phoenix that enable soft real-time communication with and between millions of connected clients.\n\nSome possible use cases include:\n\n- Chat rooms and APIs for messaging apps\n- Breaking news, like \"a goal was scored\" or \"an earthquake is coming\"\n- Tracking trains, trucks, or race participants on a map\n- Events in multiplayer games\n- Monitoring sensors and controlling lights\n- Notifying a browser that a page's CSS or JavaScript has changed (this is handy in development)\n\nConceptually, Channels are pretty simple.\n\nFirst, clients connect to the server using some transport, like WebSocket. Once connected, they join one or more topics. For example, to interact with a public chat room clients may join a topic called `public_chat`, and to receive updates from a product with ID 7, they may need to join a topic called `product_updates:7`.\n\nClients can push messages to the topics they've joined, and can also receive messages from them. The other way around, Channel servers receive messages from their connected clients, and can push messages to them too.\n\nServers are able to broadcast messages to all clients subscribed to a certain topic. This is illustrated in the following diagram:\n\n```plaintext\n                                                                  +----------------+\n                                                     +--Topic X-->| Mobile Client  |\n                                                     |            +----------------+\n                              +-------------------+  |\n+----------------+            |                   |  |            +----------------+\n| Browser Client |--Topic X-->| Phoenix Server(s) |--+--Topic X-->| Desktop Client |\n+----------------+            |                   |  |            +----------------+\n                              +-------------------+  |\n                                                     |            +----------------+\n                                                     +--Topic X-->|   IoT Client   |\n                                                                  +----------------+\n```\n\nBroadcasts work even if the application runs on several nodes/computers. That is, if two clients have their socket connected to different application nodes and are subscribed to the same topic `T`, both of them will receive messages broadcasted to `T`. That is possible thanks to an internal PubSub mechanism.\n\nChannels can support any kind of client: a browser, native app, smart watch, embedded device, or anything else that can connect to a network.\nAll the client needs is a suitable library; see the [Client Libraries](#client-libraries) section below.\nEach client library communicates using one of the \"transports\" that Channels understand.\nCurrently, that's either Websockets or long polling, but other transports may be added in the future.\n\nUnlike stateless HTTP connections, Channels support long-lived connections, each backed by a lightweight BEAM process, working in parallel and maintaining its own state.\n\nThis architecture scales well; Phoenix Channels [can support millions of subscribers with reasonable latency on a single box](https://phoenixframework.org/blog/the-road-to-2-million-websocket-connections), passing hundreds of thousands of messages per second.\nAnd that capacity can be multiplied by adding more nodes to the cluster.","ref":"channels.html"},{"type":"extras","title":"The Moving Parts - Channels","doc":"Although Channels are simple to use from a client perspective, there are a number of components involved in routing messages to clients across a cluster of servers.\nLet's take a look at them.","ref":"channels.html#the-moving-parts"},{"type":"extras","title":"Overview - Channels","doc":"To start communicating, a client connects to a node (a Phoenix server) using a transport (e.g., Websockets or long polling) and joins one or more channels using that single network connection.\nOne channel server lightweight process is created per client, per topic. Each channel holds onto the `%Phoenix.Socket{}` and can maintain any state it needs within its `socket.assigns`.\n\nOnce the connection is established, each incoming message from a client is routed, based on its topic, to the correct channel server.\nIf the channel server asks to broadcast a message, that message is sent to the local PubSub, which sends it out to any clients connected to the same server and subscribed to that topic.\n\nIf there are other nodes in the cluster, the local PubSub also forwards the message to their PubSubs, which send it out to their own subscribers.\nBecause only one message has to be sent per additional node, the performance cost of adding nodes is negligible, while each new node supports many more subscribers.\n\nThe message flow looks something like this:\n\n```plaintext\n                                 Channel   +-------------------------+      +--------+\n                                  route    | Sending Client, Topic 1 |      | Local  |\n                              +----------->|     Channel.Server      |----->| PubSub |--+\n+----------------+            |            +-------------------------+      +--------+  |\n| Sending Client |-Transport--+                                                  |      |\n+----------------+                         +-------------------------+           |      |\n                                           | Sending Client, Topic 2 |           |      |\n                                           |     Channel.Server      |           |      |\n                                           +-------------------------+           |      |\n                                                                                 |      |\n                                           +-------------------------+           |      |\n+----------------+                         | Browser Client, Topic 1 |           |      |\n| Browser Client |<-------Transport--------|     Channel.Server      |<----------+      |\n+----------------+                         +-------------------------+                  |\n                                                                                        |\n                                                                                        |\n                                                                                        |\n                                           +-------------------------+                  |\n+----------------+                         |  Phone Client, Topic 1  |                  |\n|  Phone Client  |<-------Transport--------|     Channel.Server      |<-+               |\n+----------------+                         +-------------------------+  |   +--------+  |\n                                                                        |   | Remote |  |\n                                           +-------------------------+  +---| PubSub |<-+\n+----------------+                         |  Watch Client, Topic 1  |  |   +--------+  |\n|  Watch Client  |<-------Transport--------|     Channel.Server      |<-+               |\n+----------------+                         +-------------------------+                  |\n                                                                                        |\n                                                                                        |\n                                           +-------------------------+      +--------+  |\n+----------------+                         |   IoT Client, Topic 1   |      | Remote |  |\n|   IoT Client   |<-------Transport--------|     Channel.Server      |<-----| PubSub |<-+\n+----------------+                         +-------------------------+      +--------+\n```","ref":"channels.html#overview"},{"type":"extras","title":"Endpoint - Channels","doc":"In your Phoenix app's `Endpoint` module, a `socket` declaration specifies which socket handler will receive connections on a given URL.\n\n```elixir\nsocket \"/socket\", HelloWeb.UserSocket,\n  websocket: true,\n  longpoll: false\n```\n\nPhoenix comes with two default transports: websocket and longpoll. You can configure them directly via the `socket` declaration.","ref":"channels.html#endpoint"},{"type":"extras","title":"Socket Handlers - Channels","doc":"On the client side, you will establish a socket connection to the route above:\n\n```javascript\nlet socket = new Socket(\"/socket\", {params: {token: window.userToken}})\n```\n\nOn the server, Phoenix will invoke `HelloWeb.UserSocket.connect/2`, passing your parameters and the initial socket state. Within the socket, you can authenticate and identify a socket connection and set default socket assigns. The socket is also where you define your channel routes.","ref":"channels.html#socket-handlers"},{"type":"extras","title":"Channel Routes - Channels","doc":"Channel routes match on the topic string and dispatch matching requests to the given Channel module.\n\nThe star character `*` acts as a wildcard matcher, so in the following example route, requests for `room:lobby` and `room:123` would both be dispatched to the `RoomChannel`. In your `UserSocket`, you would have:\n\n```elixir\nchannel \"room:*\", HelloWeb.RoomChannel\n```","ref":"channels.html#channel-routes"},{"type":"extras","title":"Channels - Channels","doc":"Channels handle events from clients, so they are similar to Controllers, but there are two key differences. Channel events can go both directions - incoming and outgoing. Channel connections also persist beyond a single request/response cycle. Channels are the highest level abstraction for real-time communication components in Phoenix.\n\nEach Channel will implement one or more clauses of each of these four callback functions - `join/3`, `terminate/2`, `handle_in/3`, and `handle_out/3`.","ref":"channels.html#channels"},{"type":"extras","title":"Topics - Channels","doc":"Topics are string identifiers - names that the various layers use in order to make sure messages end up in the right place. As we saw above, topics can use wildcards. This allows for a useful `\"topic:subtopic\"` convention. Often, you'll compose topics using record IDs from your application layer, such as `\"users:123\"`.","ref":"channels.html#topics"},{"type":"extras","title":"Messages - Channels","doc":"The `Phoenix.Socket.Message` module defines a struct with the following keys which denotes a valid message. From the [Phoenix.Socket.Message docs](https://hexdocs.pm/phoenix/Phoenix.Socket.Message.html).\n\n- `topic` - The string topic or `\"topic:subtopic\"` pair namespace, such as `\"messages\"` or `\"messages:123\"`\n- `event` - The string event name, for example `\"phx_join\"`\n- `payload` - The message payload\n- `ref` - The unique string ref","ref":"channels.html#messages"},{"type":"extras","title":"PubSub - Channels","doc":"PubSub is provided by the `Phoenix.PubSub` module. Interested parties can receive events by subscribing to topics. Other processes can broadcast events to certain topics.\n\nThis is useful to broadcast messages on channel and also for application development in general. For instance, letting all connected [live views](https://github.com/phoenixframework/phoenix_live_view) to know that a new comment has been added to a post.\n\nThe PubSub system takes care of getting messages from one node to another so that they can be sent to all subscribers across the cluster.\nBy default, this is done using [Phoenix.PubSub.PG2](https://hexdocs.pm/phoenix_pubsub/Phoenix.PubSub.PG2.html), which uses native BEAM messaging.\n\nIf your deployment environment does not support distributed Elixir or direct communication between servers, Phoenix also ships with a [Redis Adapter](https://hexdocs.pm/phoenix_pubsub_redis/Phoenix.PubSub.Redis.html) that uses Redis to exchange PubSub data. Please see the [Phoenix.PubSub docs](https://hexdocs.pm/phoenix_pubsub/Phoenix.PubSub.html) for more information.","ref":"channels.html#pubsub"},{"type":"extras","title":"Client Libraries - Channels","doc":"Any networked device can connect to Phoenix Channels as long as it has a client library.\nThe following libraries exist today, and new ones are always welcome; to write your own, see our how-to guide [Writing a Channels Client](writing_a_channels_client.md).\n\n#### Official\n\nPhoenix ships with a JavaScript client that is available when generating a new Phoenix project. The documentation for the JavaScript module is available at [https://hexdocs.pm/phoenix/js/](https://hexdocs.pm/phoenix/js/); the code is in [multiple js files](https://github.com/phoenixframework/phoenix/blob/main/assets/js/phoenix/).\n\n#### 3rd Party\n\n+ Swift (iOS)\n  - [SwiftPhoenix](https://github.com/davidstump/SwiftPhoenixClient)\n+ Java (Android)\n  - [JavaPhoenixChannels](https://github.com/eoinsha/JavaPhoenixChannels)\n+ Kotlin (Android)\n  - [JavaPhoenixClient](https://github.com/dsrees/JavaPhoenixClient)\n+ C#\n  - [PhoenixSharp](https://github.com/Mazyod/PhoenixSharp)\n+ Elixir\n  - [phoenix_gen_socket_client](https://github.com/Aircloak/phoenix_gen_socket_client)\n  - [slipstream](https://hexdocs.pm/slipstream/Slipstream.html)\n+ GDScript (Godot Game Engine)\n  - [GodotPhoenixChannels](https://github.com/alfredbaudisch/GodotPhoenixChannels)","ref":"channels.html#client-libraries"},{"type":"extras","title":"Tying it all together - Channels","doc":"Let's tie all these ideas together by building a simple chat application. Make sure [you created a new Phoenix application](https://hexdocs.pm/phoenix/up_and_running.html) and now we are ready to generate the `UserSocket`.","ref":"channels.html#tying-it-all-together"},{"type":"extras","title":"Generating a socket - Channels","doc":"Let's invoke the socket generator to get started:\n\n```console\n$ mix phx.gen.socket User\n```\n\nIt will create two files, the client code in `assets/js/user_socket.js` and the server counter-part in `lib/hello_web/channels/user_socket.ex`. After running, the generator will also ask to add the following line to `lib/hello_web/endpoint.ex`:\n\n```elixir\ndefmodule HelloWeb.Endpoint do\n  use Phoenix.Endpoint, otp_app: :hello\n\n  socket \"/socket\", HelloWeb.UserSocket,\n    websocket: true,\n    longpoll: false\n\n  ...\nend\n```\n\nThe generator also asks us to import the client code, we will do that later.\n\nNext, we will configure our socket to ensure messages get routed to the correct channel. To do that, we'll uncomment the `\"room:*\"` channel definition:\n\n```elixir\ndefmodule HelloWeb.UserSocket do\n  use Phoenix.Socket","ref":"channels.html#generating-a-socket"},{"type":"extras","title":"Channels - Channels","doc":"channel \"room:*\", HelloWeb.RoomChannel\n  ...\n```\n\nNow, whenever a client sends a message whose topic starts with `\"room:\"`, it will be routed to our RoomChannel. Next, we'll define a `HelloWeb.RoomChannel` module to manage our chat room messages.","ref":"channels.html#channels"},{"type":"extras","title":"Joining Channels - Channels","doc":"The first priority of your channels is to authorize clients to join a given topic. For authorization, we must implement `join/3` in `lib/hello_web/channels/room_channel.ex`.\n\n```elixir\ndefmodule HelloWeb.RoomChannel do\n  use Phoenix.Channel\n\n  def join(\"room:lobby\", _message, socket) do\n    {:ok, socket}\n  end\n\n  def join(\"room:\" <> _private_room_id, _params, _socket) do\n    {:error, %{reason: \"unauthorized\"}}\n  end\nend\n```\n\nFor our chat app, we'll allow anyone to join the `\"room:lobby\"` topic, but any other room will be considered private and special authorization, say from a database, will be required.\n(We won't worry about private chat rooms for this exercise, but feel free to explore after we finish.)\n\nWith our channel in place, let's get the client and server talking.\n\nThe generated `assets/js/user_socket.js` defines a simple client based on the socket implementation that ships with Phoenix.\n\nWe can use that library to connect to our socket and join our channel, we just need to set our room name to `\"room:lobby\"` in that file.\n\n```javascript\n// assets/js/user_socket.js\n// ...\nsocket.connect()\n\n// Now that you are connected, you can join channels with a topic:\nlet channel = socket.channel(\"room:lobby\", {})\nchannel.join()\n  .receive(\"ok\", resp => { console.log(\"Joined successfully\", resp) })\n  .receive(\"error\", resp => { console.log(\"Unable to join\", resp) })\n\nexport default socket\n```\n\nAfter that, we need to make sure `assets/js/user_socket.js` gets imported into our application JavaScript file. To do that, uncomment this line in `assets/js/app.js`.\n\n```javascript\n// ...\nimport \"./user_socket.js\"\n```\n\nSave the file and your browser should auto refresh, thanks to the Phoenix live reloader. If everything worked, we should see \"Joined successfully\" in the browser's JavaScript console. Our client and server are now talking over a persistent connection. Now let's make it useful by enabling chat.\n\nIn `lib/hello_web/controllers/page_html/home.html.heex`, we'll replace the existing code with a container to hold our chat messages, and an input field to send them:\n\n```heex\n  \n \n```\n\nNow let's add a couple of event listeners to `assets/js/user_socket.js`:\n\n```javascript\n// ...\nlet channel           = socket.channel(\"room:lobby\", {})\nlet chatInput         = document.querySelector(\"#chat-input\")\nlet messagesContainer = document.querySelector(\"#messages\")\n\nchatInput.addEventListener(\"keypress\", event => {\n  if(event.key === 'Enter'){\n    channel.push(\"new_msg\", {body: chatInput.value})\n    chatInput.value = \"\"\n  }\n})\n\nchannel.join()\n  .receive(\"ok\", resp => { console.log(\"Joined successfully\", resp) })\n  .receive(\"error\", resp => { console.log(\"Unable to join\", resp) })\n\nexport default socket\n```\n\nAll we had to do is detect that enter was pressed and then `push` an event over the channel with the message body. We named the event `\"new_msg\"`. With this in place, let's handle the other piece of a chat application, where we listen for new messages and append them to our messages container.\n\n```javascript\n// ...\nlet channel           = socket.channel(\"room:lobby\", {})\nlet chatInput         = document.querySelector(\"#chat-input\")\nlet messagesContainer = document.querySelector(\"#messages\")\n\nchatInput.addEventListener(\"keypress\", event => {\n  if(event.key === 'Enter'){\n    channel.push(\"new_msg\", {body: chatInput.value})\n    chatInput.value = \"\"\n  }\n})\n\nchannel.on(\"new_msg\", payload => {\n  let messageItem = document.createElement(\"p\")\n  messageItem.innerText = `[${Date()}] ${payload.body}`\n  messagesContainer.appendChild(messageItem)\n})\n\nchannel.join()\n  .receive(\"ok\", resp => { console.log(\"Joined successfully\", resp) })\n  .receive(\"error\", resp => { console.log(\"Unable to join\", resp) })\n\nexport default socket\n```\n\nWe listen for the `\"new_msg\"` event using `channel.on`, and then append the message body to the DOM. Now let's handle the incoming and outgoing events on the server to complete the picture.","ref":"channels.html#joining-channels"},{"type":"extras","title":"Incoming Events - Channels","doc":"We handle incoming events with `handle_in/3`. We can pattern match on the event names, like `\"new_msg\"`, and then grab the payload that the client passed over the channel. For our chat application, we simply need to notify all other `room:lobby` subscribers of the new message with `broadcast!/3`.\n\n```elixir\ndefmodule HelloWeb.RoomChannel do\n  use Phoenix.Channel\n\n  def join(\"room:lobby\", _message, socket) do\n    {:ok, socket}\n  end\n\n  def join(\"room:\" <> _private_room_id, _params, _socket) do\n    {:error, %{reason: \"unauthorized\"}}\n  end\n\n  def handle_in(\"new_msg\", %{\"body\" => body}, socket) do\n    broadcast!(socket, \"new_msg\", %{body: body})\n    {:noreply, socket}\n  end\nend\n```\n\n`broadcast!/3` will notify all joined clients on this `socket`'s topic and invoke their `handle_out/3` callbacks. `handle_out/3` isn't a required callback, but it allows us to customize and filter broadcasts before they reach each client. By default, `handle_out/3` is implemented for us and simply pushes the message on to the client. Hooking into outgoing events allows for powerful message customization and filtering. Let's see how.","ref":"channels.html#incoming-events"},{"type":"extras","title":"Intercepting Outgoing Events - Channels","doc":"We won't implement this for our application, but imagine our chat app allowed users to ignore messages about new users joining a room. We could implement that behavior like this, where we explicitly tell Phoenix which outgoing event we want to intercept and then define a `handle_out/3` callback for those events. (Of course, this assumes that we have an `Accounts` context with an `ignoring_user?/2` function, and that we pass a user in via the `assigns` map). It is important to note that the `handle_out/3` callback will be called for every recipient of a message, so more expensive operations like hitting the database should be considered carefully before being included in `handle_out/3`.\n\n```elixir\nintercept [\"user_joined\"]\n\ndef handle_out(\"user_joined\", msg, socket) do\n  if Accounts.ignoring_user?(socket.assigns[:user], msg.user_id) do\n    {:noreply, socket}\n  else\n    push(socket, \"user_joined\", msg)\n    {:noreply, socket}\n  end\nend\n```\n\nThat's all there is to our basic chat app. Fire up multiple browser tabs and you should see your messages being pushed and broadcasted to all windows!","ref":"channels.html#intercepting-outgoing-events"},{"type":"extras","title":"Using Token Authentication - Channels","doc":"When we connect, we'll often need to authenticate the client. Fortunately, this is a 4-step process with [Phoenix.Token](https://hexdocs.pm/phoenix/Phoenix.Token.html).","ref":"channels.html#using-token-authentication"},{"type":"extras","title":"Step 1 - Assign a Token in the Connection - Channels","doc":"Let's say we have an authentication plug in our app called `OurAuth`. When `OurAuth` authenticates a user, it sets a value for the `:current_user` key in `conn.assigns`. Since the `current_user` exists, we can simply assign the user's token in the connection for use in the layout. We can wrap that behavior up in a private function plug, `put_user_token/2`. This could also be put in its own module as well. To make this all work, we just add `OurAuth` and `put_user_token/2` to the browser pipeline.\n\n```elixir\npipeline :browser do\n  ...\n  plug OurAuth\n  plug :put_user_token\nend\n\ndefp put_user_token(conn, _) do\n  if current_user = conn.assigns[:current_user] do\n    token = Phoenix.Token.sign(conn, \"user socket\", current_user.id)\n    assign(conn, :user_token, token)\n  else\n    conn\n  end\nend\n```\n\nNow our `conn.assigns` contains the `current_user` and `user_token`.","ref":"channels.html#step-1-assign-a-token-in-the-connection"},{"type":"extras","title":"Step 2 - Pass the Token to the JavaScript - Channels","doc":"Next, we need to pass this token to JavaScript. We can do so inside a script tag in `lib/hello_web/components/layouts/app.html.heex` right above the app.js script, as follows:\n\n```heex\n window.userToken = \"<%= assigns[:user_token] %>\"; \n  \n```","ref":"channels.html#step-2-pass-the-token-to-the-javascript"},{"type":"extras","title":"Step 3 - Pass the Token to the Socket Constructor and Verify - Channels","doc":"We also need to pass the `:params` to the socket constructor and verify the user token in the `connect/3` function. To do so, edit `lib/hello_web/channels/user_socket.ex`, as follows:\n\n```elixir\ndef connect(%{\"token\" => token}, socket, _connect_info) do\n  # max_age: 1209600 is equivalent to two weeks in seconds\n  case Phoenix.Token.verify(socket, \"user socket\", token, max_age: 1209600) do\n    {:ok, user_id} ->\n      {:ok, assign(socket, :current_user, user_id)}\n    {:error, reason} ->\n      :error\n  end\nend\n```\n\nIn our JavaScript, we can use the token set previously when constructing the Socket:\n\n```javascript\nlet socket = new Socket(\"/socket\", {params: {token: window.userToken}})\n```\n\nWe used `Phoenix.Token.verify/4` to verify the user token provided by the client. `Phoenix.Token.verify/4` returns either `{:ok, user_id}` or `{:error, reason}`. We can pattern match on that return in a `case` statement. With a verified token, we set the user's id as the value to `:current_user` in the socket. Otherwise, we return `:error`.","ref":"channels.html#step-3-pass-the-token-to-the-socket-constructor-and-verify"},{"type":"extras","title":"Step 4 - Connect to the socket in JavaScript - Channels","doc":"With authentication set up, we can connect to sockets and channels from JavaScript.\n\n```javascript\nlet socket = new Socket(\"/socket\", {params: {token: window.userToken}})\nsocket.connect()\n```\n\nNow that we are connected, we can join channels with a topic:\n\n```javascript\nlet channel = socket.channel(\"topic:subtopic\", {})\nchannel.join()\n  .receive(\"ok\", resp => { console.log(\"Joined successfully\", resp) })\n  .receive(\"error\", resp => { console.log(\"Unable to join\", resp) })\n\nexport default socket\n```\n\nNote that token authentication is preferable since it's transport agnostic and well-suited for long running-connections like channels, as opposed to using sessions or other authentication approaches.","ref":"channels.html#step-4-connect-to-the-socket-in-javascript"},{"type":"extras","title":"Fault Tolerance and Reliability Guarantees - Channels","doc":"Servers restart, networks split, and clients lose connectivity. In order to design robust systems, we need to understand how Phoenix responds to these events and what guarantees it offers.","ref":"channels.html#fault-tolerance-and-reliability-guarantees"},{"type":"extras","title":"Handling Reconnection - Channels","doc":"Clients subscribe to topics, and Phoenix stores those subscriptions in an in-memory ETS table. If a channel crashes, the clients will need to reconnect to the topics they had previously subscribed to. Fortunately, the Phoenix JavaScript client knows how to do this. The server will notify all the clients of the crash. This will trigger each client's `Channel.onError` callback. The clients will attempt to reconnect to the server using an exponential backoff strategy. Once they reconnect, they'll attempt to rejoin the topics they had previously subscribed to. If they are successful, they'll start receiving messages from those topics as before.","ref":"channels.html#handling-reconnection"},{"type":"extras","title":"Resending Client Messages - Channels","doc":"Channel clients queue outgoing messages into a `PushBuffer`, and send them to the server when there is a connection. If no connection is available, the client holds on to the messages until it can establish a new connection. With no connection, the client will hold the messages in memory until it establishes a connection, or until it receives a `timeout` event. The default timeout is set to 5000 milliseconds. The client won't persist the messages in the browser's local storage, so if the browser tab closes, the messages will be gone.","ref":"channels.html#resending-client-messages"},{"type":"extras","title":"Resending Server Messages - Channels","doc":"Phoenix uses an at-most-once strategy when sending messages to clients. If the client is offline and misses the message, Phoenix won't resend it. Phoenix doesn't persist messages on the server. If the server restarts, unsent messages will be gone. If our application needs stronger guarantees around message delivery, we'll need to write that code ourselves. Common approaches involve persisting messages on the server and having clients request missing messages. For an example, see Chris McCord's Phoenix training: [client code](https://github.com/chrismccord/elixirconf_training/blob/master/web/static/js/app.js#L38-L39) and [server code](https://github.com/chrismccord/elixirconf_training/blob/master/web/channels/document_channel.ex#L13-L19).","ref":"channels.html#resending-server-messages"},{"type":"extras","title":"Example Application - Channels","doc":"To see an example of the application we just built, checkout the project [phoenix_chat_example](https://github.com/chrismccord/phoenix_chat_example).","ref":"channels.html#example-application"},{"type":"extras","title":"Presence","doc":"# Presence\n\n> **Requirement**: This guide expects that you have gone through the [introductory guides](installation.html) and got a Phoenix application [up and running](up_and_running.html).\n\n> **Requirement**: This guide expects that you have gone through the [Channels guide](channels.html).\n\nPhoenix Presence is a feature which allows you to register process information on a topic and replicate it transparently across a cluster. It's a combination of both a server-side and client-side library, which makes it simple to implement. A simple use-case would be showing which users are currently online in an application.\n\nPhoenix Presence is special for a number of reasons. It has no single point of failure, no single source of truth, relies entirely on the standard library with no operational dependencies and self-heals.","ref":"presence.html"},{"type":"extras","title":"Setting up - Presence","doc":"We are going to use Presence to track which users are connected on the server and send updates to the client as users join and leave. We will deliver those updates via Phoenix Channels. Therefore, let's create a `RoomChannel`, as we did in the channels guides:\n\n```console\n$ mix phx.gen.channel Room\n```\n\nFollow the steps after the generator and you are ready to start tracking presence.","ref":"presence.html#setting-up"},{"type":"extras","title":"The Presence generator - Presence","doc":"To get started with Presence, we'll first need to generate a presence module. We can do this with the `mix phx.gen.presence` task:\n\n```console\n$ mix phx.gen.presence\n* creating lib/hello_web/channels/presence.ex\n\nAdd your new module to your supervision tree,\nin lib/hello/application.ex:\n\n    children = [\n      ...\n      HelloWeb.Presence,\n    ]\n\nYou're all set! See the Phoenix.Presence docs for more details:\nhttps://hexdocs.pm/phoenix/Phoenix.Presence.html\n```\n\nIf we open up the `lib/hello_web/channels/presence.ex` file, we will see the following line:\n\n```elixir\nuse Phoenix.Presence,\n  otp_app: :hello,\n  pubsub_server: Hello.PubSub\n```\n\nThis sets up the module for presence, defining the functions we require for tracking presences. As mentioned in the generator task, we should add this module to our supervision tree in\n`application.ex`:\n\n```elixir\nchildren = [\n  ...\n  HelloWeb.Presence,\n]\n```","ref":"presence.html#the-presence-generator"},{"type":"extras","title":"Usage With Channels and JavaScript - Presence","doc":"Next, we will create the channel that we'll communicate presence over. After a user joins, we can push the list of presences down the channel and then track the connection. We can also provide a map of additional information to track.\n\n```elixir\ndefmodule HelloWeb.RoomChannel do\n  use Phoenix.Channel\n  alias HelloWeb.Presence\n\n  def join(\"room:lobby\", %{\"name\" => name}, socket) do\n    send(self(), :after_join)\n    {:ok, assign(socket, :name, name)}\n  end\n\n  def handle_info(:after_join, socket) do\n    {:ok, _} =\n      Presence.track(socket, socket.assigns.name, %{\n        online_at: inspect(System.system_time(:second))\n      })\n\n    push(socket, \"presence_state\", Presence.list(socket))\n    {:noreply, socket}\n  end\nend\n```\n\nFinally, we can use the client-side Presence library included in `phoenix.js` to manage the state and presence diffs that come down the socket. It listens for the `\"presence_state\"` and `\"presence_diff\"` events and provides a simple callback for you to handle the events as they happen, with the `onSync` callback.\n\nThe `onSync` callback allows you to easily react to presence state changes, which most often results in re-rendering an updated list of active users. You can use the `list` method to format and return each individual presence based on the needs of your application.\n\nTo iterate users, we use the `presences.list()` function which accepts a callback. The callback will be called for each presence item with 2 arguments, the presence id and a list of metas (one for each presence for that presence id). We use this to display the users and the number of devices they are online with.\n\nWe can see presence working by adding the following to `assets/js/app.js`:\n\n```javascript\nimport {Socket, Presence} from \"phoenix\"\n\nlet socket = new Socket(\"/socket\", {params: {token: window.userToken}})\nlet channel = socket.channel(\"room:lobby\", {name: window.location.search.split(\"=\")[1]})\nlet presence = new Presence(channel)\n\nfunction renderOnlineUsers(presence) {\n  let response = \"\"\n\n  presence.list((id, {metas: [first, ...rest]}) => {\n    let count = rest.length + 1\n    response += ` ${id} (count: ${count}) `\n  })\n\n  document.querySelector(\"main\").innerHTML = response\n}\n\nsocket.connect()\n\npresence.onSync(() => renderOnlineUsers(presence))\n\nchannel.join()\n```\n\nWe can ensure this is working by opening 3 browser tabs. If we navigate to   on two browser tabs and   then we should see:\n\n```plaintext\nAlice (count: 2)\nBob (count: 1)\n```\n\nIf we close one of the Alice tabs, then the count should decrease to 1. If we close another tab, the user should disappear from the list entirely.","ref":"presence.html#usage-with-channels-and-javascript"},{"type":"extras","title":"Making it safe - Presence","doc":"In our initial implementation, we are passing the name of the user as part of the URL. However, in many systems, you want to allow only logged in users to access the presence functionality. To do so, you should set up token authentication, [as detailed in the token authentication section of the channels guide](channels.html#using-token-authentication).\n\nWith token authentication, you should access `socket.assigns.user_id`, set in `UserSocket`, instead of `socket.assigns.name` set from parameters.","ref":"presence.html#making-it-safe"},{"type":"extras","title":"Usage With LiveView - Presence","doc":"Whilst Phoenix does ship with a JavaScript API for dealing with presence, it is also possible to extend the `HelloWeb.Presence` module to support [LiveView](https://hexdocs.pm/phoenix_live_view).\n\nOne thing to keep in mind when dealing with LiveView, is that each LiveView is a stateful process, so if we keep the presence state in the LiveView, each LiveView process will contain the full list of online users in memory. Instead, we can keep track of the online users within the `Presence` process, and pass separate events to the LiveView, which can use a stream to update the online list.\n\nTo start with, we need to update the `lib/hello_web/channels/presence.ex` file to add some optional callbacks to the `HelloWeb.Presence` module.\n\nFirstly, we add the `init/1` callback. This allows us to keep track of the presence state within the process.\n\n```elixir\n  def init(_opts) do\n    {:ok, %{}}\n  end\n```\n\nThe presence module also allows a `fetch/2` callback, this allows the data fetched from the presence to be modified, allowing us to define the shape of the response. In this case we are adding an `id` and a `user` map.\n\n```elixir\n  def fetch(_topic, presences) do\n    for {key, %{metas: [meta | metas]}} <- presences, into: %{} do\n      # user can be populated here from the database here we populate\n      # the name for demonstration purposes\n      {key, %{metas: [meta | metas], id: meta.id, user: %{name: meta.id}}}\n    end\n  end\n```\n\nThe final thing to add is the `handle_metas/4` callback. This callback updates the state that we keep track of in `HelloWeb.Presence` based on the user leaves and joins.\n\n```elixir\n  def handle_metas(topic, %{joins: joins, leaves: leaves}, presences, state) do\n    for {user_id, presence} <- joins do\n      user_data = %{id: user_id, user: presence.user, metas: Map.fetch!(presences, user_id)}\n      msg = {__MODULE__, {:join, user_data}}\n      Phoenix.PubSub.local_broadcast(Hello.PubSub, \"proxy:#{topic}\", msg)\n    end\n\n    for {user_id, presence} <- leaves do\n      metas =\n        case Map.fetch(presences, user_id) do\n          {:ok, presence_metas} -> presence_metas\n          :error -> []\n        end\n\n      user_data = %{id: user_id, user: presence.user, metas: metas}\n      msg = {__MODULE__, {:leave, user_data}}\n      Phoenix.PubSub.local_broadcast(Hello.PubSub, \"proxy:#{topic}\", msg)\n    end\n\n    {:ok, state}\n  end\n```\n\nYou can see that we are broadcasting events for the joins and leaves. These will be listened to by the LiveView process. You'll also see that we use \"proxy\" channel when broadcasting the joins and leaves. This is because we don't want our LiveView process to receive the presence events directly. We can add a few helper functions so that this particular implementation detail is abstracted from the LiveView module.\n\n```elixir\n  def list_online_users(), do: list(\"online_users\") |> Enum.map(fn {_id, presence} -> presence end)\n\n  def track_user(name, params), do: track(self(), \"online_users\", name, params)\n\n  def subscribe(), do: Phoenix.PubSub.subscribe(Hello.PubSub, \"proxy:online_users\")\n```\n\nNow that we have our presence module set up and broadcasting events, we can create a LiveView. Create a new file `lib/hello_web/live/online/index.ex` with the following contents:\n\n```elixir\ndefmodule HelloWeb.OnlineLive do\n  use HelloWeb, :live_view\n\n  def mount(params, _session, socket) do\n    socket = stream(socket, :presences, [])\n    socket =\n    if connected?(socket) do\n      HelloWeb.Presence.track_user(params[\"name\"], %{id: params[\"name\"]})\n      HelloWeb.Presence.subscribe()\n      stream(socket, :presences, HelloWeb.Presence.list_online_users())\n    else\n       socket\n    end\n\n    {:ok, socket}\n  end\n\n  def render(assigns) do\n    ~H\"\"\"\n     \n       <%= id %> (<%= length(metas) %>) \n     \n    \"\"\"\n  end\n\n  def handle_info({HelloWeb.Presence, {:join, presence}}, socket) do\n    {:noreply, stream_insert(socket, :presences, presence)}\n  end\n\n  def handle_info({HelloWeb.Presence, {:leave, presence}}, socket) do\n    if presence.metas == [] do\n      {:noreply, stream_delete(socket, :presences, presence)}\n    else\n      {:noreply, stream_insert(socket, :presences, presence)}\n    end\n  end\nend\n```\n\nIf we add this route to the `lib/hello_web/router.ex`:\n\n```elixir\n    live \"/online/:name\", OnlineLive, :index\n```\n\nThen we can navigate to http://localhost:4000/online/Alice in one tab, and http://localhost:4000/online/Bob in another, you'll see that the presences are tracked, along with the number of presences per user. Opening and closing tabs with various users will update the presence list in real-time.","ref":"presence.html#usage-with-liveview"},{"type":"extras","title":"Introduction to Testing","doc":"# Introduction to Testing\n\n> **Requirement**: This guide expects that you have gone through the [introductory guides](installation.html) and got a Phoenix application [up and running](up_and_running.html).\n\nTesting has become integral to the software development process, and the ability to easily write meaningful tests is an indispensable feature for any modern web framework. Phoenix takes this seriously, providing support files to make all the major components of the framework easy to test. It also generates test modules with real-world examples alongside any generated modules to help get us going.\n\nElixir ships with a built-in testing framework called [ExUnit](https://hexdocs.pm/ex_unit). ExUnit strives to be clear and explicit, keeping magic to a minimum. Phoenix uses ExUnit for all of its testing, and we will use it here as well.","ref":"testing.html"},{"type":"extras","title":"Running tests - Introduction to Testing","doc":"When Phoenix generates a web application for us, it also includes tests. To run them, simply type `mix test`:\n\n```console\n$ mix test\n....\n\nFinished in 0.09 seconds\n5 tests, 0 failures\n\nRandomized with seed 652656\n```\n\nWe already have five tests!\n\nIn fact, we already have a directory structure completely set up for testing, including a test helper and support files.\n\n```console\ntest\n├── hello_web\n│   └── controllers\n│       ├── error_html_test.exs\n│       ├── error_json_test.exs\n│       └── page_controller_test.exs\n├── support\n│   ├── conn_case.ex\n│   └── data_case.ex\n└── test_helper.exs\n```\n\nThe test cases we get for free include those from `test/hello_web/controllers/`. They are testing our controllers and views. If you haven't read the guides for controllers and views, now is a good time.","ref":"testing.html#running-tests"},{"type":"extras","title":"Understanding test modules - Introduction to Testing","doc":"We are going to use the next sections to get acquainted with Phoenix testing structure. We will start with the three test files generated by Phoenix.\n\nThe first test file we'll look at is `test/hello_web/controllers/page_controller_test.exs`.\n\n```elixir\ndefmodule HelloWeb.PageControllerTest do\n  use HelloWeb.ConnCase\n\n  test \"GET /\", %{conn: conn} do\n    conn = get(conn, ~p\"/\")\n    assert html_response(conn, 200) =~ \"Peace of mind from prototype to production\"\n  end\nend\n```\n\nThere are a couple of interesting things happening here.\n\nOur test files simply define modules. At the top of each module, you will find a line such as:\n\n```elixir\nuse HelloWeb.ConnCase\n```\n\nIf you were to write an Elixir library, outside of Phoenix, instead of `use HelloWeb.ConnCase` you would write `use ExUnit.Case`. However, Phoenix already ships with a bunch of functionality for testing controllers and `HelloWeb.ConnCase` builds on top of `ExUnit.Case` to bring these functionalities in. We will explore the `HelloWeb.ConnCase` module soon.\n\nThen we define each test using the `test/3` macro. The `test/3` macro receives three arguments: the test name, the testing context that we are pattern matching on, and the contents of the test. In this test, we access the root page of our application by a \"GET\" HTTP request on the path \"/\" with the `get/2` macro. Then we **assert** that the rendered page contains the string \"Peace of mind from prototype to production\".\n\nWhen writing tests in Elixir, we use assertions to check that something is true. In our case, `assert html_response(conn, 200) =~ \"Peace of mind from prototype to production\"` is doing a couple things:\n\n  * It asserts that `conn` has rendered a response\n  * It asserts that the response has the 200 status code (which means OK in HTTP parlance)\n  * It asserts that the type of the response is HTML\n  * It asserts that the result of `html_response(conn, 200)`, which is an HTML response, has the string \"Peace of mind from prototype to production\" in it\n\nHowever, from where does the `conn` we use on `get` and `html_response` come from? To answer this question, let's take a look at `HelloWeb.ConnCase`.","ref":"testing.html#understanding-test-modules"},{"type":"extras","title":"The ConnCase - Introduction to Testing","doc":"If you open up `test/support/conn_case.ex`, you will find this (with comments removed):\n\n```elixir\ndefmodule HelloWeb.ConnCase do\n  use ExUnit.CaseTemplate\n\n  using do\n    quote do\n      # The default endpoint for testing\n      @endpoint HelloWeb.Endpoint\n\n      use HelloWeb, :verified_routes\n\n      # Import conveniences for testing with connections\n      import Plug.Conn\n      import Phoenix.ConnTest\n      import HelloWeb.ConnCase\n    end\n  end\n  \n  setup tags do\n    Hello.DataCase.setup_sandbox(tags)\n    {:ok, conn: Phoenix.ConnTest.build_conn()}\n  end\nend\n```\n\nThere is a lot to unpack here.\n\nThe second line says this is a case template. This is a ExUnit feature that allows developers to replace the built-in `use ExUnit.Case` by their own case. This line is pretty much what allows us to write `use HelloWeb.ConnCase` at the top of our controller tests.\n\nNow that we have made this module a case template, we can define callbacks that are invoked on certain occasions. The `using` callback defines code to be injected on every module that calls `use HelloWeb.ConnCase`. In this case, it starts by setting the `@endpoint` module attribute with the name of our endpoint.\n\nNext, it wires up `:verified_routes` to allow us to use `~p` based paths in our test just like we do in the rest of our application to easily generate paths and URLs in our tests.\n\nFinally, we import [`Plug.Conn`](https://hexdocs.pm/plug/Plug.Conn.html), so all of the connection helpers available in controllers are also available in tests, and then imports [`Phoenix.ConnTest`](https://hexdocs.pm/phoenix/Phoenix.ConnTest.html). You can consult these modules to learn all functionality available.\n\nThen our case template defines a `setup` block. The `setup` block will be called before test. Most of the setup block is on setting up the SQL Sandbox, which we will talk about later. In the last line of the `setup` block, we will find this:\n\n```elixir\n{:ok, conn: Phoenix.ConnTest.build_conn()}\n```\n\nThe last line of `setup` can return test metadata that will be available in each test. The metadata we are passing forward here is a newly built `Plug.Conn`. In our test, we extract the connection out of this metadata at the very beginning of our test:\n\n```elixir\ntest \"GET /\", %{conn: conn} do\n```\n\nAnd that's where the connection comes from! At first, the testing structure does come with a bit of indirection, but this indirection pays off as our test suite grows, since it allows us to cut down the amount of boilerplate.","ref":"testing.html#the-conncase"},{"type":"extras","title":"View tests - Introduction to Testing","doc":"The other test files in our application are responsible for testing our views.\n\nThe error view test case, `test/hello_web/controllers/error_html_test.exs`, illustrates a few interesting things of its own.\n\n```elixir\ndefmodule HelloWeb.ErrorHTMLTest do\n  use HelloWeb.ConnCase, async: true\n\n  # Bring render_to_string/4 for testing custom views\n  import Phoenix.Template\n\n  test \"renders 404.html\" do\n    assert render_to_string(HelloWeb.ErrorHTML, \"404\", \"html\", []) == \"Not Found\"\n  end\n\n  test \"renders 500.html\" do\n    assert render_to_string(HelloWeb.ErrorHTML, \"500\", \"html\", []) == \"Internal Server Error\"\n  end\nend\n```\n\n`HelloWeb.ErrorHTMLTest` sets `async: true` which means that this test case will be run in parallel with other test cases. While individual tests within the case still run serially, this can greatly increase overall test speeds.\n\nIt also imports `Phoenix.Template` in order to use the `render_to_string/4` function. With that, all the assertions can be simple string equality tests.","ref":"testing.html#view-tests"},{"type":"extras","title":"Running tests per directory/file - Introduction to Testing","doc":"Now that we have an idea what our tests are doing, let's look at different ways to run them.\n\nAs we saw near the beginning of this guide, we can run our entire suite of tests with `mix test`.\n\n```console\n$ mix test\n....\n\nFinished in 0.2 seconds\n5 tests, 0 failures\n\nRandomized with seed 540755\n```\n\nIf we would like to run all the tests in a given directory, `test/hello_web/controllers` for instance, we can pass the path to that directory to `mix test`.\n\n```console\n$ mix test test/hello_web/controllers/\n.\n\nFinished in 0.2 seconds\n5 tests, 0 failures\n\nRandomized with seed 652376\n```\n\nIn order to run all the tests in a specific file, we can pass the path to that file into `mix test`.\n\n```console\n$ mix test test/hello_web/controllers/error_html_test.exs\n...\n\nFinished in 0.2 seconds\n2 tests, 0 failures\n\nRandomized with seed 220535\n```\n\nAnd we can run a single test in a file by appending a colon and a line number to the filename.\n\nLet's say we only wanted to run the test for the way `HelloWeb.ErrorHTML` renders `500.html`. The test begins on line 11 of the file, so this is how we would do it.\n\n```console\n$ mix test test/hello_web/controllers/error_html_test.exs:11\nIncluding tags: [line: \"11\"]\nExcluding tags: [:test]\n\n.\n\nFinished in 0.1 seconds\n2 tests, 0 failures, 1 excluded\n\nRandomized with seed 288117\n```\n\nWe chose to run this specifying the first line of the test, but actually, any line of that test will do. These line numbers would all work - `:11`, `:12`, or `:13`.","ref":"testing.html#running-tests-per-directory-file"},{"type":"extras","title":"Running tests using tags - Introduction to Testing","doc":"ExUnit allows us to tag our tests individually or for the whole module. We can then choose to run only the tests with a specific tag, or we can exclude tests with that tag and run everything else.\n\nLet's experiment with how this works.\n\nFirst, we'll add a `@moduletag` to `test/hello_web/controllers/error_html_test.exs`.\n\n```elixir\ndefmodule HelloWeb.ErrorHTMLTest do\n  use HelloWeb.ConnCase, async: true\n\n  @moduletag :error_view_case\n  ...\nend\n```\n\nIf we use only an atom for our module tag, ExUnit assumes that it has a value of `true`. We could also specify a different value if we wanted.\n\n```elixir\ndefmodule HelloWeb.ErrorHTMLTest do\n  use HelloWeb.ConnCase, async: true\n\n  @moduletag error_view_case: \"some_interesting_value\"\n  ...\nend\n```\n\nFor now, let's leave it as a simple atom `@moduletag :error_view_case`.\n\nWe can run only the tests from the error view case by passing `--only error_view_case` into `mix test`.\n\n```console\n$ mix test --only error_view_case\nIncluding tags: [:error_view_case]\nExcluding tags: [:test]\n\n...\n\nFinished in 0.1 seconds\n5 tests, 0 failures, 3 excluded\n\nRandomized with seed 125659\n```\n\n> Note: ExUnit tells us exactly which tags it is including and excluding for each test run. If we look back to the previous section on running tests, we'll see that line numbers specified for individual tests are actually treated as tags.\n\n```console\n$ mix test test/hello_web/controllers/error_html_test.exs:11\nIncluding tags: [line: \"11\"]\nExcluding tags: [:test]\n\n.\n\nFinished in 0.2 seconds\n2 tests, 0 failures, 1 excluded\n\nRandomized with seed 364723\n```\n\nSpecifying a value of `true` for `error_view_case` yields the same results.\n\n```console\n$ mix test --only error_view_case:true\nIncluding tags: [error_view_case: \"true\"]\nExcluding tags: [:test]\n\n...\n\nFinished in 0.1 seconds\n5 tests, 0 failures, 3 excluded\n\nRandomized with seed 833356\n```\n\nSpecifying `false` as the value for `error_view_case`, however, will not run any tests because no tags in our system match `error_view_case: false`.\n\n```console\n$ mix test --only error_view_case:false\nIncluding tags: [error_view_case: \"false\"]\nExcluding tags: [:test]\n\n\n\nFinished in 0.1 seconds\n5 tests, 0 failures, 5 excluded\n\nRandomized with seed 622422\nThe --only option was given to \"mix test\" but no test executed\n```\n\nWe can use the `--exclude` flag in a similar way. This will run all of the tests except those in the error view case.\n\n```console\n$ mix test --exclude error_view_case\nExcluding tags: [:error_view_case]\n\n.\n\nFinished in 0.2 seconds\n5 tests, 0 failures, 2 excluded\n\nRandomized with seed 682868\n```\n\nSpecifying values for a tag works the same way for `--exclude` as it does for `--only`.\n\nWe can tag individual tests as well as full test cases. Let's tag a few tests in the error view case to see how this works.\n\n```elixir\ndefmodule HelloWeb.ErrorHTMLTest do\n  use HelloWeb.ConnCase, async: true\n\n  @moduletag :error_view_case\n\n  # Bring render/4 and render_to_string/4 for testing custom views\n  import Phoenix.Template\n\n  @tag individual_test: \"yup\"\n  test \"renders 404.html\" do\n    assert render_to_string(HelloWeb.ErrorView, \"404\", \"html\", []) ==\n           \"Not Found\"\n  end\n\n  @tag individual_test: \"nope\"\n  test \"renders 500.html\" do\n    assert render_to_string(HelloWeb.ErrorView, \"500\", \"html\", []) ==\n           \"Internal Server Error\"\n  end\nend\n```\n\nIf we would like to run only tests tagged as `individual_test`, regardless of their value, this will work.\n\n```console\n$ mix test --only individual_test\nIncluding tags: [:individual_test]\nExcluding tags: [:test]\n\n..\n\nFinished in 0.1 seconds\n5 tests, 0 failures, 3 excluded\n\nRandomized with seed 813729\n```\n\nWe can also specify a value and run only tests with that.\n\n```console\n$ mix test --only individual_test:yup\nIncluding tags: [individual_test: \"yup\"]\nExcluding tags: [:test]\n\n.\n\nFinished in 0.1 seconds\n5 tests, 0 failures, 4 excluded\n\nRandomized with seed 770938\n```\n\nSimilarly, we can run all tests except for those tagged with a given value.\n\n```console\n$ mix test --exclude individual_test:nope\nExcluding tags: [individual_test: \"nope\"]\n\n...\n\nFinished in 0.2 seconds\n5 tests, 0 failures, 1 excluded\n\nRandomized with seed 539324\n```\n\nWe can be more specific and exclude all the tests from the error view case except the one tagged with `individual_test` that has the value \"yup\".\n\n```console\n$ mix test --exclude error_view_case --include individual_test:yup\nIncluding tags: [individual_test: \"yup\"]\nExcluding tags: [:error_view_case]\n\n..\n\nFinished in 0.2 seconds\n5 tests, 0 failures, 1 excluded\n\nRandomized with seed 61472\n```\n\nFinally, we can configure ExUnit to exclude tags by default. The default ExUnit configuration is done in the `test/test_helper.exs` file:\n\n```elixir\nExUnit.start(exclude: [error_view_case: true])\n\nEcto.Adapters.SQL.Sandbox.mode(Hello.Repo, :manual)\n```\n\nNow when we run `mix test`, it only runs the specs from our `page_controller_test.exs` and `error_json_test.exs`.\n\n```console\n$ mix test\nExcluding tags: [error_view_case: true]\n\n.\n\nFinished in 0.2 seconds\n5 tests, 0 failures, 2 excluded\n\nRandomized with seed 186055\n```\n\nWe can override this behavior with the `--include` flag, telling `mix test` to include tests tagged with `error_view_case`.\n\n```console\n$ mix test --include error_view_case\nIncluding tags: [:error_view_case]\nExcluding tags: [error_view_case: true]\n\n....\n\nFinished in 0.2 seconds\n5 tests, 0 failures\n\nRandomized with seed 748424\n```\n\nThis technique can be very useful to control very long running tests, which you may only want to run in CI or in specific scenarios.","ref":"testing.html#running-tests-using-tags"},{"type":"extras","title":"Randomization - Introduction to Testing","doc":"Running tests in random order is a good way to ensure that our tests are truly isolated. If we notice that we get sporadic failures for a given test, it may be because a previous test changes the state of the system in ways that aren't cleaned up afterward, thereby affecting the tests which follow. Those failures might only present themselves if the tests are run in a specific order.\n\nExUnit will randomize the order tests run in by default, using an integer to seed the randomization. If we notice that a specific random seed triggers our intermittent failure, we can re-run the tests with that same seed to reliably recreate that test sequence in order to help us figure out what the problem is.\n\n```console\n$ mix test --seed 401472\n....\n\nFinished in 0.2 seconds\n5 tests, 0 failures\n\nRandomized with seed 401472\n```","ref":"testing.html#randomization"},{"type":"extras","title":"Concurrency and partitioning - Introduction to Testing","doc":"As we have seen, ExUnit allows developers to run tests concurrently. This allows developers to use all of the power in their machine to run their test suites as fast as possible. Couple this with Phoenix performance, most test suites compile and run in a fraction of the time compared to other frameworks.\n\nWhile developers usually have powerful machines available to them during development, this may not always be the case in your Continuous Integration servers. For this reason, ExUnit also supports out of the box test partitioning in test environments. If you open up your `config/test.exs`, you will find the database name set to:\n\n```elixir\ndatabase: \"hello_test#{System.get_env(\"MIX_TEST_PARTITION\")}\",\n```\n\nBy default, the `MIX_TEST_PARTITION` environment variable has no value, and therefore it has no effect. But in your CI server, you can, for example, split your test suite across machines by using four distinct commands:\n\n```console\n$ MIX_TEST_PARTITION=1 mix test --partitions 4\n$ MIX_TEST_PARTITION=2 mix test --partitions 4\n$ MIX_TEST_PARTITION=3 mix test --partitions 4\n$ MIX_TEST_PARTITION=4 mix test --partitions 4\n```\n\nThat's all you need to do and ExUnit and Phoenix will take care of all rest, including setting up the database for each distinct partition with a distinct name.","ref":"testing.html#concurrency-and-partitioning"},{"type":"extras","title":"Going further - Introduction to Testing","doc":"While ExUnit is a simple test framework, it provides a really flexible and robust test runner through the `mix test` command. We recommend you to run `mix help test` or [read the docs online](https://hexdocs.pm/mix/Mix.Tasks.Test.html)\n\nWe've seen what Phoenix gives us with a newly generated app. Furthermore, whenever you generate a new resource, Phoenix will generate all appropriate tests for that resource too. For example, you can create a complete scaffold with schema, context, controllers, and views by running the following command at the root of your application:\n\n```console\n$ mix phx.gen.html Blog Post posts title body:text\n* creating lib/hello_web/controllers/post_controller.ex\n* creating lib/hello_web/controllers/post_html/edit.html.heex\n* creating lib/hello_web/controllers/post_html/index.html.heex\n* creating lib/hello_web/controllers/post_html/new.html.heex\n* creating lib/hello_web/controllers/post_html/show.html.heex\n* creating lib/hello_web/controllers/post_html/post_form.html.heex\n* creating lib/hello_web/controllers/post_html.ex\n* creating test/hello_web/controllers/post_controller_test.exs\n* creating lib/hello/blog/post.ex\n* creating priv/repo/migrations/20211001233016_create_posts.exs\n* creating lib/hello/blog.ex\n* injecting lib/hello/blog.ex\n* creating test/hello/blog_test.exs\n* injecting test/hello/blog_test.exs\n* creating test/support/fixtures/blog_fixtures.ex\n* injecting test/support/fixtures/blog_fixtures.ex\n\nAdd the resource to your browser scope in lib/demo_web/router.ex:\n\n    resources \"/posts\", PostController\n\n\nRemember to update your repository by running migrations:\n\n    $ mix ecto.migrate\n\n```\n\nNow let's follow the directions and add the new resources route to our `lib/hello_web/router.ex` file and run the migrations.\n\nWhen we run `mix test` again, we see that we now have twenty-one tests!\n\n```console\n$ mix test\n................\n\nFinished in 0.1 seconds\n21 tests, 0 failures\n\nRandomized with seed 537537\n```\n\nAt this point, we are at a great place to transition to the rest of the testing guides, in which we'll examine these tests in much more detail, and add some of our own.","ref":"testing.html#going-further"},{"type":"extras","title":"Testing Contexts","doc":"# Testing Contexts\n\n> **Requirement**: This guide expects that you have gone through the [introductory guides](installation.html) and got a Phoenix application [up and running](up_and_running.html).\n\n> **Requirement**: This guide expects that you have gone through the [Introduction to Testing guide](testing.html).\n\n> **Requirement**: This guide expects that you have gone through the [Contexts guide](contexts.html).\n\nAt the end of the Introduction to Testing guide, we generated an HTML resource for posts using the following command:\n\n```console\n$ mix phx.gen.html Blog Post posts title body:text\n```\n\nThis gave us a number of modules for free, including a Blog context and a Post schema, alongside their respective test files. As we have learned in the Context guide, the Blog context is simply a module with functions to a particular area of our business domain, while Post schema maps to a particular table in our database.\n\nIn this guide, we are going to explore the tests generated for our contexts and schemas. Before we do anything else, let's run `mix test` to make sure our test suite runs cleanly.\n\n```console\n$ mix test\n................\n\nFinished in 0.6 seconds\n21 tests, 0 failures\n\nRandomized with seed 638414\n```\n\nGreat. We've got twenty-one tests and they are all passing!","ref":"testing_contexts.html"},{"type":"extras","title":"Testing posts - Testing Contexts","doc":"If you open up `test/hello/blog_test.exs`, you will see a file with the following:\n\n```elixir\ndefmodule Hello.BlogTest do\n  use Hello.DataCase\n\n  alias Hello.Blog\n\n  describe \"posts\" do\n    alias Hello.Blog.Post\n\n    import Hello.BlogFixtures\n\n    @invalid_attrs %{body: nil, title: nil}\n\n    test \"list_posts/0 returns all posts\" do\n      post = post_fixture()\n      assert Blog.list_posts() == [post]\n    end\n\n    ...\n```\n\nAs the top of the file we import `Hello.DataCase`, which as we will see soon, it is similar to `HelloWeb.ConnCase`. While `HelloWeb.ConnCase` sets up helpers for working with connections, which is useful when testing controllers and views, `Hello.DataCase` provides functionality for working with contexts and schemas.\n\nNext, we define an alias, so we can refer to `Hello.Blog` simply as `Blog`.\n\nThen we start a `describe \"posts\"` block. A `describe` block is a feature in ExUnit that allows us to group similar tests. The reason why we have grouped all post related tests together is because contexts in Phoenix are capable of grouping multiple schemas together. For example, if we ran this command:\n\n```console\n$ mix phx.gen.html Blog Comment comments post_id:references:posts body:text\n```\n\nWe will get a bunch of new functions in the `Hello.Blog` context, plus a whole new `describe \"comments\"` block in our test file.\n\nThe tests defined for our context are very straight-forward. They call the functions in our context and assert on their results. As you can see, some of those tests even create entries in the database:\n\n```elixir\ntest \"create_post/1 with valid data creates a post\" do\n  valid_attrs = %{body: \"some body\", title: \"some title\"}\n\n  assert {:ok, %Post{} = post} = Blog.create_post(valid_attrs)\n  assert post.body == \"some body\"\n  assert post.title == \"some title\"\nend\n```\n\nAt this point, you may wonder: how can Phoenix make sure the data created in one of the tests do not affect other tests? We are glad you asked. To answer this question, let's talk about the `DataCase`.","ref":"testing_contexts.html#testing-posts"},{"type":"extras","title":"The DataCase - Testing Contexts","doc":"If you open up `test/support/data_case.ex`, you will find the following:\n\n```elixir\ndefmodule Hello.DataCase do\n  use ExUnit.CaseTemplate\n\n  using do\n    quote do\n      alias Hello.Repo\n\n      import Ecto\n      import Ecto.Changeset\n      import Ecto.Query\n      import Hello.DataCase\n    end\n  end\n\n  setup tags do\n    Hello.DataCase.setup_sandbox(tags)\n    :ok\n  end\n\n  def setup_sandbox(tags) do\n    pid = Ecto.Adapters.SQL.Sandbox.start_owner!(Hello.Repo, shared: not tags[:async])\n    on_exit(fn -> Ecto.Adapters.SQL.Sandbox.stop_owner(pid) end)\n  end\n\n  def errors_on(changeset) do\n    ...\n  end\nend\n```\n\n`Hello.DataCase` is another `ExUnit.CaseTemplate`. In the `using` block, we can see all of the aliases and imports `DataCase` brings into our tests. The `setup` chunk for `DataCase` is very similar to the one from `ConnCase`. As we can see, most of the `setup` block revolves around setting up a SQL Sandbox.\n\nThe SQL Sandbox is precisely what allows our tests to write to the database without affecting any of the other tests. In a nutshell, at the beginning of every test, we start a transaction in the database. When the test is over, we automatically rollback the transaction, effectively erasing all of the data created in the test.\n\nFurthermore, the SQL Sandbox allows multiple tests to run concurrently, even if they talk to the database. This feature is provided for PostgreSQL databases and it can be used to further speed up your contexts and controllers tests by adding a `async: true` flag when using them:\n\n```elixir\nuse Hello.DataCase, async: true\n```\n\nThere are some considerations you need to have in mind when running asynchronous tests with the sandbox, so please refer to the [`Ecto.Adapters.SQL.Sandbox`](https://hexdocs.pm/ecto_sql/Ecto.Adapters.SQL.Sandbox.html) for more information.\n\nFinally at the end of the of the `DataCase` module we can find a function named `errors_on` with some examples of how to use it. This function is used for testing any validation we may want to add to our schemas. Let's give it a try by adding our own validations and then testing them.","ref":"testing_contexts.html#the-datacase"},{"type":"extras","title":"Testing schemas - Testing Contexts","doc":"When we generate our HTML Post resource, Phoenix generated a Blog context and a Post schema. It generated a test file for the context, but no test file for the schema. However, this doesn't mean we don't need to test the schema, it just means we did not have to test the schema so far.\n\nYou may be wondering then: when do we test the context directly and when do we test the schema directly? The answer to this question is the same answer to the question of when do we add code to a context and when do we add it to the schema?\n\nThe general guideline is to keep all side-effect free code in the schema. In other words, if you are simply working with data structures, schemas and changesets, put it in the schema. The context will typically have the code that creates and updates schemas and then write them to a database or an API.\n\nWe'll be adding additional validations to the schema module, so that's a great opportunity to write some schema specific tests. Open up `lib/hello/blog/post.ex` and add the following validation to `def changeset`:\n\n```elixir\ndef changeset(post, attrs) do\n  post\n  |> cast(attrs, [:title, :body])\n  |> validate_required([:title, :body])\n  |> validate_length(:title, min: 2)\nend\n```\n\nThe new validation says the title needs to have at least 2 characters. Let's write a test for this. Create a new file at `test/hello/blog/post_test.exs` with this:\n\n```elixir\ndefmodule Hello.Blog.PostTest do\n  use Hello.DataCase, async: true\n  alias Hello.Blog.Post\n\n  test \"title must be at least two characters long\" do\n    changeset = Post.changeset(%Post{}, %{title: \"I\"})\n    assert %{title: [\"should be at least 2 character(s)\"]} = errors_on(changeset)\n  end\nend\n```\n\nAnd that's it. As our business domain grows, we have well-defined places to test our contexts and schemas.","ref":"testing_contexts.html#testing-schemas"},{"type":"extras","title":"Testing Controllers","doc":"# Testing Controllers\n\n> **Requirement**: This guide expects that you have gone through the [introductory guides](installation.html) and got a Phoenix application [up and running](up_and_running.html).\n\n> **Requirement**: This guide expects that you have gone through the [Introduction to Testing guide](testing.html).\n\nAt the end of the Introduction to Testing guide, we generated an HTML resource for posts using the following command:\n\n```console\n$ mix phx.gen.html Blog Post posts title body:text\n```\n\nThis gave us a number of modules for free, including a PostController and the associated tests. We are going to explore those tests to learn more about testing controllers in general. At the end of the guide, we will generate a JSON resource, and explore how our API tests look like.","ref":"testing_controllers.html"},{"type":"extras","title":"HTML controller tests - Testing Controllers","doc":"If you open up `test/hello_web/controllers/post_controller_test.exs`, you will find the following:\n\n```elixir\ndefmodule HelloWeb.PostControllerTest do\n  use HelloWeb.ConnCase\n\n  import Hello.BlogFixtures\n\n  @create_attrs %{body: \"some body\", title: \"some title\"}\n  @update_attrs %{body: \"some updated body\", title: \"some updated title\"}\n  @invalid_attrs %{body: nil, title: nil}\n  \n  describe \"index\" do\n    test \"lists all posts\", %{conn: conn} do\n      conn = get(conn, ~p\"/posts\")\n      assert html_response(conn, 200) =~ \"Listing Posts\"\n    end\n  end\n\n  ...\n```\n\nSimilar to the `PageControllerTest` that ships with our application, this controller tests uses `use HelloWeb.ConnCase` to setup the testing structure. Then, as usual, it defines some aliases, some module attributes to use throughout testing, and then it starts a series of `describe` blocks, each of them to test a different controller action.","ref":"testing_controllers.html#html-controller-tests"},{"type":"extras","title":"The index action - Testing Controllers","doc":"The first describe block is for the `index` action. The action itself is implemented like this in `lib/hello_web/controllers/post_controller.ex`:\n\n```elixir\ndef index(conn, _params) do\n  posts = Blog.list_posts()\n  render(conn, :index, posts: posts)\nend\n```\n\nIt gets all posts and renders the \"index.html\" template. The template can be found in `lib/hello_web/templates/page/index.html.heex`.\n\nThe test looks like this:\n\n```elixir\ndescribe \"index\" do\n  test \"lists all posts\", %{conn: conn} do\n    conn = get(conn, ~p\"/posts\")\n    assert html_response(conn, 200) =~ \"Listing Posts\"\n  end\nend\n```\n\nThe test for the `index` page is quite straight-forward. It uses the `get/2` helper to make a request to the `\"/posts\"` page, which is verified against our router in the test thanks to `~p`, then we assert we got a successful HTML response and match on its contents.","ref":"testing_controllers.html#the-index-action"},{"type":"extras","title":"The create action - Testing Controllers","doc":"The next test we will look at is the one for the `create` action. The `create` action implementation is this:\n\n```elixir\ndef create(conn, %{\"post\" => post_params}) do\n  case Blog.create_post(post_params) do\n    {:ok, post} ->\n      conn\n      |> put_flash(:info, \"Post created successfully.\")\n      |> redirect(to: ~p\"/posts/#{post}\")\n\n    {:error, %Ecto.Changeset{} = changeset} ->\n      render(conn, :new, changeset: changeset)\n  end\nend\n```\n\nSince there are two possible outcomes for the `create`, we will have at least two tests:\n\n```elixir\ndescribe \"create post\" do\n  test \"redirects to show when data is valid\", %{conn: conn} do\n    conn = post(conn, ~p\"/posts\", post: @create_attrs)\n\n    assert %{id: id} = redirected_params(conn)\n    assert redirected_to(conn) == ~p\"/posts/#{id}\"\n\n    conn = get(conn, ~p\"/posts/#{id}\")\n    assert html_response(conn, 200) =~ \"Post #{id}\"\n  end\n\n  test \"renders errors when data is invalid\", %{conn: conn} do\n    conn = post(conn, ~p\"/posts\", post: @invalid_attrs)\n    assert html_response(conn, 200) =~ \"New Post\"\n  end\nend\n```\n\nThe first test starts with a `post/2` request. That's because once the form in the `/posts/new` page is submitted, it becomes a POST request to the create action. Because we have supplied valid attributes, the post should have been successfully created and we should have redirected to the show action of the new post. This new page will have an address like `/posts/ID`, where ID is the identifier of the post in the database.\n\nWe then use `redirected_params(conn)` to get the ID of the post and then match that we indeed redirected to the show action. Finally, we do request a `get` request to the page we redirected to, allowing us to verify that the post was indeed created.\n\nFor the second test, we simply test the failure scenario. If any invalid attribute is given, it should re-render the \"New Post\" page.\n\nOne common question is: how many failure scenarios do you test at the controller level? For example, in the [Testing Contexts](testing_contexts.html) guide, we introduced a validation to the `title` field of the post:\n\n```elixir\ndef changeset(post, attrs) do\n  post\n  |> cast(attrs, [:title, :body])\n  |> validate_required([:title, :body])\n  |> validate_length(:title, min: 2)\nend\n```\n\nIn other words, creating a post can fail for the following reasons:\n\n  * the title is missing\n  * the body is missing\n  * the title is present but is less than 2 characters\n\nShould we test all of these possible outcomes in our controller tests?\n\nThe answer is no. All of the different rules and outcomes should be verified in your context and schema tests. The controller works as the integration layer. In the controller tests we simply want to verify, in broad strokes, that we handle both success and failure scenarios.\n\nThe test for `update` follows a similar structure as `create`, so let's skip to the `delete` test.","ref":"testing_controllers.html#the-create-action"},{"type":"extras","title":"The delete action - Testing Controllers","doc":"The `delete` action looks like this:\n\n```elixir\ndef delete(conn, %{\"id\" => id}) do\n  post = Blog.get_post!(id)\n  {:ok, _post} = Blog.delete_post(post)\n\n  conn\n  |> put_flash(:info, \"Post deleted successfully.\")\n  |> redirect(to: ~p\"/posts\")\nend\n```\n\nThe test is written like this:\n\n```elixir\n  describe \"delete post\" do\n    setup [:create_post]\n\n    test \"deletes chosen post\", %{conn: conn, post: post} do\n      conn = delete(conn, ~p\"/posts/#{post}\")\n      assert redirected_to(conn) == ~p\"/posts\"\n\n      assert_error_sent 404, fn ->\n        get(conn, ~p\"/posts/#{post}\")\n      end\n    end\n  end\n\n  defp create_post(_) do\n    post = post_fixture()\n    %{post: post}\n  end\n```\n\nFirst of all, `setup` is used to declare that the `create_post` function should run before every test in this `describe` block. The `create_post` function simply creates a post and stores it in the test metadata. This allows us to, in the first line of the test, match on both the post and the connection:\n\n```elixir\ntest \"deletes chosen post\", %{conn: conn, post: post} do\n```\n\nThe test uses `delete/2` to delete the post and then asserts that we redirected to the index page. Finally, we check that it is no longer possible to access the show page of the deleted post:\n\n```elixir\nassert_error_sent 404, fn ->\n  get(conn, ~p\"/posts/#{post}\")\nend\n```\n\n`assert_error_sent` is a testing helper provided by `Phoenix.ConnTest`. In this case, it verifies that:\n\n  1. An exception was raised\n  2. The exception has a status code equivalent to 404 (which stands for Not Found)\n\nThis pretty much mimics how Phoenix handles exceptions. For example, when we access `/posts/12345` where `12345` is an ID that does not exist, we will invoke our `show` action:\n\n```elixir\ndef show(conn, %{\"id\" => id}) do\n  post = Blog.get_post!(id)\n  render(conn, :show, post: post)\nend\n```\n\nWhen an unknown post ID is given to `Blog.get_post!/1`, it raises an `Ecto.NotFoundError`. If your application raises any exception during a web request, Phoenix translates those requests into proper HTTP response codes. In this case, 404.\n\nWe could, for example, have written this test as:\n\n```elixir\nassert_raise Ecto.NotFoundError, fn ->\n  get(conn, ~p\"/posts/#{post}\")\nend\n```\n\nHowever, you may prefer the implementation Phoenix generates by default as it ignores the specific details of the failure, and instead verifies what the browser would actually receive.\n\nThe tests for `new`, `edit`, and `show` actions are simpler variations of the tests we have seen so far. You can check the action implementation and their respective tests yourself. Now we are ready to move to JSON controller tests.","ref":"testing_controllers.html#the-delete-action"},{"type":"extras","title":"JSON controller tests - Testing Controllers","doc":"So far we have been working with a generated HTML resource. However, let's take a look at how our tests look like when we generate a JSON resource.\n\nFirst of all, run this command:\n\n```console\n$ mix phx.gen.json News Article articles title body\n```\n\nWe chose a very similar concept to the Blog context <-> Post schema, except we are using a different name, so we can study these concepts in isolation.\n\nAfter you run the command above, do not forget to follow the final steps output by the generator. Once all is done, we should run `mix test` and now have 35 passing tests:\n\n```console\n$ mix test\n................\n\nFinished in 0.6 seconds\n35 tests, 0 failures\n\nRandomized with seed 618478\n```\n\nYou may have noticed that this time the scaffold controller has generated fewer tests. Previously it generated 16 (we went from 5 to 21) and now it generated 14 (we went from 21 to 35). That's because JSON APIs do not need to expose the `new` and `edit` actions. We can see this is the case in the resource we have added to the router at the end of the `mix phx.gen.json` command:\n\n```elixir\nresources \"/articles\", ArticleController, except: [:new, :edit]\n```\n\n`new` and `edit` are only necessary for HTML because they basically exist to assist users in creating and updating resources. Besides having less actions, we will notice the controller and view tests and implementations for JSON are drastically different from the HTML ones.\n\nThe only thing that is pretty much the same between HTML and JSON is the contexts and the schema, which, once you think about it, it makes total sense. After all, your business logic should remain the same, regardless if you are exposing it as HTML or JSON.\n\nWith the differences in hand, let's take a look at the controller tests.","ref":"testing_controllers.html#json-controller-tests"},{"type":"extras","title":"The index action - Testing Controllers","doc":"Open up `test/hello_web/controllers/article_controller_test.exs`. The initial structure is quite similar to `post_controller_test.exs`. So let's take a look at the tests for the `index` action. The `index` action itself is implemented in `lib/hello_web/controllers/article_controller.ex` like this:\n\n```elixir\ndef index(conn, _params) do\n  articles = News.list_articles()\n  render(conn, :index, articles: articles)\nend\n```\n\nThe action gets all articles and renders the index template. Since we are talking about JSON, we don't have a `index.json.heex` template. Instead, the code that converts `articles` into JSON can be found directly in the ArticleJSON module, defined at `lib/hello_web/controllers/article_json.ex` like this:\n\n```elixir\ndefmodule HelloWeb.ArticleJSON do\n  alias Hello.News.Article\n\n  def index(%{articles: articles}) do\n    %{data: for(article <- articles, do: data(article))}\n  end\n\n  def show(%{article: article}) do\n    %{data: data(article)}\n  end\n\n  defp data(%Article{} = article) do\n    %{\n      id: article.id,\n      title: article.title,\n      body: article.body\n    }\n  end\nend\n```\n\nSince a controller render is a regular function call, we don't need any extra features to render JSON. We simply define functions for our `index` and `show` actions that return the map of JSON for articles.\n\nLet's take a look at the test for the `index` action then:\n\n```elixir\ndescribe \"index\" do\n  test \"lists all articles\", %{conn: conn} do\n    conn = get(conn, ~p\"/api/articles\")\n    assert json_response(conn, 200)[\"data\"] == []\n  end\nend\n```\n\nIt simply accesses the `index` path, asserts we got a JSON response with status 200 and that it contains a \"data\" key with an empty list, as we have no articles to return.\n\nThat was quite boring. Let's look at something more interesting.","ref":"testing_controllers.html#the-index-action"},{"type":"extras","title":"The `create` action - Testing Controllers","doc":"The `create` action is defined like this:\n\n```elixir\ndef create(conn, %{\"article\" => article_params}) do\n  with {:ok, %Article{} = article} <- News.create_article(article_params) do\n    conn\n    |> put_status(:created)\n    |> put_resp_header(\"location\", ~p\"/api/articles/#{article}\")\n    |> render(:show, article: article)\n  end\nend\n```\n\nAs we can see, it checks if an article could be created. If so, it sets the status code to `:created` (which translates to 201), it sets a \"location\" header with the location of the article, and then renders \"show.json\" with the article.\n\nThis is precisely what the first test for the `create` action verifies:\n\n```elixir\ndescribe \"create article\" do\n  test \"renders article when data is valid\", %{conn: conn} do\n    conn = post(conn, ~p\"/articles\", article: @create_attrs)\n    assert %{\"id\" => id} = json_response(conn, 201)[\"data\"]\n\n    conn = get(conn, ~p\"/api/articles/#{id}\")\n\n    assert %{\n             \"id\" => ^id,\n             \"body\" => \"some body\",\n             \"title\" => \"some title\"\n           } = json_response(conn, 200)[\"data\"]\n  end\n```\n\nThe test uses `post/2` to create a new article and then we verify that the article returned a JSON response, with status 201, and that it had a \"data\" key in it. We pattern match the \"data\" on `%{\"id\" => id}`, which allows us to extract the ID of the new article. Then we perform a `get/2` request on the `show` route and verify that the article was successfully created.\n\nInside `describe \"create article\"`, we will find another test, which handles the failure scenario. Can you spot the failure scenario in the `create` action? Let's recap it:\n\n```elixir\ndef create(conn, %{\"article\" => article_params}) do\n  with {:ok, %Article{} = article} <- News.create_article(article_params) do\n```\n\nThe `with` special form that ships as part of Elixir allows us to check explicitly for the happy paths. In this case, we are interested only in the scenarios where `News.create_article(article_params)` returns `{:ok, article}`, if it returns anything else, the other value will simply be returned directly and none of the contents inside the `do/end` block will be executed. In other words, if `News.create_article/1` returns `{:error, changeset}`, we will simply return `{:error, changeset}` from the action.\n\nHowever, this introduces an issue. Our actions do not know how to handle the `{:error, changeset}` result by default. Luckily, we can teach Phoenix Controllers to handle it with the Action Fallback controller. At the top of `ArticleController`, you will find:\n\n```elixir\n  action_fallback HelloWeb.FallbackController\n```\n\nThis line says: if any action does not return a `%Plug.Conn{}`, we want to invoke `FallbackController` with the result. You will find `HelloWeb.FallbackController` at `lib/hello_web/controllers/fallback_controller.ex` and it looks like this:\n\n```elixir\ndefmodule HelloWeb.FallbackController do\n  use HelloWeb, :controller\n\n  def call(conn, {:error, %Ecto.Changeset{} = changeset}) do\n    conn\n    |> put_status(:unprocessable_entity)\n    |> put_view(json: HelloWeb.ChangesetJSON)\n    |> render(:error, changeset: changeset)\n  end\n\n  def call(conn, {:error, :not_found}) do\n    conn\n    |> put_status(:not_found)\n    |> put_view(html: HelloWeb.ErrorHTML, json: HelloWeb.ErrorJSON)\n    |> render(:\"404\")\n  end\nend\n```\n\nYou can see how the first clause of the `call/2` function handles the `{:error, changeset}` case, setting the status code to unprocessable entity (422), and then rendering \"error.json\" from the changeset view with the failed changeset.\n\nWith this in mind, let's look at our second test for `create`:\n\n```elixir\ntest \"renders errors when data is invalid\", %{conn: conn} do\n  conn = post(conn, ~p\"/api/articles\", article: @invalid_attrs)\n  assert json_response(conn, 422)[\"errors\"] != %{}\nend\n```\n\nIt simply posts to the `create` path with invalid parameters. This makes it return a JSON response, with status code 422, and a response with a non-empty \"errors\" key.\n\nThe `action_fallback` can be extremely useful to reduce boilerplate when designing APIs. You can learn more about the \"Action Fallback\" in the [Controllers guide](controllers.html).","ref":"testing_controllers.html#the-create-action"},{"type":"extras","title":"The `delete` action - Testing Controllers","doc":"Finally, the last action we will study is the `delete` action for JSON. Its implementation looks like this:\n\n```elixir\ndef delete(conn, %{\"id\" => id}) do\n  article = News.get_article!(id)\n\n  with {:ok, %Article{}} <- News.delete_article(article) do\n    send_resp(conn, :no_content, \"\")\n  end\nend\n```\n\nThe new action simply attempts to delete the article and, if it succeeds, it returns an empty response with status code `:no_content` (204).\n\nThe test looks like this:\n\n```elixir\ndescribe \"delete article\" do\n  setup [:create_article]\n\n  test \"deletes chosen article\", %{conn: conn, article: article} do\n    conn = delete(conn, ~p\"/api/articles/#{article}\")\n    assert response(conn, 204)\n\n    assert_error_sent 404, fn ->\n      get(conn, ~p\"/api/articles/#{article}\")\n    end\n  end\nend\n\ndefp create_article(_) do\n  article = article_fixture()\n  %{article: article}\nend\n```\n\nIt setups a new article, then in the test it invokes the `delete` path to delete it, asserting on a 204 response, which is neither JSON nor HTML. Then it verifies that we can no longer access said article.\n\nThat's all!\n\nNow that we understand how the scaffolded code and their tests work for both HTML and JSON APIs, we are prepared to move forward in building and maintaining our web applications!","ref":"testing_controllers.html#the-delete-action"},{"type":"extras","title":"Testing Channels","doc":"# Testing Channels\n\n> **Requirement**: This guide expects that you have gone through the [introductory guides](installation.html) and got a Phoenix application [up and running](up_and_running.html).\n\n> **Requirement**: This guide expects that you have gone through the [Introduction to Testing guide](testing.html).\n\n> **Requirement**: This guide expects that you have gone through the [Channels guide](channels.html).\n\nIn the Channels guide, we saw that a \"Channel\" is a layered system with different components. Given this, there would be cases when writing unit tests for our Channel functions may not be enough. We may want to verify that its different moving parts are working together as we expect. This integration testing would assure us that we correctly defined our channel route, the channel module, and its callbacks; and that the lower-level layers such as the PubSub and Transport are configured correctly and are working as intended.","ref":"testing_channels.html"},{"type":"extras","title":"Generating channels - Testing Channels","doc":"As we progress through this guide, it would help to have a concrete example we could work off of. Phoenix comes with a Mix task for generating a basic channel and tests. These generated files serve as a good reference for writing channels and their corresponding tests. Let's go ahead and generate our Channel:\n\n```console\n$ mix phx.gen.channel Room\n* creating lib/hello_web/channels/room_channel.ex\n* creating test/hello_web/channels/room_channel_test.exs\n* creating test/support/channel_case.ex\n\nThe default socket handler - HelloWeb.UserSocket - was not found.\n\nDo you want to create it? [Yn]  \n* creating lib/hello_web/channels/user_socket.ex\n* creating assets/js/user_socket.js\n\nAdd the socket handler to your `lib/hello_web/endpoint.ex`, for example:\n\n    socket \"/socket\", HelloWeb.UserSocket,\n      websocket: true,\n      longpoll: false\n\nFor the front-end integration, you need to import the `user_socket.js`\nin your `assets/js/app.js` file:\n\n    import \"./user_socket.js\"\n```\n\nThis creates a channel, its test and instructs us to add a channel route in `lib/hello_web/channels/user_socket.ex`. It is important to add the channel route or our channel won't function at all!","ref":"testing_channels.html#generating-channels"},{"type":"extras","title":"The ChannelCase - Testing Channels","doc":"Open up `test/hello_web/channels/room_channel_test.exs` and you will find this:\n\n```elixir\ndefmodule HelloWeb.RoomChannelTest do\n  use HelloWeb.ChannelCase\n```\n\nSimilar to `ConnCase` and `DataCase`, we now have a `ChannelCase`. All three of them have been generated for us when we started our Phoenix application. Let's take a look at it. Open up `test/support/channel_case.ex`:\n\n```elixir\ndefmodule HelloWeb.ChannelCase do\n  use ExUnit.CaseTemplate\n\n  using do\n    quote do\n      # Import conveniences for testing with channels\n      import Phoenix.ChannelTest\n      import HelloWeb.ChannelCase\n\n      # The default endpoint for testing\n      @endpoint HelloWeb.Endpoint\n    end\n  end\n\n  setup _tags do\n    Hello.DataCase.setup_sandbox(tags)\n    :ok\n  end\nend\n```\n\nIt is very straight-forward. It sets up a case template that imports all of `Phoenix.ChannelTest` on use. In the `setup` block, it starts the SQL Sandbox, which we discussed in the [Testing contexts guide](testing_contexts.html).","ref":"testing_channels.html#the-channelcase"},{"type":"extras","title":"Subscribe and joining - Testing Channels","doc":"Now that we know that Phoenix provides with a custom Test Case just for channels and what it\nprovides, we can move on to understanding the rest of `test/hello_web/channels/room_channel_test.exs`.\n\nFirst off, is the setup block:\n\n```elixir\nsetup do\n  {:ok, _, socket} =\n    HelloWeb.UserSocket\n    |> socket(\"user_id\", %{some: :assign})\n    |> subscribe_and_join(HelloWeb.RoomChannel, \"room:lobby\")\n\n  %{socket: socket}\nend\n```\n\nThe `setup` block sets up a `Phoenix.Socket` based on the `UserSocket` module, which you can find at `lib/hello_web/channels/user_socket.ex`. Then it says we want to subscribe and join the `RoomChannel`, accessible as `\"room:lobby\"` in the `UserSocket`. At the end of the test, we return the `%{socket: socket}` as metadata, so we can reuse it on every test.\n\nIn a nutshell, `subscribe_and_join/3` emulates the client joining a channel and subscribes the test process to the given topic. This is a necessary step since clients need to join a channel before they can send and receive events on that channel.","ref":"testing_channels.html#subscribe-and-joining"},{"type":"extras","title":"Testing a synchronous reply - Testing Channels","doc":"The first test block in our generated channel test looks like:\n\n```elixir\ntest \"ping replies with status ok\", %{socket: socket} do\n  ref = push(socket, \"ping\", %{\"hello\" => \"there\"})\n  assert_reply ref, :ok, %{\"hello\" => \"there\"}\nend\n```\n\nThis tests the following code in our `HelloWeb.RoomChannel`:\n\n```elixir\n# Channels can be used in a request/response fashion\n# by sending replies to requests from the client\ndef handle_in(\"ping\", payload, socket) do\n  {:reply, {:ok, payload}, socket}\nend\n```\n\nAs is stated in the comment above, we see that a `reply` is synchronous since it mimics the request/response pattern we are familiar with in HTTP. This synchronous reply is best used when we only want to send an event back to the client when we are done processing the message on the server. For example, when we save something to the database and then send a message to the client only once that's done.\n\nIn the `test \"ping replies with status ok\", %{socket: socket} do` line, we see that we have the map `%{socket: socket}`. This gives us access to the `socket` in the setup block.\n\nWe emulate the client pushing a message to the channel with `push/3`. In the line `ref = push(socket, \"ping\", %{\"hello\" => \"there\"})`, we push the event `\"ping\"` with the payload `%{\"hello\" => \"there\"}` to the channel. This triggers the `handle_in/3` callback we have for the `\"ping\"` event in our channel. Note that we store the `ref` since we need that on the next line for asserting the reply. With `assert_reply ref, :ok, %{\"hello\" => \"there\"}`, we assert that the server sends a synchronous reply `:ok, %{\"hello\" => \"there\"}`. This is how we check that the `handle_in/3` callback for the `\"ping\"` was triggered.","ref":"testing_channels.html#testing-a-synchronous-reply"},{"type":"extras","title":"Testing a Broadcast - Testing Channels","doc":"It is common to receive messages from the client and broadcast to everyone subscribed to a current topic. This common pattern is simple to express in Phoenix and is one of the generated `handle_in/3` callbacks in our `HelloWeb.RoomChannel`.\n\n```elixir\ndef handle_in(\"shout\", payload, socket) do\n  broadcast(socket, \"shout\", payload)\n  {:noreply, socket}\nend\n```\n\nIts corresponding test looks like:\n\n```elixir\ntest \"shout broadcasts to room:lobby\", %{socket: socket} do\n  push(socket, \"shout\", %{\"hello\" => \"all\"})\n  assert_broadcast \"shout\", %{\"hello\" => \"all\"}\nend\n```\n\nWe notice that we access the same `socket` that is from the setup block. How handy! We also do the same `push/3` as we did in the synchronous reply test. So we `push` the `\"shout\"` event with the payload `%{\"hello\" => \"all\"}`.\n\nSince the `handle_in/3` callback for the `\"shout\"` event just broadcasts the same event and payload, all subscribers in the `\"room:lobby\"` should receive the message. To check that, we do `assert_broadcast \"shout\", %{\"hello\" => \"all\"}`.\n\n**NOTE:** `assert_broadcast/3` tests that the message was broadcast in the PubSub system. For testing if a client receives a message, use `assert_push/3`.","ref":"testing_channels.html#testing-a-broadcast"},{"type":"extras","title":"Testing an asynchronous push from the server - Testing Channels","doc":"The last test in our `HelloWeb.RoomChannelTest` verifies that broadcasts from the server are pushed to the client. Unlike the previous tests discussed, we are indirectly testing that the channel's `handle_out/3` callback is triggered. By default, `handle_out/3` is implemented for us and simply pushes the message on to the client.\n\nSince the `handle_out/3` event is only triggered when we call `broadcast/3` from our channel, we will need to emulate that in our test. We do that by calling `broadcast_from` or `broadcast_from!`. Both serve the same purpose with the only difference of `broadcast_from!` raising an error when broadcast fails.\n\nThe line `broadcast_from!(socket, \"broadcast\", %{\"some\" => \"data\"})` will trigger the `handle_out/3` callback which pushes the same event and payload back to the client. To test this, we do `assert_push \"broadcast\", %{\"some\" => \"data\"}`.\n\nThat's it. Now you are ready to develop and fully test real-time applications. To learn more about other functionality provided when testing channels, check out the documentation for [`Phoenix.ChannelTest`](https://hexdocs.pm/phoenix/Phoenix.ChannelTest.html).","ref":"testing_channels.html#testing-an-asynchronous-push-from-the-server"},{"type":"extras","title":"Introduction to Deployment","doc":"# Introduction to Deployment\n\nOnce we have a working application, we're ready to deploy it. If you're not quite finished with your own application, don't worry. Just follow the [Up and Running Guide](up_and_running.html) to create a basic application to work with.\n\nWhen preparing an application for deployment, there are three main steps:\n\n  * Handling of your application secrets\n  * Compiling your application assets\n  * Starting your server in production\n\nIn this guide, we will learn how to get the production environment running locally. You can use the same techniques in this guide to run your application in production, but depending on your deployment infrastructure, extra steps will be necessary.\n\nAs an example of deploying to other infrastructures, we also discuss four different approaches in our guides: using [Elixir's releases](releases.html) with `mix release`, [using Gigalixir](gigalixir.html), [using Fly](fly.html), and [using Heroku](heroku.html). We've also included links to deploying Phoenix on other platforms under [Community Deployment Guides](#community-deployment-guides). Finally, the release guide has a sample Dockerfile you can use if you prefer to deploy with container technologies.\n\nLet's explore those steps above one by one.","ref":"deployment.html"},{"type":"extras","title":"Handling of your application secrets - Introduction to Deployment","doc":"All Phoenix applications have data that must be kept secure, for example, the username and password for your production database, and the secret Phoenix uses to sign and encrypt important information. The general recommendation is to keep those in environment variables and load them into your application. This is done in `config/runtime.exs` (formerly `config/prod.secret.exs` or `config/releases.exs`), which is responsible for loading secrets and configuration from environment variables.\n\nTherefore, you need to make sure the proper relevant variables are set in production:\n\n```console\n$ mix phx.gen.secret\nREALLY_LONG_SECRET\n$ export SECRET_KEY_BASE=REALLY_LONG_SECRET\n$ export DATABASE_URL=ecto://USER:PASS@HOST/database\n```\n\nDo not copy those values directly, set `SECRET_KEY_BASE` according to the result of `mix phx.gen.secret` and `DATABASE_URL` according to your database address.\n\nIf for some reason you do not want to rely on environment variables, you can hard code the secrets in your `config/runtime.exs` but make sure not to check the file into your version control system.\n\nWith your secret information properly secured, it is time to configure assets!\n\nBefore taking this step, we need to do one bit of preparation. Since we will be readying everything for production, we need to do some setup in that environment by getting our dependencies and compiling.\n\n```console\n$ mix deps.get --only prod\n$ MIX_ENV=prod mix compile\n```","ref":"deployment.html#handling-of-your-application-secrets"},{"type":"extras","title":"Compiling your application assets - Introduction to Deployment","doc":"This step is required only if you have compilable assets like JavaScript and stylesheets. By default, Phoenix uses `esbuild` but everything is encapsulated in a single `mix assets.deploy` task defined in your `mix.exs`:\n\n```console\n$ MIX_ENV=prod mix assets.deploy\nCheck your digested files at \"priv/static\".\n```\n\nAnd that is it! The Mix task by default builds the assets and then generates digests with a cache manifest file so Phoenix can quickly serve assets in production.\n\n> Note: if you run the task above in your local machine, it will generate many digested assets in `priv/static`. You can prune them by running `mix phx.digest.clean --all`.\n\nKeep in mind that, if you by any chance forget to run the steps above, Phoenix will show an error message:\n\n```console\n$ PORT=4001 MIX_ENV=prod mix phx.server\n10:50:18.732 [info] Running MyAppWeb.Endpoint with Cowboy on http://example.com\n10:50:18.735 [error] Could not find static manifest at \"my_app/_build/prod/lib/foo/priv/static/cache_manifest.json\". Run \"mix phx.digest\" after building your static files or remove the configuration from \"config/prod.exs\".\n```\n\nThe error message is quite clear: it says Phoenix could not find a static manifest. Just run the commands above to fix it or, if you are not serving or don't care about assets at all, you can just remove the `cache_static_manifest` configuration from your config.","ref":"deployment.html#compiling-your-application-assets"},{"type":"extras","title":"Starting your server in production - Introduction to Deployment","doc":"To run Phoenix in production, we need to set the `PORT` and `MIX_ENV` environment variables when invoking `mix phx.server`:\n\n```console\n$ PORT=4001 MIX_ENV=prod mix phx.server\n10:59:19.136 [info] Running MyAppWeb.Endpoint with Cowboy on http://example.com\n```\n\nTo run in detached mode so that the Phoenix server does not stop and continues to run even if you close the terminal:\n\n```console\n$ PORT=4001 MIX_ENV=prod elixir --erl \"-detached\" -S mix phx.server\n```\n\nIn case you get an error message, please read it carefully, and open up a bug report if it is still not clear how to address it.\n\nYou can also run your application inside an interactive shell:\n\n```console\n$ PORT=4001 MIX_ENV=prod iex -S mix phx.server\n10:59:19.136 [info] Running MyAppWeb.Endpoint with Cowboy on http://example.com\n```","ref":"deployment.html#starting-your-server-in-production"},{"type":"extras","title":"Putting it all together - Introduction to Deployment","doc":"The previous sections give an overview about the main steps required to deploy your Phoenix application. In practice, you will end-up adding steps of your own as well. For example, if you are using a database, you will also want to run `mix ecto.migrate` before starting the server to ensure your database is up to date.\n\nOverall, here is a script you can use as a starting point:\n\n```console\n# Initial setup\n$ mix deps.get --only prod\n$ MIX_ENV=prod mix compile\n\n# Compile assets\n$ MIX_ENV=prod mix assets.deploy\n\n# Custom tasks (like DB migrations)\n$ MIX_ENV=prod mix ecto.migrate\n\n# Finally run the server\n$ PORT=4001 MIX_ENV=prod mix phx.server\n```\n\nAnd that's it. Next, you can use one of our official guides to deploy:\n\n  * [with Elixir's releases](releases.html)\n  * [to Gigalixir](gigalixir.html), an Elixir-centric Platform as a Service (PaaS)\n  * [to Fly.io](fly.html), a PaaS that deploys your servers close to your users with built-in distribution support\n  * and [to Heroku](heroku.html), one of the most popular PaaS.","ref":"deployment.html#putting-it-all-together"},{"type":"extras","title":"Community Deployment Guides - Introduction to Deployment","doc":"* [Render](https://render.com) has first class support for Phoenix applications. There are guides for hosting Phoenix with [Mix releases](https://render.com/docs/deploy-phoenix), [Distillery](https://render.com/docs/deploy-phoenix-distillery), and as a [Distributed Elixir Cluster](https://render.com/docs/deploy-elixir-cluster).","ref":"deployment.html#community-deployment-guides"},{"type":"extras","title":"Deploying with Releases","doc":"# Deploying with Releases","ref":"releases.html"},{"type":"extras","title":"What we'll need - Deploying with Releases","doc":"The only thing we'll need for this guide is a working Phoenix application. For those of us who need a simple application to deploy, please follow the [Up and Running guide](up_and_running.html).","ref":"releases.html#what-we-ll-need"},{"type":"extras","title":"Goals - Deploying with Releases","doc":"Our main goal for this guide is to package your Phoenix application into a self-contained directory that includes the Erlang VM, Elixir, all of your code and dependencies. This package can then be dropped into a production machine.","ref":"releases.html#goals"},{"type":"extras","title":"Releases, assemble! - Deploying with Releases","doc":"If you are not familiar with Elixir releases yet, we recommend you to read [Elixir's excellent docs](https://hexdocs.pm/mix/Mix.Tasks.Release.html) before continuing.\n\nOnce that is done, you can assemble a release by going through all of the steps in our general [deployment guide](deployment.html) with `mix release` at the end. Let's recap.\n\nFirst set the environment variables:\n\n```console\n$ mix phx.gen.secret\nREALLY_LONG_SECRET\n$ export SECRET_KEY_BASE=REALLY_LONG_SECRET\n$ export DATABASE_URL=ecto://USER:PASS@HOST/database\n```\n\nThen load dependencies to compile code and assets:\n\n```console\n# Initial setup\n$ mix deps.get --only prod\n$ MIX_ENV=prod mix compile\n\n# Compile assets\n$ MIX_ENV=prod mix assets.deploy\n```\n\nAnd now run `mix phx.gen.release`:\n\n```console\n$ mix phx.gen.release\n==> my_app\n* creating rel/overlays/bin/server\n* creating rel/overlays/bin/server.bat\n* creating rel/overlays/bin/migrate\n* creating rel/overlays/bin/migrate.bat\n* creating lib/my_app/release.ex\n\nYour application is ready to be deployed in a release!\n\n    # To start your system\n    _build/dev/rel/my_app/bin/my_app start\n\n    # To start your system with the Phoenix server running\n    _build/dev/rel/my_app/bin/server\n\n    # To run migrations\n    _build/dev/rel/my_app/bin/migrate\n\nOnce the release is running:\n\n    # To connect to it remotely\n    _build/dev/rel/my_app/bin/my_app remote\n\n    # To stop it gracefully (you may also send SIGINT/SIGTERM)\n    _build/dev/rel/my_app/bin/my_app stop\n\nTo list all commands:\n\n    _build/dev/rel/my_app/bin/my_app\n\n```\n\nThe `phx.gen.release` task generated a few files for us to assist in releases. First, it created `server` and `migrate` *overlay* scripts for conveniently running the phoenix server inside a release or invoking migrations from a release. The files in the `rel/overlays` directory are copied into every release environment. Next, it generated a `release.ex` file which is used to invoke Ecto migrations without a dependency on `mix` itself.\n\n*Note*: If you are a Docker user, you can pass the `--docker` flag to `mix phx.gen.release` to generate a Dockerfile ready for deployment.\n\nNext, we can invoke `mix release` to build the release:\n\n```console\n$ MIX_ENV=prod mix release\nGenerated my_app app\n* assembling my_app-0.1.0 on MIX_ENV=prod\n* using config/runtime.exs to configure the release at runtime\n\nRelease created at _build/prod/rel/my_app!\n\n    # To start your system\n    _build/prod/rel/my_app/bin/my_app start\n\n...\n```\n\nYou can start the release by calling `_build/prod/rel/my_app/bin/my_app start`, or boot your webserver by calling `_build/prod/rel/my_app/bin/server`, where you have to replace `my_app` by your current application name.\n\nNow you can get all of the files under the `_build/prod/rel/my_app` directory, package it, and run it in any production machine with the same OS and architecture as the one that assembled the release. For more details, check the [docs for `mix release`](https://hexdocs.pm/mix/Mix.Tasks.Release.html).\n\nBut before we finish this guide, there is one more feature from releases that most Phoenix application will use, so let's talk about that.","ref":"releases.html#releases-assemble"},{"type":"extras","title":"Ecto migrations and custom commands - Deploying with Releases","doc":"A common need in production systems is to execute custom commands required to set up the production environment. One of such commands is precisely migrating the database. Since we don't have `Mix`, a *build* tool, inside releases, which are a production artifact, we need to bring said commands directly into the release.\n\nThe `phx.gen.release` command created the following `release.ex` file in your project `lib/my_app/release.ex`, with the following content:\n\n```elixir\ndefmodule MyApp.Release do\n  @app :my_app\n\n  def migrate do\n    load_app()\n\n    for repo <- repos() do\n      {:ok, _, _} = Ecto.Migrator.with_repo(repo, &Ecto.Migrator.run(&1, :up, all: true))\n    end\n  end\n\n  def rollback(repo, version) do\n    load_app()\n    {:ok, _, _} = Ecto.Migrator.with_repo(repo, &Ecto.Migrator.run(&1, :down, to: version))\n  end\n\n  defp repos do\n    Application.fetch_env!(@app, :ecto_repos)\n  end\n\n  defp load_app do\n    Application.load(@app)\n  end\nend\n```\n\nWhere you replace the first two lines by your application names.\n\nNow you can assemble a new release with `MIX_ENV=prod mix release` and you can invoke any code, including the functions in the module above, by calling the `eval` command:\n\n```console\n$ _build/prod/rel/my_app/bin/my_app eval \"MyApp.Release.migrate\"\n```\n\nAnd that's it! If you peek inside the `migrate` script, you'll see it wraps exactly this invocation.\n\nYou can use this approach to create any custom command to run in production. In this case, we used `load_app`, which calls `Application.load/1` to load the current application without starting it. However, you may want to write a custom command that starts the whole application. In such cases, `Application.ensure_all_started/1` must be used. Keep in mind, starting the application will start all processes for the current application, including the Phoenix endpoint. This can be circumvented by changing your supervision tree to not start certain children under certain conditions. For example, in the release commands file you could do:\n\n```elixir\ndefp start_app do\n  load_app()\n  Application.put_env(@app, :minimal, true)\n  Application.ensure_all_started(@app)\nend\n```\n\nAnd then in your application you check `Application.get_env(@app, :minimal)` and start only part of the children when it is set.","ref":"releases.html#ecto-migrations-and-custom-commands"},{"type":"extras","title":"Containers - Deploying with Releases","doc":"Elixir releases work well with container technologies, such as Docker. The idea is that you assemble the release inside the Docker container and then build an image based on the release artifacts.\n\nIf you call `mix phx.gen.release --docker` you'll see a new file with these contents:\n\n```Dockerfile\n# Find eligible builder and runner images on Docker Hub. We use Ubuntu/Debian\n# instead of Alpine to avoid DNS resolution issues in production.\n#\n# https://hub.docker.com/r/hexpm/elixir/tags?page=1&name=ubuntu\n# https://hub.docker.com/_/ubuntu?tab=tags\n#\n# This file is based on these images:\n#\n#   - https://hub.docker.com/r/hexpm/elixir/tags - for the build image\n#   - https://hub.docker.com/_/debian?tab=tags&page=1&name=bullseye-20230612-slim - for the release image\n#   - https://pkgs.org/ - resource for finding needed packages\n#   - Ex: hexpm/elixir:1.14.5-erlang-25.3.2.4-debian-bullseye-20230612-slim\n#\nARG ELIXIR_VERSION=1.14.5\nARG OTP_VERSION=25.3.2.4\nARG DEBIAN_VERSION=bullseye-20230612-slim\n\nARG BUILDER_IMAGE=\"hexpm/elixir:${ELIXIR_VERSION}-erlang-${OTP_VERSION}-debian-${DEBIAN_VERSION}\"\nARG RUNNER_IMAGE=\"debian:${DEBIAN_VERSION}\"\n\nFROM ${BUILDER_IMAGE} as builder\n\n# install build dependencies\nRUN apt-get update -y && apt-get install -y build-essential git \\\n    && apt-get clean && rm -f /var/lib/apt/lists/*_*\n\n# prepare build dir\nWORKDIR /app\n\n# install hex + rebar\nRUN mix local.hex --force && \\\n    mix local.rebar --force\n\n# set build ENV\nENV MIX_ENV=\"prod\"\n\n# install mix dependencies\nCOPY mix.exs mix.lock ./\nRUN mix deps.get --only $MIX_ENV\nRUN mkdir config\n\n# copy compile-time config files before we compile dependencies\n# to ensure any relevant config change will trigger the dependencies\n# to be re-compiled.\nCOPY config/config.exs config/${MIX_ENV}.exs config/\nRUN mix deps.compile\n\nCOPY priv priv\n\nCOPY lib lib\n\nCOPY assets assets\n\n# compile assets\nRUN mix assets.deploy\n\n# Compile the release\nRUN mix compile\n\n# Changes to config/runtime.exs don't require recompiling the code\nCOPY config/runtime.exs config/\n\nCOPY rel rel\nRUN mix release\n\n# start a new build stage so that the final image will only contain\n# the compiled release and other runtime necessities\nFROM ${RUNNER_IMAGE}\n\nRUN apt-get update -y && \\\n  apt-get install -y libstdc++6 openssl libncurses5 locales ca-certificates \\\n  && apt-get clean && rm -f /var/lib/apt/lists/*_*\n\n# Set the locale\nRUN sed -i '/en_US.UTF-8/s/^# //g' /etc/locale.gen && locale-gen\n\nENV LANG en_US.UTF-8\nENV LANGUAGE en_US:en\nENV LC_ALL en_US.UTF-8\n\nWORKDIR \"/app\"\nRUN chown nobody /app\n\n# set runner ENV\nENV MIX_ENV=\"prod\"\n\n# Only copy the final release from the build stage\nCOPY --from=builder --chown=nobody:root /app/_build/${MIX_ENV}/rel/my_app ./\n\nUSER nobody\n\n# If using an environment that doesn't automatically reap zombie processes, it is\n# advised to add an init process such as tini via `apt-get install`\n# above and adding an entrypoint. See https://github.com/krallin/tini for details\n# ENTRYPOINT [\"/tini\", \"--\"]\n\nCMD [\"/app/bin/server\"]\n```\n\nWhere `my_app` is the name of your app. At the end, you will have an application in `/app` ready to run as `/app/bin/server`.\n\nA few points about configuring a containerized application:\n\n- If you run your app in a container, the `Endpoint` needs to be configured to listen on a \"public\" `:ip` address (like `0.0.0.0`) so that the app can be reached from outside the container. Whether the host should publish the container's ports to its own public IP or to localhost depends on your needs.\n- The more configuration you can provide at runtime (using `config/runtime.exs`), the more reusable your images will be across environments. In particular, secrets like database credentials and API keys should not be compiled into the image, but rather should be provided when creating containers based on that image. This is why the `Endpoint`'s `:secret_key_base` is configured in `config/runtime.exs` by default.\n- If possible, any environment variables that are needed at runtime should be read in `config/runtime.exs`, not scattered throughout your code. Having them all visible in one place will make it easier to ensure the containers get what they need, especially if the person doing the infrastructure work does not work on the Elixir code. Libraries in particular should never directly read environment variables; all their configuration should be handed to them by the top-level application, preferably [without using the application environment](https://hexdocs.pm/elixir/library-guidelines.html#avoid-application-configuration).","ref":"releases.html#containers"},{"type":"extras","title":"Deploying on Gigalixir","doc":"# Deploying on Gigalixir","ref":"gigalixir.html"},{"type":"extras","title":"What we'll need - Deploying on Gigalixir","doc":"The only thing we'll need for this guide is a working Phoenix application. For those of us who need a simple application to deploy, please follow the [Up and Running guide](https://hexdocs.pm/phoenix/up_and_running.html).","ref":"gigalixir.html#what-we-ll-need"},{"type":"extras","title":"Goals - Deploying on Gigalixir","doc":"Our main goal for this guide is to get a Phoenix application running on Gigalixir.","ref":"gigalixir.html#goals"},{"type":"extras","title":"Steps - Deploying on Gigalixir","doc":"Let's separate this process into a few steps, so we can keep track of where we are.\n\n- Initialize Git repository\n- Install the Gigalixir CLI\n- Sign up for Gigalixir\n- Create and set up Gigalixir application\n- Provision a database\n- Make our project ready for Gigalixir\n- Deploy time!\n- Useful Gigalixir commands","ref":"gigalixir.html#steps"},{"type":"extras","title":"Initializing Git repository - Deploying on Gigalixir","doc":"If you haven't already, we'll need to commit our files to git. We can do so by running the following commands in our project directory:\n\n```console\n$ git init\n$ git add .\n$ git commit -m \"Initial commit\"\n```","ref":"gigalixir.html#initializing-git-repository"},{"type":"extras","title":"Installing the Gigalixir CLI - Deploying on Gigalixir","doc":"Follow the instructions [here](https://gigalixir.readthedocs.io/en/latest/getting-started-guide.html#install-the-command-line-interface) to install the command-line interface for your platform.","ref":"gigalixir.html#installing-the-gigalixir-cli"},{"type":"extras","title":"Signing up for Gigalixir - Deploying on Gigalixir","doc":"We can sign up for an account at [gigalixir.com](https://www.gigalixir.com) or with the CLI. Let's use the CLI.\n\n```console\n$ gigalixir signup\n```\n\nGigalixir’s free tier does not require a credit card and comes with 1 app instance and 1 PostgreSQL database for free, but please consider upgrading to a paid plan if you are running a production application.\n\nNext, let's login\n\n```console\n$ gigalixir login\n```\n\nAnd verify\n\n```console\n$ gigalixir account\n```","ref":"gigalixir.html#signing-up-for-gigalixir"},{"type":"extras","title":"Creating and setting up our Gigalixir application - Deploying on Gigalixir","doc":"There are three different ways to deploy a Phoenix app on Gigalixir: with mix, with Elixir's releases, or with Distillery. In this guide, we'll be using Mix because it is the easiest to get up and running, but you won't be able to connect a remote observer or hot upgrade. For more information, see [Mix vs Distillery vs Elixir Releases](https://gigalixir.readthedocs.io/en/latest/modify-app/index.html#mix-vs-distillery-vs-elixir-releases). If you want to deploy with another method, follow the [Getting Started Guide](https://gigalixir.readthedocs.io/en/latest/getting-started-guide.html).","ref":"gigalixir.html#creating-and-setting-up-our-gigalixir-application"},{"type":"extras","title":"Creating a Gigalixir application - Deploying on Gigalixir","doc":"Let's create a Gigalixir application\n\n```console\n$ gigalixir create -n \"your_app_name\"\n```\n\nNote: the app name cannot be changed afterwards. A random name is used if you do not provide one.\n\nVerify the app was created\n\n```console\n$ gigalixir apps\n```\n\nVerify that a git remote was created \n\n```console\n$ git remote -v\n```","ref":"gigalixir.html#creating-a-gigalixir-application"},{"type":"extras","title":"Specifying versions - Deploying on Gigalixir","doc":"The buildpacks we use default to Elixir, Erlang, and Node.js versions that are quite old and it's generally a good idea to run the same version in production as you do in development, so let's do that.\n\n```console\n$ echo 'elixir_version=1.14.3' > elixir_buildpack.config\n$ echo 'erlang_version=24.3' >> elixir_buildpack.config\n$ echo 'node_version=12.16.3' > phoenix_static_buildpack.config\n```\n\nPhoenix v1.6 uses `esbuild` to compile your assets, but all Gigalixir images come with `npm`, so we will configure `npm` directly to deploy our assets. Add a `assets/package.json` file if you don't have any with the following:\n\n```json\n{\n  \"scripts\": {\n    \"deploy\": \"cd .. && mix assets.deploy && rm -f _build/esbuild*\"\n  }\n}\n```\n\nFinally, don't forget to commit:\n\n```console\n$ git add elixir_buildpack.config phoenix_static_buildpack.config assets/package.json\n$ git commit -m \"Set Elixir, Erlang, and Node version\"\n```","ref":"gigalixir.html#specifying-versions"},{"type":"extras","title":"Making our Project ready for Gigalixir - Deploying on Gigalixir","doc":"There's nothing we need to do to get our app running on Gigalixir, but for a production app, you probably want to enforce SSL. To do that, see [Force SSL](https://hexdocs.pm/phoenix/using_ssl.html#force-ssl)\n\nYou may also want to use SSL for your database connection. For that, uncomment the line `ssl: true` in your `Repo` config.","ref":"gigalixir.html#making-our-project-ready-for-gigalixir"},{"type":"extras","title":"Provisioning a database - Deploying on Gigalixir","doc":"Let's provision a database for our app\n\n```console\n$ gigalixir pg:create --free\n```\n\nVerify the database was created\n\n```console\n$ gigalixir pg\n```\n\nVerify that a `DATABASE_URL` and `POOL_SIZE` were created\n\n```console\n$ gigalixir config\n```","ref":"gigalixir.html#provisioning-a-database"},{"type":"extras","title":"Deploy Time! - Deploying on Gigalixir","doc":"Our project is now ready to be deployed on Gigalixir.\n\n```console\n$ git push gigalixir\n```\n\nCheck the status of your deploy and wait until the app is `Healthy`\n\n```console\n$ gigalixir ps\n```\n\nRun migrations\n\n```console\n$ gigalixir run mix ecto.migrate\n```\n\nCheck your app logs\n\n```console\n$ gigalixir logs\n```\n\nIf everything looks good, let's take a look at your app running on Gigalixir\n\n```console\n$ gigalixir open\n```","ref":"gigalixir.html#deploy-time"},{"type":"extras","title":"Useful Gigalixir Commands - Deploying on Gigalixir","doc":"Open a remote console\n\n```console\n$ gigalixir account:ssh_keys:add \"$(cat ~/.ssh/id_rsa.pub)\"\n$ gigalixir ps:remote_console\n```\n\nTo open a remote observer, see [Remote Observer](https://gigalixir.readthedocs.io/en/latest/runtime.html#how-to-launch-a-remote-observer)\n\nTo set up clustering, see [Clustering Nodes](https://gigalixir.readthedocs.io/en/latest/cluster.html)\n\nTo hot upgrade, see [Hot Upgrades](https://gigalixir.readthedocs.io/en/latest/deploy.html#how-to-hot-upgrade-an-app)\n\nFor custom domains, scaling, jobs and other features, see the [Gigalixir Documentation](https://gigalixir.readthedocs.io/)","ref":"gigalixir.html#useful-gigalixir-commands"},{"type":"extras","title":"Troubleshooting - Deploying on Gigalixir","doc":"See [Troubleshooting](https://gigalixir.readthedocs.io/en/latest/troubleshooting.html)\n\nAlso, don't hesitate to email [help@gigalixir.com](mailto:help@gigalixir.com) or [request an invitation](https://elixir-lang.slack.com/join/shared_invite/zt-1f13hz7mb-N4KGjF523ONLCcHfb8jYgA#/shared-invite/email) and join the #gigalixir channel on [Slack](https://elixir-lang.slack.com).","ref":"gigalixir.html#troubleshooting"},{"type":"extras","title":"Deploying on Fly.io","doc":"# Deploying on Fly.io\n\n\nFly.io maintains their own guide for Elixir/Phoenix here: [Fly.io/docs/elixir/getting-started/](https://fly.io/docs/elixir/getting-started/) we will keep this guide up but for the latest and greatest check with them!","ref":"fly.html"},{"type":"extras","title":"What we'll need - Deploying on Fly.io","doc":"The only thing we'll need for this guide is a working Phoenix application. For those of us who need a simple application to deploy, please follow the [Up and Running guide](https://hexdocs.pm/phoenix/up_and_running.html).\n\nYou can just:\n\n```console\n$ mix phx.new my_app\n```","ref":"fly.html#what-we-ll-need"},{"type":"extras","title":"Goals - Deploying on Fly.io","doc":"The main goal for this guide is to get a Phoenix application running on [Fly.io](https://fly.io).","ref":"fly.html#goals"},{"type":"extras","title":"Sections - Deploying on Fly.io","doc":"Let's separate this process into a few steps, so we can keep track of where we are.\n\n- Install the Fly.io CLI\n- Sign up for Fly.io\n- Deploy the app to Fly.io\n- Extra Fly.io tips\n- Helpful Fly.io resources","ref":"fly.html#sections"},{"type":"extras","title":"Installing the Fly.io CLI - Deploying on Fly.io","doc":"Follow the instructions [here](https://fly.io/docs/getting-started/installing-flyctl/) to install Flyctl, the command-line interface for the Fly.io platform.","ref":"fly.html#installing-the-fly-io-cli"},{"type":"extras","title":"Sign up for Fly.io - Deploying on Fly.io","doc":"We can [sign up for an account](https://fly.io/docs/getting-started/log-in-to-fly/) using the CLI.\n\n```console\n$ fly auth signup\n```\n\nOr sign in.\n\n```console\n$ flyctl auth login\n```\n\nFly has a [free tier](https://fly.io/docs/about/pricing/) for most applications. A credit card is required when setting up an account to help prevent abuse. See the [pricing](https://fly.io/docs/about/pricing/) page for more details.","ref":"fly.html#sign-up-for-fly-io"},{"type":"extras","title":"Deploy the app to Fly.io - Deploying on Fly.io","doc":"To tell Fly about your application, run `fly launch` in the directory with your source code. This creates and configures a Fly.io app.\n\n```console\n$ fly launch\n```\n\nThis scans your source, detects the Phoenix project, and runs `mix phx.gen.release --docker` for you! This creates a Dockerfile for you.\n\nThe `fly launch` command walks you through a few questions.\n\n- You can name the app or have it generate a random name for you.\n- Choose an organization (defaults to `personal`). Organizations are a way of sharing applications and resources between Fly.io users.\n- Choose a region to deploy to. Defaults to the nearest Fly.io region. You can check out the [complete list of regions here](https://fly.io/docs/reference/regions/).\n- Sets up a Postgres DB for you.\n- Builds the Dockerfile.\n- Deploys your application!\n\nThe `fly launch` command also created a `fly.toml` file for you. This is where you can set ENV values and other config.","ref":"fly.html#deploy-the-app-to-fly-io"},{"type":"extras","title":"Storing secrets on Fly.io - Deploying on Fly.io","doc":"You may also have some secrets you'd like to set on your app.\n\nUse [`fly secrets`](https://fly.io/docs/reference/secrets/#setting-secrets) to configure those.\n\n```console\n$ fly secrets set MY_SECRET_KEY=my_secret_value\n```","ref":"fly.html#storing-secrets-on-fly-io"},{"type":"extras","title":"Deploying again - Deploying on Fly.io","doc":"When you want to deploy changes to your application, use `fly deploy`.\n\n```console\n$ fly deploy\n```\n\nNote: On Apple Silicon (M1) computers, docker runs cross-platform builds using qemu which might not always work. If you get a segmentation fault error like the following:\n\n```\n => [build  7/17] RUN mix deps.get --only\n => => # qemu: uncaught target signal 11 (Segmentation fault) - core dumped\n```\n\nYou can use fly's remote builder by adding the `--remote-only` flag:\n\n```console\n$ fly deploy --remote-only\n```\n\nYou can always check on the status of a deploy\n\n```console\n$ fly status\n```\n\nCheck your app logs\n\n```console\n$ fly logs\n```\n\nIf everything looks good, open your app on Fly\n\n```console\n$ fly open\n```","ref":"fly.html#deploying-again"},{"type":"extras","title":"Extra Fly.io tips - Deploying on Fly.io","doc":"","ref":"fly.html#extra-fly-io-tips"},{"type":"extras","title":"Getting an IEx shell into a running node - Deploying on Fly.io","doc":"Elixir supports getting a IEx shell into a running production node.\n\nThere are a couple prerequisites, we first need to establish an [SSH Shell](https://fly.io/docs/flyctl/ssh/) to our machine on Fly.io.\n\nThis step sets up a root certificate for your account and then issues a certificate.\n\n```console\n$ fly ssh issue --agent\n```\n\nWith SSH configured, let's open a console.\n\n```console\n$ fly ssh console\nConnecting to my-app-1234.internal... complete\n/ #\n```\n\nIf all has gone smoothly, then you have a shell into the machine! Now we just need to launch our remote IEx shell. The deployment Dockerfile was configured to pull our application into `/app`. So the command for an app named `my_app` looks like this:\n\n```console\n$ app/bin/my_app remote\nErlang/OTP 23 [erts-11.2.1] [source] [64-bit] [smp:1:1] [ds:1:1:10] [async-threads:1]\n\nInteractive Elixir (1.11.2) - press Ctrl+C to exit (type h() ENTER for help)\niex(my_app@fdaa:0:1da8:a7b:ac4:b204:7e29:2)1>\n```\n\nNow we have a running IEx shell into our node! You can safely disconnect using CTRL+C, CTRL+C.","ref":"fly.html#getting-an-iex-shell-into-a-running-node"},{"type":"extras","title":"Clustering your application - Deploying on Fly.io","doc":"Elixir and the BEAM have the incredible ability to be clustered together and pass messages seamlessly between nodes. This portion of the guide walks you through clustering your Elixir application.\n\nThere are 2 parts to getting clustering quickly setup on Fly.io.\n\n- Installing and using `libcluster`\n- Scaling the application to multiple instances\n\n#### Adding `libcluster`\n\nThe widely adopted library [libcluster](https://github.com/bitwalker/libcluster) helps here.\n\nThere are multiple strategies that `libcluster` can use to find and connect with other nodes. The strategy we'll use on Fly.io is `DNSPoll`.\n\nAfter installing `libcluster`, add it to the application like this:\n\n```elixir\ndefmodule MyApp.Application do\n  use Application\n\n  def start(_type, _args) do\n    topologies = Application.get_env(:libcluster, :topologies) || []\n\n    children = [\n      # ...\n      # setup for clustering\n      {Cluster.Supervisor, [topologies, [name: MyApp.ClusterSupervisor]]}\n    ]\n\n    # ...\n  end\n\n  # ...\nend\n```\n\nOur next step is to add the `topologies` configuration to `config/runtime.exs`.\n\n```elixir\n  app_name =\n    System.get_env(\"FLY_APP_NAME\") ||\n      raise \"FLY_APP_NAME not available\"\n\n  config :libcluster,\n    topologies: [\n      fly6pn: [\n        strategy: Cluster.Strategy.DNSPoll,\n        config: [\n          polling_interval: 5_000,\n          query: \"#{app_name}.internal\",\n          node_basename: app_name\n        ]\n      ]\n    ]\n```\n\nThis configures `libcluster` to use the `DNSPoll` strategy and look for other deployed apps using the `$FLY_APP_NAME` on the `.internal` private network.\n\n#### Controlling the name for our node\n\nWe need to control the naming of our Elixir nodes. To help them connect up, we'll name them using this pattern: `your-fly-app-name@the.ipv6.address.on.fly`. To do this, we'll generate the release config.\n\n```console\n$ mix release.init\n```\n\nThen edit the generated `rel/env.sh.eex` file and add the following lines:\n\n```console\nip=$(grep fly-local-6pn /etc/hosts | cut -f 1)\nexport RELEASE_DISTRIBUTION=name\nexport RELEASE_NODE=$FLY_APP_NAME@$ip\n```\n\nAfter making the change, deploy your app!\n\n```console\n$ fly deploy\n```\n\nFor our app to be clustered, we have to have multiple instances. Next we'll add an additional node instance.\n\n#### Running multiple instances\n\nThere are two ways to run multiple instances.\n\n1. Scale our application to have multiple instances in one region.\n2. Add an instance to another region (multiple regions).\n\nLet's first start with a baseline of our single deployment.\n\n```console\n$ fly status\n...\nInstances\nID       VERSION REGION DESIRED STATUS  HEALTH CHECKS      RESTARTS CREATED\nf9014bf7 26      sea    run     running 1 total, 1 passing 0        1h8m ago\n```\n\n#### Scaling in a single region\n\nLet's scale up to 2 instances in our current region.\n\n```console\n$ fly scale count 2\nCount changed to 2\n```\n\nChecking the status, we can see what happened.\n\n```console\n$ fly status\n...\nInstances\nID       VERSION REGION DESIRED STATUS  HEALTH CHECKS      RESTARTS CREATED\neb4119d3 27      sea    run     running 1 total, 1 passing 0        39s ago\nf9014bf7 27      sea    run     running 1 total, 1 passing 0        1h13m ago\n```\n\nWe now have two instances in the same region.\n\nLet's make sure they are clustered together. We can check the logs:\n\n```console\n$ fly logs\n...\napp[eb4119d3] sea [info] 21:50:21.924 [info] [libcluster:fly6pn] connected to :\"my-app-1234@fdaa:0:1da8:a7b:ac2:f901:4bf7:2\"\n...\n```\n\nBut that's not as rewarding as seeing it from inside a node. From an IEx shell, we can ask the node we're connected to, what other nodes it can see.\n\n```console\n$ fly ssh console -C \"/app/bin/my_app remote\"\n```\n\n```elixir\niex(my-app-1234@fdaa:0:1da8:a7b:ac2:f901:4bf7:2)1> Node.list\n[:\"my-app-1234@fdaa:0:1da8:a7b:ac4:eb41:19d3:2\"]\n```\n\nThe IEx prompt is included to help show the IP address of the node we are connected to. Then getting the `Node.list` returns the other node. Our two instances are connected and clustered!\n\n#### Scaling to multiple regions\n\nFly makes it easy to deploy instances closer to your users. Through the magic of DNS, users are directed to the nearest region where your application is located. You can read more about [Fly.io regions here](https://fly.io/docs/reference/regions/).\n\nStarting back from our baseline of a single instance running in `sea` which is Seattle, Washington (US), let's add the region `ewr` which is Parsippany, NJ (US). This puts an instance on both coasts of the US.\n\n```console\n$ fly regions add ewr\nRegion Pool:\newr\nsea\nBackup Region:\niad\nlax\nsjc\nvin\n```\n\nLooking at the status shows that we're only in 1 region because our count is set to 1.\n\n```console\n$ fly status\n...\nInstances\nID       VERSION REGION DESIRED STATUS  HEALTH CHECKS      RESTARTS CREATED\ncdf6c422 29      sea    run     running 1 total, 1 passing 0        58s ago\n```\n\nLet's add a 2nd instance and see it deploy to `ewr`.\n\n```console\n$ fly scale count 2\nCount changed to 2\n```\n\nNow the status shows we have two instances spread across 2 regions!\n\n```console\n$ fly status\n...\nInstances\nID       VERSION REGION DESIRED STATUS  HEALTH CHECKS      RESTARTS CREATED\n0a8e6666 30      ewr    run     running 1 total, 1 passing 0        16s ago\ncdf6c422 30      sea    run     running 1 total, 1 passing 0        6m47s ago\n```\n\nLet's ensure they are clustered together.\n\n```console\n$ fly ssh console -C \"/app/bin/my_app remote\"\n```\n\n```elixir\niex(my-app-1234@fdaa:0:1da8:a7b:ac2:cdf6:c422:2)1> Node.list\n[:\"my-app-1234@fdaa:0:1da8:a7b:ab2:a8e:6666:2\"]\n```\n\nWe have two instances of our application deployed to the West and East coasts of the North American continent and they are clustered together! Our users will automatically be directed to the server nearest them.\n\nThe Fly.io platform has built-in distribution support making it easy to cluster distributed Elixir nodes in multiple regions.","ref":"fly.html#clustering-your-application"},{"type":"extras","title":"Helpful Fly.io resources - Deploying on Fly.io","doc":"Open the Dashboard for your account\n\n```console\n$ fly dashboard\n```\n\nDeploy your application\n\n```console\n$ fly deploy\n```\n\nShow the status of your deployed application\n\n```console\n$ fly status\n```\n\nAccess and tail the logs\n\n```console\n$ fly logs\n```\n\nScaling your application up or down\n\n```console\n$ fly scale count 2\n```\n\nRefer to the [Fly.io Elixir documentation](https://fly.io/docs/getting-started/elixir) for additional information.\n\n[Working with Fly.io applications](https://fly.io/docs/getting-started/working-with-fly-apps/) covers things like:\n\n* Status and logs\n* Custom domains\n* Certificates","ref":"fly.html#helpful-fly-io-resources"},{"type":"extras","title":"Troubleshooting - Deploying on Fly.io","doc":"See [Troubleshooting](https://fly.io/docs/getting-started/troubleshooting/) and [Elixir Troubleshooting](https://fly.io/docs/elixir/the-basics/troubleshooting/)\n\nVisit the [Fly.io Community](https://community.fly.io/) to find solutions and ask questions.","ref":"fly.html#troubleshooting"},{"type":"extras","title":"Deploying on Heroku","doc":"# Deploying on Heroku","ref":"heroku.html"},{"type":"extras","title":"What we'll need - Deploying on Heroku","doc":"The only thing we'll need for this guide is a working Phoenix application. For those of us who need a simple application to deploy, please follow the [Up and Running guide](https://hexdocs.pm/phoenix/up_and_running.html).","ref":"heroku.html#what-we-ll-need"},{"type":"extras","title":"Goals - Deploying on Heroku","doc":"Our main goal for this guide is to get a Phoenix application running on Heroku.","ref":"heroku.html#goals"},{"type":"extras","title":"Limitations - Deploying on Heroku","doc":"Heroku is a great platform and Elixir performs well on it. However, you may run into limitations if you plan to leverage advanced features provided by Elixir and Phoenix, such as:\n\n- Connections are limited.\n  - Heroku [limits the number of simultaneous connections](https://devcenter.heroku.com/articles/http-routing#request-concurrency) as well as the [duration of each connection](https://devcenter.heroku.com/articles/limits#http-timeouts). It is common to use Elixir for real-time apps which need lots of concurrent, persistent connections, and Phoenix is capable of [handling over 2 million connections on a single server](https://www.phoenixframework.org/blog/the-road-to-2-million-websocket-connections).\n\n- Distributed clustering is not possible.\n  - Heroku [firewalls dynos off from one another](https://devcenter.heroku.com/articles/dynos#networking). This means things like [distributed Phoenix channels](https://dockyard.com/blog/2016/01/28/running-elixir-and-phoenix-projects-on-a-cluster-of-nodes) and [distributed tasks](https://hexdocs.pm/elixir/distributed-tasks.html) will need to rely on something like Redis instead of Elixir's built-in distribution.\n\n- In-memory state such as those in [Agents](https://hexdocs.pm/elixir/agents.html), [GenServers](https://hexdocs.pm/elixir/genservers.html), and [ETS](https://hexdocs.pm/elixir/erlang-term-storage.html) will be lost every 24 hours.\n  - Heroku [restarts dynos](https://devcenter.heroku.com/articles/dynos#restarting) every 24 hours regardless of whether the node is healthy.\n\n- [The built-in observer](https://hexdocs.pm/elixir/debugging.html#observer) can't be used with Heroku.\n  - Heroku does allow for connection into your dyno, but you won't be able to use the observer to watch the state of your dyno.\n\nIf you are just getting started, or you don't expect to use the features above, Heroku should be enough for your needs. For instance, if you are migrating an existing application running on Heroku to Phoenix, keeping a similar set of features, Elixir will perform just as well or even better than your current stack.\n\nIf you want a platform-as-a-service without these limitations, try [Gigalixir](gigalixir.html). If you would rather deploy to a cloud platform, such as EC2, Google Cloud, etc, consider using `mix release`.","ref":"heroku.html#limitations"},{"type":"extras","title":"Steps - Deploying on Heroku","doc":"Let's separate this process into a few steps, so we can keep track of where we are.\n\n- Initialize Git repository\n- Sign up for Heroku\n- Install the Heroku Toolbelt\n- Create and set up Heroku application\n- Make our project ready for Heroku\n- Deploy time!\n- Useful Heroku commands","ref":"heroku.html#steps"},{"type":"extras","title":"Initializing Git repository - Deploying on Heroku","doc":"[Git](https://git-scm.com/) is a popular decentralized revision control system and is also used to deploy apps to Heroku.\n\nBefore we can push to Heroku, we'll need to initialize a local Git repository and commit our files to it. We can do so by running the following commands in our project directory:\n\n```console\n$ git init\n$ git add .\n$ git commit -m \"Initial commit\"\n```\n\nHeroku offers some great information on how it is using Git [here](https://devcenter.heroku.com/articles/git#prerequisites-install-git-and-the-heroku-cli).","ref":"heroku.html#initializing-git-repository"},{"type":"extras","title":"Signing up for Heroku - Deploying on Heroku","doc":"Signing up to Heroku is very simple, just head over to [https://signup.heroku.com/](https://signup.heroku.com/) and fill in the form.\n\nThe Free plan will give us one web [dyno](https://devcenter.heroku.com/articles/dynos) and one worker dyno, as well as a PostgreSQL and Redis instance for free.\n\nThese are meant to be used for testing and development, and come with some limitations. In order to run a production application, please consider upgrading to a paid plan.","ref":"heroku.html#signing-up-for-heroku"},{"type":"extras","title":"Installing the Heroku Toolbelt - Deploying on Heroku","doc":"Once we have signed up, we can download the correct version of the Heroku Toolbelt for our system [here](https://toolbelt.heroku.com/).\n\nThe Heroku CLI, part of the Toolbelt, is useful to create Heroku applications, list currently running dynos for an existing application, tail logs or run one-off commands (mix tasks for instance).","ref":"heroku.html#installing-the-heroku-toolbelt"},{"type":"extras","title":"Create and Set Up Heroku Application - Deploying on Heroku","doc":"There are two different ways to deploy a Phoenix app on Heroku. We could use Heroku buildpacks or their container stack. The difference between these two approaches is in how we tell Heroku to treat our build. In buildpack case, we need to update our apps configuration on Heroku to use Phoenix/Elixir specific buildpacks. On container approach, we have more control on how we want to set up our app, and we can define our container image using `Dockerfile` and `heroku.yml`. This section will explore the buildpack approach. In order to use Dockerfile, it is often recommended to convert our app to use releases, which we will describe later on.","ref":"heroku.html#create-and-set-up-heroku-application"},{"type":"extras","title":"Create Application - Deploying on Heroku","doc":"A [buildpack](https://devcenter.heroku.com/articles/buildpacks) is a convenient way of packaging framework and/or runtime support. Phoenix requires 2 buildpacks to run on Heroku, the first adds basic Elixir support and the second adds Phoenix specific commands.\n\nWith the Toolbelt installed, let's create the Heroku application. We will do so using the latest available version of the [Elixir buildpack](https://github.com/HashNuke/heroku-buildpack-elixir):\n\n```console\n$ heroku create --buildpack hashnuke/elixir\nCreating app... done, ⬢ mysterious-meadow-6277\nSetting buildpack to hashnuke/elixir... done\nhttps://mysterious-meadow-6277.herokuapp.com/ | https://git.heroku.com/mysterious-meadow-6277.git\n```\n\n> Note: the first time we use a Heroku command, it may prompt us to log in. If this happens, just enter the email and password you specified during signup.\n\n> Note: the name of the Heroku application is the random string after \"Creating\" in the output above (mysterious-meadow-6277). This will be unique, so expect to see a different name from \"mysterious-meadow-6277\".\n\n> Note: the URL in the output is the URL to our application. If we open it in our browser now, we will get the default Heroku welcome page.\n\n> Note: if we hadn't initialized our Git repository before we ran the `heroku create` command, we wouldn't have our Heroku remote repository properly set up at this point. We can set that up manually by running: `heroku git:remote -a [our-app-name].`\n\nThe buildpack uses a predefined Elixir and Erlang version, but to avoid surprises when deploying, it is best to explicitly list the Elixir and Erlang version we want in production to be the same we are using during development or in your continuous integration servers. This is done by creating a config file named `elixir_buildpack.config` in the root directory of your project with your target version of Elixir and Erlang:\n\n```console\n# Elixir version\nelixir_version=1.14.0\n\n# Erlang version\n# https://github.com/HashNuke/heroku-buildpack-elixir-otp-builds/blob/master/otp-versions\nerlang_version=24.3\n\n# Invoke assets.deploy defined in your mix.exs to deploy assets with esbuild\n# Note we nuke the esbuild executable from the image\nhook_post_compile=\"eval mix assets.deploy && rm -f _build/esbuild*\"\n```\n\nFinally, let's tell the build pack how to start our webserver. Create a file named `Procfile` at the root of your project:\n\n```console\nweb: mix phx.server\n```","ref":"heroku.html#create-application"},{"type":"extras","title":"Optional: Node, npm, and the Phoenix Static buildpack - Deploying on Heroku","doc":"By default, Phoenix uses `esbuild` and manages all assets for you. However, if you are using `node` and `npm`, you will need to install the [Phoenix Static buildpack](https://github.com/gjaldon/heroku-buildpack-phoenix-static) to handle them:\n\n```console\n$ heroku buildpacks:add https://github.com/gjaldon/heroku-buildpack-phoenix-static.git\nBuildpack added. Next release on mysterious-meadow-6277 will use:\n  1. https://github.com/HashNuke/heroku-buildpack-elixir.git\n  2. https://github.com/gjaldon/heroku-buildpack-phoenix-static.git\n```\n\nWhen using this buildpack, you want to delegate all asset bundling to `npm`. So you must remove the `hook_post_compile` configuration from your `elixir_buildpack.config` and move it to the deploy script of your `assets/package.json`. Something like this:\n\n```javascript\n{\n  ...\n  \"scripts\": {\n    \"deploy\": \"cd .. && mix assets.deploy && rm -f _build/esbuild*\"\n  }\n  ...\n}\n```\n\nThe Phoenix Static buildpack uses a predefined Node.js version, but to avoid surprises when deploying, it is best to explicitly list the Node.js version we want in production to be the same we are using during development or in your continuous integration servers. This is done by creating a config file named `phoenix_static_buildpack.config` in the root directory of your project with your target version of Node.js:\n\n```text\n# Node.js version\nnode_version=10.20.1\n```\n\nPlease refer to the [configuration section](https://github.com/gjaldon/heroku-buildpack-phoenix-static#configuration) for full details. You can make your own custom build script, but for now we will use the [default one provided](https://github.com/gjaldon/heroku-buildpack-phoenix-static/blob/master/compile).\n\nFinally, note that since we are using multiple buildpacks, you might run into an issue where the sequence is out of order (the Elixir buildpack needs to run before the Phoenix Static buildpack). [Heroku's docs](https://devcenter.heroku.com/articles/using-multiple-buildpacks-for-an-app) explain this better, but you will need to make sure the Phoenix Static buildpack comes last.","ref":"heroku.html#optional-node-npm-and-the-phoenix-static-buildpack"},{"type":"extras","title":"Making our Project ready for Heroku - Deploying on Heroku","doc":"Every new Phoenix project ships with a config file `config/runtime.exs` (formerly `config/prod.secret.exs`) which loads configuration and secrets from [environment variables](https://devcenter.heroku.com/articles/config-vars). This aligns well with Heroku best practices ([12-factor apps](https://12factor.net/)), so the only work left for us to do is to configure URLs and SSL.\n\nFirst let's tell Phoenix to only use the SSL version of the website. Find the endpoint config in your `config/prod.exs`:\n\n```elixir\nconfig :scaffold, ScaffoldWeb.Endpoint,\n  url: [port: 443, scheme: \"https\"],\n```\n\n... and add `force_ssl`\n\n```elixir\nconfig :scaffold, ScaffoldWeb.Endpoint,\n  url: [port: 443, scheme: \"https\"],\n  force_ssl: [rewrite_on: [:x_forwarded_proto]],\n```\n\n`force_ssl` need to be set here because it is a _compile_ time config. It will not work when set from `runtime.exs`.\n\nThen in your `config/runtime.exs` (formerly `config/prod.secret.exs`):\n\n... add `host`\n\n```elixir\nconfig :scaffold, ScaffoldWeb.Endpoint,\n  url: [host: host, port: 443, scheme: \"https\"]\n```\n\nand uncomment the `# ssl: true,` line in your repository configuration. It will look like this:\n\n```elixir\nconfig :hello, Hello.Repo,\n  ssl: true,\n  url: database_url,\n  pool_size: String.to_integer(System.get_env(\"POOL_SIZE\") || \"10\")\n```\n\nFinally, if you plan on using websockets, then we will need to decrease the timeout for the websocket transport in `lib/hello_web/endpoint.ex`. If you do not plan on using websockets, then leaving it set to false is fine. You can find further explanation of the options available at the [documentation](https://hexdocs.pm/phoenix/Phoenix.Endpoint.html#socket/3-websocket-configuration).\n\n```elixir\ndefmodule HelloWeb.Endpoint do\n  use Phoenix.Endpoint, otp_app: :hello\n\n  socket \"/socket\", HelloWeb.UserSocket,\n    websocket: [timeout: 45_000]\n\n  ...\nend\n```\n\nAlso set the host in Heroku:\n\n```console\n$ heroku config:set PHX_HOST=\"mysterious-meadow-6277.herokuapp.com\"\n```\n\nThis ensures that any idle connections are closed by Phoenix before they reach Heroku's 55-second timeout window.","ref":"heroku.html#making-our-project-ready-for-heroku"},{"type":"extras","title":"Creating Environment Variables in Heroku - Deploying on Heroku","doc":"The `DATABASE_URL` config var is automatically created by Heroku when we add the [Heroku Postgres add-on](https://elements.heroku.com/addons/heroku-postgresql). We can create the database via the Heroku toolbelt:\n\n```console\n$ heroku addons:create heroku-postgresql:mini\n```\n\nNow we set the `POOL_SIZE` config var:\n\n```console\n$ heroku config:set POOL_SIZE=18\n```\n\nThis value should be just under the number of available connections, leaving a couple open for migrations and mix tasks. The mini database allows 20 connections, so we set this number to 18. If additional dynos will share the database, reduce the `POOL_SIZE` to give each dyno an equal share.\n\nWhen running a mix task later (after we have pushed the project to Heroku) you will also want to limit its pool size like so:\n\n```console\n$ heroku run \"POOL_SIZE=2 mix hello.task\"\n```\n\nSo that Ecto does not attempt to open more than the available connections.\n\nWe still have to create the `SECRET_KEY_BASE` config based on a random string. First, use `mix phx.gen.secret` to get a new secret:\n\n```console\n$ mix phx.gen.secret\nxvafzY4y01jYuzLm3ecJqo008dVnU3CN4f+MamNd1Zue4pXvfvUjbiXT8akaIF53\n```\n\nYour random string will be different; don't use this example value.\n\nNow set it in Heroku:\n\n```console\n$ heroku config:set SECRET_KEY_BASE=\"xvafzY4y01jYuzLm3ecJqo008dVnU3CN4f+MamNd1Zue4pXvfvUjbiXT8akaIF53\"\nSetting config vars and restarting mysterious-meadow-6277... done, v3\nSECRET_KEY_BASE: xvafzY4y01jYuzLm3ecJqo008dVnU3CN4f+MamNd1Zue4pXvfvUjbiXT8akaIF53\n```","ref":"heroku.html#creating-environment-variables-in-heroku"},{"type":"extras","title":"Deploy Time! - Deploying on Heroku","doc":"Our project is now ready to be deployed on Heroku.\n\nLet's commit all our changes:\n\n```console\n$ git add elixir_buildpack.config\n$ git commit -a -m \"Use production config from Heroku ENV variables and decrease socket timeout\"\n```\n\nAnd deploy:\n\n```console\n$ git push heroku main\nCounting objects: 55, done.\nDelta compression using up to 8 threads.\nCompressing objects: 100% (49/49), done.\nWriting objects: 100% (55/55), 48.48 KiB | 0 bytes/s, done.\nTotal 55 (delta 1), reused 0 (delta 0)\nremote: Compressing source files... done.\nremote: Building source:\nremote:\nremote: -----> Multipack app detected\nremote: -----> Fetching custom git buildpack... done\nremote: -----> elixir app detected\nremote: -----> Checking Erlang and Elixir versions\nremote:        WARNING: elixir_buildpack.config wasn't found in the app\nremote:        Using default config from Elixir buildpack\nremote:        Will use the following versions:\nremote:        * Stack cedar-14\nremote:        * Erlang 17.5\nremote:        * Elixir 1.0.4\nremote:        Will export the following config vars:\nremote:        * Config vars DATABASE_URL\nremote:        * MIX_ENV=prod\nremote: -----> Stack changed, will rebuild\nremote: -----> Fetching Erlang 17.5\nremote: -----> Installing Erlang 17.5 (changed)\nremote:\nremote: -----> Fetching Elixir v1.0.4\nremote: -----> Installing Elixir v1.0.4 (changed)\nremote: -----> Installing Hex\nremote: 2015-07-07 00:04:00 URL:https://s3.amazonaws.com/s3.hex.pm/installs/1.0.0/hex.ez [262010/262010] ->\n\"/app/.mix/archives/hex.ez\" [1]\nremote: * creating /app/.mix/archives/hex.ez\nremote: -----> Installing rebar\nremote: * creating /app/.mix/rebar\nremote: -----> Fetching app dependencies with mix\nremote: Running dependency resolution\nremote: Dependency resolution completed successfully\nremote: [...]\nremote: -----> Compiling\nremote: [...]\nremote: Generated phoenix_heroku app\nremote: [...]\nremote: Consolidated protocols written to _build/prod/consolidated\nremote: -----> Creating .profile.d with env vars\nremote: -----> Fetching custom git buildpack... done\nremote: -----> Phoenix app detected\nremote:\nremote: -----> Loading configuration and environment\nremote:        Loading config...\nremote:        [...]\nremote:        Will export the following config vars:\nremote:        * Config vars DATABASE_URL\nremote:        * MIX_ENV=prod\nremote:\nremote: -----> Compressing... done, 82.1MB\nremote: -----> Launching... done, v5\nremote:        https://mysterious-meadow-6277.herokuapp.com/ deployed to Heroku\nremote:\nremote: Verifying deploy... done.\nTo https://git.heroku.com/mysterious-meadow-6277.git\n * [new branch]      master -> master\n```\n\nTyping `heroku open` in the terminal should launch a browser with the Phoenix welcome page opened. In the event that you are using Ecto to access a database, you will also need to run migrations after the first deploy:\n\n```console\n$ heroku run \"POOL_SIZE=2 mix ecto.migrate\"\n```\n\nAnd that's it!","ref":"heroku.html#deploy-time"},{"type":"extras","title":"Deploying to Heroku using the container stack - Deploying on Heroku","doc":"","ref":"heroku.html#deploying-to-heroku-using-the-container-stack"},{"type":"extras","title":"Create Heroku application - Deploying on Heroku","doc":"Set the stack of your app to `container`, this allows us to use `Dockerfile` to define our app setup.\n\n```console\n$ heroku create\nCreating app... done, ⬢ mysterious-meadow-6277\n$ heroku stack:set container\n```\n\nAdd a new `heroku.yml` file to your root folder. In this file you can define addons used by your app, how to build the image and what configs are passed to the image. You can learn more about Heroku's `heroku.yml` options [here](https://devcenter.heroku.com/articles/build-docker-images-heroku-yml). Here is a sample:\n\n```yaml\nsetup:\n  addons:\n    - plan: heroku-postgresql\n      as: DATABASE\nbuild:\n  docker:\n    web: Dockerfile\n  config:\n    MIX_ENV: prod\n    SECRET_KEY_BASE: $SECRET_KEY_BASE\n    DATABASE_URL: $DATABASE_URL\n```","ref":"heroku.html#create-heroku-application"},{"type":"extras","title":"Set up releases and Dockerfile - Deploying on Heroku","doc":"Now we need to define a `Dockerfile` at the root folder of your project that contains your application. We recommend to use releases when doing so, as the release will allow us to build a container with only the parts of Erlang and Elixir we actually use. Follow the [releases docs](releases.html). At the end of the guide, there is a sample Dockerfile file you can use.\n\nOnce you have the image definition set up, you can push your app to heroku and you can see it starts building the image and deploy it.","ref":"heroku.html#set-up-releases-and-dockerfile"},{"type":"extras","title":"Useful Heroku Commands - Deploying on Heroku","doc":"We can look at the logs of our application by running the following command in our project directory:\n\n```console\n$ heroku logs # use --tail if you want to tail them\n```\n\nWe can also start an IEx session attached to our terminal for experimenting in our app's environment:\n\n```console\n$ heroku run \"POOL_SIZE=2 iex -S mix\"\n```\n\nIn fact, we can run anything using the `heroku run` command, like the Ecto migration task from above:\n\n```console\n$ heroku run \"POOL_SIZE=2 mix ecto.migrate\"\n```","ref":"heroku.html#useful-heroku-commands"},{"type":"extras","title":"Connecting to your dyno - Deploying on Heroku","doc":"Heroku gives you the ability to connect to your dyno with an IEx shell which allows running Elixir code such as database queries.\n\n- Modify the `web` process in your Procfile to run a named node:\n\n  ```text\n  web: elixir --sname server -S mix phx.server\n  ```\n\n- Redeploy to Heroku\n- Connect to the dyno with `heroku ps:exec` (if you have several applications on the same repository you will need to specify the app name or the remote name with `--app APP_NAME` or `--remote REMOTE_NAME`)\n- Launch an iex session with `iex --sname console --remsh server`\n\nYou have an iex session into your dyno!","ref":"heroku.html#connecting-to-your-dyno"},{"type":"extras","title":"Troubleshooting - Deploying on Heroku","doc":"","ref":"heroku.html#troubleshooting"},{"type":"extras","title":"Compilation Error - Deploying on Heroku","doc":"Occasionally, an application will compile locally, but not on Heroku. The compilation error on Heroku will look something like this:\n\n```console\nremote: == Compilation error on file lib/postgrex/connection.ex ==\nremote: could not compile dependency :postgrex, \"mix compile\" failed. You can recompile this dependency with \"mix deps.compile postgrex\", update it with \"mix deps.update postgrex\" or clean it with \"mix deps.clean postgrex\"\nremote: ** (CompileError) lib/postgrex/connection.ex:207: Postgrex.Connection.__struct__/0 is undefined, cannot expand struct Postgrex.Connection\nremote:     (elixir) src/elixir_map.erl:58: :elixir_map.translate_struct/4\nremote:     (stdlib) lists.erl:1353: :lists.mapfoldl/3\nremote:     (stdlib) lists.erl:1354: :lists.mapfoldl/3\nremote:\nremote:\nremote:  !     Push rejected, failed to compile elixir app\nremote:\nremote: Verifying deploy...\nremote:\nremote: !   Push rejected to mysterious-meadow-6277.\nremote:\nTo https://git.heroku.com/mysterious-meadow-6277.git\n```\n\nThis has to do with stale dependencies which are not getting recompiled properly. It's possible to force Heroku to recompile all dependencies on each deploy, which should fix this problem. The way to do it is to add a new file called `elixir_buildpack.config` at the root of the application. The file should contain this line:\n\n```text\nalways_rebuild=true\n```\n\nCommit this file to the repository and try to push again to Heroku.","ref":"heroku.html#compilation-error"},{"type":"extras","title":"Connection Timeout Error - Deploying on Heroku","doc":"If you are constantly getting connection timeouts while running `heroku run` this could mean that your internet provider has blocked port number 5000:\n\n```console\nheroku run \"POOL_SIZE=2 mix myapp.task\"\nRunning POOL_SIZE=2 mix myapp.task on mysterious-meadow-6277... !\nETIMEDOUT: connect ETIMEDOUT 50.19.103.36:5000\n```\n\nYou can overcome this by adding `detached` option to run command:\n\n```console\nheroku run:detached \"POOL_SIZE=2 mix ecto.migrate\"\nRunning POOL_SIZE=2 mix ecto.migrate on mysterious-meadow-6277... done, run.8089 (Free)\n```","ref":"heroku.html#connection-timeout-error"},{"type":"extras","title":"Routing cheatsheet","doc":"# Routing cheatsheet\n\n> Those need to be declared in the correct router module and scope.\n\nA quick reference to the common routing features' syntax. For an exhaustive overview, refer to the [routing guides](routing.md).","ref":"router.html"},{"type":"extras","title":"Routing declaration - Routing cheatsheet","doc":"{: .col-2}","ref":"router.html#routing-declaration"},{"type":"extras","title":"Single route - Routing cheatsheet","doc":"```elixir\nget \"/users\", UserController, :index\npatch \"/users/:id\", UserController, :update\n```\n```elixir\n# generated routes\n~p\"/users\"\n~p\"/users/9\" # user_id is 9\n```\nAlso accepts `put`, `patch`, `options`, `delete` and `head`.","ref":"router.html#single-route"},{"type":"extras","title":"Resources - Routing cheatsheet","doc":"#### Simple\n\n```elixir\nresources \"/users\", UserController\n```\nGenerates `:index`, `:edit`, `:new`, `:show`, `:create`, `:update` and `:delete`.\n\n#### Options\n\n```elixir\nresources \"/users\", UserController, only: [:show]\nresources \"/users\", UserController, except: [:create, :delete]\nresources \"/users\", UserController, as: :person # ~p\"/person\"\n```\n\n#### Nested\n\n```elixir\nresources \"/users\", UserController do\n  resources \"/posts\", PostController\nend\n```\n```elixir\n# generated routes\n~p\"/users/3/posts\" # user_id is 3\n~p\"/users/3/posts/17\" # user_id is 3 and post_id = 17\n```\nFor more info check the [resources docs.](routing-1.html#resources)","ref":"router.html#resources"},{"type":"extras","title":"Scopes - Routing cheatsheet","doc":"#### Simple\n```elixir\nscope \"/admin\", HelloWeb.Admin do\n  pipe_through :browser\n\n  resources \"/users\",   UserController\nend\n```\n```elixir\n# generated path helpers\n~p\"/admin/users\"\n```\n\n#### Nested\n```elixir\nscope \"/api\", HelloWeb.Api, as: :api do\n  pipe_through :api\n\n  scope \"/v1\", V1, as: :v1 do\n    resources \"/users\", UserController\n  end\nend\n```\n```elixir\n# generated path helpers\n~p\"/api/v1/users\"\n```\nFor more info check the [scoped routes](routing.md#scoped-routes) docs.","ref":"router.html#scopes"},{"type":"extras","title":"Custom Error Pages","doc":"# Custom Error Pages\n\nNew Phoenix projects have two error views called `ErrorHTML` and `ErrorJSON`, which live in `lib/hello_web/controllers/`. The purpose of these views is to handle errors in a general way for each format, from one centralized location.","ref":"custom_error_pages.html"},{"type":"extras","title":"The Error Views - Custom Error Pages","doc":"For new applications, the `ErrorHTML` and `ErrorJSON` views looks like this:\n\n```elixir\ndefmodule HelloWeb.ErrorHTML do\n  use HelloWeb, :html\n\n  # If you want to customize your error pages,\n  # uncomment the embed_templates/1 call below\n  # and add pages to the error directory:\n  #\n  #   * lib/<%= @lib_web_name %>/controllers/error_html/404.html.heex\n  #   * lib/<%= @lib_web_name %>/controllers/error_html/500.html.heex\n  #\n  # embed_templates \"error_html/*\"\n\n  # The default is to render a plain text page based on\n  # the template name. For example, \"404.html\" becomes\n  # \"Not Found\".\n  def render(template, _assigns) do\n    Phoenix.Controller.status_message_from_template(template)\n  end\nend\n\ndefmodule HelloWeb.ErrorJSON do\n  # If you want to customize a particular status code,\n  # you may add your own clauses, such as:\n  #\n  # def render(\"500.json\", _assigns) do\n  #   %{errors: %{detail: \"Internal Server Error\"}}\n  # end\n\n  # By default, Phoenix returns the status message from\n  # the template name. For example, \"404.json\" becomes\n  # \"Not Found\".\n  def render(template, _assigns) do\n    %{errors: %{detail: Phoenix.Controller.status_message_from_template(template)}}\n  end\nend\n```\n\nBefore we dive into this, let's see what the rendered `404 Not Found` message looks like in a browser. In the development environment, Phoenix will debug errors by default, showing us a very informative debugging page. What we want here, however, is to see what page the application would serve in production. In order to do that, we need to set `debug_errors: false` in `config/dev.exs`.\n\n```elixir\nimport Config\n\nconfig :hello, HelloWeb.Endpoint,\n  http: [port: 4000],\n  debug_errors: false,\n  code_reloader: true,\n  . . .\n```\n\nAfter modifying our config file, we need to restart our server in order for this change to take effect. After restarting the server, let's go to [http://localhost:4000/such/a/wrong/path](http://localhost:4000/such/a/wrong/path) for a running local application and see what we get.\n\nOk, that's not very exciting. We get the bare string \"Not Found\", displayed without any markup or styling.\n\nThe first question is, where does that error string come from? The answer is right in `ErrorHTML`.\n\n```elixir\ndef render(template, _assigns) do\n  Phoenix.Controller.status_message_from_template(template)\nend\n```\n\nGreat, so we have this `render/2` function that takes a template and an `assigns` map, which we ignore. When you call `render(conn, :some_template)` from the controller, Phoenix first looks for a `some_template/1` function on the view module. If no function exists, it falls back to calling `render/2` with the template and format name, such as `\"some_template.html\"`.\n\nIn other words, to provide custom error pages, we could simply define a proper `render/2` function clause in `HelloWeb.ErrorHTML`.\n\n```elixir\n  def render(\"404.html\", _assigns) do\n    \"Page Not Found\"\n  end\n```\n\nBut we can do even better.\n\nPhoenix generates an `ErrorHTML` for us, but it doesn't give us a `lib/hello_web/controllers/error_html` directory. Let's create one now. Inside our new directory, let's add a template named `404.html.heex` and give it some markup – a mixture of our application layout and a new ` ` with our message to the user.\n\n```heex\n<!DOCTYPE html>\n \n   \n     \n     \n     Welcome to Phoenix! \n     \n      \n   \n   \n     \n       \n         \n           \n              Get Started  \n           \n         \n         \n           \n         \n       \n     \n     \n       \n         Sorry, the page you are looking for does not exist. \n       \n     \n   \n \n```\n\nAfter you define the template file, remember to remove the equivalent `render/2` clause for that template, as otherwise the function overrides the template. Let's do so for the 404.html clause we have previously introduced in `lib/hello_web/controllers/error_html.ex`. We also need to tell Phoenix to embed our templates into the module:\n\n```diff\n+ embed_templates \"error_html/*\"\n\n- def render(\"404.html\", _assigns) do\n-  \"Page Not Found\"\n- end\n```\n\nNow, when we go back to [http://localhost:4000/such/a/wrong/path](http://localhost:4000/such/a/wrong/path), we should see a much nicer error page. It is worth noting that we did not render our `404.html.heex` template through our application layout, even though we want our error page to have the look and feel of the rest of our site. This is to avoid circular errors. For example, what happens if our application failed due to an error in the layout? Attempting to render the layout again will just trigger another error. So ideally we want to minimize the amount of dependencies and logic in our error templates, sharing only what is necessary.","ref":"custom_error_pages.html#the-error-views"},{"type":"extras","title":"Custom exceptions - Custom Error Pages","doc":"Elixir provides a macro called `defexception/1` for defining custom exceptions. Exceptions are represented as structs, and structs need to be defined inside of modules.\n\nIn order to create a custom exception, we need to define a new module. Conventionally, this will have \"Error\" in the name. Inside that module, we need to define a new exception with `defexception/1`, the file `lib/hello_web.ex` seems like a good place for it.\n\n```elixir\ndefmodule HelloWeb.SomethingNotFoundError do\n  defexception [:message]\nend\n```\n\nYou can raise your new exception like this:\n\n```elixir\nraise HelloWeb.SomethingNotFoundError, \"oops\"\n```\n\nBy default, Plug and Phoenix will treat all exceptions as 500 errors. However, Plug provides a protocol called `Plug.Exception` where we are able to customize the status and add actions that exception structs can return on the debug error page.\n\nIf we wanted to supply a status of 404 for an `HelloWeb.SomethingNotFoundError` error, we could do it by defining an implementation for the `Plug.Exception` protocol like this, in `lib/hello_web.ex`:\n\n```elixir\ndefimpl Plug.Exception, for: HelloWeb.SomethingNotFoundError do\n  def status(_exception), do: 404\n  def actions(_exception), do: []\nend\n```\n\nAlternatively, you could define a `plug_status` field directly in the exception struct:\n\n```elixir\ndefmodule HelloWeb.SomethingNotFoundError do\n  defexception [:message, plug_status: 404]\nend\n```\n\nHowever, implementing the `Plug.Exception` protocol by hand can be convenient in certain occasions, such as when providing actionable errors.","ref":"custom_error_pages.html#custom-exceptions"},{"type":"extras","title":"Actionable errors - Custom Error Pages","doc":"Exception actions are functions that can be triggered from the error page, and they're basically a list of maps defining a `label` and a `handler` to be executed. As an example, Phoenix will display an error if you have pending migrations and will provide a button on the error page to perform the pending migrations.\n\nWhen `debug_errors` is `true`, they are rendered in the error page as a collection of buttons and follow the format of:\n\n```elixir\n[\n  %{\n    label: String.t(),\n    handler: {module(), function :: atom(), args :: []}\n  }\n]\n```\n\nIf we wanted to return some actions for an `HelloWeb.SomethingNotFoundError` we would implement `Plug.Exception` like this:\n\n```elixir\ndefimpl Plug.Exception, for: HelloWeb.SomethingNotFoundError do\n  def status(_exception), do: 404\n\n  def actions(_exception) do\n    [\n      %{\n        label: \"Run seeds\",\n        handler: {Code, :eval_file, [\"priv/repo/seeds.exs\"]}\n      }\n    ]\n  end\nend\n```","ref":"custom_error_pages.html#actionable-errors"},{"type":"extras","title":"File Uploads","doc":"# File Uploads\n\nOne common task for web applications is uploading files. These files might be images, videos, PDFs, or files of any other type. In order to upload files through an HTML interface, we need a `file` input tag in a multipart form.\n\n> #### Looking for the LiveView Uploads guide? {: .neutral}\n>\n> This guide explains multipart HTTP file uploads via `Plug.Upload`.\n> For more information about LiveView file uploads, including direct-to-cloud external uploads on\n> the client, refer to the [LiveView Uploads guide](https://hexdocs.pm/phoenix_live_view/uploads.html).\n\nPlug provides a `Plug.Upload` struct to hold the data from the `file` input. A `Plug.Upload` struct will automatically appear in your request parameters if a user has selected a file when they submit the form.\n\nIn this guide you will do the following:\n\n  1.  Configure a multipart form\n\n  2. Add a file input element to the form\n\n  3. Verify your upload params\n\n  4. Manage your uploaded files\n\nIn the [`Contexts guide`](contexts.md), we generated an HTML resource for products. We can reuse the form we generated there in order to demonstrate how file uploads work in Phoenix. Please refer to that guide for instructions on generating the product resource you will be using here.","ref":"file_uploads.html"},{"type":"extras","title":"Configure a multipart form - File Uploads","doc":"The first thing you need to do is change your form into a multipart form. The `HelloWeb.CoreComponents` `simple_form/1` component accepts a `multipart` attribute where you can specify this.\n\nHere is the form from `lib/hello_web/controllers/product_html/product_form.html.heex` with that change in place:\n\n```heex\n<.simple_form :let={f} for={@changeset} action={@action} multipart>\n. . .\n```","ref":"file_uploads.html#configure-a-multipart-form"},{"type":"extras","title":"Add a file input - File Uploads","doc":"Once you have a multipart form, you need a `file` input. Here's how you would do that, also in `product_form.html.heex`:\n\n```heex\n. . .\n  <.input field={f[:photo]} type=\"file\" label=\"Photo\" />\n\n  <:actions>\n    <.button>Save Product</.button>\n  </:actions>\n</.simple_form>\n```\n\nWhen rendered, here is the HTML for the default `HelloWeb.CoreComponents` `input/1` component:\n\n```html\n \n   Photo \n   \n \n```\n\nNote the `name` attribute of your `file` input. This will create the `\"photo\"` key in the `product_params` map which will be available in your controller action.\n\nThis is all from the form side. Now when users submit the form, a `POST` request will route to your `HelloWeb.ProductController` `create/2` action.\n\n> #### Should I add photo to my Ecto schema? {: .neutral}\n>\n> The photo input does not need to be part of your schema for it to come across in the `product_params`. If you want to persist any properties of the photo in a database, however, you would need to add it to your `Hello.Product` schema.","ref":"file_uploads.html#add-a-file-input"},{"type":"extras","title":"Verify your upload params - File Uploads","doc":"Since you generated an HTML resource, you can now start your server with `mix phx.server`, visit [http://localhost:4000/products/new](http://localhost:4000/products/new), and create a new product with a photo.\n\nBefore you begin, add `IO.inspect product_params` to the top of your `ProductController.create/2` action in `lib/hello_web/controllers/product_controller.ex`. This will show the `product_params` in your development log so you can get a better sense of what's happening.\n\n```elixir\n. . .\n  def create(conn, %{\"product\" => product_params}) do\n    IO.inspect product_params\n. . .\n```\n\nWhen you do that, this is what your `product_params` will output in the log:\n\n```elixir\n%{\"title\" => \"Metaprogramming Elixir\", \"description\" => \"Write Less Code, Get More Done (and Have Fun!)\", \"price\" => \"15.000000\", \"views\" => \"0\",\n\"photo\" => %Plug.Upload{content_type: \"image/png\", filename: \"meta-cover.png\", path: \"/var/folders/_6/xbsnn7tx6g9dblyx149nrvbw0000gn/T//plug-1434/multipart-558399-917557-1\"}}\n```\n\nYou have a `\"photo\"` key which maps to the pre-populated `Plug.Upload` struct representing your uploaded photo.\n\nTo make this easier to read, focus on the struct itself:\n\n```elixir\n%Plug.Upload{content_type: \"image/png\", filename: \"meta-cover.png\", path: \"/var/folders/_6/xbsnn7tx6g9dblyx149nrvbw0000gn/T//plug-1434/multipart-558399-917557-1\"}\n```\n\n`Plug.Upload` provides the file's content type, original filename, and path to the temporary file which Plug created for you. In this case, `\"/var/folders/_6/xbsnn7tx6g9dblyx149nrvbw0000gn/T//plug-1434/\"` is the directory created by Plug in which to put uploaded files. The directory will persist across requests. `\"multipart-558399-917557-1\"` is the name Plug gave to your uploaded file. If you had multiple `file` inputs and if the user selected photos for all of them, you would have multiple files scattered in temporary directories. Plug will make sure all the filenames are unique.\n\n> #### Plug.Upload files are temporary {: .info}\n>\n> Plug removes uploads from its directory as the request completes. If you need to do anything with this file, you need to do it before then (or [give it away](`Plug.Upload.give_away/3`), but that is outside the scope of this guide).","ref":"file_uploads.html#verify-your-upload-params"},{"type":"extras","title":"Manage your uploaded files - File Uploads","doc":"Once you have the `Plug.Upload` struct available in your controller, you can perform any operation on it you want. For example, you may want to do one or more of the following:\n\n* Check to make sure the file exists with `File.exists?/1`\n\n* Copy the file somewhere else on the filesystem with `File.cp/2`\n\n* Give the file away to another Elixir process with `Plug.Upload.give_away/3`\n\n* Send it to S3 with an external library\n\n* Send it back to the client with `Plug.Conn.send_file/5`\n\nIn a production system, you may want to copy the file to a root directory, such as `/media`. When doing so, it is important to guarantee the names are unique. For instance, if you are allowing users to upload product cover images, you could use the product id to generate a unique name:\n\n```elixir\nif upload = product_params[\"photo\"] do\n  extension = Path.extname(upload.filename)\n  File.cp(upload.path, \"/media/#{product.id}-cover#{extension}\")\nend\n```\n\nThen a `Plug.Static` plug could be added in your `lib/my_app_web/endpoint.ex` to serve the files at `\"/media\"`:\n\n```elixir\nplug Plug.Static, at: \"/uploads\", from: \"/media\"\n```\n\nThe uploaded file can now be accessed from your browsers using a path such as `\"/uploads/1-cover.jpg\"`. In practice, there are other concerns you want to handle when uploading files, such validating extensions, encoding names, and so on. Many times, using a library that already handles such cases is preferred.\n\nFinally, notice that when there is no data from the `file` input, you get neither the `\"photo\"` key nor a `Plug.Upload` struct. Here are the `product_params` from the log.\n\n```elixir\n%{\"title\" => \"Metaprogramming Elixir\", \"description\" => \"Write Less Code, Get More Done (and Have Fun!)\", \"price\" => \"15.000000\", \"views\" => \"0\"}\n```","ref":"file_uploads.html#manage-your-uploaded-files"},{"type":"extras","title":"Configuring upload limits - File Uploads","doc":"The conversion from the data being sent by the form to an actual `Plug.Upload` is done by the `Plug.Parsers` plug which you can find inside `HelloWeb.Endpoint`:\n\n```elixir\n# lib/hello_web/endpoint.ex\nplug Plug.Parsers,\n  parsers: [:urlencoded, :multipart, :json],\n  pass: [\"*/*\"],\n  json_decoder: Phoenix.json_library()\n```\n\nBesides the options above, `Plug.Parsers` accepts other options to control data upload:\n\n  * `:length` - sets the max body length to read, defaults to `8_000_000` bytes\n  * `:read_length` - set the amount of bytes to read at one time, defaults to `1_000_000` bytes\n  * `:read_timeout` - set the timeout for each chunk received, defaults to `15_000` ms\n\nThe first option configures the maximum data allowed. The remaining ones configure how much data we expect to read and its frequency. If the client cannot push data fast enough, the connection will be terminated. Phoenix ships with reasonable defaults but you may want to customize it under special circumstances, for example, if you are expecting really slow clients to send large chunks of data.\n\nIt is also worth pointing out those limits are important as a security mechanism. For example, if you don't set a limit for data upload, attackers could open up thousands of connections to your application and send one byte every 2 minutes, which would take very long to complete while using up all connections to your server. The limits above expect at least a reasonable amount of progress, making attackers' lives a bit harder.","ref":"file_uploads.html#configuring-upload-limits"},{"type":"extras","title":"Using SSL","doc":"# Using SSL\n\nTo prepare an application to serve requests over SSL, we need to add a little bit of configuration and two environment variables. In order for SSL to actually work, we'll need a key file and certificate file from a certificate authority. The environment variables that we'll need are paths to those two files.\n\nThe configuration consists of a new `https:` key for our endpoint whose value is a keyword list of port, path to the key file, and path to the cert (PEM) file. If we add the `otp_app:` key whose value is the name of our application, Plug will begin to look for them at the root of our application. We can then put those files in our `priv` directory and set the paths to `priv/our_keyfile.key` and `priv/our_cert.crt`.\n\nHere's an example configuration from `config/runtime.exs`.\n\n```elixir\nimport Config\n\nconfig :hello, HelloWeb.Endpoint,\n  http: [port: {:system, \"PORT\"}],\n  url: [host: \"example.com\"],\n  cache_static_manifest: \"priv/static/cache_manifest.json\",\n  https: [\n    port: 443,\n    cipher_suite: :strong,\n    otp_app: :hello,\n    keyfile: System.get_env(\"SOME_APP_SSL_KEY_PATH\"),\n    certfile: System.get_env(\"SOME_APP_SSL_CERT_PATH\"),\n    # OPTIONAL Key for intermediate certificates:\n    cacertfile: System.get_env(\"INTERMEDIATE_CERTFILE_PATH\")\n  ]\n\n```\n\nWithout the `otp_app:` key, we need to provide absolute paths to the files wherever they are on the filesystem in order for Plug to find them.\n\n```elixir\nPath.expand(\"../../../some/path/to/ssl/key.pem\", __DIR__)\n```\n\nThe options under the `https:` key are passed to the Plug adapter, typically `Bandit`, which in turn uses `Plug.SSL` to select the TLS socket options. Please refer to the documentation for [Plug.SSL.configure/1](https://hexdocs.pm/plug/Plug.SSL.html#configure/1) for more information on the available options and their defaults. The [Plug HTTPS Guide](https://hexdocs.pm/plug/https.html) and the [Erlang/OTP ssl](https://www.erlang.org/doc/man/ssl.html) documentation also provide valuable information.","ref":"using_ssl.html"},{"type":"extras","title":"SSL in Development - Using SSL","doc":"If you would like to use HTTPS in development, a self-signed certificate can be generated by running: `mix phx.gen.cert`. This requires Erlang/OTP 20 or later.\n\nWith your self-signed certificate, your development configuration in `config/dev.exs` can be updated to run an HTTPS endpoint:\n\n```elixir\nconfig :my_app, MyAppWeb.Endpoint,\n  ...\n  https: [\n    port: 4001,\n    cipher_suite: :strong,\n    keyfile: \"priv/cert/selfsigned_key.pem\",\n    certfile: \"priv/cert/selfsigned.pem\"\n  ]\n```\n\nThis can replace your `http` configuration, or you can run HTTP and HTTPS servers on different ports.","ref":"using_ssl.html#ssl-in-development"},{"type":"extras","title":"Force SSL - Using SSL","doc":"In many cases, you'll want to force all incoming requests to use SSL by redirecting HTTP to HTTPS. This can be accomplished by setting the `:force_ssl` option in your endpoint configuration. It expects a list of options which are forwarded to `Plug.SSL`. By default, it sets the \"strict-transport-security\" header in HTTPS requests, forcing browsers to always use HTTPS. If an unsafe (HTTP) request is sent, it redirects to the HTTPS version using the `:host` specified in the `:url` configuration. For example:\n\n```elixir\nconfig :my_app, MyAppWeb.Endpoint,\n  force_ssl: [rewrite_on: [:x_forwarded_proto]]\n```\n\nTo dynamically redirect to the `host` of the current request, set `:host` in the `:force_ssl` configuration to `nil`.\n\n```elixir\nconfig :my_app, MyAppWeb.Endpoint,\n  force_ssl: [rewrite_on: [:x_forwarded_proto], host: nil]\n```\n\nIn these examples, the `rewrite_on:` key specifies the HTTP header used by a reverse proxy or load balancer in front of the application to indicate whether the request was received over HTTP or HTTPS. For more information on the implications of offloading TLS to an external element, in particular relating to secure cookies, refer to the [Plug HTTPS Guide](https://hexdocs.pm/plug/https.html#offloading-tls). Keep in mind that the options passed to `Plug.SSL` in that document should be set using the `force_ssl:` endpoint option in a Phoenix application.\n\nIt is important to note that `force_ssl:` is a *compile* time config, so it normally is set in `prod.exs`, it will not work when set from `runtime.exs`.","ref":"using_ssl.html#force-ssl"},{"type":"extras","title":"HSTS - Using SSL","doc":"HSTS, short for 'HTTP Strict-Transport-Security', is a mechanism that allows websites to declare themselves as accessible exclusively through a secure connection (HTTPS). It was introduced to prevent man-in-the-middle attacks that strip SSL/TLS encryption. HSTS causes web browsers to redirect from HTTP to HTTPS and to refuse to connect unless the connection uses SSL/TLS.\n\nWith `force_ssl: [hsts: true]` set, the `Strict-Transport-Security` header is added with a max-age that defines the duration for which the policy is valid. Modern web browsers will respond to this by redirecting from HTTP to HTTPS, among other consequences. [RFC6797](https://tools.ietf.org/html/rfc6797), which defines HSTS, also specifies that **the browser should keep track of a host's policy and apply it until it expires.** It further specifies that **traffic on any port other than 80 is assumed to be encrypted** as per the policy.\n\nWhile HSTS is recommended in production, it can lead to unexpected behavior when accessing applications on localhost. For instance, accessing an application with HSTS enabled at `https://localhost:4000` leads to a situation where all subsequent traffic from localhost, except for port 80, is expected to be encrypted. This can disrupt traffic to other local servers or proxies running on your computer that are unrelated to your Phoenix application and may not support encrypted traffic.\n\nIf you inadvertently enable HSTS for localhost, you may need to reset your browser's cache before it will accept HTTP traffic from localhost again.\n\nFor Chrome:\n1. Open the Developer Tools Panel.\n2. Click and hold the reload icon next to the address bar to reveal a dropdown menu.\n3. Select \"Empty Cache and Hard Reload\".\n\nFor Safari:\n1. Clear your browser cache.\n2. Remove the entry from `~/Library/Cookies/HSTS.plist` or delete the file entirely.\n3. Restart Safari.\n\nFor other browsers, please consult the documentation for HSTS.\n\nAlternatively, setting the `:expires` option on `force_ssl` to `0` should expire the entry and disable HSTS.\n\nFor more information on HSTS options, see [Plug.SSL](https://hexdocs.pm/plug/Plug.SSL.html).","ref":"using_ssl.html#hsts"},{"type":"extras","title":"Writing a Channels Client","doc":"# Writing a Channels Client\n\nClient libraries for Phoenix Channels already exist in [several languages](https://hexdocs.pm/phoenix/channels.html#client-libraries), but if you want to write your own, this guide should get you started.\nIt may also be useful as a guide for manual testing with a WebSocket client.","ref":"writing_a_channels_client.html"},{"type":"extras","title":"Overview - Writing a Channels Client","doc":"Because WebSockets are bidirectional, messages can flow in either direction at any time.\nFor this reason, clients typically use callbacks to handle incoming messages whenever they come.\n\nA client must join at least one topic to begin sending and receiving messages, and may join any number of topics using the same connection.","ref":"writing_a_channels_client.html#overview"},{"type":"extras","title":"Connecting - Writing a Channels Client","doc":"To establish a WebSocket connection to Phoenix Channels, first make note of the `socket` declaration in the application's `Endpoint` module.\nFor example, if you see: `socket \"/mobile\", MyAppWeb.MobileSocket`, the path for the initial HTTP request is:\n\n    [host]:[port]/mobile/websocket?vsn=2.0.0\n\nPassing `&vsn=2.0.0` specifies `Phoenix.Socket.V2.JSONSerializer`, which is built into Phoenix, and which expects and returns messages in the form of lists.\n\nYou also need to include [the standard header fields for upgrading an HTTP request to a WebSocket connection](https://developer.mozilla.org/en-US/docs/Web/HTTP/Protocol_upgrade_mechanism) or use an HTTP library that handles this for you; in Elixir, [mint_web_socket](https://hex.pm/packages/mint_web_socket) is an example.\n\nOther parameters or headers may be expected or required by the specific `connect/3` function in the application's socket module (in the example above, `MyAppWeb.MobileSocket.connect/3`).","ref":"writing_a_channels_client.html#connecting"},{"type":"extras","title":"Message Format - Writing a Channels Client","doc":"The message format is determined by the serializer configured for the application.\nFor these examples, `Phoenix.Socket.V2.JSONSerializer` is assumed.\n\nThe general format for messages a client sends to a Phoenix Channel is as follows:\n\n```\n[join_reference, message_reference, topic_name, event_name, payload]\n```\n\n- The `join_reference` is also chosen by the client and should also be a unique value. It only needs to be sent for a `\"phx_join\"` event; for other messages it can be `null`. It is used as a message reference for `push` messages from the server, meaning those that are not replies to a specific client message. For example, imagine something like \"a new user just joined the chat room\".\n- The `message_reference` is chosen by the client and should be a unique value. The server includes it in its reply so that the client knows which message the reply is for.\n- The `topic_name` must be a known topic for the socket endpoint, and a client must join that topic before sending any messages on it.\n- The `event_name` must match the first argument of a `handle_in` function on the server channel module.\n- The `payload` should be a map and is passed as the second argument to that `handle_in` function.\n\nThere are three events that are understood by every Phoenix application.\n\nFirst, `phx_join` is used join a channel. For example, to join the `miami:weather` channel:\n\n```json\n[\"0\", \"0\", \"miami:weather\", \"phx_join\", {\"some\": \"param\"}]\n```\n\nSecond, `phx_leave` is used to leave a channel. For example, to leave the `miami:weather` channel:\n\n```json\n[null, \"1\", \"miami:weather\", \"phx_leave\", {}]\n```\n\nThird, `heartbeat` is used to maintain the WebSocket connection. For example:\n\n\n```json\n[null, \"2\", \"phoenix\", \"heartbeat\", {}]\n```\n\nThe `heartbeat` message is only needed when no other messages are being sent and prevents Phoenix from closing the connection; the exact `:timeout` is configured in the application's `Endpoint` module.\n\nOther allowed messages depend on the Phoenix application.\n\nFor example, if the Channel serving the `miami:weather` can handle a `report_emergency` event:\n\n```elixir\ndef handle_in(\"report_emergency\", payload, socket) do\n  MyApp.Emergencies.report(payload) # or whatever\n  {:reply, :ok, socket}\nend\n```\n\n...a client could send:\n\n```json\n[null, \"3\", \"miami:weather\", \"report_emergency\", {\"category\": \"sharknado\"}]\n```","ref":"writing_a_channels_client.html#message-format"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,48]}}